#target photoshop
//
// ContactSheetX
//
// $Id: ContactSheetX.jsx,v 1.123 2008/12/18 18:19:03 xbytor Exp $
// Copyright: (c)2008, xbytor
// License: http://creativecommons.org/licenses/LGPL/2.1
// Contact: xbytor@gmail.com
//
//$.level = 1;
//

//XXX Manually change the name to match the version number

/* 
<javascriptresource>
   <name>Contact Sheet X v1.4.2...</name>
   <menu>automate</menu>
   <category>xtools</category>

   <about>Contact Sheet X: An enhanced contact sheet generator.
$Revision: 1.123 $
Copyright: (c)2008, xbytor
License: http://creativecommons.org/licenses/LGPL/2.1
Contact: xbytor@gmail.com</about>
   <eventid>0be2b720-cd2e-11dd-ad8b-0800200c9a66</eventid>
<terminology><![CDATA[<<< /Version 1
    /Events <<
        /50727710-7013-11db-9fe1-0800200c9a66 [
        (Contact Sheet X) /csxResource <<
           /imageSource [(Image Source) /typeString]
           /folder [(Image Folder) /typePlatformFilePath]
           /recurse [(User Recursion) /typeBoolean]
           /spanFolders [(Group by Folder) /typeBoolean]
           /background [(Background) /typeString]
           /templateFile [(Template File) /typePlatformFilePath]
           /docUnits [(Document Units) /typeText]
           /docWidth [(Document Width) /typeFloat]
           /docHeight [(Document Height) /typeFloat]
           /resolution [(Document Resolution) /typeFloat]
           /resUnits [(Resolution Units) /typeText]
           /mode [(Document Color Mode) /typeText]
           /marginsEnabled [(Margins Enabled) /typeBoolean]
           /leftMargin [(Left Margin) /typeFloat]
           /rightMargin [(Right Margin) /typeFloat]
           /topMargin [(Top Margin) /typeFloat]
           /bottomMargin [(Bottom Margin) /typeFloat]
           /alternateMargins [(Alternate Margins) /typeFloat]
           /acrossFirst [(Across First) /typeBoolean]
           /bestFit [(Rotate to Fit) /typeBoolean]
           /rotate [(Rotate Direction) /typeText]
           /autoFill [(Auto-Fill) /typeBoolean]
           /valign [(Vertical Alignment) /typeText]
           /rowCount [(Row Count) /typeInteger]
           /columnCount [(Column Count) /typeInteger]
           /useAutoSpacing [(Auto-Spacing) /typeBoolean]
           /vertical [(Vertical Space) /typeDouble]
           /horizontal [(Horizontal Space) /typeDouble]
           /thumbStyle [(Thumbnail Layer Style) /typeText]
           /squareCell [(Constrain to Square) /typeBoolean]
           /caption [(Enable Caption) /typeBoolean]
           /captionFormatEnabled [(Caption Format Enabled) /typeString]
           /captionFormat [(Caption Format) /typeString]
           /noExtensions [(No File Extensions) /typeBoolean]
           /font [(Font) /typeText]
           /fontSize [(Font Size) /typeFloat]
           /fontColor [(Font Color) /typeText]
           /captionStyle [(Caption Layer Style) /typeText]
           /overlayCaption [(Overlay Caption) /typeBoolean]
           /keepOpen [(Keep Sheets Open) /typeBoolean]
           /saveSheet [(Save Sheets) /typeBoolean]
           /outputFolder [(Destination Folder] /typePlatformFilePath]
           /outputPrefix [(File Prefix) /typeText]
           /outputFormat [(File Format) /typeText]
           /jpgQuality [(JPEG Quality) /typeInteger]
           /jpgFormat [(JPEG Format) /typeText]
           /tiffEncoding [(Tiff Encoding) /typeText]
           /flatten [(Flatten Layers) /typeBoolean]
           /accumulateKeywords [(Accumulate Keywords) /typeBoolean]
           /enableTextSubsitution [(Enable Text Substitution) /typeBoolean]
           /enablePageLayers [(Enable Page Layers) /typeBoolean]
           /enableDateLayers [(Enable Date Layers) /typeBoolean]
           /hiperfMode [(Performance Mode) /typeInteger]
           /hp2submode [(HiPerf 2 Submode) /typeText]
           /hp3submode [(HiPerf 3 Submode) /typeText]
           /dateFormat [(Default Date Format) /typeText]
           /logEnabled [(Logging Enabled) /typeBoolean]
           /logFile [(Log File) /typeString]
           /headerEnabled [(Header Enabled) /typeBoolean]
           /uiX [(User Interface X) /typeInteger]
           /uiY [(User Interface Y) /typeInteger]
        >>]
   >>> ]]></terminology>
</javascriptresource>
*/
//
//@show include
//

app;

//
//
//-include "xlib/GenericUI.jsx"
//-include "xlib/stdlib.js"
//-include "xlib/ColorChooser.jsx"
//-include "xlib/PresetsManager.jsx"
//-include "xlib/xexec.js"
//-include "xlib/metadata.js"
//-include "xlib/XBridgeTalk.jsx"
//-include "xlib/XProperty.jsx"
//
//
// CSXCore
//
// $Id: CSXCore.jsx,v 1.95 2008/12/18 18:19:03 xbytor Exp $
// Copyright: (c)2008, xbytor
// License: http://creativecommons.org/licenses/LGPL/2.1
// Contact: xbytor@gmail.com
//
//
//@show include
//
//
//
// stdlib.js
//   This file contains a collection of utility routines that I've
//   written, borrowed, rewritten, and occasionally tested and
//   documented.
//
//   Most of this stuff is photoshop specific. I'll break out the parts
//   that aren't sometime in the future.
//
// $Id: stdlib.js,v 1.253 2008/11/18 04:55:07 anonymous Exp $
// Copyright: (c)2008, xbytor
// License: http://creativecommons.org/licenses/LGPL/2.1
// Contact: xbytor@gmail.com
//
//@show include
//
//

//================================== misc ====================================
//
// Some shorthand functions for TypeID conversion
//
cTID = function(s) {
  if (s.length != 4) {
    Error.runtimeError(19, s);  // Bad Argument
  }
  return app.charIDToTypeID(s);
};
sTID = function(s) { return app.stringIDToTypeID(s); };
xTID = function(s) {
  if (s == undefined) {
    if (isCS3() || isCS4()) {
      Stdlib.log("undefined id detected at: " + $.stack);
    } else {
      Stdlib.log("undefined id detected");
    }
  }

  if (s.constructor == Number) {
    return s;
  }
  if (s.constructor == String) {
    if (s.length > 0) {
      if (s.length != 4) return sTID(s);
      try { return cTID(s); } catch (e) { return sTID(s); }
    }
  }
  Error.runtimeError(19, s);  // Bad Argument
};

//
// This reverses the mapping from a TypeID to something readable.
// If PSConstants.js has been included, the string returned is even
// more readable
//
id2char = function(s) {
  if (isNaN(Number(s))){
    return '';
  }
  var v;

  // Use every mechanism available to map the typeID
  var lvl = $.level;
  $.level = 0;
  try {
    if (!v) {
      try { v = PSConstants.reverseNameLookup(s); } catch (e) {}
    }
    if (!v) {
      try { v = PSConstants.reverseSymLookup(s); } catch (e) {}
    }
    if (!v) {
      try { v = app.typeIDToCharID(s); } catch (e) {}
    }
    if (!v) {
      try { v = app.typeIDToStringID(s); } catch (e) {}
    }
  } catch (e) {
  }
  $.level = lvl;
  if (!v) {
    v = Stdlib.numberToAscii(s); 
  }
  return v ? v : s;
};
id2charId = function(s) {
  if (isNaN(Number(s))){
    return '';
  }
  var v;

  // Use every mechanism available to map the typeID
  var lvl = $.level;
  $.level = 0;
  try {
    if (!v) {
      try { v = PSConstants.reverseSymLookup(s); } catch (e) {}
    }
    if (!v) {
      try { v = app.typeIDToCharID(s); } catch (e) {}
    }
    if (!v) {
      try { v = PSConstants.reverseNameLookup(s); } catch (e) {}
    }
    if (!v) {
      try { v = app.typeIDToStringID(s); } catch (e) {}
    }
  } catch (e) {
  }
  $.level = lvl;
  if (!v) {
    v = Stdlib.numberToAscii(s); 
  }
  return v ? v : s;
};
// deprecated
id2name = function(s) {
  return id2char(s);
};

if (!$.evalFile) {
  // only CS3 defines global and evalFile
  global = this;
} else {
  global = $.global;
}

isPhotoshop = function() {
  return !!app.name.match(/photoshop/i);
};
isBridge = function() {
  return !!app.name.match(/bridge/i);
};
isInDesign = function() {
  return !!app.name.match(/indesign/i);
};

//
// Simple checks for photoshop version
//
var psVersion;
try {
  var lvl = $.level;
  $.level = 0;
  psVersion = app.version;

 } catch (e) {
  psVersion = version;

 } finally {
   $.level = lvl;
   delete lvl;
}

// see XBridgeTalk for more comprehensive isCSX handling
// if (!global["isCS3"]) {
//   isCS3 = function()  { return psVersion.match(/^10\./) != null; };
// }
// if (!global["isCS2"]) {
//   isCS2 = function()  { return psVersion.match(/^9\./) != null; };
// }
isCS4 = function()  { return psVersion.match(/^11\./) != null; };
isCS3 = function()  { return psVersion.match(/^10\./) != null; };
isCS2 = function()  { return psVersion.match(/^9\./) != null; };
isCS  = function()  { return psVersion.match(/^8\./) != null; };
isPS7 = function()  { return psVersion.match(/^7\./) != null; };

if (isPS7()) {  // this does not work for eval-includes
  app = this;
}

isWindows = function() {
  return $.os.match(/windows/i);
};
isMac = function() {
  return !isWindows();
};

// this makes PS7 compatibility a bit easier
function getUnitValue(u) { return (u.value != undefined) ? u.value : u; }

//
//=============================== Stdlib =====================================
// This is the name space for utility functions. This should probably be
// broken up into smaller classes

Stdlib = function Stdlib() {};

Stdlib.RcsId = "$Id: stdlib.js,v 1.253 2008/11/18 04:55:07 anonymous Exp $";

Stdlib.ERROR_CODE = 9001;
Stdlib.IO_ERROR_CODE = 9002;

//================================= language =================================
//
// throwError
//     throw an exception where you would normally have an
//     expression e.g.
//        var f = File("~/start.ini");
//        f.open("r") || Stdlib.throwError(f.error);
//
Stdlib.throwError = function(e) {
  throw e;
};
throwError = Stdlib.throwError;


Stdlib.quit = function(interactive) {
  // no interactive support yet...
  executeAction(cTID('quit'), new ActionDescriptor(), DialogModes.NO);
};

//
// createObject
//
Stdlib.createObject = function(cls, attrs) {
  var obj = new cls();
  for (var v in attrs) {
    obj[v] = attrs[v];
  }
  return obj;
};

//
// for when you really, really have to wipe-out an object
//
Stdlib.clearObject = function(obj) {
  for (var idx in obj) {
    delete obj[idx];
  }
  return obj;
};

Stdlib.copyFromTo = function(from, to) {
  if (!from || !to) {
    return;
  }
  for (var idx in from) {
    var v = from[idx];
    if (typeof v != 'function') {
        to[idx] = v;
    }
  }
};

Stdlib.randomElement = function(ary) {
  return ary[Math.floor(Math.random(ary.length) * ary.length)];
};

Stdlib.popRandomElement = function(ar) {
  if (ar.length == 0) {
    return undefined;
  }
  if (ar.length == 1) {
    var el = ar[0];
    ar.length = 0;
    return el;
  }
  var idx = Math.floor(Math.random(ar.length) * ar.length);
  var el = ar[idx];
  ar.splice(idx, 1);
  return el;
};


//
// This is one way of getting an environment variable. This is deprecated
// in CS2.
//
Stdlib.getenv = function(key) {
  key = key.toUpperCase();
  if (Stdlib.env != undefined) {
    return key ? Stdlib.env[key]: Stdlib.env;
  }
  Stdlib.env = new Object();

  var f = new File(Folder.temp + "/getenv.bat");
  f.open("w");
  f.writeln("set > env.txt");
  f.writeln("rename env.txt env.dat");
  f.close();
  f.execute();
  var o;

  var maxCount = 100;
  while (maxCount--) {
    // lets take a brief pause here....
    // 10000 seems about right on my box...
    // need to loop this and port to CS2
    Stdlib.pause(10000);
    o = new File("env.dat");
    if (o.exists) {
      break;
    }
    o = undefined
  }
  if (!o) {
    Error.runtimeError(33); // internal error
  }
  o.open("r");
  var s = o.read();
  o.close();

  f.remove();
  o.remove();

  var envlist = s.split("\n");

  for (var i =0; i < envlist.length; i++) {
    var x = envlist[i].split("=");
    Stdlib.env[x[0].toUpperCase()] = x[1];
  }

  return key ? Stdlib.env[key]: Stdlib.env;
};

//
// runScript
//     load and execute an external script. use the standard
//     xscripts search path if the name is not absolute
//
Stdlib.IncludePathFile = "IncludePath.js";  // deprecated...

Stdlib.runScript = function(name) {
  Stdlib.runScriptByName(name,
                         (name.charAt(0) == '/') ?
                         null : Stdlib.IncludePathFile);
};

Stdlib.runScriptByName = function(name, path) {
  var str = "//@include \"" + name + "\";\r";
  if (path) {
    str = "//@include \"" + path + "\";\r" + str;
  }
  eval(str); // can't do this at top-level so some scoping problems
             // are inevitable
  return true;
};

//
// Thanks to Rags Gardner and Bob Stucky
// news://adobeforums.com:119/3bbff2b9.3@webcrossing.la2eafNXanI
//
Stdlib.getScriptFolder = function() { 
  return Stdlib.getScriptFile().parent;
};
Stdlib.getScriptFileName = function() {
  var f = Stdlib.getScriptFile();
  return (f ? f.absoluteURI : '');
};

Stdlib.getScriptFile = function() {
  if (isCS() || isPS7()) {
    return undefined;
  }

  // this behaves oddly in the presence of @include files in CS3
  var dbLevel = $.level;
  $.level = 0;
  var path = undefined;

  try {
    some_undefined_variable;
  } catch (e) {
    path = e.fileName;
  }

  $.level = dbLevel;

  return new File(path);
};

// thanks to Andrew Hall
Stdlib.btRunScript = function(script, btapp) {
  if (!btapp) { btapp = BridgeTalk.appSpecifier; }

  BridgeTalk.bringToFront(btapp);

  var bt = new BridgeTalk();
  bt.target = btapp;
  bt.body = "//@include \"" + script + "\";\r\n";
  bt.send();
};
Stdlib.btExec = function(code, btapp) {
  if (!btapp) { btapp = BridgeTalk.appSpecifier; }

  BridgeTalk.bringToFront(btapp);

  var bt = new BridgeTalk();
  bt.target = btapp;
  bt.body = code;
  bt.send();
};

//XXX experimental DO NOT USE
Stdlib.restartScript = function() {
  Stdlib.btRunScript(Stdlib.getScriptFileName());
};

try {
Stdlib.PRESETS_FOLDER = 
  new Folder(app.path + '/' +
             localize("$$$/ApplicationPresetsFolder/Presets=Presets"));

Stdlib.ADOBE_PRESETS_FOLDER = Stdlib.PRESETS_FOLDER;

Stdlib.USER_PRESETS_FOLDER =
    new Folder(Folder.userData + '/' +
               localize("$$$/private/AdobeSystemFolder/Adobe=Adobe") + '/' +
               localize("$$$/private/FolderNames/AdobePhotoshopProductVersionFolder") + '/' +
               localize("$$$/private/FolderName/UserPresetsFolder/Presets=Presets"));
    
Stdlib.SCRIPTS_FOLDER =
  new Folder(app.path + '/' +
             localize("$$$/ScriptingSupport/InstalledScripts=Presets/Scripts"));
} catch (e) {
}

Stdlib._getPreferencesFolder = function() {
  var userData = Folder.userData;

  if (!userData || !userData.exists) {
    userData = Folder("~");
  }

  var folder = new Folder(userData + "/xtools");

  if (!folder.exists) {
    folder.create();
  }

  return folder;
};

Stdlib.PREFERENCES_FOLDER = Stdlib._getPreferencesFolder();

//
// Format a Date object into a proper ISO 8601 date string
//
Stdlib.toISODateString = function(date, timeDesignator, dateOnly, precision) {
  if (!date) date = new Date();
  var str = '';
  if (timeDesignator == undefined) { timeDesignator = 'T' };
  function _zeroPad(val) { return (val < 10) ? '0' + val : val; }
  if (date instanceof Date) {
    str = (date.getFullYear() + '-' +
           _zeroPad(date.getMonth()+1,2) + '-' +
           _zeroPad(date.getDate(),2));
    if (!dateOnly) {
      str += (timeDesignator +
              _zeroPad(date.getHours(),2) + ':' +
              _zeroPad(date.getMinutes(),2) + ':' +
              _zeroPad(date.getSeconds(),2));
      if (precision && typeof(precision) == "number") {
        var ms = date.getMilliseconds();
        if (ms) {
          var millis = _zeroPad(ms.toString(),precision);
          var s = millis.slice(0, Math.min(precision, millis.length));
          str += "." + s;
        }
      }
    }
  }
  return str;
};

//
// Make it a Date object method
//
Date.prototype.toISODateString = function(timeDesignator, dateOnly, precision) {
  return Stdlib.toISODateString(this, timeDesignator, dateOnly, precision);
};
Date.prototype.toISOString = Date.prototype.toISODateString;


Stdlib.testISODate = function() {
  var strs = ["2006-09-01",
              "1997-07-16T19:20",
              "1997-07-16T19:20Z",
              "1997-07-16T19:20+01:00",
              "2006-09-01T16:33:26",
              "2006-09-01 16:33:26",
              "2006:09:01 16:33:26",
              "1997-07-16T19:20:30",
              "1997-07-16T19:20:30Z",
              "1997-07-16T19:20:30-01:00",
              "1997-07-16T19:20:30.45",
              "1997-07-16T19:20:30.45Z",
              "1997-07-16T19:20:30.45+01:05"];

  for (var i = 0; i < strs.length; i++) {
    var s = strs[i];
    alert(s + " :: " + Stdlib.parseISODateString(s).toISODateString('T', false, 2));
  }
};

// xmp = new XMPData(doc); Stdlib.parseISODateString(xmp.get('createdate'))
Stdlib.parseISODateString = function(str) {
  if (!str) {
    return undefined;
  }
  // \d{4}(:|-)\d{2}(:-)\d{2}( |T).\d{2}:\d{2}:\d{2}(Z|((\-\+)\d{2}:\d{2}))?

  // Date portion /^(\d{4}).?(\d{2}).?(\d{2})/
  // Divider ( |T)
  var date = undefined;
  //$.level = 1; debugger;
  if (str.length >= 10 && str.length <= 35) {

    // we are assuming that this date is formatted correctly
    var utc = str.endsWith('Z');

    // handle the data portion e.g. 2006-06-08 or 2006:06:08 or 20060680
    var m = str.match(/^(\d{4}).?(\d{2}).?(\d{2})/);

    if (m) {
      var date = new Date();
      if (utc) {
        date.setUTCFullYear(Number(m[1]),
                            Number(m[2])-1,
                            Number(m[3]));
        date.setUTCHours(0, 0, 0);
        date.setUTCMilliseconds(0);

      } else {
        date.setFullYear(Number(m[1]),
                         Number(m[2])-1,
                         Number(m[3]));
        date.setHours(0, 0, 0);
        date.setMilliseconds(0);
      }


      // handle the time portion e.g. 12:15:02
      // or 12:15:02-06:00 or 12:15:02Z or 12:15:02.25Z or 12:15:02.25+10:30
      if (str.length > 10) {
        m = str.match(/( |T)(\d{2}):(\d{2})(?::(\d{2})(\.\d+)?)?(?:(Z)|(\-|\+)(\d{2}):(\d{2}))?$/);

        if (m) {
          var hours = Number(m[2]);
          var mins = Number(m[3]);

          var nstr = str.slice(m.index);

          var secs = (m[4] ? Number(m[4]) : 0);
          var ms = 0;
          if (m[5]) {
            ms = Number("0" + m[5]) * 1000;
          }

          var z = (m[6] == 'Z');
          // assert(z == utc);

          if (utc) {
            date.setUTCHours(hours, mins, secs);
            date.setUTCMilliseconds(ms);

          } else {
            date.setHours(hours, mins, secs);
            date.setMilliseconds(ms);
          }

          if (m[6] || (m[7] && m[8] && m[9])) {
            var tzd = (z ? 'Z' : m[7] + m[8] + ':' + m[9]);
            date.tzd = tzd;
          }

        } else {
          date = undefined;
        }
      }
    }
  }

  return date;
};

Stdlib.binToHex = function(s, whitespace) {
  function hexDigit(d) {
    if (d < 10) return d.toString();
    d -= 10;
    return String.fromCharCode('A'.charCodeAt(0) + d);
  }
  var str = '';

  if (s.constructor != String) {
    s = s.toString();
  }

  for (var i = 0; i < s.length; i++) {
    if (i) {
      if (whitespace == true) {
        if (!(i & 0xf)) {
          str += '\r\n';
        } else if (!(i & 3)) {
          str += ' ';
        }
      }
    }
    var ch = s.charCodeAt(i) & 0xFF;  // check for unicode here...
    str += hexDigit(ch >> 4) + hexDigit(ch & 0xF);
  }
  return str;
};
Stdlib.hexToBin = function(h) {
  function binMap(n) {
    if (n.match(/[0-9]/)) return parseInt(n);
    return parseInt((n.charCodeAt(0) - 'A'.charCodeAt(0)) + 10);
  }

  h = h.toUpperCase().replace(/\s/g, '');
  var bytes = '';

  for (var i = 0; i < h.length/2; i++) {
    var hi = h.charAt(i * 2);
    var lo = h.charAt(i * 2 + 1);
    var b = (binMap(hi) << 4) + binMap(lo);
    bytes += String.fromCharCode(b);
  }
  return bytes;
};
Stdlib.hexToJS = function(h) {
  var str = '';
  var blockSize = 64;
  var blockCnt = (h.length/blockSize).toFixed();

  for (var i = 0; i < blockCnt; i++) {
    var ofs = i * blockSize;
    str += "  \"" + h.slice(ofs, ofs + blockSize) + "\" +\n";
  }

  str += "  \"" + h.slice(blockCnt * blockSize) + "\"\n";
  return str;
};
Stdlib.shortToHex = function(w) {
  function sfcc(c) { return String.fromCharCode(c); }
  var bytes = [sfcc((w >> 8) & 0xFF),
               sfcc(w & 0xFF)];
  return Stdlib.binToHex(bytes.join(""));
};
Stdlib.longToHex = function(w) {
  function sfcc(c) { return String.fromCharCode(c); }
  var bytes = [sfcc((w >> 24) & 0xFF),
               sfcc((w >> 16) & 0xFF),
               sfcc((w >> 8) & 0xFF),
               sfcc(w & 0xFF)];
  return Stdlib.binToHex(bytes.join(""));
};
Stdlib.hexToLong = function(h) {
  function cca(s, i) { return s.charCodeAt(i); }
  var bytes = Stdlib.hexToBin(h);

  return ((cca(bytes, 0) << 24) +
          (cca(bytes, 1) << 16) +
          (cca(bytes, 2) << 8) +
          cca(bytes, 3));
};

Stdlib.hexTest = function() {
  var f = new File("/c/work/xxx.asl");
  var s = Stdlib.readFromFile(f, 'BINARY');
  var h = Stdlib.binToHex(s);
  var js = Stdlib.hexToJS(h);

  //alert(h.slice(0, 132));
  //alert(js.slice(0, 132));
  eval(" xxx = " + js);
  alert(xxx == h);
  
  var f = new File("/c/work/xxx2.asl");
  Stdlib.writeToFile(f, Stdlib.hexToBin(xxx), 'BINARY');
};

Stdlib.numberToAscii = function(n) {
  if (isNaN(n)) {
    return n;
  }
  var str = '';
  str += String.fromCharCode(n >> 24);
  str += String.fromCharCode((n >> 16) & 0xFF);
  str += String.fromCharCode((n >> 8) & 0xFF);
  str += String.fromCharCode(n & 0xFF);

  return str.match(/^\w{4}$/) ? str : n;
};

//
//==================================== Strings ===============================
//


String.prototype.contains = function(sub) {
  return this.indexOf(sub) != -1;
};

String.prototype.containsWord = function(str) {
  return this.match(new RegExp("\\b" + str + "\\b")) != null;
};

String.prototype.endsWith = function(sub) {
  return this.length >= sub.length &&
    this.slice(this.length - sub.length) == sub;
};

String.prototype.reverse = function() {
  var ar = this.split('');
  ar.reverse();
  return ar.join('');
};

String.prototype.startsWith = function(sub) {
  return this.indexOf(sub) == 0;
};

String.prototype.trim = function() {
  return this.replace(/^[\s]+|[\s]+$/g, '');
};
String.prototype.ltrim = function() {
  return this.replace(/^[\s]+/g, '');
};
String.prototype.rtrim = function() {
  return this.replace(/[\s]+$/g, '');
};


//
// Trim leading and trailing whitepace from a string
//
Stdlib.trim = function(value) {
   return value.replace(/^[\s]+|[\s]+$/g, '');
};

Array.contains = function(ar, el) {
  for (var i = 0; i < ar.length; i++) {
    if (ar[i] == el) {
      return true;
    }
  }
  return false;
};
if (!Array.prototype.contains) {
  Array.prototype.contains = function(el) {
    for (var i = 0; i < this.length; i++) {
      if (this[i] == el) {
        return true;
      }
    }
    return false;
  };
}

if (!Array.prototype.indexOf) {
  Array.prototype.indexOf = function(el) {
    for (var i = 0; i < this.length; i++) {
      if (this[i] == el) {
        return i;
      }
    }
    return -1;
  };
}
if (!Array.prototype.lastIndexOf) {
  Array.prototype.indexOf = function(el) {
    for (var i = this.length-1; i >= 0; i--) {
      if (this[i] == el) {
        return i;
      }
    }
  return -1;
  };
}



// Array.prototype.iterate = function(ftn) {
//   for (var i = 0; i < this.length; i++) {
//     ftn(this[i]);
//   }
// };

// Array.prototype.grep = function(re, ftn, prop) {
//   for (var i = 0; i < this.length; i++) {
//     if (prop) {
//       if (this[i][prop].match(re)) {
//         ftn(re);
//       }
//     } else {
//       if (this[i].match(re)) {
//         ftn(re);
//       }
//     }
//   }
// };

//
//============================= File Utilities ===============================
//

throwFileError = function(f, msg) {
  if (msg == undefined) {
    msg = '';
  }
  Error.runtimeError(Stdlib.IO_ERROR_CODE,
                     "IOError: " + msg + " \"" + f + "\": " +
                     f.error + '.');
};

//
// Return a File or Folder object given one of:
//    A File or Folder Object
//    A string literal or a String object that refers to either
//    a File or Folder
//
Stdlib.convertFptr = function(fptr) {
  var f;
  if (fptr.constructor == String) {
    f = File(fptr);

  } else if (fptr instanceof File || fptr instanceof Folder) {
    f = fptr;

  } else {
    Error.runtimeError(19, "fptr");
  }
  return f;
};

Stdlib.createFileSelect = function(str) {
  if (isWindows()) {
    return str;
  }

  if (!str.constructor == String) {
    return str;
  }

  var exts = [];
  var rex = /\*\.(\*|[\w]+)(.*)/;
  var m;
  while (m = rex.exec(str)) {
    exts.push(m[1].toLowerCase());
    str = m[2];
  }

  function macSelect(f) {
    var name = decodeURI(f.absoluteURI).toLowerCase();
    var _exts = macSelect.exts;

    // alert(name);

    while (f.alias) { 
      f = f.resolve(); 
      if (f == null) {
        return false; 
      }
    } 

    if (f instanceof Folder) {
      return true;
    }

    for (var i = 0; i < _exts.length; i++) {
      var ext = _exts[i];
      if (ext == '.*') {
        return true;
      }
      if (name.match(RegExp("\\." + ext + "$", "i")) != null) {
        return true;
      }
    }
    return false;
  }

  macSelect.exts = exts;
  return macSelect;
};

//
// Open a dialog to prompt the user to select a file.
// An initial file or folder can optionally be specified
// Change the current directory reference if we it
// seems appropriate.
//
//  var file = Stdlib.selectFileOpen("Choose a file to open",
//                                   "JPEG Files: *.jpg", "/c/tmp")
//  var file = Stdlib.selectFileSave("Choose a file to save",
//                                "JPEG Files: *.jpg", File("/c/tmp/tmp.jpg"))
//
Stdlib.selectFileOpen = function(prompt, select, start) {
  return Stdlib._selectFile(prompt, select, start, true);
};
Stdlib.selectFileSave = function(prompt, select, start) {
  return Stdlib._selectFile(prompt, select, start, false);
};
Stdlib.selectFile = Stdlib.selectFileOpen;

Stdlib._selectFile = function(prompt, select, start, open) {
  var file;

  if (!prompt) {
    prompt = 'Select a file';
  }

  if (start) {
    start = Stdlib.convertFptr(start);
  }

  var classFtn = (open ? File.openDialog : File.saveDialog);

  if (!start) {
    file = classFtn(prompt, select);

  } else {
    if (start instanceof Folder) {
      while (start && !start.exists) {
        start = start.parent;
      }

      var files = start.getFiles(select);
      if (!files || files.length == 0) {
        files = start.getFiles();
      }
      for (var i = 0; i < files.length; i++) {
        if (files[i] instanceof File) {
          start = files[i];
          break;
        }
      }
      if (start instanceof Folder) {
        start = new File(start + "/file.ext");
      }
    }

    if (start instanceof File) {
      var instanceFtn = (open ? "openDlg" : "saveDlg");

      if (instanceFtn in start) {
        file = start[instanceFtn](prompt, select);

      } else {
        try {
          if (start.exists) {
            Folder.current = start.parent;
          }
        } catch (e) {
        }
        file = classFtn(prompt, select);
      }
    } else {
      file = Folder.selectDialog(prompt); 
//       Folder.current = start;
//       file = classFtn(prompt, select);
    }
  }

  if (file) {
    Folder.current = file.parent;
  }
  return file;
};

Stdlib.selectFolder = function(prompt, start) {
  var folder;

  if (!prompt) {
    prompt = 'Select a folder';
  }
  if (start) {
    start = Stdlib.convertFptr(start);
    while (start && !start.exists) {
      start = start.parent;
    }
  }

  if (!start) {
    folder = Folder.selectDialog(prompt);

  } else {
    if (start instanceof File) {
      start = start.parent;
    }

    if (start.selectDlg) {   // for CS2
      folder = start.selectDlg(prompt);

    } else {               // for CS
      var preset = Folder.current;
      if (start.exists) {
        preset = start;
      }
      folder = Folder.selectDialog(prompt, preset);
    }
  }
  return folder;
};

Stdlib.ImageFileExtsComplete = 
  "8bps,3ds,ai3,ai4,ai5,ai6,ai7,ai8,ai,arw,bmp,cin,cr2,crw,dae,dc2,dc3,dcr," +
  "dib,dic,dng,dpx,eps,epsf,epsp,erf,exr,fido,flm,gif,hdr,hrr," +
  "icb,jpeg?,jpg,kdc,kmz,m4v,mef,mfw,mos,mov,mp4,mpeg,mrw,nef,obj,orf,pam," +
  "pbm,pcd,pct,pcx,pdd,pdf,pdp,pef,pict?,png,pnm," +
  "ps(d|b)?,pxr,raf,raw,rgbe,rle,sct,sdpx,sr2,srf,tga,tiff?,u3d,vda,vst," +
  "wbmp?,x3f,xyze";

Stdlib.ImageFileExtsCompleteRE =
  new RegExp("\\.(" +
             Stdlib.ImageFileExtsComplete.replace(/,/g, '|') + ")$", 'i');

Stdlib.ImageFileExtsCommon = 
  "psd,pdd,jpeg?,jpg,png,8bps,gif,bmp,rle,dib,tiff?,raw,dng,crw,cr2,nef,raf,orf";

Stdlib.ImageFileExtsCommonRE =
  new RegExp("\\.(" +
             Stdlib.ImageFileExtsCommon.replace(/,/g, '|')
             + ")$", 'i');

// 3rf,ciff,cs1,k25
Stdlib.RawImageFileExts =
  "arw,cr2,crw,dcr,dng,erf,kdc,mos,mef,mrw,nef,orf,pef,raf,raw," +
  "sr2,srf,x3f";

Stdlib.RawImageFileExtsRE =
  new RegExp("\\.(" +
             Stdlib.RawImageFileExts.replace(/,/g, '|')
             + ")$", 'i');

Stdlib.isImageFile = function(fstr) {
  return fstr.toString().match(Stdlib.ImageFileExtsCommonRE) != null;
};
Stdlib.isRawImageFile = function(fstr) {
  return fstr.toString().match(Stdlib.RawImageFileExtsRE) != null;
};

// deprecated
Stdlib.isPSFileType = Stdlib.isImageFile;


//
// Sort an array of files in XP's 'intuitive' sort order
// so that files like [x1.jpg,x2.jpg,x10.jpg,x20.jpg] are
// ordered in numerical sequence
//
Stdlib.XPFileSort = function(list) {
  var rex = /(\d+)\./;

  function xpCmp(a, b) {
    var ap = a.name.match(rex);
    var bp = b.name.match(rex);
    if (ap != null && bp != null) {
      return toNumber(ap[1]) - toNumber(bp[1]);
    }
    if (a.name.toLowerCase() < b.name.toLowerCase()) {
      return -1;
    } else if (a.name > b.name) {
      return 1;
    }
    return 0;
  }

  return list.sort(xpCmp);
};

//
// Adds RegExp support and avoids PS7/CS bug in Folder.getFiles()
// usage:
//    getFiles(folder);
//    getFiles(folder, "*.jpg");
//    getFiles(folder, /\.jpg$/);
//    getFiles(folder, function(f) { return f instanceof Folder; });
//
Stdlib.getFiles = function(folder, mask) {
  var files = [];

  folder = Stdlib.convertFptr(folder);

  if (folder.alias) {
    folder = folder.resolve();
  }

  //Stdlib.fullStop();
  var getF;
  if (Folder.prototype._getFiles) {
    getF = function(f, m) { return f._getFiles(m); }
  } else {
    getF = function(f, m) { return f.getFiles(m); }
  }

  if (mask instanceof RegExp) {
    var allFiles = getF(folder);
    for (var i = 0; i < allFiles.length; i = i + 1) {
      var f = allFiles[i];
      if (decodeURI(f.absoluteURI).match(mask)) {
        files.push(f);
      }
    }
  } else if (typeof mask == "function") {
    var allFiles = getF(folder);
    for (var i = 0; i < allFiles.length; i = i + 1) {
      var f = allFiles[i];
      if (mask(f)) {
        files.push(f);
      }
    }
  } else {
    files = getF(folder, mask);
  }

  return files;
};

//
// Install an adaptor to that our getFiles code will be invoked when
// Folder.getFiles is called. The difficulty here is that we need to retain
// a handle to the original implementation so that we can invoke it from
// our version and that this code may be executed multiple times.
//
Stdlib.getFiles.install = function() {
  if (!Folder.prototype._getFiles) {
     // save the original getFiles
    Folder.prototype._getFiles = Folder.prototype.getFiles;
    // slide in an adaptor for our version
    Folder.prototype.getFiles = function(mask) {
      return Stdlib.getFiles(this, mask);
    }
  }
};
//
// Remove our adaptor and restore the original Folder.getFiles method
//
Stdlib.getFiles.uninstall = function() {
  if (Folder.prototype._getFiles) {
    // restore the original getFiles
    Folder.prototype.getFiles = Folder.prototype._getFiles;
    // delete our adaptor
    delete Folder.protoype._getFiles;
  }
};

Stdlib.getFolders = function(folder) {
  if (folder.alias) {
    folder = folder.resolve();
  }
  var folders = Stdlib.getFiles(folder,
                                function(f) { return f instanceof Folder; });
  return folders;
};

Stdlib.getFiles.install();   // install our version of Folder.getFiles

Stdlib.findFiles = function(folder, mask) {
  if (folder.alias) {
    folder = folder.resolve();
  }
  var files = Stdlib.getFiles(folder, mask);
  var folders = Stdlib.getFolders(folder);

  for (var i = 0; i < folders.length; i++) {
    var f = folders[i];
    var ffs = Stdlib.findFiles(f, mask);
    // files.concat(ffs); This occasionally fails for some unknown reason (aka
    // interpreter Bug) so we do it manually instead
    while (ffs.length > 0) {
      files.push(ffs.shift());
    }
  }
  return files;
};

Stdlib.findImageFiles = function(folder) {
  return Stdlib.findFiles(folder, Stdlib.ImageFileExtsCommonRE);
};

Folder.prototype.findFiles = function(mask) {
  return Stdlib.findFiles(this, mask);
};

Stdlib.getImageFiles = function(folder, recursive, complete) {
  if (folder.alias) {
    folder = folder.resolve();
  }

  if (recursive == undefined) recursive = false;
  if (complete == undefined) complete = false;
  var mask = (complete ?
              Stdlib.ImageFileExtsCompleteRE : Stdlib.ImageFileExtsCommonRE);
  if (recursive) {
    return Stdlib.findFiles(folder, mask);
  } else {
    return Stdlib.getFiles(folder, mask);
  }
};

Stdlib.grep = function(folder, rex, frex, recursive) {
  if (folder.alias) {
    folder = folder.resolve();
  }

  if (frex == undefined) {
    frex = /.*/;
  }
  var files = (!!recursive ?
               Stdlib.findFiles(folder, frex) :
               Stdlib.getFiles(folder, frex));

  var hits = [];
  for (var i = 0; i < files.length; i++) {
    var file = files[i];
    if (file instanceof File) {
      var str = Stdlib.readFromFile(file);
      if (str.match(rex)) {
        hits.push(file);
      }
    }
  }
  return hits;
};

//
// Returns null if the match or a string if they don't
// Useful for testing but not much else
//
Stdlib.compareFiles = function(f1, f2) {
  if (!(f1 instanceof File)) f1 = new File(f1);
  if (!(f2 instanceof File)) f2 = new File(f2);

  if (!f1.exists || !f2.exists) {
    return "File(s) do not exist.";
  }
  if (f1.length != f2.length) {
    return "Files are different sizes.";
  }

  try {
    f1.open("r") || throwFileError(f1, "Unable to open input file ");
    f1.encoding = 'BINARY';
    f2.open("r") || throwFileError(f2, "Unable to open input file ");
    f2.encoding = 'BINARY';

  } finally {
    try { f1.close(); } catch (e) {}
    try { f2.close(); } catch (e) {}
  }

  while (!f1.eof && !f2.eof && (f1.read(1) == f2.read(1))) {
    // do nothing
  }
  if (!(f1.eof && f2.eof)) {
    return "File contents do not match.";
  }
  return null;
};

Stdlib.writeToFile = function(fptr, str, encoding, lineFeed) {
  var xfile = Stdlib.convertFptr(fptr);

  xfile.open("w") || throwFileError(xfile, "Unable to open output file ");
  if (encoding) {
    xfile.encoding = encoding;
  }

  if (lineFeed) {
    xfile.lineFeed = lineFeed;
  }

  if (isPS7() && encoding == 'BINARY') {
    xfile.lineFeed = 'unix';

    var pos = 0;
    var cr = '\r';
    var next;
    while ((next = str.indexOf(cr, pos)) != -1) {
      xfile.write(str.substring(pos, next));
      xfile.lineFeed = 'mac';
      xfile.write(cr);
      xfile.lineFeed = 'unix';
      pos = next + 1;
    }
    if (pos < str.length) {
      xfile.write(str.substring(pos));
    }
  } else {
    xfile.write(str);
  }
  xfile.close();
};

Stdlib.readFromFile = function(fptr, encoding, lineFeed) {
  var file = Stdlib.convertFptr(fptr);
  file.open("r") || throwFileError(file, "Unable to open input file ");
  if (encoding) {
    file.encoding = encoding;
  }
  if (lineFeed) {
    file.lineFeed = lineFeed;
  }
  var str = file.read();
  file.close();
  return str;
};

Stdlib.INI_ENCODING = "LATIN1";

Stdlib.toIniString = function(obj) {
  var str = '';
  for (var idx in obj) {
    if (idx.charAt(0) == '_') {         // private stuff
      continue;
    }
    if (idx == 'typename') {
      continue;
    }
    var val = obj[idx];

    if (val == undefined) {
      val = '';
    }

    if (val.constructor == String ||
        val.constructor == Number ||
        val.constructor == Boolean ||
        typeof(val) == "object") {
      str += (idx + ": " + val.toString() + "\n");
    }
  }
  return str;
};
Stdlib.fromIniString = function(str, obj) {
  if (!obj) {
    obj = {};
  }
  var lines = str.split(/[\r\n]+/);

  var rexp = new RegExp(/([^:]+):(.*)$/);

  for (var i = 0; i < lines.length; i++) {
    var line = lines[i].trim();
    if (!line || line.charAt(0) == '#') {
      continue;
    }
    var ar = rexp.exec(line);
    if (!ar) {
      alert("Bad line in config file: \"" + line + "\"");
      return;
    }
    obj[ar[1].trim()] = ar[2].trim();
  }
  return obj;
};
Stdlib.readIniFile = function(fptr, obj) {
  if (!obj) {
    obj = {};
  }
  fptr = Stdlib.convertFptr(fptr);
  if (!fptr.exists) {
    return obj;
  }
  if (fptr.open("r", "TEXT", "????")) {
    fptr.lineFeed = "unix";
    fptr.encoding = Stdlib.INI_ENCODING;
    var str = fptr.read();
    fptr.close(); 
    return Stdlib.fromIniString(str, obj);
  }
  return obj;
};

Stdlib.readIniValue = function(fptr, nm) {
  var obj = Stdlib.readIniFile(fptr);
  return obj[nm];
};

Stdlib.writeIniValue = function(fptr, nm, val) {
  var obj = {};
  obj[nm] = val;
  Stdlib.updateIniFile(fptr, obj);
};

Stdlib.writeIniFile = function(fptr, obj, header) {
  var str = (header != undefined) ? header : '';

  str += Stdlib.toIniString(obj);

  var file = Stdlib.convertFptr(fptr);
  file.open("w", "TEXT", "????");
  file.encoding = Stdlib.INI_ENCODING;
  file.lineFeed = "unix";
  file.write(str);
  file.close();
};

Stdlib.updateIniFile = function(fptr, ini) {
  if (!ini || !fptr) {
    return;
  }
  var file = Stdlib.convertFptr(fptr);

  // we can only update the file if it exists
  var update = file.exists;
  var str = '';

  if (update) {
    file.open("r", "TEXT", "????");
    fptr.encoding = Stdlib.INI_ENCODING;
    file.lineFeed = "unix";
    str = file.read();
    file.close();
    
    for (var idx in ini) {
      if (idx.charAt(0) == '_') {         // private stuff
        continue;
      }
      if (idx == "noUI") {
        continue;
      }
      if (idx == "typename") {
        continue;
      }

      var val = ini[idx];

      if (typeof(val) == "undefined") {
        val = '';
      }
      
      if (typeof val == "string" ||
          typeof val == "number" ||
          typeof val == "boolean" ||
          typeof val == "object") {
        idx += ':';
        var re = RegExp('^' + idx, 'm');

        if (re.test(str)) {
          re = RegExp('^' + idx + '[^\n]*', 'm');
          str = str.replace(re, idx + ' ' + val);
        } else {
          str += '\n' + idx + ' ' + val;
        }
      }
    }
  } else {
    // write out a new ini file
    for (var idx in ini) {
      if (idx.charAt(0) == '_') {         // private stuff
        continue;
      }
      if (idx == "noUI") {
        continue;
      }
      if (idx == "typename") {
        continue;
      }
      var val = ini[idx];
      
      if (typeof val == "string" ||
          typeof val == "number" ||
          typeof val == "boolean" ||
          typeof val == "object") {
        str += (idx + ": " + val.toString() + "\n");
      }
    }
  }

  if (str) {
    file.open("w", "TEXT", "????");
    fptr.encoding = Stdlib.INI_ENCODING;
    file.lineFeed = "unix";
    file.write(str);
    file.close();
  }

  return ini;
};

Stdlib.xmlFromIni = function(ini, arg) {
  var xml;

  if (ini == undefined) {
    Error.runtimeError(2, "ini"); // isUndefined
  }

  if (arg) {
    if (arg.constructor.name == 'String') {
      xml = new XML('<' + arg + '></' + arg + '>');
    } else if (arg instanceof XML) {
      xml = arg;
    } else {
      Error.runtimeError(1243); // bad arg 2
    }
  } else {
    xml = new XML('Ini');
  }

  for (var idx in ini) {
    if (idx.charAt(0) == '_') {         // private stuff
      continue;
    }
    if (idx == "noUI") {
      continue;
    }
    if (idx == "typename") {
      continue;
    }
    var val = ini[idx];

    if (typeof val == "string" ||
        typeof val == "number" ||
        typeof val == "boolean" ||
        typeof val == "object") {
      xml[idx] = val;
    }
  }

  return xml;
};

Stdlib.iniFromXML = function(xml, ini) {
  if (!xml) {
    Error.runtimeError(2, "xml");
  }
  if (!ini) {
    ini = {};
  }

  var els = xml.elements();

  for (var i = 0; i < els.length(); i++) {
    var el = els[i];
    ini[el.name()] = el.toString();
  }

  return ini;
};

Stdlib.readXMLFile = function(fptr) {
  var file = Stdlib.convertFptr(fptr);
  if (!file.exists) {
    Error.runtimeError(48); // File/Folder does not exist
//     throw "Cannot find file: " + file.toUIString();
  }

  file.encoding = "UTF8";
  file.lineFeed = "unix";
  file.open("r", "TEXT", "????");
  var str = file.read();
  file.close();

  return new XML(str);
};

Stdlib.writeXMLFile = function(fptr, xml) {
  if (!(xml instanceof XML)) {
    Error.runtimeError(19, "xml"); // "Bad XML parameter";
  }
  var file = Stdlib.convertFptr(fptr);
  file.encoding = "UTF8";
  file.open("w", "TEXT", "????");
  // unicode signature, this is UTF16 but will convert to UTF8 "EF BB BF"
  file.write("\uFEFF"); 
  file.lineFeed = "unix";
  file.write(xml.toXMLString());
  file.close();
};

//
// If the CSV string has headers (default) an array of objects
// is returned using the headers as property names.
// If the CSV string does not have headers, an array of rows (Arrays)
// is returned
//
Stdlib.fromCSVString = function(str, ar, hasHeaders) {
  return Stdlib.fromCharSVString(str, ',', ar, hasHeaders);
};
Stdlib.readCSVFile = function(fptr, ar, hasHeaders) {
  return Stdlib.readCharSVFile(fptr, ',', ar, hasHeaders);
};
Stdlib.fromTSVString = function(str, ar, hasHeaders) {
  return Stdlib.fromCharSVString(str, '\t', ar, hasHeaders);
};
Stdlib.readTSVFile = function(fptr, ar, hasHeaders) {
  return Stdlib.readCharSVFile(fptr, '\t', ar, hasHeaders);
};
Stdlib.fromCharSVString = function(str, ch, ar, hasHeaders) {
  hasHeaders = !!hasHeaders;
  if (!ar) {
    ar = [];
  }
  var lines = str.split(/\r|\n/);
  if (lines.length == 0) {
    return ar;
  }

  // This doesn't work '([^",]+)|"((?:[^"]|"")*)"|,(?=(,|$))';
  var rexStr = '([^",]+)|"((?:[^"]|"")*)"|^,';

  if (ch != ',') {
    rexStr = rexStr.replace(/,/g, ch);
  }

  var rexp = new RegExp(rexStr);
  function parseCSVLine(line, ch) {
    var parts = [];
    line = line.trim();
    var res;

    while (line.length && (res = line.match(rexp)) != null) {
      if (res[1] || res[2]) {
        if (res[1]) {
          parts.push(res[1]);
        } else {
          parts.push(res[2].replace(/""/g, '"'));
        }
        line = line.slice(res[0].length + res.index);
        if (line[0] == ch) {
          line = line.slice(1);
        }
      } else {
        while (true) {
          if (line[0] == ch) {
            parts.push('');
            line = line.slice(1);
            continue;
          }
          if (line.startsWith('""')) {
            parts.push('');
            line = line.slice(2);
            if (line[0] == ch) {
              line = line.slice(1);
            }
            continue;
          }
          break;
        }
      }
    }
    return parts;
  }

  var headers = [];
  if (hasHeaders) {
    var line = lines[0].trim();
    headers = parseCSVLine(line, ch);
    lines.shift();
  }
  ar.headers = headers;

  if (lines.length == 0) {
    return ar;
  }

  for (var i = 0; i < lines.length; i++) {
    var row = parseCSVLine(lines[i], ch);
    if (row.length == 0) {
      continue;
    }

    if (hasHeaders) {
      var obj = new Object();
      for (var j = 0; j < row.length; j++) {
        if (headers[j]) {
          obj[headers[j]] = row[j] || '';
        } else {
          obj[j] = row[j] || '';
        }
      }
      ar.push(obj);

    } else {
      ar.push(row);
    }
  }
  return ar;
};
Stdlib.readCharSVFile = function(fptr, ch, ar, hasHeaders) {
  if (!ar) {
    ar = [];
  }
  fptr = Stdlib.convertFptr(fptr);
  if (!fptr.exists) {
    return ar;
  }
  var str = Stdlib.readFromFile(fptr);
  return Stdlib.fromCharSVString(str, ch, ar, hasHeaders);
};

// XXX This is untested
Stdlib.writeCSVFile = function(fptr, content, headers) {

 function arrayAsCSV(ar) {
    var str = '';
    for (var i = 0; i < ar.length; i++) {
      var v = ar[i];
      if (!isNumber(v)) {
        v = '\"' + v.replace(/"/g, '\"\"') + '\"';
        //");// needed for emacs syntax hilighting
        
      }
      str += v;
      if (i+1 != ar.length) {
        str += ',';
      }
    }

   return str;
  }

  fptr = Stdlib.convertFptr(fptr);
  
  if (!fptr.open("w", "TEXT", "????")) {
    Error.runtimeError(Stdlib.IO_ERROR_CODE,
                       "IOError: unable to open file \"" + fptr + "\": " +
                       fptr.error + '.');
  }
  
  if (headers) {
    fptr.writeln(arrayAsCSV(headers));
  }

  for (var i = 0; i < content.length; i++) {
    var row = content[i];
    fptr.writeln(arrayAsCSV(row));
  }

  fptr.close();
};


//
// The interactive parameter is not fully implemented
//
Stdlib.createFolder = function(fptr, interactive) {
  if (!fptr) {
    Error.runtimeError(19, "fptr");  // Bad Argument
  }

  if (fptr.constructor == String) {
    fptr = new Folder(fptr);
  }

  // XXX this needs testing
  if ((!fptr.exists || (fptr.parent && !fptr.parent.exists)) && interactive) {
    var f = (fptr instanceof File) ? fptr.parent : fptr;
    if (!confirm(f.toUIString() + " does not exist. Create?")) {
      return false;
    }
  }

  if (fptr instanceof File) {
    return Stdlib.createFolder(fptr.parent);
  }
  if (fptr.exists) {
    return true;
  }
  if (fptr.parent && !fptr.parent.exists) {
    if (!Stdlib.createFolder(fptr.parent)) {
      return false;
    }
  }
  return fptr.create();
};

Stdlib.log = function(msg) {
  var file;

  if (!Stdlib.log.enabled) {
    return;
  }

  if (!Stdlib.log.filename) {
    return;
  }

//   if (Stdlib.log.filename.endsWith(".ini")) {
//     debugger;
//     throw "Bad log file name";
//   }

  if (!Stdlib.log.fptr) {
    file = new File(Stdlib.log.filename);
    if (Stdlib.log.append && file.exists) {
      if (!file.open("e", "TEXT", "????"))  {
        Error.runtimeError(Stdlib.IO_ERROR_CODE,
                           "Unable to open log file(1) " +
                           file + ": " + file.error);
      }
      file.seek(0, 2); // jump to the end of the file

    } else {
      if (!file.open("w", "TEXT", "????")) {
        if (!file.open("e", "TEXT", "????")) {
          Error.runtimeError(Stdlib.IO_ERROR_CODE,
                             "Unable to open log file(2) " +
                             file + ": " +  file.error);
        }
        file.seek(0, 0); // jump to the beginning of the file
      }
    }
    Stdlib.log.fptr = file;

  } else {
    file = Stdlib.log.fptr;
    if (!file.open("e", "TEXT", "????"))  {
      Error.runtimeError(Stdlib.IO_ERROR_CODE,
                         "Unable to open log file(3) " +
                         file + ": " + file.error);
    }
    file.seek(0, 2); // jump to the end of the file
  }

  if (isMac()) {
    file.lineFeed = "Unix";
  }

  if (Stdlib.log.encoding) {
    file.encoding = Stdlib.log.encoding;
  }

  if (msg) {
    msg.toString();
  }
  
  if (!file.writeln(new Date().toISODateString() + " - " + msg)) {
    Error.runtimeError(Stdlib.IO_ERROR_CODE,
                       "Unable to write to log file(4) " +
                       file + ": " + file.error);
  }
  
  file.close();
};
Stdlib.log.filename = undefined; //"~/logfile.txt";
Stdlib.log.enabled = false;
Stdlib.log.append = false;
Stdlib.log.setFile = function(filename, encoding) {
  Stdlib.log.filename = filename;
  Stdlib.log.enabled = filename != undefined;
  Stdlib.log.encoding = encoding;
  Stdlib.log.fptr = undefined;
};
Stdlib.log.setFilename = Stdlib.log.setFile;

//
// Thanks to Bob Stucky for this...
//
Stdlib.exceptionMessage = function(e) {
  var str = '';
  var fname = (!e.fileName ? '???' : decodeURI(e.fileName));
  str += "   Message: " + e.message + '\n';
  str += "   File: " + fname + '\n';
  str += "   Line: " + (e.line || '???') + '\n';
  str += "   Error Name: " + e.name + '\n';
  str += "   Error Number: " + e.number + '\n';

  if (e.source) {
    var srcArray = e.source.split("\n");
    var a = e.line - 10;
    var b = e.line + 10;
    var c = e.line - 1;
    if (a < 0) {
      a = 0;
    }
    if (b > srcArray.length) {
      b = srcArray.length;
    }
    for ( var i = a; i < b; i++ ) {
      if ( i == c ) {
        str += "   Line: (" + (i + 1) + ") >> " + srcArray[i] + '\n';
      } else {
        str += "   Line: (" + (i + 1) + ")    " + srcArray[i] + '\n';
      }
    }
  }

  if ($.stack) {
    str += '\n' + $.stack + '\n';
  }

  return str;
};

Stdlib.logException = function(e, msg, doAlert) {
  if (!Stdlib.log.enabled) {
    return;
  }

  if (doAlert == undefined) {
    doAlert = false;

    if (msg == undefined) {
      msg = '';
    } else if (isBoolean(msg)) {
      doAlert = msg;
      msg = '';
    }
  }

  doAlert = !!doAlert;

  var str = ((msg || '') + "\n" +
             "==============Exception==============\n" +
             Stdlib.exceptionMessage(e) +
             "==============End Exception==============\n");

  Stdlib.log(str);

  if (doAlert) {
    str += ("\r\rMore information can be found in the file:\r" +
            "    " + Stdlib.log.fptr.toUIString());

    alert(str);
  }
};


//
//========================= Photoshop - General ==============================
//

//
// Return an item called 'name' from the specified container.
// This works for the "magic" on PS containers like Documents.getByName(),
// for instance. However this returns null if an index is not found instead
// of throwing an exception.
//
// The 'name' argument can also be a regular expression.
// If 'all' is set to true, it will return all matches
//
Stdlib.getByName = function(container, name, all) {
  // check for a bad index
  if (!name) {
    Error.runtimeError(2, "name"); // "'undefined' is an invalid name/index");
  }

  var matchFtn;

  if (name instanceof RegExp) {
    matchFtn = function(s1, re) { return s1.match(re) != null; }
  } else {
    matchFtn = function(s1, s2) { return s1 == s2;  }
  }

  var obj = [];

  for (var i = 0; i < container.length; i++) {
    if (matchFtn(container[i].name, name)) {
      if (!all) {
        return container[i];     // there can be only one!
      }
      obj.push(container[i]);    // add it to the list
    }
  }

  return all ? obj : undefined;
};

//
// Returns all items in the container with the specified name.
//
Stdlib.getAllByName = function(container, name) {
  return Stdlib.getByName(container, name, true);
};

Stdlib.getByProperty = function(container, prop, value, all) {
  // check for a bad index
  if (prop == undefined) {
    Error.runtimeError(2, "prop");
  }
  if (value == undefined) {
    Error.runtimeError(2, "value");
  }
  var matchFtn;

  if (value instanceof RegExp) {
    matchFtn = function(s1, re) { return s1.match(re) != null; }
  } else {
    matchFtn = function(s1, s2) { return s1 == s2;  }
  }

  var obj = [];

  for (var i = 0; i < container.length; i++) {
    if (matchFtn(container[i][prop], value)) {
      if (!all) {
        return container[i];     // there can be only one!
      }
      obj.push(container[i]);    // add it to the list
    }
  }

  return all ? obj : undefined;
};

//
// Stdlib.getByFunction
//   Return an element (or elements) of the container where the match function
//     returns 'true'
//
// Stdlib.getByFunction(doc.artLayers, function(layer) {
//   return layer.name.length > 10; }, true)
//
Stdlib.getByFunction = function(container, matchFtn, all) {
  // check for a match function
  if (!matchFtn) {
    Error.runtimeError(2, "matchFtn"); //"'undefined' is an invalid function"
  }

  if (typeof matchFtn != "function") {
    Error(19, "matchFtn"); // Bad arg "A match function must be specified"
  }

  var obj = [];

  for (var i = 0; i < container.length; i++) {
    if (matchFtn(container[i])) {
      if (!all) {
        return container[i];     // there can be only one!
      }
      obj.push(container[i]);    // add it to the list
    }
  }

  return all ? obj : undefined;
};

Stdlib.setPropertyValues = function(container, prop, value) {
  // check for a bad index
  if (prop == undefined) {
    Error.runtimeError(2, "prop");
  }
  if (value == undefined) {
    Error.runtimeError(2, "value");
  }
  var matchFtn;

  var obj = [];

  for (var i = 0; i < container.length; i++) {
    container[i][prop] = value;
  }

  return;
};


Stdlib.sortByName = function(ary) {
  function nameCmp(a, b) {
    if (a.name < b.name) {
      return -1;
    } else if (a.name > b.name) {
      return 1;
    }
    return 0;
  }

  return ary.sort(nameCmp);
};


// makeActive
// Make the object (regardless of class) the 'active' one. Currently, this
// works for documents and layers. The one that was active before this call
// is returned
//
Stdlib.makeActive = function(obj) {
  var prev = undefined;

  if (!obj) {
    return undefined;
  }

  if (obj.typename == "Document") {
    prev = app.activeDocument;
    if (obj != prev) {
      app.activeDocument = obj;
    }
  } else if (obj.typename.match(/Layer/)) {
    var doc = obj.parent;
    while (!(doc.typename == "Document") && doc) {
      doc = doc.parent;
    }
    if (!doc) {
      Error.runtimeError(19, "obj"); // "Bad Layer object specified"
    }
    prev = doc.activeLayer;
    if (obj != prev) {
      doc.activeLayer = obj;
    }
  }

  return prev;
};

//
// ScriptingListener code operates on the "active" document.
// There are times, however, when that is _not_ what I want.
// This wrapper will make the specified document the active
// document for the duration of the ScriptingListener code and
// swaps in the previous active document as needed
//
Stdlib.wrapLC = function(doc, ftn) {
  var ad = app.activeDocument;
  if (doc) {
    if (ad != doc) {
      app.activeDocument = doc;
    }
  } else {
    doc = ad;
  }

  var res = undefined;
  try {
    res = ftn(doc);
  } finally {
    if (ad && app.activeDocument != ad) {
      app.activeDocument = ad;
    }
  }

  return res;
};

//
// The same as wrapLC except it permits specifying a layer
//
Stdlib.wrapLCLayer = function(doc, layer, ftn) {
  var ad = app.activeDocument;
  if (doc) {
    if (ad != doc) {
      app.activeDocument = doc;
    }
  } else {
    doc = ad;
  }
  
  var al = doc.activeLayer;
  var alvis = al.visible;

  if (layer && doc.activeLayer != layer) {
    doc.activeLayer = layer;
  } else {
    layer = doc.activeLayer;
  }

  var res = undefined;

  try {
    res = ftn(doc, layer);

  } finally {
    if (doc.activeLayer != al) {
      doc.activeLayer = al;
    }
    if (!doc.activeLayer.isBackgroundLayer) {
      doc.activeLayer.visible = alvis;
    }

    if (app.activeDocument != ad) {
      app.activeDocument = ad;
    }
  }

  return res;
};

//
// Invoke a Photoshop Event with no arguments
//
Stdlib.doEvent = function(doc, eid, interactive, noDesc) {
  var id;

  if (doc != undefined && eid == undefined) {
    if (doc.constructor == Number) {
      eid = doc.valueOf();
    } else if (doc.constructor == String) {
      eid = doc;
    }
    doc = undefined;
  }

  if (!eid) {
    Error.runtimeError(8600); // Event key is missing "No event id specified");
  }

  if (eid.constructor != Number) {
    if (eid.length < 4) {
      // "Event id must be at least 4 characters long"
      Error.runtimeError(19, "eventID");
    }

    if (eid.length == 4) {
      id = cTID(eid);
    } else {
      id = sTID(eid);
    }
  } else {
    id  = eid;
  }

  interactive = interactive == true;
  noDesc = noDesc == true;

  function _ftn() {
    var dmode = (interactive ? DialogModes.ALL : DialogModes.NO);
    var desc = (noDesc ? undefined : new ActionDescriptor());
    return app.executeAction(id, desc, dmode);
  }

  if (doc) {
    return Stdlib.wrapLC(doc, _ftn);
  } else {
    return _ftn(id);
  }
};

//
// Select/invoke a menu item
//
Stdlib.doMenuItem = function(item, interactive) {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();

  if (item.constructor == String) {
    item = xTID(item);
  }

//  ref.putEnumerated(PSClass.MenuItem, PSType.MenuItem, item);
  ref.putEnumerated(cTID("Mn  "), cTID("MnIt"), item);
  desc.putReference(cTID("null"), ref);

  var lvl = $.level;
  $.level = 0;
  try {
    var mode = (interactive != true ? DialogModes.NO : DialogModes.ALL);
//     executeAction(PSString.select, desc, mode);
    executeAction(sTID("select"), desc, mode);
  } catch (e) {
    $.level = lvl;
    if (e.number != 8007) { // if not "User cancelled"
      throw e;
    } else {
      return false;
    }
  }
  $.level = lvl;

  return true;
};

Stdlib._print = function() {
  var dialogMode = DialogModes.NO;
  var desc1 = new ActionDescriptor();
  desc1.putBoolean(cTID('PstS'), true);
  desc1.putEnumerated(cTID('Inte'), cTID('Inte'), cTID('Clrm'));
  executeAction(cTID('Prnt'), desc1, dialogMode);
};


//
// Select a tool from the tool palette
//   PSString.addKnotTool
//   PSString.artBrushTool
//   PSString.bucketTool
//   PSString.colorReplacementBrushTool
//   PSString.colorSamplerTool
//   PSString.convertKnotTool
//   PSString.cropTool
//   PSString.customShapeTool
//   PSString.deleteKnotTool
//   PSString.directSelectTool
//   PSString.ellipseTool
//   PSString.eyedropperTool
//   PSString.freeformPenTool
//   PSString.handTool
//   PSString.lassoTool
//   PSString.lineTool
//   PSString.magicStampTool
//   PSString.magicWandTool
//   PSString.magneticLassoTool
//   PSString.marqueeEllipTool
//   PSString.marqueeRectTool
//   PSString.marqueeSingleColumnTool
//   PSString.marqueeSingleRowTool
//   PSString.measureTool
//   PSString.moveTool
//   PSString.pathComponentSelectTool
//   PSString.penTool
//   PSString.polySelTool
//   PSString.polygonTool
//   PSString.rectangleTool
//   PSString.redEyeTool
//   PSString.roundedRectangleTool
//   PSString.sliceSelectTool
//   PSString.sliceTool
//   PSString.soundAnnotTool
//   PSString.spotHealingBrushTool
//   PSString.textAnnotTool 
//   PSString.typeCreateMaskTool
//   PSString.typeCreateOrEditTool
//   PSString.typeVerticalCreateMaskTool
//   PSString.typeVerticalCreateOrEditTool
//   PSString.zoomTool
//
//   PSClass.ArtHistoryBrushTool
//   PSClass.BackgroundEraserTool
//   PSClass.BlurTool
//   PSClass.BurnInTool
//   PSClass.CloneStampTool
//   PSClass.DodgeTool
//   PSClass.EraserTool
//   PSClass.GradientTool
//   PSClass.HistoryBrushTool
//   PSClass.MagicEraserTool
//   PSClass.PaintbrushTool
//   PSClass.PatternStampTool
//   PSClass.PencilTool
//   PSClass.SaturationTool
//   PSClass.SharpenTool
//   PSClass.SmudgeTool
//
Stdlib.selectTool = function(tool) {

  if (!Stdlib.selectTool.map) {
    var map = {};
    map[ToolType.ARTHISTORYBRUSH] = cTID('ABTl'); // ArtHistoryBrushTool;
    map[ToolType.BACKGROUNDERASER] = cTID('SETl'); // BackgroundEraserTool;
    map[ToolType.BLUR] = cTID('BlTl'); // BlurTool;
    map[ToolType.BRUSH] = cTID('PbTl'); // PaintbrushTool;
    map[ToolType.BURN] = cTID('BrTl'); // BurnInTool;
    map[ToolType.CLONESTAMP] = cTID('ClTl'); // CloneStampTool;
    map[ToolType.COLORREPLACMENTTOOL] = sTID('colorReplacementTool');
    map[ToolType.DODGE] = cTID('DdTl'); // DodgeTool;
    map[ToolType.ERASER] = cTID('ErTl'); // EraserTool;
    map[ToolType.HEALINGBRUSH] = sTID('magicStampTool');
    map[ToolType.HISTORYBRUSH] = cTID('HBTl'); // HistoryBrushTool;
    map[ToolType.PATTERNSTAMP] = cTID('PaTl'); // PatternStampTool;
    map[ToolType.PENCIL] = cTID('PcTl'); // PencilTool;
    map[ToolType.SHARPEN] = cTID('ShTl'); // SharpenTool;
    map[ToolType.SMUDGE] = cTID('SmTl'); // SmudgeTool;
    Stdlib.selectTool.map = map;
  }

  var toolID;

  if (tool.toString().startsWith('ToolType')) {
    var tid = Stdlib.selectTool.map[tool];

    if (tid == undefined) {
      var ttype = {};
      ttype._name = tool.substring(9);
      ttype.toString = function() {
        return "ToolType." + this._name.toUpperCase();
      }
      ToolType[ttype._name] = ttype;
      
      Stdlib.selectTool.map[ToolType[ttype._name]] = xTID(ttype._name);
      tid = Stdlib.selectTool.map[tool];
    }
    toolID = tid;

  } else {
    toolID = xTID(tool);
  }

  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putClass(tool);
  desc.putReference(cTID('null'), ref);
  executeAction(PSEvent.Select, desc, DialogModes.NO);
};

Stdlib.zoomIn = function() {
  Stdlib.doMenuItem("ZmIn");
};
Stdlib.zoomOut = function() {
  Stdlib.doMenuItem("ZmOt");
};
Stdlib.zoomActualPixels = function() {
  Stdlib.doMenuItem("ActP");
};
Stdlib.zoomFitOnScreen = function() {
  Stdlib.doMenuItem("FtOn");
};
Stdlib.zoomPrintSize = function() {
  Stdlib.doMenuItem("PrnS");
};

Stdlib.resetSwatches = function() {
  var desc26 = new ActionDescriptor();
  var ref16 = new ActionReference();
  ref16.putProperty( cTID('Clr '), cTID('Clrs') );
  desc26.putReference( cTID('null'), ref16 );
  executeAction( cTID('Rset'), desc26, DialogModes.NO );
};


//
//================================== Document =================================
//

//
// Create a new document with the name, mode, etc..., specified
//
Stdlib.newDocument = function(name, mode, width, height, resolution,
                              depth, colorProfile) {

// Stdlib.newDocument("bbb.psd", "RGBM", 250, 500, 72, 16)

  function _ftn(name, mode, width, height, resolution, depth) {
    var desc = new ActionDescriptor();
    desc.putString(cTID("Nm  "), name);
    desc.putClass(cTID("Md  "), cTID(mode));
    desc.putUnitDouble(cTID("Wdth"), cTID("#Rlt"), width);
    desc.putUnitDouble(cTID("Hght"), cTID("#Rlt"), height);
    desc.putUnitDouble(cTID("Rslt"), cTID("#Rsl"), resolution);
    desc.putDouble(sTID("pixelScaleFactor"), 1.000000 );
    desc.putEnumerated(cTID("Fl  "), cTID("Fl  "), cTID("Wht "));
    desc.putInteger(cTID("Dpth"), depth );
    desc.putString(sTID("profile"), colorProfile);

    var mkdesc = new ActionDescriptor();
    mkdesc.putObject(cTID("Nw  "), cTID("Dcmn"), desc);
    executeAction(cTID("Mk  "), mkdesc, DialogModes.NO );
  }

  if (!colorProfile) {
    colorProfile = ColorProfileNames.SRGB;
  }

  _ftn(name, mode, width, height, resolution, depth);
  return app.activeDocument;
};

Stdlib.newDocumentFromClipboard = function(name) {
  function _newDoc() {
    var desc2 = new ActionDescriptor();
    var desc3 = new ActionDescriptor();
    if (name) {
      desc3.putString( cTID('Nm  '), "Name-XXX" );
    }
    desc3.putString( sTID('preset'), "Clipboard" );
    desc2.putObject( cTID('Nw  '), cTID('Dcmn'), desc3 );
    executeAction( cTID('Mk  '), desc2, DialogModes.NO );
  };

  function _paste() {
    var desc = new ActionDescriptor();   // AntiAlias
    desc.putEnumerated(cTID("AntA"), cTID("Annt"), cTID("Anno"));
    executeAction(cTID("past"), desc, DialogModes.NO);
  }

  _newDoc();
  _paste();

  return app.activeDocument;
};

//
// Stdlib.getObjectProperty
//   Return the value of a PS object's properties from the underlying
//     ActionDescriptor-based definition.
//   Returns 'undefined' if the property's value cannot be determined
//   This api currently only works on Application, Document, and
//   Layer-family objects.
//   Lower level apis make it possible to access other kinds of objects.
//
// Examples:
// var str = Stdlib.getObjectProperty(0, "Nm  ", "Lyr ")
// var bool = Stdlib.getObjectProperty(doc.activeLayer, "Vsbl", "Lyr ")
// var str = Stdlib.getObjectProperty(doc, 'Ttl ');
// var file = Stdlib.getObjectProperty(app, 'Path');
// var clrDesc = Stdlib.getObjectProperty(app, 'FrgC');
//
Stdlib.getObjectProperty = function(obj, prop, typ) {
  var val = Stdlib._getObjProperty(obj, prop, typ);

  return (val ? val.value : undefined);
};

// Stdlib.getObjectPropertyType
//   For UnitDouble, return the type
//   For Object, return the classId
//   For Enumerated, return the enumerationTypeId
//   All else, return undefined
//
Stdlib.getObjectPropertyType = function(obj, prop, typ) {
  var val = Stdlib._getObjProperty(obj, prop, typ);

  return (val ? val.type : undefined);
};
//
// Stdlib._getObjProperty
//   Returns an object with value and (optional) type of the property.
//   The 'typ' can be used when accessing an object type that this
//   function does not already understand
//
Stdlib._getObjProperty = function(obj, prop, typ) {
  var propId;
  var otyp;

  function _ftn(obj, propId, otyp) {
    var ref = new ActionReference();
    ref.putProperty(cTID("Prpr"), propId);

    if (typeof(obj) == "number") {
      ref.putIndex(cTID(otyp), obj);
    } else {
      ref.putEnumerated(cTID(otyp), cTID("Ordn"), cTID("Trgt") );
    }

    var desc;
    try {
      desc = executeActionGet(ref);
    } catch (e) {
      return undefined;
    } 
    var val = {};

    if (desc.hasKey(propId)) {
      var typ = desc.getType(propId);
      switch (typ) {
        case DescValueType.ALIASTYPE:
          val.value = desc.getPath(propId); break;
        case DescValueType.BOOLEANTYPE:
          val.value = desc.getBoolean(propId); break;
        case DescValueType.CLASSTYPE:
          val.value = desc.getClass(propId); break;
        case DescValueType.DOUBLETYPE:
          val.value = desc.getDouble(propId); break;
        case DescValueType.ENUMERATEDTYPE:  
          val.value = desc.getEnumeratedValue(propId);
          val.type = desc.getEnumeratedType(propId);
          break;o
        case DescValueType.INTEGERTYPE:
          val.value = desc.getInteger(propId); break;
        case DescValueType.LISTTYPE:
          val.value = desc.getList(propId); break;
        case DescValueType.OBJECTTYPE:
          val.value = desc.getObjectValue(propId);
          val.type = desc.getObjectType(propId);
          break;
        case DescValueType.RAWTYPE:
          val.value = desc.getData(propId); break;
        case DescValueType.REFERENCETYPE:
          val.value = desc.getReference(propId); break;
        case DescValueType.STRINGTYPE:
          val.value = desc.getString(propId); break;
        case DescValueType.UNITDOUBLE:
          val.value = desc.getUnitDoubleValue(propId);
          val.type = desc.getUnitDoubleType(propId);
          break;
      }
    }
    return val;
  }

  if (obj == undefined) {
    Error.runtimeError(2, "object");
  }
  if (prop == undefined) {
    Error.runtimeError(2, "property");
  }

  if (prop.constructor == String) {
    propId = xTID(prop);
  } else if (prop.constructor == Number) {
    propId = prop;
  } else {
    Error.runtimeError(19, "property");
  }

  var val; // {value: undefind, type: undefined}

  //$.level = 1; debugger;

  if (app.documents.length > 0) {
    var o_doc = app.activeDocument;   // active doc before this function
    var o_layer = o_doc.activeLayer;  // active layer before this function
  }

  if (typeof(obj) == "object") {
    if (typ == "Dcmn" || obj.typename == "Document") {
      otyp = "Dcmn";
      if (app.activeDocument != obj) {
        o_doc = app.activeDocument;
        app.activeDocument = obj;
      }

    } else if (typ == "Lyr " || obj.typename == "ArtLayer"
               || obj.typename == "LayerSet") {
      otyp = "Lyr ";
      var layer = obj;
      while(layer.parent != undefined &&
            layer.parent.typename != "Document") {
        layer = layer.parent;
      }
      if (app.activeDocument != layer.parent) {
        app.activeDocument = layer.parent;
      }
      if (layer.parent.activeLayer != layer) {
        layer.parent.activeLayer = layer;
      }
        
    } else if (typ == "capp" || obj.typename == "Application") {
      otyp = "capp";

    } else {
      Error.runtimeError(55, prop);
//       throw ("Unable to get property from " +
//              (obj.typename ? obj.typename : "unknown") +
//              " type of object.");
    }
  } else if (typeof(obj) == "number") {
    if (!typ) {
      Error.runtimeError(55, prop);
//       throw ("Unable to get property from unknown type of object");
    }
    if (typ != "Lyr " && typ != "Dcmn") {
      Error.runtimeError(9001,
                         "Indexed app operations are not yet supported.");
    }
    otyp = typ;
  }

  var val = _ftn(obj, propId, otyp);

  if (app.documents.length > 0) {
    if (o_doc.activeLayer != o_layer) {
      o_doc.activeLayer = o_layer;
    }
    if (app.activeDocument != o_doc) {
      app.activeDocument = o_doc;
    }
  }

  return val;
};

Stdlib.getLayerProperty = function(index, propSym) {
  return Stdlib.getObjectProperty(index, propSym, 'Lyr ');
};
Stdlib.getDocumentProperty = function(index, propSym) {
  return Stdlib.getObjectProperty(index, propSym, 'Dcmn');
};
Stdlib.getApplicationProperty = function(propSym) {
  return Stdlib.getObjectProperty(app, propSym);
};

//
// Duplicate an existing document and use the name specified.
// Optionally merge the layers
//
Stdlib.duplicateDocument = function(doc, name, merged) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated(cTID("Dcmn"), cTID("Ordn"), cTID("Trgt"));
    desc.putReference(cTID("null"), ref );

    if (name) {
      desc.putString(cTID("Nm  "), name);
    }
    if (merged == true) {
      desc.putBoolean(cTID("Mrgd"), true);
    }
    executeAction(cTID("Dplc"), desc, DialogModes.NO );
    return app.activeDocument;
  }

  return Stdlib.wrapLC(doc, _ftn);
};

Stdlib.getDocumentDescriptor = function(doc) {
  function _ftn() {
    var ref = new ActionReference();
    ref.putEnumerated( cTID("Dcmn"),
                       cTID("Ordn"),
                       cTID("Trgt") );  //activeDoc
    return executeActionGet(ref);
  }

  return Stdlib.wrapLC(doc, _ftn);
};

Stdlib.getDocumentIndex = function(doc) {
  return Stdlib.getDocumentProperty(doc, cTID('ItmI'));
};


Stdlib.isDocumentNew = function(doc){
  var desc = Stdlib.getDocumentDescriptor(doc);
  var rc = true;
  if (desc.hasKey(cTID("FilR"))) {  //FileReference
    var path = desc.getPath(cTID("FilR"));
    if (path) {
      rc = (path.absoluteURI.length == 0);
    }
  }
  return rc;
};

Stdlib.hasBackground = function(doc) {
   return doc.layers[doc.layers.length-1].isBackgroundLayer;

//   // Mike Hale's version...
//   function _ftn() {
//     var ref = new ActionReference();
//     ref.putProperty(cTID("Prpr"), cTID("Bckg"));
//     //bottom Layer/background
//     ref.putEnumerated(cTID("Lyr "),cTID("Ordn"),cTID("Back"));
//     var desc =  executeActionGet(ref);
//     var res = desc.getBoolean(cTID("Bckg"));
//     return res;
//   }; 

//   return Stdlib.wrapLC(doc, _ftn);


//   // or
//   try {
//     doc.backgroundLayer;
//     return true;
//   } catch (e) {
//     return false;
//   }
};
Stdlib.hasBackgroundLayer = Stdlib.hasBackground;

//
// Returns true if the file is an open document
//
Stdlib.isDocumentOpen = function(file) {
  if (file && (app.documents.length > 0)) {
    var doc = Stdlib.getByName(app.documents, file.name) 
    if (doc) {
      return file == doc.fullName;
    }
  }
  return false;
};

Stdlib.getDocumentName = function(doc) {
  function _ftn() {
    var ref = new ActionReference();
    ref.putProperty(cTID('Prpr'), cTID('FilR'));
    ref.putEnumerated(cTID('Dcmn'), cTID('Ordn'), cTID('Trgt'));
    var desc = executeActionGet(ref);
    return desc.hasKey(cTID('FilR')) ? desc.getPath(cTID('FilR')) : undefined;
  }
  return Stdlib.wrapLC(doc, _ftn);
};
Stdlib.getDocumentFile = function(doc) {
  return Stdlib.getDocumentName(doc);
};

//
// Revert the document, or active document if one isn't specified
//
Stdlib.revertDocument = function(doc) {
  Stdlib.doEvent(doc, "Rvrt");
};

Stdlib.isLandscapeMode = function(obj) {
  var ru = app.preferences.rulerUnits;
  app.preferences.rulerUnits = Units.PIXELS;
  
  var rc = obj.width.value > obj.height.value;
  app.preferences.rulerUnits = ru;
  return rc;
};
Stdlib.isPortraitMode = function(obj) {
  var ru = app.preferences.rulerUnits;
  app.preferences.rulerUnits = Units.PIXELS;
  
  var rc = obj.width.value < obj.height.value;
  app.preferences.rulerUnits = ru;
  return rc;
};
Stdlib.isSquareMode = function(obj) {
  var ru = app.preferences.rulerUnits;
  app.preferences.rulerUnits = Units.PIXELS;
  
  var rc = obj.width.value == obj.height.value;
  app.preferences.rulerUnits = ru;
  return rc;
};

Stdlib.validateUnitValue = function(str, bu, ru) {
  var self = this;

  if (str instanceof UnitValue) {
    return str;
  }

  if (bu && bu instanceof Document) {
    var doc = bu;
    ru = doc.width.type;
    bu = UnitValue(1/doc.resolution, ru);

  } else {
    if (!ru) {
      ru = Stdlib.getDefaultRulerUnitsString();
    }
    if (!bu) {
      UnitValue.baseUnit = UnitValue(1/72, ru);
    }
  }
  str = str.toString();

  var zero = new UnitValue("0 " + ru);
  var un = zero;
  if (!str.match(/[a-z%]+/)) {
    str += ' ' + ru.units;
  }
  un = new UnitValue(str);

  if (isNaN(un.value) || un.type == '?') {
    return undefined;
  }

  if (un.value == 0) {
    un = zero;
  }

  return un;
};

//
// Pops open a standard File Open Dialog and returns a Document or
// null if none is selected
// This is primarily for PS7 which does not have File.openDialog
//
Stdlib.openDialogPS7 = function(folder) {
  return Stdlib.selectImageFile(folder);
}

//
// selectImageFile will open a dialog on the folder it chooses,
// totally ignoring the default.
//
Stdlib.selectImageFile = function(file) {
  var ad;
  var doc = undefined;

  if (documents.length) {
    ad = app.activeDocument;
  }

  if (!file) {
    file = Folder.current;
  } else {
    file = Stdlib.convertFptr(file);
    if (!file.exists) {
      file = file.parent;
    }
  }
  if (file instanceof Folder) {
    var files = Stdlib.getImageFiles(file, false, true);
    if (files.length > 0) {
      file = files[0];
    } else {
      file = new File(file + "/untitled.psd");
    }
  }

  try {
    var desc = new ActionDescriptor();
    Folder.current = file.parent;
    desc.putPath( cTID('null'), file); 
    executeAction(cTID("Opn "), desc, DialogModes.ALL);

  } catch (e) {
    throw e;
  }

  if (ad != app.activeDocument) {
    doc = app.activeDocument;
  }

  return doc;
};

//
// Paste the contents of the clipboard into the doc with antialias off
//
Stdlib.pasteInto = function(doc) {
  function _ftn() {
    var desc = new ActionDescriptor();   // AntiAlias
    desc.putEnumerated(cTID("AntA"), cTID("Annt"), cTID("Anno"));
    executeAction(cTID("PstI"), desc, DialogModes.NO);
  }
  Stdlib.wrapLC(doc, _ftn);
};


//
// Make it a Document object method
//
// Document.prototype.revert = function() {
//   Stdlib.revertDocument(this);
// };

//============================= History  ===============================
//
// Thanks to Andrew Hall for the idea
// Added named snapshot support
//
Stdlib.takeSnapshot = function(doc, sname) {
  function _ftn() {
    var desc = new ActionDescriptor();  // Make

    var sref = new ActionReference();   // Snapshot
    sref.putClass(cTID("SnpS"));
    desc.putReference(cTID("null"), sref);

    var fref = new ActionReference();    // Current History State
    fref.putProperty(cTID("HstS"), cTID("CrnH"));
    desc.putReference(cTID("From"), fref );

    if (sname) {                         // Named snapshot
      desc.putString(cTID("Nm  "), sname);
    }
    
    desc.putEnumerated(cTID("Usng"), cTID("HstS"), cTID("FllD"));
    executeAction(cTID("Mk  "), desc, DialogModes.NO );
  }

  Stdlib.wrapLC(doc, _ftn);
};

//
// Revert to named snapshot
//
Stdlib.revertToSnapshot = function(doc, sname) {
  function _ftn() {
    if (!sname) {
      return Stdlib.revertToLastSnapshot(doc);
    }
    var state = Stdlib.getByName(doc.historyStates, sname);
    if (state) {
      doc.activeHistoryState = state;
      return true;
    }
    return false;
  }
  return Stdlib.wrapLC(doc, _ftn);
};

//
// Revert to the last auto-named snapshot
//
Stdlib.revertToLastSnapshot = function(doc) {
  function _ftn() {
    var states = Stdlib.getByName(doc.historyStates, /^Snapshot /, true);
    if (states.length > 0) {
      doc.activeHistoryState = states.pop();
      return true;
    }
    return false;
  }
  return Stdlib.wrapLC(doc, _ftn);
};

Stdlib.deleteSnapshot = function(doc, name) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putName(cTID('SnpS'), name);
    desc.putReference(cTID('null'), ref);
    executeAction(cTID('Dlt '), desc, DialogModes.NO ); 
  }
  return Stdlib.wrapLC(doc, _ftn);

//   function _deleteCurrent() {
//     var ref = new ActionReference();
//     ref.putProperty(cTID("HstS"), cTID("CrnH"));

//     var desc = new ActionDescriptor();
//     desc.putReference(cTID("null"), ref );
//     executeAction(cTID("Dlt "), desc, DialogModes.NO );
//   };

//   var state = doc.activeHistoryState;
//   if (!Stdlib.revertToSnapshot(doc, name)) {
//     return false;
//   }
//   try {
//     _deleteCurrent(doc, name);
//   } finally {
//     var level = $.level;
//     try { 
//       $.level = 0;
//       doc.activeHistoryState = state;
//     } catch (e) {
//     }
//     $.level = level;
//   }
//   return true;
};

Stdlib.hist = function(dir) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated(cTID("HstS"), cTID("Ordn"), cTID(dir));
    desc.putReference(cTID("null"), ref);
    executeAction(cTID("slct"), desc, DialogModes.NO);
  }

  _ftn();
};
Stdlib.undo = function () {
  Stdlib.hist("Prvs");
};
Stdlib.redo = function () {
  Stdlib.hist("Nxt ");
};
Stdlib.Undo = function () {
  Stdlib.doEvent("undo");
};
Stdlib.Redo = function () {
  Stdlib.doEvent(sTID('redo'));
};



//
//================================== Layers ===================================
//
Stdlib.convertTextLayerToShape = function(doc, layer) {
  function _ftn() {
    if (layer.kind != LayerKind.TEXT) {
      Error.runtimeError(8177);  // Layer is not a text layer
//       throw "Cannot convert non-text layers to shapes.";
    }

    var desc = new ActionDescriptor();
    var cref = new ActionReference();
    cref.putClass( sTID('contentLayer') );
    desc.putReference( cTID('null'), cref );
    var lref = new ActionReference();
    lref.putEnumerated( cTID('TxLr'), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('Usng'), lref );
    executeAction( cTID('Mk  '), desc, DialogModes.NO );
  }
  Stdlib.makeActive(doc);
  Stdlib.makeActive(layer);
  _ftn();
  return doc.activeLayer;
};
Stdlib.copyLayerToDocument = function(doc, layer, otherDoc) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var fref = new ActionReference();
    fref.putEnumerated(cTID('Lyr '), cTID('Ordn'), cTID('Trgt'));
    desc.putReference(cTID('null'), fref);
    var tref = new ActionReference();
    tref.putName(cTID('Dcmn'), otherDoc.name);
    desc.putReference(cTID('T   '), tref);
    desc.putInteger(cTID('Vrsn'), 2 );
    executeAction(cTID('Dplc'), desc, DialogModes.NO);
  };

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.convertToSmartLayer = function(doc, layer) {
  function _ftn() {
    Stdlib.doEvent(sTID('newPlacedLayer'));
  }
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.getSmartObjectType = function(doc, layer) {

  function _ftn() {
    var type = undefined;
    var ref = new ActionReference();
    ref.putEnumerated(cTID('Lyr '), cTID('Ordn'), sTID('Trgt') );
    var desc = executeActionGet(ref);
    if (desc.hasKey(sTID('smartObject'))){// is smart object?
      var desc = executeActionGet(ref);
      var smObj = desc.getObjectValue(sTID('smartObject'));
      var place = smObj.getEnumerationValue(sTID('placed'));
      type = id2char(place);
    }
  }

  var typ = Stdlib.wrapLCLayer(doc, layer, _ftn);

  return typ;
};

Stdlib.editSmartObject = function(doc, layer) {
  function _ftn() {
    var id21 = sTID( "placedLayerEditContents" );
    var desc7 = new ActionDescriptor();
    executeAction( id21, desc7, DialogModes.NO );
  }
  Stdlib.makeActive(doc);
  Stdlib.makeActive(layer);
  _ftn();
  return app.activeDocument;
};

Stdlib.updateSmartLayer = function(doc, layer) {
  function _ftn() {
    executeAction(sTID('updatePlacedLayer'), undefined, DialogModes.NO);
  };

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

//
// Traverse the all layers, including nested layers, executing
// the specified function. Traversal can happen in both directions.
//
Stdlib.traverseLayers = function(doc, ftn, reverse, layerSets) {

  function _traverse(doc, layers, ftn, reverse, layerSets) {
    var ok = true;
    for (var i = 1; i <= layers.length && ok != false; i++) {
      var index = (reverse == true) ? layers.length-i : i - 1;
      var layer = layers[index];

      if (layer.typename == "LayerSet") {
        if (layerSets) {
          ok = ftn(doc, layer);
        }
        if (ok) {
          ok = _traverse(doc, layer.layers, ftn, reverse, layerSets);
        }
      } else {
        ok = ftn(doc, layer);
        try {
          if (app.activeDocument != doc) {
            app.activeDocument = doc;
          }
        } catch (e) {
        }
      }
    }
    return ok;
  };

  return _traverse(doc, doc.layers, ftn, reverse, layerSets);
};

Stdlib.getLayersList = function(doc, reverse, layerSets) {
  function _ftn(doc, layer) {
    _ftn.list.push(layer);
    return true;
  };

  _ftn.list = [];
  Stdlib.traverseLayers(doc, _ftn, reverse, layerSets);

  var lst = _ftn.list;
  _ftn.list = undefined;
  return lst;
};

Stdlib.getVisibleLayers = function(doc) {
  var layers = Stdlib.getLayersList(doc);
  return Stdlib.getByProperty(layers, "visible", true, true);
};

Stdlib._setSelLayerVis = function(doc, state) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var list = new ActionList();
    var ref = new ActionReference();

    ref.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    list.putReference(ref);
    desc.putList(cTID('null'),  list);

    executeAction(cTID(state), desc, DialogModes.NO);
  }
  Stdlib.wrapLC(doc, _ftn);
};
Stdlib.hideSelectedLayers = function(doc) {
  Stdlib._setSelectLayerVis(doc, 'Hd  ');
};
Stdlib.showSelectedLayers = function(doc) {
  Stdlib._setSelectLayerVis(doc, 'Shw ');
};

Stdlib._setOtherLayerVis = function(doc, layer, state) {
  function _extendLayerSelectionToIndex(doc, index) {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putIndex(cTID('Lyr '), index);
    desc.putReference(cTID('null'), ref);
    desc.putEnumerated(sTID('selectionModifier'),
                       sTID('selectionModifierType'),
                       sTID('addToSelectionContinuous'));
    desc.putBoolean(cTID('MkVs'), false);
    executeAction(cTID('slct'), desc, DialogModes.NO);
  };

  var top = doc.layers[0];
  var lvis = layer.visible;
  var lidx = Stdlib.getLayerIndex(doc, layer);
  var bottom = doc.layers[doc.layers.length-1];

  doc.activeLayer = top;
  var bidx = Stdlib.getLayerIndex(doc, bottom);
  _extendLayerSelectionToIndex(doc, bidx);
  Stdlib._setSelLayerVis(state);
  Stdlib.selectLayerByIndex(doc, lidx);
  layer.visible = lvis;
};

Stdlib.showOtherLayers = function(doc, layer) {
  Stdlib._setOtherLayerVis(doc, layer, 'Shw ');
};

Stdlib.hideOtherLayers = function(doc, layer) {
  Stdlib._setOtherLayerVis(doc, layer, 'Hd  ');
};


Stdlib.findLayer = function(doc, layerName) {
  function _findLayer(doc, layer) {
    if (_findLayer.matchFtn(layer.name, _findLayer.layerName)) {
      _findLayer.layer = layer;
      return false;
    }
    return true;
  }

  var matchFtn;

  if (layerName instanceof RegExp) {
    matchFtn = function(s1, re) { return s1.match(re) != null; }
  } else {
    matchFtn = function(s1, s2) { return s1 == s2;  }
  }

  _findLayer.matchFtn = matchFtn;
  _findLayer.layerName = layerName;
  Stdlib.traverseLayers(doc, _findLayer, false, true);
  return _findLayer.layer;
};


// Ex: layers = Stdlib.findLayerByProperty(doc, "visible", true, true);
Stdlib.findLayerByProperty = function(doc, prop, val, all) {

  function _findLayer(doc, layer) {
    if (_findLayer.matchFtn(layer[_findLayer.property], _findLayer.value)) {

      if (_findLayer.all) {
        _findLayer.result.push(layer);
        return true;

      } else {
        _findLayer.result = layer;
        return false;
      }
    }
    return true;
  }

  var _matchFtn;

  if (val instanceof RegExp) {
    _matchFtn = function(s1, re) { return s1.match(re) != null; }
  } else {
    _matchFtn = function(s1, s2) { return s1 == s2;  }
  }

  _findLayer.matchFtn = _matchFtn;
  _findLayer.property = prop;
  _findLayer.value = val;
  _findLayer.all = all;
  if (all) {
    _findLayer.result = [];
  }

  Stdlib.traverseLayers(doc, _findLayer, false, true);
  return _findLayer.result;
};


Stdlib.isLayerEmpty = function(doc, layer) {
  if (!doc) {
    doc = app.activeDocument;
  }
  if (!layer) {
    layer = doc.activeLayer;
  }

  return parseInt(layer.bounds.toString().replace(/\D/g,"")) == 0;
};

Stdlib.mergeVisible = function(doc) {
  Stdlib.doEvent(doc, "MrgV");  // "MergeVisible"
};

Stdlib.mergeLayers = function(doc, layers) {
  if (layers) {
    Stdlib.selectLayers(doc, layers);
  }
  Stdlib.doEvent(doc, "Mrg2");  // "MergeLayers"
}

Stdlib.previousLayer = function(doc) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Bckw') );
    desc.putReference( cTID('null'), ref );
    desc.putBoolean( cTID('MkVs'), false );
    executeAction( cTID('slct'), desc, DialogModes.NO );
  }
  var layer = doc.activeLayer;
  try {
    var lvl = $.level;
    $.level = 0;
    var idx = Stdlib.getActiveLayerIndex(doc);
    Stdlib.wrapLC(doc, _ftn);
    var idx2 = Stdlib.getActiveLayerIndex(doc);

    if (idx2 > idx) {
      layer = doc.activeLayer;
    } else {
      doc.activeLayer = layer;
      layer = undefined;
    }

  } catch (e) {

  } finally {
   $.level = lvl;
   delete lvl;
  }
  return layer;
};

Stdlib.nextLayer = function(doc) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Frwr') );
    desc.putReference( cTID('null'), ref );
    desc.putBoolean( cTID('MkVs'), false );
    executeAction( cTID('slct'), desc, DialogModes.NO );
  }
  var layer = doc.activeLayer;
  try {
    var lvl = $.level;
    $.level = 0;
    var idx = Stdlib.getActiveLayerIndex(doc);
    Stdlib.wrapLC(doc, _ftn);
    var idx2 = Stdlib.getActiveLayerIndex(doc);

    if (idx2 > idx) {
      layer = doc.activeLayer;
    } else {
      doc.activeLayer = layer;
      layer = undefined;
    }

  } catch (e) {
    //$.level = 1; debugger;

  } finally {
   $.level = lvl;
   delete lvl;
  }
  return layer;
};


//
// Copy the styles from the current layer into the styles clipboard
//
Stdlib.copyStyles = function(doc, ignoreError) {
  if (ignoreError == true) {
    var lvl = $.level;
    $.level = 0;
    var rc = false;
    try {
      Stdlib.doEvent(doc, "CpFX");
      rc = true;
    } // "CopyEffects";
    catch (e) {}
    $.level = lvl; 
    return rc;
  } else {
    Stdlib.doEvent(doc, "CpFX"); // "CopyEffects";
  }
};

//
// Paste the styles from the styles clipboard into the current layer
//
Stdlib.pasteStyles = function(doc, layer, ignoreError) {
  if (ignoreError == true) {
    var lvl = $.level;
    $.level = 0;
    var rc = false;
    try {
      Stdlib.pasteStyles(doc, layer, false);
      rc = true;
    }
    catch (e) {}
    $.level = lvl;
    return rc;

  } else {
    var prev;
    if (layer) {
      prev = Stdlib.makeActive(layer);
    }
    Stdlib.doEvent(doc, "PaFX"); // "PasteEffects";
    if (prev) {
      Stdlib.makeActive(prev);
    }
  }
};

Stdlib.hasEffects = function(doc, layer) {
  var hasEffects = true;
  var lvl = $.level;
  try {
    $.level = 0;
    Stdlib.copyEffects(doc, layer);
  } catch (e) {
    hasEffects = false;
  } finally {
    $.level = lvl;
  }
  return hasEffects;
};
Stdlib.hasLayerStyles = Stdlib.hasEffects;

Stdlib.clearEffects = function(doc, layer) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref );
    executeAction( sTID('disableLayerStyle'), desc, DialogModes.NO );
  }
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};
Stdlib.clearLayerStyles = Stdlib.clearEffects;

Stdlib.copyEffects = function(doc, layer) {
  var prev;
  if (layer) {
    prev = Stdlib.makeActive(layer);
  }
  Stdlib.doEvent(doc, "CpFX"); // "CopyEffects";
  if (prev) {
    Stdlib.makeActive(prev);
  }
};
Stdlib.pasteEffects = function(doc, layer) {
  var prev;
  if (layer) {
    prev = Stdlib.makeActive(layer);
  }
  Stdlib.doEvent(doc, "PaFX"); // "PasteEffects";
  if (prev) {
    Stdlib.makeActive(prev);
  }
};
Stdlib._setEffectsViz = function(doc, layer, id) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var list = new ActionList();
    var ref = new ActionReference();
    ref.putClass(cTID('Lefx'));
    ref.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    list.putReference(ref);
    desc.putList(cTID('null'), list);
    executeAction(cTID(id), desc, DialogModes.NO);
  }
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};
Stdlib.hideLayerEffects = function(doc, layer) {
  Stdlib._setEffectsViz(doc, layer, 'Hd  ');
};
Stdlib.hideLayerStyles = Stdlib.hideEffects = Stdlib.hideLayerEffects;
Stdlib.showLayerEffects = function(doc, layer) {
  Stdlib._setEffectsViz(doc, layer, 'Shw ');
};
Stdlib.showLayerStyles = Stdlib.showEffects = Stdlib.showLayerEffects;

//
// Stdlib.layerEffectsVisible(doc, doc.activeLayer);
//
Stdlib.layerEffectsVisible = function(doc, layer) {
  var al = doc.activeLayer;
  if (al != layer) {
    doc.activeLayer = layer;
  }
  var desc = Stdlib.getLayerDescriptor(doc, layer);
  var id = cTID('lfxv');
  var visible = desc.hasKey(id) && desc.getBoolean(id);

  if (al != layer) {
    doc.activeLayer = al;
  }

  return visible;
};

Stdlib.applyLayerStyleInteractive = function(doc, layer, ldesc) {
  return Stdlib.applyLayerStyle(doc, layer, ldesc, true);
};

Stdlib.applyLayerStyle = function(doc, layer, ldesc, interactive) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putProperty(cTID('Prpr'), cTID('Lefx') );
    ref.putEnumerated(cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference(cTID('null'), ref);

    if (!ldesc) {
      ldesc = new ActionDescriptor();
    }
    desc.putObject(cTID('T   '), cTID('Lefx'), ldesc);

    var xdesc = undefined;
    var mode = (interactive ? DialogModes.ALL : DialogModes.NO);
    try {
      xdesc = executeAction(cTID('setd'), desc, mode);
    } catch (e) {
      if (e.number != 8007) { // if not "User cancelled"
        throw e;
      }
    }
    return xdesc;
  }

  return Stdlib.wrapLCLayer(doc, layer, _ftn);
};



//
// Create a new document from the specified layer with the given name
//
Stdlib.makeDocFromLayer = function(doc, layer, docName) {
  function _ftn() {
    var desc = new ActionDescriptor();     // Make

    var dref = new ActionReference();      // Document
    dref.putClass(cTID("Dcmn"));
    desc.putReference(cTID("null"), dref);

    desc.putString(cTID("Nm  "), docName);  // Name

    var lref = new ActionReference();       // Layer
    lref.putName( cTID("Lyr "), layer.name);
    desc.putReference(cTID("Usng"), lref);

    executeAction(cTID("Mk  "), desc, DialogModes.NO);
  }

  // wrapLC is not used because we want to return the new
  // document from this function
  if (doc) {
    app.activeDocument = doc;
  } else {
    doc = app.activeDocument;
  }
  if (layer) {
    doc.activeLayer = layer;
  } else {
    layer = doc.activeLayer;
  }
  _ftn();
  return app.activeDocument;
};

Stdlib.getDocumentFromLayer = function(layer) {
  while(layer.parent != undefined && layer.parent.typename != "Document") {
    layer = layer.parent;
  }
  return layer.parent;
};

// from discussions with Mike Hale
Stdlib.hasLayerMask = function(doc, layer) {
  function _ftn() {
    var ref = new ActionReference();
    ref.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    var desc = executeActionGet(ref);
    return desc.hasKey(cTID("UsrM"));
  }
  return Stdlib.wrapLCLayer(doc, layer, _ftn);
};


//
// Remove the mask from the layer. Apply the mask if 'apply' is true
//
Stdlib.removeLayerMask = function(doc, layer, apply) {
  function _ftn() {
    var desc = new ActionDescriptor();     // Delete

    var ref = new ActionReference();       // Mask Channel
    ref.putEnumerated(cTID("Chnl"), cTID("Chnl"), cTID("Msk "));
    desc.putReference(cTID("null"), ref);

    apply = (apply == true);
    desc.putBoolean(cTID("Aply"), apply);  // Apply Mask

    executeAction(cTID("Dlt "), desc, DialogModes.NO);
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};
Stdlib.removeMask = Stdlib.removeLayerMask;  // backwards compatibility

Stdlib.applyLayerMask = function(doc, layer) {
  function _ftn() {
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Chnl'), cTID('Ordn'), cTID('Trgt') );
    
    var desc = new ActionDescriptor();
    desc.putReference( cTID('null'), ref );
    desc.putBoolean( cTID('Aply'), true );
    
    executeAction( cTID('Dlt '), desc, DialogModes.NO );
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.selectLayerMask = function(doc, layer) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();

    ref.putEnumerated(cTID("Chnl"), cTID("Chnl"), cTID("Msk "));
    desc.putReference(cTID("null"), ref);
    desc.putBoolean(cTID("MkVs"), false );
    executeAction(cTID("slct"), desc, DialogModes.NO );
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};
Stdlib.selectLayerMaskEdit = function(doc, layer) {
  function _ftn() {
    var desc11 = new ActionDescriptor();
        var ref8 = new ActionReference();
        ref8.putEnumerated( cTID('Chnl'), cTID('Ordn'), cTID('Trgt') );
    desc11.putReference( cTID('null'), ref8 );
    desc11.putBoolean( cTID('MkVs'), true );
    executeAction( cTID('slct'), desc11, DialogModes.NO );
  };
  Stdlib.selectLayerMask(doc, layer);
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.createLayerMask = function(doc, layer, fromSelection) {
  function _ftn() {
    var desc = new ActionDescriptor();
    desc.putClass(cTID("Nw  "), cTID("Chnl"));
    var ref = new ActionReference();
    ref.putEnumerated(cTID("Chnl"), cTID("Chnl"), cTID("Msk "));
    desc.putReference(cTID("At  "), ref);
    if (fromSelection == true) {
      desc.putEnumerated(cTID("Usng"), cTID("UsrM"), cTID("RvlS"));
    } else {
      desc.putEnumerated(cTID("Usng"), cTID("UsrM"), cTID("RvlA"));
    }
    executeAction(cTID("Mk  "), desc, DialogModes.NO);
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.isLayerMaskEnabled = function(doc, layer) {
  var desc = Stdlib.getLayerDescriptor(doc, layer);
  return (desc.hasKey(cTID("UsrM")) && desc.getBoolean(cTID("UsrM")));
};

Stdlib.disableLayerMask = function(doc, layer) {
  Stdlib.setLayerMaskEnabledState(doc, layer, false);
};
Stdlib.enableLayerMask = function(doc, layer) {
  Stdlib.setLayerMaskEnabledState(doc, layer, true);
};
Stdlib.setLayerMaskEnabledState = function(doc, layer, state) {
  function _ftn() {
    var desc = new ActionDescriptor();

    var ref = new ActionReference();
    ref.putEnumerated(cTID('Lyr '), cTID('Ordn'), cTID('Trgt'));
    desc.putReference(cTID('null'), ref );

    var tdesc = new ActionDescriptor();
    tdesc.putBoolean(cTID('UsrM'), state);
    desc.putObject(cTID('T   '), cTID('Lyr '), tdesc);

    executeAction(cTID('setd'), desc, DialogModes.NO );
  }
  if (state == undefined) {
    state = false;
  }
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.createClippingMask = function(doc, layer) {

  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref );
    executeAction( cTID('GrpL'), desc, DialogModes.NO );
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};


Stdlib.releaseClippingMask = function(doc, layer) {

  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref );
    executeAction( cTID('Ungr'), desc, DialogModes.NO );
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.hasClippingMask = function(doc, layer) {
  return Stdlib.getLayerProperty(layer, 'Grup');
};

Stdlib.isClippingMask = function(doc, layer) {
  var rc = false;
  try {
    var idx = Stdlib.getLayerIndex(doc, layer);
    Stdlib.selectLayerByIndex(doc, idx+1);
    var rc = Stdlib.getLayerProperty(doc.activeLayer, 'Grup');
    doc.activeLayer = layer;
  } catch (e) {
  }

  return rc;
};

Stdlib.rotateLayer = function(doc, layer, angle) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    desc.putReference(cTID("null"), ref);
    desc.putUnitDouble(cTID("Angl"), cTID("#Ang"), angle);
    executeAction(cTID("Rtte"), desc, DialogModes.NO );
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.rotateLayerAround = function(doc, layer, angle, x, y) {
  angle = Number(angle);
  if (isNaN(angle)) {
    Error.runtimeError(19, "angle");  // BadArgument
  }
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref );
    desc.putEnumerated( cTID('FTcs'), cTID('QCSt'), cTID('Qcsi') );
    var ldesc = new ActionDescriptor();
    ldesc.putUnitDouble( cTID('Hrzn'), cTID('#Pxl'), x );
    ldesc.putUnitDouble( cTID('Vrtc'), cTID('#Pxl'), y );
    desc.putObject( cTID('Pstn'), cTID('Pnt '), ldesc );
    desc.putUnitDouble( cTID('Angl'), cTID('#Ang'), angle );
    executeAction( cTID('Trnf'), desc, DialogModes.NO );
  };

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};


// Stdlib.moveLayerContent(doc, doc.activeLayer, -25, -25);
Stdlib.moveLayerContent = function(doc, layer, dx, dy) {
  function _ftn() {
    var idx = Stdlib.getActiveLayerIndex(doc);
    Stdlib.moveLayerContentByIndex(doc, idx, dx, dy);
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.moveLayerContentByIndex = function(doc, idx, dx, dy) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putIndex(cTID('Lyr '), idx);
    desc.putReference(cTID('null'), ref );
    var pdesc = new ActionDescriptor();
    pdesc.putUnitDouble(cTID('Hrzn'), cTID('#Pxl'), dx);
    pdesc.putUnitDouble(cTID('Vrtc'), cTID('#Pxl'), dy);
    desc.putObject(cTID('T   '), cTID('Ofst'), pdesc);
    executeAction(cTID('move'), desc, DialogModes.NO);
  }

  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.freeTransform = function(doc, layer) {
//   Stdlib.doMenuItem(PSEnum.FreeTransform, true);
  Stdlib.doMenuItem(cTID("FrTr"), true);
};

Stdlib.transformScale = function(doc, layer, linked) {
  //   doc.activeLayer = layer;
  //   Stdlib.doMenuItem(cTID("Scl "), true);
  function _ftn() {
    var desc = new ActionDescriptor();
    var lref = new ActionReference();
    lref.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    desc.putReference(cTID("null"), lref);
    desc.putEnumerated(cTID("FTcs"), cTID("QCSt"), cTID("Qcsa"));
    if (linked == true) {
      desc.putBoolean(cTID("Lnkd"), true );
    }

    var lvl = $.level;
    $.level = 0;
    try {
      executeAction(cTID("Trnf"), desc, DialogModes.ALL);
    } catch (e) {
      $.level = lvl;
      if (e.number != 8007) { // if not "User cancelled"
        throw e;
      }
    }
    $.level = lvl;
  }
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};



// Stdlib.transformLayer(doc, doc.activeLayer, Stdlib.getMaskBounds(doc, doc.activeLayer))

Stdlib.getLayerBounds = function(doc, layer) {
  var ru = app.preferences.rulerUnits;

  try {
    app.preferences.rulerUnits = Units.PIXELS;

    var reenable = false;
    var st;
    if (Stdlib.hasLayerMask(doc, layer) &&
        Stdlib.isLayerMaskEnabled(doc, layer)) {
      st = doc.activeHistoryState;
      Stdlib.disableLayerMask(doc, layer);
      reenable = true;
    }
    
    var lbnds = layer.bounds;

    // fix this to modify the history state
    if (reenable) {
      Stdlib.enableLayerMask(doc, layer);
    }
    for (var i = 0; i < 4; i++) {
      lbnds[i] = lbnds[i].value;
    }

  } finally {
    app.preferences.rulerUnits = ru;
  }

  return lbnds;
};


// function ftn1() {
//   function cTID(s) { return app.charIDToTypeID(s); };
//   function sTID(s) { return app.stringIDToTypeID(s); };

//     var desc74 = new ActionDescriptor();
//     desc74.putEnumerated( cTID('FTcs'), cTID('QCSt'), cTID('Qcsa') );
//         var desc75 = new ActionDescriptor();
//         desc75.putUnitDouble( cTID('Hrzn'), cTID('#Pxl'), -2700.000000 );
//         desc75.putUnitDouble( cTID('Vrtc'), cTID('#Pxl'), -1350.000000 );
//     desc74.putObject( cTID('Ofst'), cTID('Ofst'), desc75 );
//     desc74.putUnitDouble( cTID('Wdth'), cTID('#Prc'), 18.181818 );
//     desc74.putUnitDouble( cTID('Hght'), cTID('#Prc'), 35.601266 );
//     executeAction( cTID('Trnf'), desc74, DialogModes.NO );
// };

Stdlib.transformLayer = function(doc, layer, bnds, orient) {
  var lbnds = Stdlib.getLayerBounds(doc, layer);

  var newW = bnds[2]-bnds[0];
  var newH = bnds[3]-bnds[1];
  var oldW = lbnds[2]-lbnds[0];
  var oldH = lbnds[3]-lbnds[1];

  var hrzn = bnds[0] - (lbnds[0] - (newW-oldW)/2);
  var vrtc = bnds[1] - (lbnds[1] - (newH-oldH)/2);

  var prc;
  if (orient.toLowerCase() == 'horz') {
    vprc = hprc = (newW/oldW) * 100;
  } else if (orient == 'both') {
    hprc = (newW/oldW) * 100;
    vprc = (newH/oldH) * 100;
  } else {
    vprc = hprc = (newH/oldH) * 100;
  }

  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref );
    desc.putEnumerated( cTID('FTcs'), cTID('QCSt'), cTID('Qcsa') );
    var ldesc = new ActionDescriptor();
    ldesc.putUnitDouble( cTID('Hrzn'), cTID('#Pxl'), hrzn );
    ldesc.putUnitDouble( cTID('Vrtc'), cTID('#Pxl'), vrtc );
    desc.putObject( cTID('Ofst'), cTID('Ofst'), ldesc );
    desc.putUnitDouble( cTID('Wdth'), cTID('#Prc'), hprc );
    desc.putUnitDouble( cTID('Hght'), cTID('#Prc'), vprc );
//     desc.putUnitDouble( cTID('Angl'), cTID('#Ang'), angle );
    executeAction( cTID('Trnf'), desc, DialogModes.NO );
  };

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.rasterizeLayer = function(doc, layer) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref );
    executeAction( sTID('rasterizeLayer'), desc, DialogModes.NO );
  };
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

// Stdlib.rotateLayer = function(doc, layer, angle) {
//   angle = Number(angle);
//   if (isNaN(angle)) {
//     Error.runtimeError(19, "angle");  // BadArgument
//   }
//   function _ftn() {
//     var desc = new ActionDescriptor();
//     var ref = new ActionReference();
//     ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
//     desc.putReference( cTID('null'), ref10 );
//     desc.putEnumerated( cTID('FTcs'), cTID('QCSt'), cTID('Qcsa') );
//     var ldesc = new ActionDescriptor();
//     ldesc.putUnitDouble( cTID('Hrzn'), cTID('#Pxl'), 0 );
//     ldesc.putUnitDouble( cTID('Vrtc'), cTID('#Pxl'), 0 );
//     desc.putObject( cTID('Ofst'), cTID('Ofst'), ldesc );
//     desc.putUnitDouble( cTID('Angl'), cTID('#Ang'), angle );
//     executeAction( cTID('Trnf'), desc, DialogModes.NO );
//   };

//   Stdlib.wrapLCLayer(doc, layer, _ftn);
// };


Stdlib.convertToLayer = function(doc, layer) {
  // layer.rasterize(RasterizeType.ENTIRELAYER);
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated(cTID('Lyr '), cTID('Ordn'), cTID('Trgt'));
    desc.putReference(cTID('null'), ref);
    desc.putEnumerated(cTID('What'), sTID('rasterizeItem'), sTID('placed'));
    executeAction(sTID('rasterizeLayer'), desc, DialogModes.NO);
  };
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.placeImage = function(doc, layer, file) {
  Stdlib.makeActive(doc);
  Stdlib.makeActive(layer);

  function _ftn() {
    var desc = new ActionDescriptor();
    desc.putPath( cTID('null'), file);
    desc.putEnumerated( cTID('FTcs'), cTID('QCSt'), cTID('Qcsa') );
        var ldesc = new ActionDescriptor();
        ldesc.putUnitDouble( cTID('Hrzn'), cTID('#Pxl'), 0.000000 );
        ldesc.putUnitDouble( cTID('Vrtc'), cTID('#Pxl'), 0.000000 );
    desc.putObject( cTID('Ofst'), cTID('Ofst'), ldesc );
    executeAction( cTID('Plc '), desc, DialogModes.NO );
  }

  _ftn();

  return doc.activeLayer;
};



// Stdlib.transformInteractive = function() {
//   var desc = new ActionDescriptor();
//   var ref = new ActionReference();
//   ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
//   desc.putReference( cTID('null'), ref );
//   desc.putEnumerated( cTID('FTcs'), cTID('QCSt'), cTID('Qcsa') );
//   desc.putBoolean( cTID('Lnkd'), true );
//   executeAction( cTID('Trnf'), desc, DialogModes.ALL );
// };


Stdlib.deleteAllHiddenLayers = function(doc) {
  function _ftn() {
    var ref = new ActionReference();
    ref.putEnumerated(cTID("Lyr "), cTID("Ordn"), sTID("hidden"));
    var dltDesc = new ActionDescriptor();
    dltDesc.putReference(cTID("null"), ref);
    executeAction(cTID("Dlt "), dltDesc, DialogModes.NO);
  }
  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.hideAllLayers = function(doc) {
  var als = Stdlib.getLayersList(doc, false, true);
  for (var i = 0; i < als.length; i++) {
    als[i].visible = false;
  }
};
Stdlib.showAllLayers = function(doc) {
  var als = Stdlib.getLayersList(doc, false, true);
  for (var i = 0; i < als.length; i++) {
    als[i].visible = true;
  }
};

Stdlib.hideSelectedLayers = function(doc) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var list = new ActionList();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    list.putReference( ref );
    desc.putList( cTID('null'), list );
    executeAction( cTID('Hd  '), desc, DialogModes.NO );
  }
  Stdlib.wrapLC(doc, _ftn);
};
Stdlib.showSelectedLayers = function(doc) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var list = new ActionList();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    list.putReference( ref );
    desc.putList( cTID('null'), list );
    executeAction( cTID('Shw '), desc, DialogModes.NO );
  }
  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.newGroupFromLayers = function(doc) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putClass( sTID('layerSection') );
    desc.putReference( cTID('null'), ref );
    var lref = new ActionReference();
    lref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('From'), lref);
    executeAction( cTID('Mk  '), desc, DialogModes.NO );
  };
  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.getLayerNameByIndex = function(doc, idx) {
  var ref = new ActionReference();
  ref.putProperty(cTID("Prpr"), cTID( "Nm  " ));
  ref.putIndex(cTID( "Lyr " ), idx);
  return executeActionGet(ref).getString(cTID( "Nm  " ));
};
Stdlib.setLayerName = function(doc, idx, nm) {
  var desc = new ActionDescriptor();

  var ref = new ActionReference();
  ref.putIndex(cTID('Lyr '), idx);
  desc.putReference(cTID('null'), ref);

  var nmdesc = new ActionDescriptor();
  nmdesc.putString(cTID('Nm  '), nm);
  desc.putObject(cTID('T   '), cTID('Lyr '), nmdesc);

  executeAction(cTID('setd'), desc, DialogModes.NO);
};

Stdlib.getActiveLayerIndex = function(doc) {
  return Stdlib.getLayerIndex(doc, doc.activeLayer);
};
Stdlib.getActiveLayerDescriptor = function(doc) {
  function _ftn() {
    var ref = new ActionReference();
    ref.putEnumerated(cTID('Lyr '), cTID('Ordn'), cTID('Trgt'));
    return executeActionGet(ref);
  }
  return Stdlib.wrapLC(doc, _ftn);
};

Stdlib.getLayerIndex = function(doc, layer, dontWrap) {
  var idx = Stdlib.getLayerProperty(layer, 'ItmI');
  return Stdlib.hasBackground(doc) ? idx-1 : idx;
};


Stdlib.getLayerID = function(doc, layer) {
  var d = Stdlib.getLayerDescriptor(doc, layer);
  return d.getInteger(cTID('LyrI'));
};

Stdlib.getLayerType = function(doc, layer) {
  var idx = Stdlib.getLayerIndex(doc, layer);
  return Stdlib.getLayerTypeByIndex(doc, idx);
};
Stdlib.getLayerTypeByIndex = function(doc, idx) {
  var ref = new ActionReference();
  ref.putProperty(cTID("Prpr") , sTID("layerSection"));
  ref.putIndex(cTID( "Lyr " ), idx);
  return executeActionGet(ref).getEnumerationValue(sTID('layerSection'));
};

Stdlib.isLayerSelected = function(doc, layer) {
  var selLayers = Stdlib.getSelectedLayers(doc, true);
  return sel.contains(layer);
};

Stdlib.deleteSelectedLayers = function(doc) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref );
    executeAction( cTID('Dlt '), desc, DialogModes.NO );
  };

  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.selectLayer = function(doc, layer, append) {
  if (isCS()) {
    doc.activeLayer = layer;

  } else {
    Stdlib.selectLayerByIndex(doc,
                              Stdlib.getLayerIndex(doc, layer, true),
                              append);
  }
};
Stdlib.selectLayers = function(doc, layers, append) {
  var idxs = [];
  var vis = [];
  var avis = doc.activeLayer.visible;
  for (var i = 0; i < layers.length; i++) {
    var l = layers[i];
    vis[i] = l.visible;
    idxs.push(Stdlib.getLayerIndex(doc, l));
  }
  Stdlib.selectLayersByIndex(doc, idxs, append);
  for (var i = 0; i < layers.length; i++) {
    layers[i].visible = vis[i];
  }
  doc.activeLayer.visible = avis;
};
Stdlib.selectLayerByName = Stdlib.selectLayer;

// 1-based indexing
Stdlib.selectLayerByIndex = function(doc, index, append) {
  if (append) {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putIndex( cTID('Lyr '), index );
    desc.putReference( cTID('null'), ref );
    desc.putEnumerated( sTID('selectionModifier'),
                        sTID('selectionModifierType'),
                        sTID('addToSelection') );
    desc.putBoolean( cTID('MkVs'), false );
    executeAction( cTID('slct'), desc, DialogModes.NO );

  } else {
    var ref = new ActionReference();
    ref.putIndex(cTID("Lyr "), index);
    var desc = new ActionDescriptor();
    desc.putReference(cTID("null"), ref );
    executeAction(cTID("slct"), desc, DialogModes.NO );
  }
};
Stdlib.selectLayersByIndex = function(doc, idxs, append) {
  if (!idxs || idxs.length == 0) {
    return;
  }
  idxs = idxs.slice(0);
  if (append != true) {
    Stdlib.selectLayerByIndex(doc, idxs.pop());
  }

  while (idxs.length) {
    Stdlib.selectLayerByIndex(doc, idxs.pop(), true);
  } 
};

Stdlib.deselectLayer = function(doc, layer) {
  if (isCS()) {
    return;
  }

  Stdlib.deselectLayerByIndex(doc, Stdlib.getLayerIndex(doc, layer, true));
};
Stdlib.deselectLayers = function(doc, layers) {
  if (isCS()) {
    return;
  }

  var idxs = [];
  var vis = [];
  for (var i = 0; i < layers.length; i++) {
    var l = layers[i];
    vis[i] = l.visible;
    idxs.push(Stdlib.getLayerIndex(doc, l));
  }
  Stdlib.deselectLayersByIndex(doc, idxs);
};

Stdlib.deselectLayerByIndex = function(doc, index) {
  if (isCS()) {
    return;
  }
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putIndex(cTID('Lyr '), index);
  desc.putReference(cTID('null'), ref);
  desc.putEnumerated(sTID('selectionModifier'),
                     sTID('selectionModifierType'),
                     sTID('removeFromSelection'));
  desc.putBoolean(cTID('MkVs'), false);
  executeAction(cTID('slct'), desc, DialogModes.NO);
};
Stdlib.deselectLayersByIndex = function(doc, idxs) {
  if (isCS()) {
    return;
  }

  if (!idxs || idxs.length == 0) {
    return;
  }
  idxs = idxs.slice(0);

  while (idxs.length) {
    Stdlib.deselectLayerByIndex(doc, idxs.pop());
  } 
};


Stdlib.getLayerBoundsByIndex = function(doc, idx) {
  var desc = Stdlib.getLayerDescriptorByIndex(doc, idx);
  var bdesc = desc.getObjectValue(sTID('bounds'));

  var bnds = [];
  bnds.push(bdesc.getUnitDoubleValue(cTID('Left')));
  bnds.push(bdesc.getUnitDoubleValue(cTID('Top '))); 
  bnds.push(bdesc.getUnitDoubleValue(cTID('Rght')));
  bnds.push(bdesc.getUnitDoubleValue(cTID('Btom')));
  return bnds;
};

Stdlib.getLayerOpacityByIndex = function(doc, idx) {
  var desc = Stdlib.getLayerDescriptorByIndex(doc, idx);
  return desc.getInteger(cTID('Opct'));
};


Stdlib.selectLayerByIdentifier = function(doc, id) {
  var ref = new ActionReference();
  ref.putIdentifier(cTID("Lyr "), id);
  var desc = new ActionDescriptor();
  desc.putReference(cTID("null"), ref );
  executeAction(cTID("slct"), desc, DialogModes.NO );
};

Stdlib.hasBG = function(doc) {
  try {
    var bgref = new ActionReference();
    bgref.putIndex(cTID("Lyr "), 0);
    executeActionGet(ref);
    return true;
  } catch (e) {
    return false;
  }
}

// 1-based indexing...
Stdlib.getLayerDescriptorByIndex = function(doc, index) {
  var ref = new ActionReference();
  // assume that the index has already been adjusted
//   var hasBG = Stdlib.hasBackground(doc); // need something better here
//   if (hasBG) {
//     index--;
//   }

  ref.putIndex(cTID( "Lyr " ), index);
  return executeActionGet(ref);
};

Stdlib.getLayerDescriptor = function(doc, layer, dontWrap) {
  function _ftn() {
    var ref = new ActionReference();
    ref.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    return executeActionGet(ref)
  };

  if (dontWrap) {
    Stdlib.makeActive(doc);
    Stdlib.makeActive(layer);
    return _ftn();
  } else {
    return Stdlib.wrapLCLayer(doc, layer, _ftn); 
  }
};

Stdlib.getVectorMaskDescriptor = function(doc, layer) {
  function _ftn() {
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Path'), cTID('Path'), sTID('vectorMask') );
    ref.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    return executeActionGet(ref)
  };

  return Stdlib.wrapLCLayer(doc, layer, _ftn); 
};

Stdlib.getPathDescriptor = function(doc, layer, name) {
  var totalPaths = doc.pathItems.length;
  var pathCount = 0;

  var pdesc;

  if (name == "WorkPath") {
    var ref = new ActionReference();
    ref.putProperty(cTID("Path"), cTID("WrPt"));
    pdesc = app.executeActionGet(ref);

  } else {
    for (var i = 1; i <= totalPaths; i++) {
      // try normal paths
      try {
        var ref = new ActionReference();
        ref.putIndex(cTID("Path"), i);
        var desc = app.executeActionGet(ref);

        var pname = desc.getString(cTID('PthN'));
        if (pname == name) {
          pdesc = desc;
          break;
        }

      } catch (e) {
        break;
      }
    }
  }

  return pdesc;
};

//
// Select either the Transparency or Mask Channel
//    kind - "Trsp" or "Msk "
//
Stdlib.loadSelection = function(doc, layer, kind, invert) {
  function _ftn() {
    var desc = new ActionDescriptor();   // Set

    var cref = new ActionReference();    // Channel Selection
    cref.putProperty(cTID("Chnl"), cTID("fsel"));
    desc.putReference(cTID("null"), cref);

    var tref = new ActionReference(); // Channel Kind ("Trsp" or "Msk ")
    tref.putEnumerated(cTID("Chnl"), cTID("Chnl"), cTID(kind));
    desc.putReference(cTID("T   "), tref);
    if (invert == true) {
      desc.putBoolean(cTID("Invr"), true);
    }
    executeAction(cTID("setd"), desc, DialogModes.NO);
  }
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};
Stdlib.selectTransparencyChannel = function(doc, layer, invert) {
  Stdlib.loadSelection(doc, layer, "Trsp", invert);
};
Stdlib.selectMaskChannel = function(doc, layer, invert) {
  Stdlib.loadSelection(doc, layer, "Msk ", invert);
};

Stdlib.saveNamedSelection = function(doc, layer, name) {
  function _ftn() {
    var desc47 = new ActionDescriptor();
    var ref33 = new ActionReference();
    ref33.putProperty( cTID('Chnl'), cTID('fsel') );
    desc47.putReference( cTID('null'), ref33 );
    desc47.putString( cTID('Nm  '), name);
    executeAction( cTID('Dplc'), desc47, DialogModes.NO );
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.selectNamedSelection = function(doc, layer, name) {
  function _ftn() {
    var desc49 = new ActionDescriptor();
    var ref35 = new ActionReference();
    ref35.putName( cTID('Chnl'), name );
    desc49.putReference( cTID('null'), ref35 );
    executeAction( cTID('slct'), desc49, DialogModes.NO );
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.loadNamedSelection = function(doc, layer, name, invert) {
  function _ftn() {
    var desc = new ActionDescriptor();   // Set

    var cref = new ActionReference();    // Channel Selection
    cref.putProperty(cTID("Chnl"), cTID("fsel"));
    desc.putReference(cTID("null"), cref);

    var tref = new ActionReference();
    tref.putName(cTID("Chnl"), name);
    desc.putReference(cTID("T   "), tref);
    if (invert == true) {
      desc.putBoolean(cTID("Invr"), true);
    }
    executeAction(cTID("setd"), desc, DialogModes.NO);
  }
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.deleteNamedSelection = function(doc, layer, name) {
  function _ftn() {
    Stdlib.selectNamedSelection(doc, layer, name);
    var desc43 = new ActionDescriptor();
    var ref29 = new ActionReference();
    ref29.putEnumerated( cTID('Chnl'), cTID('Ordn'), cTID('Trgt') );
    desc43.putReference( cTID('null'), ref29 );
    executeAction( cTID('Dlt '), desc43, DialogModes.NO );
  }
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};


//
// From Mike Hale:
// After you use Stdlib (or scriptlistner) to load the transparency channel
// as a selection you will need to apply a threshold to the selection to
// remove the semi-transparent pixels from the selection.

// activeDocument.quickMaskMode = true;
//     var desc = new ActionDescriptor();
//     desc.putInteger( charIDToTypeID( "Lvl " ), 1 );
// executeAction( charIDToTypeID( "Thrs" ), desc, DialogModes.NO );
// activeDocument.quickMaskMode = false;
//

Stdlib.getMaskBounds = function(doc, layer) {
  function _ftn() {
    var st = doc.activeHistoryState;
    Stdlib.selectMaskChannel(doc, layer);
    var bnds = Stdlib.getSelectionBounds(doc);
    doc.activeHistoryState = st;
    return bnds;
  }

//   Stdlib.undo(doc);
//   //executeAction(cTID("undo"), new ActionDescriptor(), DialogModes.NO);

  var bnds = Stdlib.wrapLCLayer(doc, layer, _ftn);

  return bnds;
};

Stdlib.appendMaskToSelection = function(doc, layer) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated(cTID("Chnl"), cTID("Chnl"), cTID("Msk "));
    desc.putReference(cTID("null"), ref);
    desc.putBoolean(cTID("MkVs"), false);
    executeAction(cTID("slct"), desc, DialogModes.NO );

    desc = new ActionDescriptor();
    ref = new ActionReference();
    ref.putEnumerated(cTID("Chnl"), cTID("Ordn"), cTID("Trgt"));
    desc.putReference(cTID("null"), ref );

    var cref = new ActionReference();
    cref.putProperty(cTID("Chnl"), cTID("fsel"));
    desc.putReference(cTID("T   "), cref);
    executeAction(cTID("Add "), desc, DialogModes.NO );
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};


//
// link/unlink the image and mask
//
Stdlib.isLayerMaskLinked = function(doc, layer) {
  var desc = Stdlib.getLayerDescriptor(doc, layer);
  return (desc.hasKey(cTID("Usrs")) && desc.getBoolean(cTID("Usrs")));
};

Stdlib._linkMask = function(doc, layer, linkOn) {
  function _ftn() {
    var desc = new ActionDescriptor();

    var lref = new ActionReference();
    lref.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    desc.putReference(cTID("null"), lref);

    var ldesc = new ActionDescriptor();
    ldesc.putBoolean(cTID("Usrs"), linkOn);

    desc.putObject(cTID("T   "), cTID("Lyr "), ldesc);
    executeAction(cTID("setd"), desc, DialogModes.NO);
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};
Stdlib.unlinkLayerMask = function(doc, layer) {
  Stdlib._linkMask(doc, layer, false);
};
Stdlib.unlinkMask = Stdlib.unlinkLayerMask;

Stdlib.linkLayerMask = function(doc, layer) {
  Stdlib._linkMask(doc, layer, true);
};
Stdlib.linkMask = Stdlib.linkLayerMask;

Stdlib.unlinkSelectedLayers = function(doc) {
  // Stdlib.doMenuItem(sTID("unlinkSelectedLayers"));
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
  desc.putReference( cTID('null'), ref );
  executeAction( sTID('unlinkSelectedLayers'), desc, DialogModes.NO );
};
Stdlib.unlinkLayers = function(doc, layers) {
  for (var i = 0; i < layers.length; i++) {
    var layer = layers[i];
    var v = layer.visibile;
    layer.unlink();
    layer.visibile = v;
  }
};
Stdlib.linkSelectedLayers = function(doc) {
  // Stdlib.doMenuItem(sTID("linkSelectedLayers"));

  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
  desc.putReference( cTID('null'), ref );
  executeAction( sTID('linkSelectedLayers'), desc, DialogModes.NO );
};
Stdlib.linkLayers = function(doc, layers) {
  var base = layers[0];
  base.unlink();
  for (var i = 1; i < layers.length; i++) {
    var layer = layers[i];
    var v = layer.visible;
    layer.unlink();
    layer.link(base);
    layer.visible = v;
  }
};

Stdlib.selectLinkedLayers = function(doc) {
  function _ftn() {
    var ref = new ActionReference();
    ref.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    var desc = new ActionDescriptor();
    executeAction(sTID("selectLinkedLayers"), desc, DialogModes.NO);
  }

  Stdlib.wrapLC(doc, _ftn);
};
Stdlib.getLinkedLayers = function(doc, layer) {
  var selLayers;
  selLayers = layer.linkedLayers.slice(0);

  if (selLayers) {
    selLayers.unshift(layer);

    var layers = [];
    var allLayers = Stdlib.getLayersList(doc);
    for (var i = 0; i < allLayers.length; i++) {
      var l = allLayers[i];
      if (selLayers.contains(l)) {
        layers.push(l);
      }
    }
    selLayers = layers;

  } else {
    selLayers = [layer];
  }
  return selLayers;
};

Stdlib.getSelectedLayers = function(doc, layerSets) {
  var layers = Stdlib.getLayersList(doc, undefined, layerSets);
  var visible = [];
  var selLayers = [];

  if (isCS() || isPS7()) {
    return [ doc.activeLayer ];
  }

  if (doc.layers.length == 1 && Stdlib.hasBackgroundLayer(doc)) {
    return [ doc.backgroundLayer ];
  }

  for (var i = 0; i < layers.length; i++) {
    var l = layers[i];
    visible[i] = l.visible;
    l.visible = false;
  }
  Stdlib.showSelectedLayers(doc);
  for (var i = 0; i < layers.length; i++) {
    var l = layers[i];
    if (l.visible) {
      selLayers.push(l);
    }
    l.visible = visible[i];
  }

  return selLayers;
};

// Stdlib.insertImageIntoMask(doc, doc.activeLayer, "/c/tmp/1.jpg");

Stdlib.insertImageIntoMask = function(doc, layer, file, fit) {
  if (!Stdlib.hasLayerMask(doc, layer)) {
    Error.runtimeError(9001, "A Layer mask is required for this operation.");
  }

  Stdlib.selectMaskChannel(doc, layer);
  Stdlib.insertImageIntoSelection(doc, layer, file, fit);
  doc.selection.deselect();
};

Stdlib.insertImageIntoSelection = function(doc, layer, im, fit) {
  var imageDoc;
  var imageFile;

  if (im instanceof Document) {
    imageDoc = im;
  } else {
    imageFile = Stdlib.convertFptr(im);
  }

  if (fit == undefined) fit = true;

  if (!Stdlib.hasSelection(doc)) {
    Error.runtimeError(8152); // "A selection is required for this operation.")
  }

  if (!imageDoc) {
    if (!imageFile.exists) {
      alert('Image ' + imageFile + ' does not exist.');
      return;
    }
    imageDoc = app.open(imageFile);

  } else {
    app.activeDocument = imageDoc;
    imageDoc = imageDoc.duplicate();
  }

//   imageDoc.flatten();

  app.activeDocument = doc;

  var ru = app.preferences.rulerUnits;
  try {
    app.preferences.rulerUnits = Units.PIXELS;

    var lname = layer.name;

    // XXX app.activeDocument = doc;

    var bnds = Stdlib.getSelectionBounds(doc);

    // resize the image doc based on the selection bounds
    var width = bnds[2] - bnds[0];
    var height = bnds[3] - bnds[1];

    if (fit) {
      // change the res
      app.activeDocument = imageDoc;
      imageDoc.resizeImage(undefined, undefined, doc.resolution,
                           ResampleMethod.NONE);
      Stdlib.fitImage(imageDoc, width, height);

    } else {
      // fit to the shortest side (image will crop)
      var dwidth = imageDoc.width.value;
      var dheight = imageDoc.height.value;
    
      var ratio = height/width;
      var dratio = dheight/dwidth;
      
      if (dratio > ratio) {
        height = undefined;
      } else {
        width = undefined;
      }
      app.activeDocument = imageDoc;
      imageDoc.resizeImage(width, height, doc.resolution,
                           ResampleMethod.BICUBIC);
    }
    
    imageDoc.selection.selectAll();
    if (imageDoc.layers.length > 1) {
      imageDoc.selection.copy(true);
    } else {
      imageDoc.selection.copy();
    }

    app.activeDocument = doc;
    doc.activeLayer = layer;

    var hasStyles = Stdlib.hasLayerStyles(doc, layer);
    if (hasStyles) {
      Stdlib.copyStyles(doc);
    }

    if (!Stdlib.hasSelection(doc)) {
      Stdlib.selectBounds(doc, bnds);
    }

    Stdlib.pasteInto(doc);
    layer.remove();
    layer = doc.activeLayer;
    layer.name = lname;

    if (hasStyles) {
      Stdlib.pasteStyles(doc);
    }

  } catch (e) {
    alert("Internal error: " + e + '@' + e.line);

  } finally {
    app.preferences.rulerUnits = ru;
    try { imageDoc.close(SaveOptions.DONOTSAVECHANGES); } catch (e) {}
  }
};

Stdlib.insertImageIntoSelectionAsSmartObject = function(doc, layer, im, fit) {
  app.activeDocument = doc;
  doc.activeLayer = layer;
  var imageFile = Stdlib.convertFptr(im);

  if (fit == undefined) fit = true;

  if (!Stdlib.hasSelection(doc)) {
    Error.runtimeError(8152); // "A selection is required for this operation."
  }

  if (!imageFile.exists) {
    Error.runtimeError(48); // 'Image ' + imageFile + ' does not exist.'
  }

  var ru = app.preferences.rulerUnits;
  var rez = doc.resolution;

  try {
    if (rez != 72) {
      doc.resizeImage(undefined, undefined, 72, ResampleMethod.NONE);
    }

    app.preferences.rulerUnits = Units.PIXELS;

    var hasStyles = Stdlib.hasLayerStyles(doc, layer);
    if (hasStyles) {
      Stdlib.copyStyles(doc, layer);
    }

    var lname = layer.name;

    var bnds = Stdlib.getSelectionBounds(doc);

    var imageLayer; // = doc.artLayers.add();
    imageLayer = Stdlib.placeImage(doc, layer, imageFile);

    // resize the image doc based on the selection bounds
    var width = bnds[2] - bnds[0];
    var height = bnds[3] - bnds[1];

    var lbnds = Stdlib.getLayerBounds(doc, imageLayer);
    var lw = lbnds[2] - lbnds[0];
    var lh = lbnds[3] - lbnds[1];

    var ratio = height/width;
    var lratio = lh/lw;


    if (fit || fit.toString().toLowerCase() == 'fit') {
      // change the res
      // XXX app.activeDocument = imageDoc;
//       imageDoc.resizeImage(undefined, undefined, doc.resolution,
//                            ResampleMethod.NONE);
//       Stdlib.fitImage(imageDoc, width, height);

    } else {
      // fit to the shortest side (image will crop)

      var prc = 100 * (bnds[2]-bnds[0])/lw;
      
      if (dratio > ratio) {
        height = undefined;
      } else {
        width = undefined;
      }
      app.activeDocument = imageDoc;
      imageDoc.resizeImage(width, height, doc.resolution,
                           ResampleMethod.BICUBIC);
    }

    layer.resize(prc, prc);

    var deltaX = bnds[0]-lbnds[0];
    var deltaY = bnds[1]-lbnds[1];

    //Stdlib.mergeLayers(doc, imageLayer);
    
    if (hasStyles) {
      Stdlib.pasteStyles(doc);
    }
    $.level = lvl;

  } catch (e) {
    alert("Internal error: " + e + '@' + e.line);

  } finally {
    app.preferences.rulerUnits = ru;
    if (rez != 72) {
      doc.resizeImage(undefined, undefined, rez, ResampleMethod.NONE);
    }
  }
};

Stdlib.resizeCanvas = function(doc, w, h, color, relative) {
  var hsb = color.hsb;
  var desc168 = new ActionDescriptor();
  if (toBoolean(relative)) {
    desc168.putBoolean(cTID('Rltv'), toBoolean(relative));
  }
  desc168.putUnitDouble( cTID('Wdth'), cTID('#Pxl'), w);
  desc168.putUnitDouble( cTID('Hght'), cTID('#Pxl'), h);
  desc168.putEnumerated( cTID('Hrzn'), cTID('HrzL'), cTID('Cntr') );
  desc168.putEnumerated( cTID('Vrtc'), cTID('VrtL'), cTID('Cntr') );
  if (color) {
    desc168.putEnumerated( sTID('canvasExtensionColorType'),
                           sTID('canvasExtensionColorType'),
                           cTID('Clr ') );
    var desc169 = new ActionDescriptor();
    desc169.putUnitDouble( cTID('H   '), cTID('#Ang'), hsb.hue );
    desc169.putDouble( cTID('Strt'), hsb.saturation );
    desc169.putDouble( cTID('Brgh'), hsb.brightness );
    desc168.putObject( sTID('canvasExtensionColor'), cTID('HSBC'), desc169 );
  }
  executeAction( cTID('CnvS'), desc168, DialogModes.NO );
};

_ResizeOptions = function() {
  var self = this;

  self.width = 1024;
  self.weight = 1024;
  self.constrain = true;
  self.scaleStyles = true;
  self.resample = true;
  self.resampleMethod = ResampleMethod.BICUBIC;
};

Stdlib._resizeImage = function(doc, opts) {

  //
  function _ftn() {
    // resample, constrain
    var desc71 = new ActionDescriptor();
    desc71.putUnitDouble( cTID('Wdth'), cTID('#Pxl'), opts.width);
    desc71.putBoolean( sTID('scaleStyles'), opts.scaleStyles );
    desc71.putBoolean( cTID('CnsP'), true );
    desc71.putEnumerated( cTID('Intr'), cTID('Intp'), cTID('Bcbc') );
    executeAction( cTID('ImgS'), desc71, DialogModes.NO );

    // no resample
    var id307 = charIDToTypeID( "ImgS" );
    var desc77 = new ActionDescriptor();
    var id308 = charIDToTypeID( "Wdth" );
    var id309 = charIDToTypeID( "#Rlt" );
    desc77.putUnitDouble( id308, id309, 477.217685 );
    executeAction( id307, desc77, DialogModes.NO );

    // resample, no constrain, no scale
    var desc84 = new ActionDescriptor();
    desc84.putUnitDouble( cTID('Wdth'), cTID('#Pxl'), 1024.000000 );
    desc84.putUnitDouble( cTID('Hght'), cTID('#Rlt'), 468.936026 );
    desc84.putEnumerated( cTID('Intr'), cTID('Intp'), cTID('Bcbc') );
    executeAction( cTID('ImgS'), desc84, DialogModes.NO );

  }

  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.PSfitImage = function(width, height) {
  var desc = new ActionDescriptor();
  desc.putUnitDouble( cTID('Wdth'), cTID('#Pxl'), width );
  desc.putUnitDouble( cTID('Hght'), cTID('#Pxl'), height );
    
  var fitId = sTID('3caa3434-cb67-11d1-bc43-0060b0a13dc4');
  return executeAction(fitId , desc, DialogModes.NO );
};
Stdlib.fitImage = function(doc, width, height, resample) {
  if (false) {
  }

  if (true) {
    Stdlib.resizeImage(doc, width, height, true, resample);
  }
};

Stdlib.resizeImage = function(doc, width, height, constrained, resample) {
  function _ftn() {
    if (constrained == undefined) {
      constrained = true;
    }

    if (resample == undefined) {
      resample = ResampleMethod.BICUBIC;
    }

    var w = doc.width.value;
    var h = doc.height.value;
    var rez = doc.resolution;

    if (w == width && h == height) {
      return;
    }
    doc.resizeImage(undefined, undefined, 72, ResampleMethod.NONE);

    if (constrained) {
      var dratio = h/w;
      var ratio = height/width;

      if (dratio > ratio) {
        width = undefined;
      } else {
        height = undefined;
      }
    }

    doc.resizeImage(width, height, 72, resample);
    
    doc.resizeImage(undefined, undefined, rez, ResampleMethod.NONE);
  };

  var ru = app.preferences.rulerUnits;
  app.preferences.rulerUnits = Units.PIXELS;

  Stdlib.wrapLC(doc, _ftn);

  app.preferences.rulerUnits = ru;
};


//
//================================ Selections ===============================
//

//
// Crop on the current selection
//
Stdlib.crop = function(doc) {
  Stdlib.doEvent(doc, "Crop"); // "Crop";
};


Stdlib.cropBounds = function(doc, bnds) {
  Stdlib.selectBounds(doc, bnds);
  Stdlib.crop(doc);
  doc.selection.deselect();
};

//
// Do an interactive crop. Use the bounds specified or the current selection
// if no bounds are specified
//
Stdlib.interactiveCrop = function(doc, bnds) {
  var cropDesc = new ActionDescriptor();
  var toDesc = new ActionDescriptor();
  toDesc.putUnitDouble( PSKey.Top, PSUnit.Pixels, bnds[0] );
  toDesc.putUnitDouble( PSKey.Left, PSUnit.Pixels, bnds[1] );
  toDesc.putUnitDouble( PSKey.Bottom, PSUnit.Pixels, bnds[2] );
  toDesc.putUnitDouble( PSKey.Right, PSUnit.Pixels, bnds[3] );
  cropDesc.putObject( PSKey.To, PSClass.Rectangle, toDesc );
  cropDesc.putUnitDouble( PSKey.Angle, PSUnit.Angle, 0.000000 );
  cropDesc.putUnitDouble( PSKey.Width, PSUnit.Pixels, 0.000000 );
  cropDesc.putUnitDouble( PSKey.Height, PSUnit.Pixels, 0.000000 );
  cropDesc.putUnitDouble( PSKey.Resolution, PSUnit.Density, 0.000000 );

  try {
    executeAction( PSEvent.Crop, cropDesc, DialogModes.ALL );
  } catch (e) {
    if (e.number != 8007) { // if not "User cancelled"
      throw e;
    }
    return false;
  }
  return true;
};

//
// Transform the current selection
//
Stdlib.transformSelection = function(doc) {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putProperty(cTID("Chnl"), cTID("fsel"));
  desc.putReference(cTID("null"), ref);
  executeAction(cTID("Trnf"), desc, DialogModes.ALL);
};

// ????
Stdlib.freeTransformSelection = function(doc, layer) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated(cTID("Mn  "), cTID("MnIt"), cTID("FrTr"));
    desc.putReference(cTID("null"), ref);
    app.executeAction(cTID("slct"), desc, DialogModes.NO );
//     app.executeAction(cTID("FrTr"),
//                              new ActionDescriptor(),
//                              DialogModes.NO);
  }
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};


Stdlib.magicWand = function(doc, x, y, tol, aa, cntg) {
  function _ftn() {
    var desc = new ActionDescriptor();

    // Selection
    var ref = new ActionReference();
    ref.putProperty(cTID("Chnl"), cTID("fsel"));
    desc.putReference(cTID("null"), ref);

    // Point
    var pdesc = new ActionDescriptor();
    pdesc.putUnitDouble(cTID("Hrzn"), cTID("#Pxl"), x);
    pdesc.putUnitDouble(cTID("Vrtc"), cTID("#Pxl"), y);
    desc.putObject(cTID("T   "), cTID("Pnt "), pdesc);

    // Tolerance
    if (tol != undefined) {
      desc.putInteger(cTID("Tlrn"), tol);
    }

    // Anti-alias
    desc.putBoolean(cTID("AntA"), !!aa);

    // Contiguous
    desc.putBoolean(cTID("Cntg"), !!cntg);
    
    executeAction(cTID("setd"), desc, DialogModes.NO);
  }

  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.selectSimilar = function(doc, tol, aa) {
  function _ftn() {
    var desc = new ActionDescriptor();

    // Selection
    var ref = new ActionReference();
    ref.putProperty(cTID("Chnl"), cTID("fsel"));
    desc.putReference(cTID("null"), ref);

    // Tolerance
    if (tol != undefined) {
      desc.putInteger(cTID("Tlrn"), tol);
    }

    // Anti-alias - defaults to true
    desc.putBoolean(cTID("AntA"), aa != false);

    executeAction(cTID("Smlr"), desc, DialogModes.NO);
  }

  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.selectBounds = function(doc, b, type, feather, antialias) {
  function _ftn () {
    doc.selection.select([[ b[0], b[1] ],
                          [ b[2], b[1] ],
                          [ b[2], b[3] ],
                          [ b[0], b[3] ]],
                         type, feather, antialias);
  }
  if (feather == undefined) {
    feather = 0;
  }
  if (antialias == undefined) {
    antialias = false;
  }
  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.computeSelectionBoundsLS = function(doc) {
  var bnds = [];
  var ru = app.preferences.rulerUnits;
  app.preferences.rulerUnits = Units.PIXELS;

  var oldLayer = doc.activeLayer;
  try {
    var layerSetRef = doc.layerSets.add();
    var layerRef = layerSetRef.artLayers.add();
    doc.activeLayer = layerRef;
    doc.selection.fill( app.foregroundColor);
    bnds = layerSetRef.bounds;
    layerSetRef.remove();
  } finally {
    doc.activeLayer = oldLayer;
    app.preferences.rulerUnits = ru;
  }

  return bnds;
};

Stdlib.computeSelectionBounds = function(doc) {
  var bnds = [];

  var dbgLevel = $.level;
  try {
    $.level = 0;
    doc.selection.makeWorkPath();
  } catch (e) {
    $.level = dbgLevel;
    return bnds;
  }
  $.level = dbgLevel;

  try {
    var pis = doc.pathItems; // should be doc.pathItems.getByName("WorkPath");
    if (pis.length > 0) {
      for (var i = 0; i < pis.length; i++) {
        var spis = pis[i].subPathItems;
        for (var j = 0; j < spis.length; j++) {
          var pps = spis[j].pathPoints;
          for (var k = 0; k < pps.length; k++) {
            var anchor = pps[k].anchor;
            if (bnds.length == 0) {
              bnds[0] = bnds[2] = anchor[0];
              bnds[1] = bnds[3] = anchor[1];
            } else {
              if (anchor[0] < bnds[0]) {
                bnds[0] = anchor[0];
              } else if (anchor[0] > bnds[2]) {
                bnds[2] = anchor[0];
              }
              if (anchor[1] < bnds[1]) {
                bnds[1] = anchor[1];
              } else if (anchor[1] > bnds[3]) {
                bnds[3] = anchor[1];
              }
            }
          }
        }
      }
    }
  } finally {
    Stdlib.undo();
  }

  return bnds;
};

Stdlib.computeSelectionBoundsPS7 = function(doc) {
  var bnds = [];

  Stdlib.makeWorkPath(doc);

  try {
    var pis = Stdlib.getPathItems(doc);

    for (var i = 0; i < pis.count; i++) {
      var spis = pis.getObjectValue(i).getList(sTID("subpathListKey"));
      var pps = spis.getObjectValue(0).getList(sTID('points'));
      
      for (var j = 0; j < pps.count; j++) {
        var anchorObj = pps.getObjectValue(j).getObjectValue(sTID("anchor"));
        var anchor = [anchorObj.getUnitDoubleValue(sTID('horizontal')),
                      anchorObj.getUnitDoubleValue(sTID('vertical'))];
        if (bnds.length == 0) {
          bnds[0] = bnds[2] = anchor[0];
          bnds[1] = bnds[3] = anchor[1];
        } else {
          if (anchor[0] < bnds[0]) {
            bnds[0] = anchor[0];
          } else if (anchor[0] > bnds[2]) {
            bnds[2] = anchor[0];
          }
          if (anchor[1] < bnds[1]) {
            bnds[1] = anchor[1];
          } else if (anchor[1] > bnds[3]) {
            bnds[3] = anchor[1];
          }
        }
      }
    }
  } finally {
    Stdlib.undo();
  }

  return bnds;
};

Stdlib.getSelectionBounds = function(doc) {
  function _ftn() {
    var l = doc.artLayers.add();

    doc.selection.fill(app.foregroundColor);
    
    var bnds = l.bounds;
    var hs = doc.historyStates;
  
    if (hs[hs.length-2].name == "Layer Order") {
      doc.activeHistoryState = hs[hs.length-4];
    } else {
      doc.activeHistoryState = hs[hs.length-3];
    }
  
    for (var i = 0; i < bnds.length; i++) {
      bnds[i] = bnds[i].value;
    }
    return bnds;
  }

  return Stdlib.wrapLCLayer(doc, doc.activeLayer, _ftn);
};

// assumes that 0,0 is a background pixel
Stdlib.selectBackground = function(doc, layer) {
  Stdlib.hideAllLayers(doc);
  layer.visible = true;
  Stdlib.magicWand(doc, 0, 0);
  Stdlib.selectSimilar(doc);
  doc.selection.invert();
};


Stdlib.hasSelection = function(doc) {
  var res = false;
  var as = doc.activeHistoryState;
  doc.selection.deselect();
  if (as != doc.activeHistoryState) {
    res = true;
    doc.activeHistoryState = as;
  }
  return res;
};

// This only returns one selected region. If the selection is disjoint,
// another function will have to be implemented
Stdlib.computeSelectionRegion = function(doc) {
  var bnds = [];

  var dbgLevel = $.level;
  try {
    $.level = 0;
    doc.selection.makeWorkPath();
  } catch (e) {
    $.level = dbgLevel;
    return bnds;
  }
  $.level = dbgLevel;

  try {
    var path = doc.pathItems["Work Path"];
    var subPathItems = path.subPathItems;

    for (var i = 0; i < subPathItems.length; i++) {
      var subPath = subPathItems[i];
      var points = subPath.pathPoints;
      for (var j = 0; j < points.length; j++) {
        var point = points[j];
        bnds.push(point.anchor);
      }
    }
  } finally {
    Stdlib.undo();
  }

  return bnds;
};

Stdlib.centerCanvasOnSelection = function(doc) {
  if (!Stdlib.hasSelection(doc)) {
    Error.runtimeError(8152); // "A selection is required for this operation."
  }

  var ru = app.preferences.rulerUnits;
  try {
    app.preferences.rulerUnits = Units.PIXELS;

    var bnds = Stdlib.getSelectionBounds(doc);
    var selX = (bnds[0]+bnds[2])/2;
    var selY = (bnds[1]+bnds[3])/2;

    var docX = doc.width.value/2;
    var docY = doc.height.value/2;

    doc.activeLayer.translate(docX-selX, docY-selY);
    doc.selection.translateBoundary(docX-selX, docY-selY);

  } finally {
    app.preferences.rulerUnits = ru;
  }
};

Stdlib.centerLayer = function(doc, layer) {
  var ru = app.preferences.rulerUnits;
  app.preferences.rulerUnits = Units.PIXELS;
  try {
    var bnds = Stdlib.getLayerBounds(doc, layer);
    var layerW = bnds[2]-bnds[0];
    var layerH = bnds[3]-bnds[1];
    var docW = doc.width.value;
    var docH = doc.height.value;
    var x = (docW/2) - (layerW/2);
    var y = (docH/2) - (layerH/2);
    var deltaX = x - bnds[0];
    var deltaY = y - bnds[1];

    layer.translate(deltaX, deltaY);

  } finally {
    app.preferences.rulerUnits = ru;
  }
};


//============================== Vector Mask ==========================

Stdlib._doVectorMask = function(doc, layer, prop, state) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref );
    var desc54 = new ActionDescriptor();
    desc54.putBoolean( xTID(prop), state );
    desc.putObject( cTID('T   '), cTID('Lyr '), desc54 );
    executeAction( cTID('setd'), desc, DialogModes.NO );
  };

  return Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.disableVectorMask = function(doc, layer) {
  Stdlib._doVectorMask(doc, layer, 'vectorMaskEnabled', false );
};
Stdlib.enableVectorMask = function(doc, layer) {
  Stdlib._doVectorMask(doc, layer, 'vectorMaskEnabled', true);
};
Stdlib.unlinkVectorMask = function(doc, layer) {
  Stdlib._doVectorMask(doc, layer, 'vectorMaskLinked', false );
};
Stdlib.linkVectorMask = function(doc, layer) {
  Stdlib._doVectorMask(doc, layer, 'vectorMaskLinked', true );
};

Stdlib.hasVectorMask = function(doc, layer) {
  var lvl = $.level;
  $.level = 0;
  var rc = false;
  try {
    var st = doc.activeHistoryState;
    Stdlib.linkVectorMask(doc, layer);
    if (doc.activeHistoryState != st) {
      doc.activeHistoryState = st;
    }
    rc = true;
  } catch (e) {
  } finally {
    $.level = lvl;
  }

  return rc;
};

Stdlib.isVectorMaskEnabled = function(doc, layer) {
  var rc = false;

  if (Stdlib.hasVectorMask(doc, layer)) {
    try {
      var st = doc.activeHistoryState;
      Stdlib.enableVectorMask(doc, layer);
      if (doc.activeHistoryState == st) {
        rc = true;
      } else {
        doc.activeHistoryState = st;
      }
    } catch (e) {
    } finally {
      $.level = lvl;
    }
  }

  return rc;
};

Stdlib.rasterizeVectorMask = function(doc, layer) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref );
    desc.putEnumerated( cTID('What'),
                        sTID('rasterizeItem'),
                        sTID('vectorMask') );
    executeAction( sTID('rasterizeLayer'), desc, DialogModes.NO );
  };

  return Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.selectVectorMask = function(doc, layer) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated(cTID('Path'), cTID('Path'), sTID('vectorMask'));
    ref.putEnumerated(cTID('Lyr '), cTID('Ordn'), cTID('Trgt'));
    desc.putReference(cTID('null'), ref);
    return executeAction(cTID('slct'), desc, DialogModes.NO);
  }
  return Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.deselectVectorMask = Stdlib.deselectActivePath;

Stdlib.loadVectorMaskSelection = function(doc, layer) {
  function _ftn() {
    var desc8 = new ActionDescriptor();
    var ref4 = new ActionReference();
    ref4.putProperty( cTID('Chnl'), cTID('fsel') );
    desc8.putReference( cTID('null'), ref4 );
    var ref5 = new ActionReference();
    ref5.putEnumerated( cTID('Path'), cTID('Path'), sTID('vectorMask') );
    ref5.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc8.putReference( cTID('T   '), ref5 );
    desc8.putBoolean( cTID('AntA'), true );
    desc8.putUnitDouble( cTID('Fthr'), cTID('#Pxl'), 0.000000 );
    executeAction( cTID('setd'), desc8, DialogModes.NO );
  }
  return Stdlib.wrapLCLayer(doc, layer, _ftn);
};


Stdlib.rotateVectorMask = function(doc, layer, angle) {
  function _ftn() {
    var desc89 = new ActionDescriptor();
        var ref67 = new ActionReference();
        ref67.putEnumerated( cTID('Path'), cTID('Ordn'), cTID('Trgt') );
    desc89.putReference( cTID('null'), ref67 );
    desc89.putEnumerated( cTID('FTcs'), cTID('QCSt'), cTID('Qcsa') );
        var desc90 = new ActionDescriptor();
        desc90.putUnitDouble( cTID('Hrzn'), cTID('#Pxl'), -0.000000 );
        desc90.putUnitDouble( cTID('Vrtc'), cTID('#Pxl'), 0.000000 );
    desc89.putObject( cTID('Ofst'), cTID('Ofst'), desc90 );
    desc89.putUnitDouble( cTID('Angl'), cTID('#Ang'), angle );
    executeAction( cTID('Trnf'), desc89, DialogModes.NO );
  }
  return Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.selectionFromVectorMask = function(doc, layer, aa, feather) {
  if (!feather) {
    feather = 0.0;
  }
  aa = !!aa;
  function _ftn() {
    var desc = new ActionDescriptor();
    var selref = new ActionReference();
    selref.putProperty(cTID('Chnl'), cTID('fsel'));
    desc.putReference(cTID('null'), selref);
    var vmref = new ActionReference();
    vmref.putEnumerated(cTID('Path'), cTID('Path'), sTID('vectorMask'));
    vmref.putEnumerated(cTID('Lyr '), cTID('Ordn'), cTID('Trgt'));
    desc.putReference(cTID('T   '), vmref);
    desc.putBoolean(cTID('AntA'), aa);
    desc.putUnitDouble(cTID('Fthr'), cTID('#Pxl'), feather);
    executeAction(cTID('setd'), desc, DialogModes.NO);
  }
  return Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.getVectorMaskBounds = function(doc, layer) {
  function _ftn() {
    var st = doc.activeHistoryState;
    Stdlib.selectionFromVectorMask(doc, layer);
    var bnds = Stdlib.getSelectionBounds(doc);
    doc.activeHistoryState = st;
    return bnds;
  }

//   Stdlib.undo(doc);
//   //executeAction(cTID("undo"), new ActionDescriptor(), DialogModes.NO);

  var bnds = Stdlib.wrapLCLayer(doc, layer, _ftn);

  return bnds;
};

Stdlib.createSolidFillLayer = function(doc, color) {
  if (!color) {
    color = Stdlib.createRGBColor(0, 0, 0);
  }
  function _ftn() {
    var desc = new ActionDescriptor();
    var clref = new ActionReference();
    clref.putClass(sTID('contentLayer'));
    desc.putReference(cTID('null'), clref);
    var tdesc = new ActionDescriptor();
    var scldesc = new ActionDescriptor();
    var rgbdesc = new ActionDescriptor();
    rgbdesc.putDouble(cTID('Rd  '), color.rgb.red);
    rgbdesc.putDouble(cTID('Grn '), color.rgb.green);
    rgbdesc.putDouble(cTID('Bl  '), color.rgb.blue);
    scldesc.putObject(cTID('Clr '), cTID('RGBC'), rgbdesc);
    tdesc.putObject(cTID('Type'), sTID('solidColorLayer'), scldesc);
    desc.putObject(cTID('Usng'), sTID('contentLayer'), tdesc);
    executeAction(cTID('Mk  '), desc, DialogModes.NO);
  }
  Stdlib.wrapLC(doc, _ftn);
  return doc.activeLayer;
};

Stdlib.createVectorMaskFromCurrentPath = function(doc, layer) {

  function _ftn(doc) {
    var desc = new ActionDescriptor();
    var ref135 = new ActionReference();
    ref135.putClass( cTID('Path') );
    desc.putReference( cTID('null'), ref135 );
    var ref136 = new ActionReference();
    ref136.putEnumerated( cTID('Path'), cTID('Path'), sTID('vectorMask') );
    desc.putReference( cTID('At  '), ref136 );
    var ref137 = new ActionReference();
    ref137.putEnumerated( cTID('Path'), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('Usng'), ref137 );
    executeAction( cTID('Mk  '), desc, DialogModes.NO );
  };

  Stdlib.wrapLC(doc, _ftn);
};


//
//================================ Paths ===============================
//
// PS7 doesn't have one of these so we provide one here...
//
Stdlib.makeWorkPath = function(doc, tolerance) {
  function _ftn(doc) {
    var desc = new ActionDescriptor();

    var pref = new ActionReference();
    pref.putClass(cTID("Path"));
    desc.putReference(cTID("null"), pref );

    var sref = new ActionReference();
    sref.putProperty( cTID("csel"), cTID("fsel"));
    desc.putReference(cTID("From"), sref );
    
    desc.putUnitDouble(cTID("Tlrn"), cTID("#Pxl"), Stdlib.makeWorkPath.tolerance);

    executeAction(cTID("Mk  "), desc, DialogModes.NO);
  }

  Stdlib.makeWorkPath.tolerance = (tolerance != undefined) ? tolerance : 2.0;

  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.makePathActive = function(doc, pathName) {
  function _ftn() {
    var desc91 = new ActionDescriptor();
    var ref82 = new ActionReference();
    ref82.putName( cTID('Path'), pathName );
    desc91.putReference( cTID('null'), ref82 );
    executeAction( cTID('slct'), desc91, DialogModes.NO );
  };

  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.makeSelectionFromPath = function(doc, pathName) {
  function _ftn() {
    var desc89 = new ActionDescriptor();
    var ref79 = new ActionReference();
    ref79.putProperty( cTID('Chnl'), cTID('fsel') );
    desc89.putReference( cTID('null'), ref79 );
    var ref80 = new ActionReference();
    ref80.putEnumerated( cTID('Path'), cTID('Ordn'), cTID('Trgt') );
    desc89.putReference( cTID('T   '), ref80 );
    desc89.putBoolean( cTID('AntA'), true );
    desc89.putUnitDouble( cTID('Fthr'), cTID('#Pxl'), 0.000000 );
    executeAction( cTID('setd'), desc89, DialogModes.NO );
  };
  
  Stdlib.makePathActive(doc, pathName);
  Stdlib.wrapLC(doc, _ftn);
};


// if (!Selection.prototype.makeWorkPath) {
// Selection.prototype.makeWorkPath = function(tol) {
//   Stdlib.makeWorkPath(this, tol);
// };
// }

Stdlib.getPathItems = function(doc) {
  function _ftn() {
    var ref = new ActionReference();
    ref.putEnumerated(sTID('path'), sTID('ordinal'), sTID('targetEnum'));
    var pathObj = executeActionGet(ref);
    var pathContents = pathObj.getObjectValue(sTID('pathContents'));
    return pathContents.getList(sTID('pathComponents'));
  }
  return Stdlib.wrapLC(doc, _ftn);
};

//
// deselect the active path. just a piece of UI fluff
//
Stdlib.deselectActivePath = function(doc) {
  function _ftn() {
    var ref = new ActionReference();
    ref.putClass(cTID("Path"));

    var desc = new ActionDescriptor();
    desc.putReference(cTID("null"), ref);
    executeAction( cTID( "Dslc" ), desc, DialogModes.NO );
  };
  Stdlib.wrapLC(doc, _ftn);
};

//
//================================= Actions ==================================
//
// attempt to execute an action. return true if OK, false if not available
// re-throws unknown exceptions.
//
Stdlib.runAction = function(atn, atnSet) {
  try {
    app.doAction(atn, atnSet);
  } catch (e) {
    if (e.toString().match(/action.+is not currently available/)) {
      return false;
    } else {
      throw e;
    }
  }
  return true;
};
runAction = Stdlib.runAction;

Stdlib.hasAction = function(atn, atnSet) {
  var asetDesc;
  var rc = false;
  var i = 1;

  var asMatches = [];
  
  while (true) {
    var ref = new ActionReference();
    ref.putIndex(cTID("ASet"), i);
    var desc;
    try {
      desc = executeActionGet(ref);
    } catch (e) {
      break;    // all done
    }
    if (desc.hasKey(cTID("Nm  ")) &&
        desc.getString(cTID("Nm  ")) == atnSet) {
      asetDesc = desc;
      asMatches.push({ index: i, desc: desc});
      //break;
    }
    i++;
  }

  if (asMatches.length == 0) {
    return false;
  }

  for (var i = 0; i < asMatches.length; i++) {
    var asmatch = asMatches[i];
    var asetIndex = asmatch.index;
    asetDesc = asmatch.desc;

    if (!asetDesc.hasKey(cTID("NmbC"))) {
      continue;
    }
    var max = asetDesc.getInteger(cTID("NmbC"));
    for (var j = 1; j <= max; j++) {
      var ref = new ActionReference();
      ref.putIndex(cTID("Actn"), j);           // Action index
      ref.putIndex(cTID("ASet"), asetIndex);   // ActionSet index
        
      var desc;
      try {
        desc = executeActionGet(ref);
      } catch (e) {
        break;   // all done
      }
      if (desc.hasKey(cTID("Nm  ")) &&
          desc.getString(cTID("Nm  ")) == atn) {
        return true;
      }
    }
  }
  return rc;
};

Stdlib.deleteActionStep = function(index, atn, atnSet) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putIndex(cTID("Cmnd"), index);
    ref.putName(cTID("Actn"), atn);
    ref.putName(cTID("ASet"), atnSet);
    desc.putReference(cTID("null"), ref);
    executeAction(cTID("Dlt "), desc, DialogModes.NO);
  }

  _ftn();
};
Stdlib.deleteAction = function(atn, atnSet) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putName(cTID("Actn"), atn);
    ref.putName(cTID("ASet"), atnSet);
    desc.putReference(cTID("null"), ref);
    executeAction(cTID("Dlt "), desc, DialogModes.NO);
  }

  _ftn();
};
Stdlib.deleteActionSet = function(atnSet) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putName(cTID("ASet"), atnSet);
    desc.putReference(cTID("null"), ref);
    executeAction(cTID("Dlt "), desc, DialogModes.NO);
  }

  try {
    _ftn();
  } catch (e) {
    // if this action is the currently executing action,
    // we can't delete it, so we return false. All other
    // exceptions are rethrown
    if (!e.toString().match(/action that is playing or recording/)) {
      throw e;
    }
    return false;
  }
  return true;
};


Stdlib.createDroplet = function(atn, atnSet, fptr) {
  debugger;

  fptr = Stdlib.convertFptr(fptr);

  function _ftn() {
    var desc = new ActionDescriptor();
    desc.putPath(cTID('In  '), fptr);
    var ref = new ActionReference();
    ref.putName(cTID('Actn'), atn);
    ref.putName(cTID('ASet'), atnSet);
    desc.putReference(cTID('Usng'), ref);
    executeAction(cTID('CrtD'), desc, DialogModes.NO);
  }

  _ftn();
};


//
//  f = File.openDialog(); Stdlib.loadActionFile(f);
//
Stdlib.loadActionFile = function(file) {
  Stdlib.btExec('app.load(new File("' + file.absoluteURI + '"));');
};

//
// Stdlib.loadActionFiles(folder.getFiles("*.atn"))'
//
Stdlib.loadActionFiles = function(files) {
  var str = '';

  for (var i = 0; i < files.length; i++) {
    var file = files[0];
    str += 'app.load(new File("' + file.absoluteURI + '"));\n'
  }
  Stdlib.btExec(str);
};

Stdlib.getActionSets = function() {
  var i = 1;
  var sets = [];
  
  while (true) {
    var ref = new ActionReference();
    ref.putIndex(cTID("ASet"), i);
    var desc;
    var lvl = $.level;
    $.level = 0;
    try {
      desc = executeActionGet(ref);
    } catch (e) {
      break;    // all done
    } finally {
      $.level = lvl;
    }
    if (desc.hasKey(cTID("Nm  "))) {
      var set = {};
      set.index = i;
      set.name = desc.getString(cTID("Nm  "));
      set.toString = function() { return this.name; };
      set.count = desc.getInteger(cTID("NmbC"));
      set.actions = [];
      for (var j = 1; j <= set.count; j++) {
        var ref = new ActionReference();
        ref.putIndex(cTID('Actn'), j);
        ref.putIndex(cTID('ASet'), set.index);
        var adesc = executeActionGet(ref);
        var actName = adesc.getString(cTID('Nm  '));
        set.actions.push(actName);
      }
      sets.push(set);
    }
    i++;
  }

  return sets;
};

Stdlib.getActions = function(aset) {
  var i = 1;
  var names = [];

  if (!aset) {
    throw Error.runtimeError(9001, "Action set must be specified");
  }
  
  while (true) {
    var ref = new ActionReference();
    ref.putIndex(cTID("ASet"), i);
    var desc;
    try {
      desc = executeActionGet(ref);
    } catch (e) {
      names = undefined;
      break;    // all done
    }
    if (desc.hasKey(cTID("Nm  "))) {
      var name = desc.getString(cTID("Nm  "));
      if (name == aset) {
        var count = desc.getInteger(cTID("NmbC"));
        var names = [];
        for (var j = 1; j <= count; j++) {
          var ref = new ActionReference();
          ref.putIndex(cTID('Actn'), j);
          ref.putIndex(cTID('ASet'), i);
          var adesc = executeActionGet(ref);
          var actName = adesc.getString(cTID('Nm  '));
          names.push(actName);
        }
        break;
      }
    }
    i++;
  }

  return names;
};

Stdlib.backupActionsPalette = function(file) {
  if (file) {
    file = Stdlib.convertFptr(file);
  } else {
    file = File.saveDialog("Save Backup ActionsPalette",
                           "PSP Files:*.PSP,All files:*");
  }

  if (file) {
    if (!app.preferencesFolder) {
      Error.runtimeError(9001, "\rNo preferencesFolder property found. " +
                         "\rUnable to complete request.");
    }
    var paletteFile = new File(app.preferencesFolder +
                               "/Actions Palette.psp");
    if (!paletteFile.exists) {
      Error.runtimeError(9001, "Unable to locate palette file.");
    }
    paletteFile.copy(file) || throwFileError(file, "Copy failed ");
  }
};

//
// Very dangerous unless you _want_ to empty your Actions Palette.
//
Stdlib.deleteAllActionSets = function(confirmDelete) {
  if (confirmDelete != false) {
    if (!confirm("Do you really want to empty your Actions Palette?")) {
      return;
    }
  }

  var sets = Stdlib.getActionSets();

  for (var i = sets.length-1; i >= 0; i--) {
    Stdlib.deleteActionSet(sets[i].name);
  }
};

Stdlib.setActionPlaybackOption = function(opt, arg) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putProperty(cTID("Prpr"), cTID("PbkO"));
    ref.putEnumerated(cTID("capp"), cTID("Ordn"), cTID("Trgt")); 
    desc.putReference(cTID("null"), ref );
    var pdesc = new ActionDescriptor();
    pdesc.putEnumerated(sTID("performance"), sTID("performance"), sTID(opt));
    if (opt == "pause" && arg != undefined) {
      pdesc.putInteger(sTID("pause"), parseInt(arg));
    }
    desc.putObject(cTID("T   "), cTID("PbkO"), pdesc );
    executeAction(cTID("setd"), desc, DialogModes.NO);
  }
  _ftn();
};
Stdlib.setPlaybackAccelerated = function() {
  Stdlib.setActionPlaybackOption("accelerated");
};
Stdlib.setPlaybackStepByStep = function() {
  Stdlib.setActionPlaybackOption("stepByStep");
};
Stdlib.setPlaybackPaused = function(delaySec) {
  Stdlib.setActionPlaybackOption("pause", delaySec);
};

Stdlib.getApplicationDescriptor = function() {
  var ref = new ActionReference();
  ref.putEnumerated(cTID("capp"), cTID("Ordn"), cTID("Trgt")); 
  executeActionGet(ref);
};

Stdlib.getDescriptorKeys = function(desc) {
  var keys = [];

  for (var i = 0; i < desc.count; i++) {
    keys.push(desc.getKey(i));
  }
  return keys;
};
Stdlib.getDescriptorKeySyms = function(desc) {
  var keys = [];

  for (var i = 0; i < desc.count; i++) {
    keys.push(id2char(desc.getKey(i)));
  }
  return keys;
};

Stdlib.getDescriptorKeyNames = function(desc) {
  var keys = [];

  for (var i = 0; i < desc.count; i++) {
    keys.push(PSConstant.reverseNameLookup(desc.getKey(i)));
  }
  return keys;
};

//
//=============================== DataSets ===================================
//
// Thanks to mhale for these
//
Stdlib.fileImportDataSets = function(dsfile) {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putClass(sTID("dataSetClass"));
  desc.putReference(cTID("null"), ref);
  desc.putPath(cTID("Usng"), new File(dsfile));
  desc.putEnumerated(cTID("Encd"),
                     sTID("dataSetEncoding"),
                     sTID("dataSetEncodingAuto"));
  desc.putBoolean(sTID("eraseAll"), true);
  desc.putBoolean(sTID("useFirstColumn"), false);
  executeAction(sTID("importDataSets"), desc, DialogModes.NO);
};

Stdlib.applyDataSet = function(setName) {
  var desc = new ActionDescriptor();
  var setRef = new ActionReference();
  setRef.putName(sTID("dataSetClass"), setName);
  desc.putReference(cTID("null"), setRef);
  executeAction(cTID("Aply"), desc, DialogModes.NO);
};

//
//================================= Batch =====================================
//
//
// This is an alternative interface to Batch (instead of app.batch)
// It has the ability to:
//    specify text fragments as file name components. 
//    recurse into subfolders
//    use a file mask/regexp to specify files
//
//  src     - a File, Folder, or an Array of Files and Folders
//  act     - the Action name
//  actset  - the ActionSet name
//  opts    - BatchOptions with support for text file naming components
//  mask    - either a simple mask ("*.jpg"), a function mask
//            (see Folder.getFiles()) or a Regular Expression (/\.jpe?g$/i)
//  recurse - if true, recurse into subdirectories 
//
Stdlib.batch = function(src, act, actset, opts, mask, recurse) {
  if (isCS() || isPS7()) {
    Error.runtimeError(9001, "Batch is only available in CS2+.");
  }

  var desc = new ActionDescriptor();

  if (src instanceof Array) {
    for (var i = 0; i < src.length; i++) {
      Stdlib.batch(src[i], act, actset, opts, mask, recurse);
      opts.startingSerial++;
    }
    return;
  }

  var subdirs;
  if (src instanceof Folder) {
    if (mask) {
      var files;
      if (recurse == true) {
        files = Stdlib.findFiles(src, mask);
      } else {
        files = Stdlib.getFiles(src, mask);
      }
      if (files.length > 0) {
        Stdlib.batch(files, act, actset, opts, mask, recurse);
      }
      return;
    }
    if (recurse == true) {
      subdirs = Stdlib.getFolders(src);
    }
  }

//   $.level = 1; debugger;
  desc.putPath(cTID("null"), src); // source

  if (opts.suppressProfile == true) {
    desc.putBoolean(sTID("suppressWarnings"), true);
  }
  if (opts.suppressOpen == true) {
    desc.putBoolean(sTID("suppressOpenOptions"), true);
  }

  var actref = new ActionReference();
  actref.putName(cTID("Actn"), act);
  actref.putName(cTID("ASet"), actset);
  desc.putReference(cTID("Usng"), actref);

  if (opts.overrideOpen == true) {
    desc.putBoolean(cTID("OvrO"), true);
  }
  
  if (opts.destination != BatchDestinationType.NODESTINATION) {
    desc.putPath(cTID("T   "), opts.destinationFolder);
  }

  var fileNaming;

  if (opts.destination == BatchDestinationType.FOLDER) {
    fileNaming = opts.fileNaming;

  } else if (opts.destination == BatchDestinationType.SAVEANDCLOSE) {
    fileNaming = [ FileNamingType.DOCUMENTNAMEMIXED,
                   FileNamingType.EXTENSIONLOWER ];
  }

  if (fileNaming) {
    if (fileNaming.length > 6) {
      Error.runtimeError(9001, "Too many BatchOptions.fileNaming components.");
    }
    var fnrdesc = new ActionDescriptor();
    var fnclist = new ActionList();
    
    for (var i = 0; i < opts.fileNaming.length; i++) {
      var namingComponent = opts.fileNaming[i];
      var fncdesc = new ActionDescriptor();
    
      if (typeof namingComponent == "string" ||
          namingComponent instanceof String) {
        fncdesc.putString(cTID("Txt "), opts.fileNaming[i]);
      } else {
        var mappedId = Stdlib.batch.map[namingComponent];
        fncdesc.putEnumerated(sTID("component"),
                              sTID("fileNamingComponent"),
                              mappedId);
      }
      fnclist.putObject(sTID("fileNamingComponents"), fncdesc);
    }

    fnrdesc.putList(sTID("fileNamingComponents"), fnclist);

    fnrdesc.putInteger(cTID("Strt"), opts.startingSerial);

    fnrdesc.putBoolean(cTID("Mcnt"), opts.macintoshCompatible);
    fnrdesc.putBoolean(cTID("Win "), opts.windowsCompatible);
    fnrdesc.putBoolean(sTID("unix"), opts.unixCompatible);
    desc.putObject(sTID("fileNamingRules"), sTID("fileNamingRules"), fnrdesc);
  }

  if (opts.destination != BatchDestinationType.NODESTINATION) {
    if (opts.overrideSave == true) {
      desc.putBoolean(cTID("Ovrd"), true);
    }
  }

  if (opts.destination == BatchDestinationType.SAVEANDCLOSE) {
    desc.putBoolean(cTID("SvAn"), true);
  }
  
  if (opts.errorFile) {
    desc.putPath(cTID("Log "), opts.errorFile.parent);
    desc.putString(cTID("Nm  "), opts.errorFile.name);
  }
  executeAction(cTID("Btch"), desc, DialogModes.NO);

  if (subdirs) {
    for (var i = 0; i < subdirs.length; i++) {
      Stdlib.batch(subdirs[i], act, actset, opts, mask, recurse);
    }
  }
};

Stdlib.batch.init = function() {
  if (!isPhotoshop()) {
    return;
  }
  if (isCS() || isPS7()) {
    return;
  }
  Stdlib.batch.map = {};
  Stdlib.batch.map[FileNamingType.DDMM] = sTID("ddmm");
  Stdlib.batch.map[FileNamingType.DDMMYY] = sTID("ddmmyy");
  Stdlib.batch.map[FileNamingType.DOCUMENTNAMELOWER] = sTID("lowerCase");
  Stdlib.batch.map[FileNamingType.DOCUMENTNAMEMIXED] = cTID("Nm  ");
  Stdlib.batch.map[FileNamingType.DOCUMENTNAMEUPPER] = sTID("upperCase");
  Stdlib.batch.map[FileNamingType.EXTENSIONLOWER] = sTID("lowerCaseExtension");
  Stdlib.batch.map[FileNamingType.EXTENSIONUPPER] = sTID("upperCaseExtension");
  Stdlib.batch.map[FileNamingType.MMDD] = sTID("mmdd");
  Stdlib.batch.map[FileNamingType.MMDDYY] = sTID("mmddyy");
  Stdlib.batch.map[FileNamingType.SERIALLETTERLOWER] = sTID("upperCaseSerial");
  Stdlib.batch.map[FileNamingType.SERIALLETTERUPPER] = sTID("lowerCaseSerial");
  Stdlib.batch.map[FileNamingType.SERIALNUMBER1] = sTID("oneDigit");
  Stdlib.batch.map[FileNamingType.SERIALNUMBER2] = sTID("twoDigit");
  Stdlib.batch.map[FileNamingType.SERIALNUMBER3] = sTID("threeDigit");
  Stdlib.batch.map[FileNamingType.SERIALNUMBER4] = sTID("fourDigit");
  Stdlib.batch.map[FileNamingType.YYDDMM] = sTID("yyddmm");
  Stdlib.batch.map[FileNamingType.YYMMDD] = sTID("yymmdd");
  Stdlib.batch.map[FileNamingType.YYYYMMDD] = sTID("yyyymmdd");
};

Stdlib.batch.init();

//
//================================= misc =====================================
//


//
// selectColorRange
//   Selects a range of colors around a specified color.
//   doc     - the document to operate on
//   color   - either a SolidColor or LabColor object
//   range   - the 'fuzziness' factor [default 40]
//   inverse - invert the selection [default 'false']
// Example:
//   Stdlib.selectColorRange(doc, Stdlib.getColorAt(doc, 125, 300), 50)
//
// Thanks to Andrew Hall for the original idea
//
Stdlib.selectColorRange = function(doc, color, range, inverse) {
  var clr = (color instanceof SolidColor) ? color.lab : color;
  if (inverse == undefined) {
    inverse = false;
  }
  if (range == undefined) {
    range = 40;
  }

  function _ftn() {
    var desc = new ActionDescriptor();
    desc.putInteger(cTID("Fzns"), range);

    var mnDesc = new ActionDescriptor();
    mnDesc.putDouble(cTID("Lmnc"), clr.l);
    mnDesc.putDouble(cTID("A   "), clr.a);
    mnDesc.putDouble(cTID("B   "), clr.b);
    desc.putObject(cTID("Mnm "), cTID("LbCl"), mnDesc);

    var mxDesc = new ActionDescriptor();
    mxDesc.putDouble(cTID("Lmnc"), clr.l);
    mxDesc.putDouble(cTID("A   "), clr.a);
    mxDesc.putDouble(cTID("B   "), clr.b);
    desc.putObject(cTID("Mxm "), cTID("LbCl"), mxDesc);

    if (inverse) {
      desc.putBoolean(cTID("Invr"), inverse);
    }

    executeAction(cTID("ClrR"), desc, DialogModes.NO );
  }
  Stdlib.wrapLC(doc, _ftn);
};

//
// selectColorRangeRGB
//   See 'selectColorRange' above
//   clr - either a RGBColor object or an Array with three(rgb) values
// Example:
//   Stdlib.selectColorRangeRGB(doc, [255, 144, 144], 50, true)
//
Stdlib.selectColorRangeRGB = function(doc, clr, range, inverse) {
  if (clr instanceof Array) {
    var c = new RGBColor();
    c.red = clr[0]; c.green = clr[1]; c.blue = clr[2];
    clr = new SolidColor();
    clr.rgb = c;
  } else if (clr instanceof RGBColor) {
    c = new SolidColor();
    c.rgb = clr;
    clr = c;
  } else {
    Error.runtimeError(19, "color"); // "Bad color argument");
  }

  Stdlib.selectColorRange(doc, clr, range, inverse);  
};

Stdlib.rgbToString = function(c) {
  return "[" + c.rgb.red + "," + c.rgb.green + "," + c.rgb.blue + "]";
};
Stdlib.rgbToArray = function(c) {
  return [c.rgb.red, c.rgb.green, c.rgb.blue];
};
Stdlib.rgbFromString = function(str) {
  var rex = /([\d\.]+),([\d\.]+),([\d\.]+)/;
  var m = str.match(rex);
  if (m) {
    return Stdlib.createRGBColor(Number(m[1]),
                                 Number(m[2]),
                                 Number(m[3]));
  }
  return undefined;
};
Stdlib.createRGBColor = function(r, g, b) {
  var c = new RGBColor();
  if (r instanceof Array) {
    b = r[2]; g = r[1]; r = r[0];
  }
  c.red = parseInt(r); c.green = parseInt(g); c.blue = parseInt(b);
  var sc = new SolidColor();
  sc.rgb = c;
  return sc;
};

try {
  if (isPhotoshop()) {
    Stdlib.COLOR_BLACK = Stdlib.createRGBColor(0, 0, 0);
    Stdlib.COLOR_RED = Stdlib.createRGBColor(255, 0, 0);
    Stdlib.COLOR_GREEN = Stdlib.createRGBColor(0, 255, 0);
    Stdlib.COLOR_BLUE = Stdlib.createRGBColor(0, 0, 255);
    Stdlib.COLOR_GRAY = Stdlib.createRGBColor(128, 128, 128);
    Stdlib.COLOR_WHITE = Stdlib.createRGBColor(255, 255, 255);
  }
} catch (e) {
}

Stdlib.colorFromString = function(str) {
  var c = Stdlib.rgbFromString(str);
  if (!c) {
    str = str.toLowerCase();
    if (str == "black") {
      c = Stdlib.COLOR_BLACK;
    } else if (str == "white") {
      c = Stdlib.COLOR_WHITE;
    } else if (str == "foreground") {
      c = app.foregroundColor;
    } else if (str == "background") {
      c = app.backgroundColor;
    } else if (str == "gray" || str == "grey") {
      c = Stdlib.COLOR_GRAY;
    } else if (str == "red") {
      c = Stdlib.COLOR_RED;
    } else if (str == "green") {
      c = Stdlib.COLOR_GREEN;
    } else if (str == "blue") {
      c = Stdlib.COLOR_BLUE;
    } 
  }
  return c;
};


// the slow way to draw...
Stdlib.setColorAt = function(doc, x, y, color, mode, opacity) {
  Stdlib.selectBounds(doc, [x, y, x+1, y+1], SelectionType.REPLACE, 0, false);
  if (!Stdlib.hasSelection(doc)) {
    Error.runtimeError(20, "Unable to select pixel at " + x + ',' + y);
  }
  if (mode == undefined) {
    mode = ColorBlendMode.NORMAL;
  }
  if (opacity == undefined) {
    opacity = 100;
  }
  if (color) {
    doc.selection.fill(color, mode, opacity);
  } else {
    doc.selection.clear();
  }
};
Stdlib.putColorAt = Stdlib.setColorAt;

// getColorAt
// based on:
//     fazstp@adobeforums.com wrote:
//     news://adobeforums.com:119/3bb84060.0@webx.la2eafNXanI
//
Stdlib.getColorAt = function(doc, x, y, undo) {
  if (!!undo) {
    undo = true;
    var st = doc.activeHistoryState;
  }
  // make new 1 pixel selection
  x = Math.floor(x);
  y = Math.floor(y);

  Stdlib.selectBounds(doc, [x, y, x+1, y+1]);

  try {
    function findPV(h) {
      for (var i = 0; i <= 255; i++ ) {
        if (h[i]) { return i; }
      }
      return 0;
    }
    
    var pColour = new SolidColor();
    
    if (doc.mode == DocumentMode.RGB) {
      pColour.mode = ColorModel.RGB;
      pColour.rgb.red   = findPV(doc.channels["Red"].histogram);
      pColour.rgb.green = findPV(doc.channels["Green"].histogram);
      pColour.rgb.blue  = findPV(doc.channels["Blue"].histogram);

    } else if (doc.mode == DocumentMode.GRAYSCALE) {
      var gr = findPV(doc.channels["Gray"].histogram);
      pColour.mode = ColorModel.GRAYSCALE;
      pColour.gray.gray = 100 * (gr/255);

    } else {
      Error.runtimeError(9001, "Color Mode not supported: " + doc.mode);
    }

  } finally {
    if (undo) {
      doc.activeHistoryState = st;
    }
  }

  return pColour;
};

Stdlib.convertProfile = function(doc, profile) {
  profile = profile.replace(/\.icc$/i, '');

  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Dcmn'), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref);
    desc.putString( cTID('T   '), profile );
    desc.putEnumerated( cTID('Inte'), cTID('Inte'), cTID('Clrm') );
    desc.putBoolean( cTID('MpBl'), true );
    desc.putBoolean( cTID('Dthr'), false );
    desc.putInteger( cTID('sdwM'), -1 );
    executeAction( sTID('convertToProfile'), desc, DialogModes.NO );
  }

  Stdlib.wrapLC(doc, _ftn);
};


// deprecated: Use Document.changeMode
Stdlib.convertMode = function(doc, cmode) {
  var mode;

  function _ftn() {
    var desc = new ActionDescriptor();
    desc.putClass(cTID("T   "), cTID(mode));
    executeAction(sTID("convertMode"), desc, DialogModes.NO);
  };

  switch (cmode) {
    case DocumentMode.BITMAP:       mode = "BtmM"; break;
    case DocumentMode.CMYK:         mode = "CMYM"; break;
    case DocumentMode.GRAYSCALE:    mode = "Grys"; break;
    case DocumentMode.INDEXEDCOLOR: mode = "IndC"; break;
    case DocumentMode.LAB:          mode = "LbCM"; break;
    case DocumentMode.MULTICHANNEL: mode = "MltC"; break;
    case DocumentMode.RGB:          mode = "RGBM"; break;
    default: Error.runtimeError(9001, "Bad color mode specified: " + cmode);
  }
  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.colorModeString = function(cmode) {
  var mode = "Unknown Mode";

  var cmodeN = toNumber(cmode);

  if (isNaN(cmodeN)) {
    switch (cmode) {
      case DocumentMode.BITMAP:       mode = "Bitmap"; break;
      case DocumentMode.CMYK:         mode = "CMYK"; break;
      case DocumentMode.DUOTONE:      mode = "Duotone"; break;
      case DocumentMode.GRAYSCALE:    mode = "Grayscale"; break;
      case DocumentMode.INDEXEDCOLOR: mode = "Indexed Color"; break;
      case DocumentMode.LAB:          mode = "Lab"; break;
      case DocumentMode.MULTICHANNEL: mode = "Multichannel"; break;
      case DocumentMode.RGB:          mode = "RGB"; break;
    }

  } else {
    switch (cmode) {
      case 0: mode = "Bitmap"; break;
      case 1: mode = "Grayscale"; break;
      case 2: mode = "Indexed Color"; break;
      case 3: mode = "RGB"; break;
      case 4: mode = "CMYK"; break;
      case 7: mode = "Multichannel"; break;
      case 8: mode = "Duotone"; break;
      case 9: mode = "Lab"; break;
    }
  }

  return mode;
};
Stdlib.copyrightedString = function(copy) {
  var str = '';
  switch (copy) {
    case CopyrightedType.COPYRIGHTEDWORK: str = "Copyrighted"; break;
    case CopyrightedType.PUBLICDOMAIN:    str = 'Public Domain'; break;
    case CopyrightedType.UNMARKED:        str = 'Unmarked'; break;
  }

  return str;
};
Stdlib.urgencyString = function(urgency) {
  var str = '';
  switch (urgency) {
    case Urgency.LOW:    str = "Urgency Low"; break;
    case Urgency.TWO:    str = "Urgency Two"; break;
    case Urgency.THREE:  str = "Urgency Three"; break;
    case Urgency.FOUR:   str = "Urgency Four"; break;
    case Urgency.NORMAL: str = "Urgency Normal"; break;
    case Urgency.SIX:    str = "Urgency Six"; break;
    case Urgency.SEVEN:  str = "Urgency Seven"; break;
    case Urgency.HIGH:   str = "Urgency High"; break;
  }

  return str;
};

Stdlib.getFillLayerColor = function(doc, layer) {
  var color = new SolidColor();
  var desc = Stdlib.getLayerDescriptor(doc, layer);
  var adjList = desc.getList(cTID('Adjs'));
  var adjDesc = adjList.getObjectValue(0);
  var clrDesc = adjDesc.getObjectValue(cTID('Clr '));
  color.rgb.red = clrDesc.getDouble(cTID('Rd  '));
  color.rgb.green = clrDesc.getDouble(cTID('Grn '));
  color.rgb.blue = clrDesc.getDouble(cTID('Bl  '));
  return color;
};

Stdlib.setFillLayerColor = function(doc, layer, color) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated(sTID('contentLayer'), cTID('Ordn'), cTID('Trgt'));
    desc.putReference(cTID('null'), ref);
    var cdesc = new ActionDescriptor();
    var rgbdesc = new ActionDescriptor();
    rgbdesc.putDouble(cTID('Rd  '), color.rgb.red);
    rgbdesc.putDouble(cTID('Grn '),  color.rgb.green);
    rgbdesc.putDouble(cTID('Bl  '),  color.rgb.blue);
    cdesc.putObject(cTID('Clr '), cTID('RGBC'), rgbdesc);
    desc.putObject(cTID('T   '), sTID('solidColorLayer'), cdesc);
    return executeAction(cTID('setd'), desc, DialogModes.NO);
  }

  return Stdlib.wrapLCLayer(doc, layer, _ftn);
};

Stdlib.createSwatch = function(name, red, green, blue) { 
  var clrDesc = new ActionDescriptor(); 
  clrDesc.putDouble(cTID("Rd  "), red); 
  clrDesc.putDouble(cTID("Grn "), green); 
  clrDesc.putDouble(cTID("Bl  "), blue); 

  var clrsDesc = new ActionDescriptor(); 
  clrsDesc.putString(cTID("Nm  "), name);
  clrsDesc.putObject(cTID("Clr "), cTID("RGBC"), clrDesc); 

  var ref = new ActionReference(); 
  ref.putClass(cTID("Clrs"));

  var desc = new ActionDescriptor(); 
  desc.putReference(cTID("null"), ref); 
  desc.putObject(cTID("Usng"), cTID("Clrs"), clrsDesc); 

  app.executeAction(cTID("Mk  "), desc, DialogModes.NO); 
};

Stdlib.saveAllPatterns = function(file) {
  var desc = new ActionDescriptor();
  desc.putPath(cTID("null"), file);
  var ref = new ActionReference();
  ref.putProperty(cTID("Prpr"), cTID("Ptrn"));
  ref.putEnumerated(cTID("capp"), cTID("Ordn"), cTID("Trgt"));
  desc.putReference(cTID("T   "), ref);
  executeAction(cTID("setd"), desc, DialogModes.NO);
};

Stdlib.savePatterns = function(file, indexArray) {
  var desc = new ActionDescriptor();
  desc.putPath(cTID("null"), file);

  var list = new ActionList();
  for (var i = 0; i < indexArray.length; i++) {
    var ref = new ActionReference();
    ref.putIndex(cTID("Ptrn"), indexArray[i]);
    list.putReference(ref);
  }
  desc.putList(cTID("T   "), list);
  executeAction(cTID("setd"), desc, DialogModes.NO);
};

Stdlib.savePattern = function(file, index) {
  Stdlib.savePatterns(file, [index]);
};

Stdlib.createGuide = function(doc, orientation, position) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var gdesc = new ActionDescriptor();
    gdesc.putUnitDouble(cTID("Pstn"), cTID("#Pxl"), position);
    gdesc.putEnumerated(cTID("Ornt"), cTID("Ornt"), cTID(orientation));
    desc.putObject(cTID("Nw  "), cTID("Gd  "), gdesc);
    executeAction(cTID("Mk  "), desc, DialogModes.NO );
  }
  Stdlib.wrapLC(doc, _ftn);
};
Stdlib.createVerticalGuide = function(doc, position) {
  Stdlib.createGuide(doc, "Vrtc", position);
};
Stdlib.createHorizontalGuide = function(doc, position) {
  Stdlib.createGuide(doc, "Hrzn", position);
};

Stdlib.clearGuides = function(doc) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated(cTID("Gd  "), cTID("Ordn"), cTID("Al  "));
    desc.putReference(cTID("null"), ref );
    executeAction(cTID("Dlt "), desc, DialogModes.NO );
  }

  Stdlib.wrapLC(doc, _ftn);
};

Stdlib.renameChannel = function(doc, oldName, newName) {
  var channels = doc.activeChannels;
  for (var i = 0; i < channels.length; i++) {
    var ch = channels[i];
    if (ch.name == oldName) {
      ch.name = newName;
      return;
    }
  }
};
Stdlib.selectChannel = function(doc, layer, chnl) {
  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated(cTID('Chnl'), cTID('Chnl'), cTID(chnl));
    desc.putReference(cTID('null'), ref);
    desc.putBoolean(cTID('MkVs'), false );
    executeAction(cTID('slct'), desc, DialogModes.NO );
  }
  Stdlib.wrapLCLayer(doc, layer, _ftn);
};
Stdlib.selectRGBChannel = function(doc, layer) {
  Stdlib.selectChannel(doc, layer, 'RGB ');
};

Stdlib.drawLine = function(doc, start, stop) {

  var startPoint = new PathPointInfo();
  startPoint.anchor = start;
  startPoint.leftDirection = start;
  startPoint.rightDirection = start;
  startPoint.kind = PointKind.CORNERPOINT;

  var stopPoint = new PathPointInfo();
  stopPoint.anchor = stop;
  stopPoint.leftDirection = stop;
  stopPoint.rightDirection = stop;
  stopPoint.kind = PointKind.CORNERPOINT;

  var spi = new SubPathInfo();
  spi.closed = false;
  spi.operation = ShapeOperation.SHAPEXOR;
  spi.entireSubPath = [startPoint, stopPoint];

  var line = doc.pathItems.add("Line", [spi]);
  line.strokePath(ToolType.PENCIL);
  line.remove();
};

Stdlib.selectEllipse = function(doc, bnds, antiAlias) {
  antiAlias = (antiAlias != false);  // defaults to true

  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putProperty(cTID('Chnl'), cTID('fsel'));
  desc.putReference(cTID('null'), ref);
  var bdesc = new ActionDescriptor();
  bdesc.putUnitDouble(cTID('Top '), cTID('#Pxl'), bnds[1]);
  bdesc.putUnitDouble(cTID('Left'), cTID('#Pxl'), bnds[0]);
  bdesc.putUnitDouble(cTID('Btom'), cTID('#Pxl'), bnds[3]);
  bdesc.putUnitDouble(cTID('Rght'), cTID('#Pxl'), bnds[2]);
  desc.putObject(cTID('T   '), cTID('Elps'), bdesc);
  desc.putBoolean(cTID('AntA'), true);
  executeAction(cTID('setd'), desc, DialogModes.NO);
};


Stdlib.stop = function(msg, cont) {
  if (msg == undefined) {
    msg = "Operation cancelled.";
  }
  var desc = new ActionDescriptor();
  desc.putString(cTID("Msge"), msg);
  if (cont != undefined) {
    desc.putBoolean(cTID("Cntn"), cont);
  }
  app.executeAction(cTID("Stop"), desc, DialogModes.ALL);
};

//
// Add a new Text layer with some string...
//
Stdlib.addTextLayer = function(doc, contents, name, size) {
  var layer = doc.artLayers.add();

  layer.kind = LayerKind.TEXT;
  if (name) { layer.name = name; }
  layer.blendMode = BlendMode.NORMAL;
  layer.opacity = 100.0;

  //$.level = 1; debugger;
  var text = layer.textItem;
  var ru = app.preferences.rulerUnits;
  var tu = app.preferences.typeUnits;
 
  try {
    var newColor = Stdlib.createRGBColor(255, 255, 255);
    
    app.preferences.typeUnits = TypeUnits.POINTS;
    app.preferences.rulerUnits = Units.PIXELS;

    text.size = (size ? size : 24);    //Math.max(doc.height/100, 3);
    text.font = "ArialMT";
    text.kind = TextType.PARAGRAPHTEXT;
    text.color = newColor;
    
    app.preferences.rulerUnits = Units.PERCENT;
    text.position = new Array(5, 5); 
    app.preferences.rulerUnits = Units.PIXELS;
    text.width  = doc.width;
    text.height = doc.height;
    text.contents = contents;

  } finally {
    app.preferences.rulerUnits = ru;
    app.preferences.typeUnits = tu;
  }

  return layer;
};

// deprecated
Stdlib.addInfoTextLayer = Stdlib.addTextLayer;

Stdlib.convertTextLayerToShape = function(doc, layer) {
  function _ftn() {
    var desc96 = new ActionDescriptor();
    var ref61 = new ActionReference();
    ref61.putClass( sTID('contentLayer') );
    desc96.putReference( cTID('null'), ref61 );
    var ref62 = new ActionReference();
    ref62.putEnumerated( cTID('TxLr'), cTID('Ordn'), cTID('Trgt') );
    desc96.putReference( cTID('Usng'), ref62 );
    executeAction( cTID('Mk  '), desc96, DialogModes.NO );
  }

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};



Stdlib.getPSFontList = function() {
  var flist = app.fonts;
  var fontList = [flist.length];
  for (var i = 0; i < flist.length; i++) {
    fontList[i] = flist[i].postScriptName;
  }
  return fontList;
};

Stdlib.findPSFont = function(f) {
  var tf = Stdlib.getByName(app.fonts, f);
  return (tf ? tf.postScriptName : undefined);
};

Stdlib.getFont = function(f) {
  // getByProperty
  var flist = app.fonts;
  for (var i = 0; i < flist.length; i++) {
    if (f == flist[i].postScriptName) {
      return flist[i];
    }
  }
  return undefined;
};

Stdlib.findFont = function(f) {
  // getByName
  var flist = app.fonts;
  for (var i = 0; i < flist.length; i++) {
    if (f == flist[i].name) {
      return flist[i];
    }
  }
  return undefined;
};

Stdlib.determineFont = function(str) {
  return (Stdlib.getByName(app.fonts, str) ||
          Stdlib.getByProperty(app.fonts, 'postScriptName', str));
};

// XXX fix this later
Stdlib.setFontRealName = function( fontName ) {
  var ref = new ActionReference();
  ref.putProperty(sTID('property'), sTID('textStyle'));
  ref.putEnumerated(sTID('textLayer'),
                    sTID('ordinal'),
                    sTID('targetEnum'));

  var desc = new ActionDescriptor();
  desc.putReference(sTID('null'), ref);

  var edesc = new ActionDescriptor();
  edesc.putString(sTID('fontName'), fontName);
  edesc.putObject(sTID('to'), sTID('textStyle'), desc);

  executeAction(sTID('set'), edesc, DialogModes.NO);
};

// UnitValue functions

Stdlib.unitValueRex = /(-)?(\d+)?(\.\d+)? (in|ft|yd|mi|mm|cm|m|km|pt|pc|tpt|ptc|ci|px|%)/;


//
//=============================== Debugging ===================================
//

//
// fullStop
//     Drop into the debugger as long as 'stop' is not false
//
Stdlib.fullStop = function(stop) {
  if (stop != false) {
    $.level = 1;
    debugger;
  }
};
//fullStop = Stdlib.fullStop;

//
// a dumb little piece of code that does a busy-wait
// for some period of time. Crank units up 'til it waits
// long enough for your purposes.
// This is deprecated in CS2.
//
Stdlib.pause = function(units){
  for (var i = 0; i < units; i++) {
    var x = 11.400930;
    var y = 33.902312;
    Stdlib.pause_dummy = eval("Math.sqrt(x/y)");
  }
};
Stdlib.listGlobals = function() {
  var lst = [];
  for (var i in global) {
    lst.push(i);
  }
  lst.sort();
  var str = '';
  for (var j in lst) {
    i = lst[j];
    str += i + ":\t";
    try {
      var o = global[i];
      str += "[" + (typeof o) + "]";
      if (typeof o != "function") {
        str += ":\t" + global[i].toString();
      }
    } catch (e) {
      str += "[]";
    }
    str += "\r\n";
  }
  return str;
};
listGlobals = Stdlib.listGlobals;

Stdlib.listProps = function(obj) {
  var s = '';
  for (var x in obj) {
    s += x + ":\t";
    try {
      var o = obj[x];
      
      s += (typeof o == "function") ? "[function]" : o;
    } catch (e) {
    }
    s += "\r\n";
  }
  return s;
};
listProps = Stdlib.listProps;

Stdlib.dumpGlobals = function(fname) {
  var f = new File(fname || "/c/temp/globals.log");
  f.open("w", "TEXT", "????");
  f.writeln(listGlobals());
  f.close();
};

Stdlib.showtext = function showtext(msg) {
  confirm(msg);
};

// A helper function for debugging
// It also helps the user see what is going on
// if you turn it off for this example you
// get a flashing cursor for a number (long) time
Stdlib.waitForRedraw = function() {
  var desc = new ActionDescriptor();
  desc.putEnumerated(cTID("Stte"), cTID("Stte"), cTID("RdCm"));
  executeAction(cTID("Wait"), desc, DialogModes.NO);
};

refresh = Stdlib.waitForRedraw;

Stdlib._dumpRI = function(ri) {
  var str = '';
  var props =
  [ "name",
    "arguments",
    "dataType",
    "defaultValue",
    "description",
    "help",
    "isCollection",
    "max",
    "min",
    "type"];
  
  str += '\t' + ri.name + '\r\n';

  for (var i = 0; i < props.length; i++) {
    var n = props[i];
    var v = ri[n];

    if (v != undefined) {
      str += "\t\t" + n + " : " + v + "\r\n";
    }
  }
  return str;
}
Stdlib.dumpRTI = function(o) {
  var r = o.reflect;
  var str = '';

  //debugger;
  str += "//\r\n// " + r.name + "\r\n//    " + r.help + "\r\n//\r\n";
  str += "class " + r.name + "\r\n";
  str += "  props:\r\n";
  for (var i = 0; i < r.properties.length; i++) {
    var ri = r.properties[i];
    str += Stdlib._dumpRI(ri);
  }
  str += "  methods:\r\n";
  for (var i = 0; i < r.methods.length; i++) {
    var ri = r.methods[i];
    str += Stdlib._dumpRI(ri);
  }
  return str;
};

Stdlib.getLastJSLogEntry = function(fptr) {
  if (fptr) {
    fptr = Stdlib.convertFptr(fptr);
  } else {
    fptr = new File("/c/ScriptingListenerJS.log");
    if (!fptr.exists) {
      Error.runtimeError(Stdlib.IO_ERROR_CODE, "Unable to find SLC log.");
    }
  }

  fptr.open("r", "TEXT", "????") || throwFileError(fptr, "Unable to open");
  //fptr.lineFeed = "unix";

  fptr.seek(1, 2);  // start of at the end of the file
  var prev = fptr.readch();

  for (var i = 2; i < fptr.length; i++) {
    fptr.seek(i, 2);  // start of at the end of the file
    var c = fptr.readch();
    if (c == '\n' && prev == '/') {
      break;
    }
    prev = c;
  }
  if (i == fptr.length && prev != '/') {
    return undefined;
  }

  fptr.readln();

  if (isCS4()) {
    // XXX There is a bug in CS4 that causes the previous readln to
    // read one too many characters. This looks of the bug and works
    // around it.

    var loc = fptr.tell();
    var str = fptr.read();

    if (str[0] == 'a') {
      fptr.seek(loc-1);
      str = fptr.read();
    }

  } else {
    var str = fptr.read();
  }
  fptr.close();
  return str;
};


Stdlib.writeDescriptor = function(fptr, desc) {
  var fptr = Stdlib.convertFptr(fptr);
  fptr.encoding = 'BINARY';
  if (!fptr.open("w")) {
    throwFileError(fptr);
  }
  var str = desc.toStream();
  if (!fptr.write(str)) {
    throwFileError(fptr);
  }
  fptr.close();
  delete str;
};

Stdlib.readDescriptor = function(fptr) {
  var fptr = Stdlib.convertFptr(fptr);
  fptr.encoding = 'BINARY';
  if (!fptr.open("r")) {
    throwFileError(fptr);
  }
  var str = fptr.read();
  fptr.close();

  var desc = new ActionDescriptor();
  desc.fromStream(str);
  return desc;
};

//=============================== UnitValue support code ======================
Stdlib._units = undefined;
Stdlib._unitsInit = function() {
  if (!isPhotoshop()) {
    return;
  }
  Stdlib._units = app.preferences.rulerUnits.toString();
  Stdlib._unitMap = {};
  Stdlib._unitMap[Units.INCHES.toString()] =  "in";
  Stdlib._unitMap[Units.CM.toString()] =      "cm";
  Stdlib._unitMap[Units.MM.toString()] =      "mm";
  Stdlib._unitMap[Units.PERCENT.toString()] = "%";
  Stdlib._unitMap[Units.PICAS.toString()] =   "pc";
  Stdlib._unitMap[Units.PIXELS.toString()] =  "px";
  Stdlib._unitMap[Units.POINTS.toString()] =  "pt";

  Stdlib._unitStrMap = {};
  Stdlib._unitStrMap["in"] = "in";
  Stdlib._unitStrMap["cm"] = "cm";
  Stdlib._unitStrMap["mm"] = "mm";
  Stdlib._unitStrMap["%"]  = "%";
  Stdlib._unitStrMap["pc"] = "picas";
  Stdlib._unitStrMap["px"] = "pixels";
  Stdlib._unitStrMap["pt"] = "points";
};
Stdlib._unitsInit();
Stdlib.getDefaultUnits = function() {
  return Stdlib._unitMap[Stdlib._units];
};
Stdlib.getDefaultUnitsString = function() {
  return Stdlib._unitStrMap[Stdlib._unitMap[Stdlib._units]];
};
Stdlib.getDefaultRulerUnitsString = Stdlib.getDefaultUnitsString;

Stdlib.validateUnitValue = function(str, bu, ru) {
  var self = this;

  if (str instanceof UnitValue) {
    return str;
  }

  if (bu && bu instanceof Document) {
    var doc = bu;
    ru = doc.width.type;
    bu = UnitValue(1/doc.resolution, ru);

  } else {
    if (!ru) {
      ru = Stdlib.getDefaultRulerUnitsString();
    }
    if (!bu) {
      UnitValue.baseUnit = UnitValue(1/72, ru);
    }
  }
  str = str.toString();

  var zero = new UnitValue("0 " + ru);
  var un = zero;
  if (!str.match(/[a-z%]+/)) {
    str += ' ' + ru.units;
  }
  un = new UnitValue(str);

  if (isNaN(un.value) || un.type == '?') {
    return undefined;
  }

  if (un.value == 0) {
    un = zero;
  }

  return un;
};

//
// Stdlib.getPixelValue
// Useful for converting strings input by a user into a pixel value.
// 'val' may be any valid UnitValue string.
//    Stdlib.getPixelValue(doc, "20 in")
//    Stdlib.getPixelValue(300, "20", undefined, "in")
//    Stdlib.getPixelValue(doc, "20%", 1200)
//    Stdlib.getPixelValue(doc, "20", 1200, '%')
// 
Stdlib.getPixelValue = function(docRes, val, base, defaultUnits) {
  var res;
  if (val == undefined) {
    return Number.NaN;
  }
  if (val.constructor == Number) {
    val = val.toString();
  }
  if (val.constructor != String) {
    return Number.NaN;
  }
  if (docRes.constructor == Number) {
    res = docRes;
  } else {
    res = docRes.resolution;
  }

  val = val.trim();

  // convert val to a unit value

  if (!defaultUnits) {
    defaultUnits = Stdlib.getDefaultUnits();
  }

  var u = new UnitValue(val);
  if (u.type == '?') {
    var n = parseFloat(val);
    if (isNaN(n)) {
      return Number.NaN;
    }
    u = new UnitValue(n, defaultUnits);
  }

  // handle '%' manually
  if (u.type == '%') {
    u = new UnitValue(base * u.value / 100, "px");
  }

  var pxVal;

  // handle 'in' manually
  if (u.type == 'in') {
    pxVal = res * u.value;

  } else if (u.type == 'px') {
    pxVal = u.value;

  } else {
    u.baseUnit = new UnitValue(1/res, "in");
    pxVal = u.as("px");
  }

  return pxVal;
};

/*

var regex = /\-*\d*\.{0,1}\d* *(?:in|inch|inches|ft|foot|feet|yd|yard|yards|mi|mile|miles|mm|millimeter|millimeters|cm|centimeter|centimeters|m|meter|meters|km|kilometer|kilometers|pt|point|points|pc|pica|picas|ci|cicero|ciceros)?/gi;
var myMatch = myString.match( regex );
try {
  var fieldIsValid = ( myEvent.target.text == myEvent.target.text.match( regex )[ 0 ] );
} catch( e ) {
  var fieldIsValid = false;
}

*/


//
//============================= File Browser =================================
//
// This FileBrowser code works _only_ in PSCS
//

// get all the files in the file browser that are selected or flagged
// this code was lifted from Dr. Brown's Image Processor2.0.js
// and is copyrighted by Adobe

FileBrowser = function FileBrowser() {};

FileBrowser.getSelectedFiles = function() {
  return FileBrowser.getFiles(true, false);
};
FileBrowser.getFlaggedFiles = function() {
  return FileBrowser.getFiles(false, true);
};
FileBrowser.getFiles = function(selected, flagged) {
  var fileArray = new Array();
  var ffIndex = 0;

  var ref = new ActionReference();
  var fileBrowserStrID = sTID( "fileBrowser" );
  ref.putProperty( cTID( 'Prpr' ), fileBrowserStrID );
  ref.putEnumerated( cTID( 'capp' ), cTID( 'Ordn' ),
                     cTID( 'Trgt' ) ); 
  var desc = executeActionGet( ref );

  if ( desc.count > 0 && desc.hasKey( fileBrowserStrID ) ) {
    var fbDesc = desc.getObjectValue( fileBrowserStrID );
    var keyFilesList = cTID( 'flst' );

    if ( fbDesc.count > 0 && fbDesc.hasKey( keyFilesList ) ) {
      var fileList = fbDesc.getList( keyFilesList );
      var flaggedID = sTID( "flagged" );
      var selectedID = cTID( 'fsel' );
      var keyPath = cTID( 'Path' );

      for ( var i = 0; i < fileList.count; i++ ) {
        var fileDesc = fileList.getObjectValue( i );
        if ( fileDesc.count > 0 && fileDesc.hasKey( keyPath )) {
          if ( flagged == true && fileDesc.hasKey( flaggedID )
               && fileDesc.getBoolean( flaggedID )) {
            var fileOrFolder = fileDesc.getPath( keyPath );
            if ( fileOrFolder instanceof File ) {
              fileArray[ffIndex++] = fileOrFolder;
            }
          }

          // fixed so that a file will not be added twice if its flagged
          // and selected and both options are 'true'
          if ( flagged == true && fileDesc.hasKey( flaggedID )
               && fileDesc.getBoolean( flaggedID )) {
            var fileOrFolder = fileDesc.getPath( keyPath );
            if ( fileOrFolder instanceof File ) {
              fileArray[ffIndex++] = fileOrFolder;
            }
          } else if ( selected == true && fileDesc.hasKey( selectedID )
               && fileDesc.getBoolean( selectedID )) {
            var fileOrFolder = fileDesc.getPath( keyPath );
            if ( fileOrFolder instanceof File ) {
              fileArray[ffIndex++] = fileOrFolder;
            }
          }

          // if neither option is set, add everything
          if (selected != true && flagged != true) {
            var fileOrFolder = fileDesc.getPath( keyPath );
            if ( fileOrFolder instanceof File ) {
              fileArray[ffIndex++] = fileOrFolder;
            }
          }
        }
      }
    }
  }

  return fileArray;
};

//
// Set
//     these are a collection of functions for operating
//     on arrays as proper Set: each entry in the array
//     is unique in the array. This is useful for things
//     like doc.info.keywords
//
Set = function Set() {}
Set.add = function(ar, str) { return Set.merge(ar, new Array(str)); }
Set.remove = function(ar, str) {
  var nar = Set.copy(ar);
  for (var idx in nar) {
    if (nar[idx] == str) {
      nar.splice(idx, 1);
    }
  }
  return nar;
};
Set.contains = function(ar, str) {
  for (var idx in ar) {
    if (ar[idx] == str) {
      return true;
    }
  }
  return false;
};
Set.merge = function(ar1, ar2) {
  var obj = new Object();
  var ar = [];

  if (ar1 != undefined) {
    for (var idx in ar1) {
      if (typeof (ar1[idx]) != "function") {
        obj[ar1[idx]] = 1;
      }
    }
  }
  if (ar2 != undefined) {
    for (var idx in ar2) {
      if (typeof (ar2[idx]) != "function") {
        obj[ar2[idx]] = 1;
      }
    }
  }
  for (var idx in obj) {
    if (typeof (obj[idx]) != "function") {
      ar.push(idx);
    }
  }
  ar.sort();
  return ar;
}
Set.copy = function(ar) {
  return ar.slice(0);
};


ColorProfileNames = {};
ColorProfileNames.ADOBE_RGB      = "Adobe RGB (1998)";
ColorProfileNames.APPLE_RGB      = "Apple RGB";
ColorProfileNames.PROPHOTO_RGB   = "ProPhoto RGB";
ColorProfileNames.SRGB           = "sRGB IEC61966-2.1";
ColorProfileNames.COLORMATCH_RGB = "ColorMatch RGB";
ColorProfileNames.WIDEGAMUT_RGB  = "Wide Gamut RGB";

// ColorProfileNames.KODAK_DC     = "KODAK DC Series Digital Camera";
// ColorProfileNames.MONITOR_SRGB = "Monitor - sRGB IEC61966-2.1";

Timer = function() {
  var self = this;
  self.startTime = 0;
  self.stopTime  = 0;
  self.elapsed = 0;
  self.cummulative = 0;
  self.count = 0;
};

Timer.prototype.start = function() {
  this.startTime = new Date().getTime();
};
Timer.prototype.stop = function() {
  var self = this;
  self.stopTime = new Date().getTime();
  self.elapsed = (self.stopTime - self.startTime)/1000.00;
  self.cummulative += self.elapsed;
  self.count++;
  self.per = self.cummulative/self.count;
};


//========================= String formatting ================================
//
// String.sprintf
//
// Documentation:
//   http://www.opengroup.org/onlinepubs/007908799/xsh/fprintf.html
//
// From these sites:
//   http://forums.devshed.com/html-programming-1/sprintf-39065.html
//   http://jan.moesen.nu/code/javascript/sprintf-and-printf-in-javascript/
//
String.prototype.sprintf = function() {
  var args = [this];
  for (var i = 0; i < arguments.length; i++) {
    args.push(arguments[i]);
  }
  return String.sprintf.apply(null, args);
};
String.sprintf = function() {
  function _sprintf() {
    if (!arguments || arguments.length < 1 || !RegExp)  {
      return "Error";
    }
    var str = arguments[0];
    var re = /([^%]*)%('.|0|\x20)?(-)?(\d+)?(\.\d+)?(%|b|c|d|u|f|o|s|x|X)/m;
            //') /* for xemacs auto-indent  */
    var a = b = [], numSubstitutions = 0, numMatches = 0;
    var result = '';

    while (a = re.exec(str)) {
      var leftpart = a[1], pPad = a[2], pJustify = a[3], pMinLength = a[4];
      var pPrecision = a[5], pType = a[6], rightPart = a[7];

      rightPart = str.slice(a[0].length);

      numMatches++;

      if (pType == '%') {
        subst = '%';
      } else {
        numSubstitutions++;
        if (numSubstitutions >= arguments.length) {
          alert('Error! Not enough function arguments (' +
                (arguments.length - 1)
                + ', excluding the string)\n'
                + 'for the number of substitution parameters in string ('
                + numSubstitutions + ' so far).');
        }
        var param = arguments[numSubstitutions];
        var pad = '';
        if (pPad && pPad.slice(0,1) == "'") {
          pad = leftpart.slice(1,2);
        } else if (pPad) {
          pad = pPad;
        }
        var justifyRight = true;
        if (pJustify && pJustify === "-") {
          justifyRight = false;
        }
        var minLength = -1;
        if (pMinLength) {
          minLength = toNumber(pMinLength);
        }
        var precision = -1;
        if (pPrecision && pType == 'f') {
          precision = toNumber(pPrecision.substring(1));
        }
        var subst = param;
        switch (pType) {
        case 'b':
          subst = toNumber(param).toString(2);
          break;
        case 'c':
          subst = String.fromCharCode(toNumber(param));
          break;
        case 'd':
          subst = toNumber(param) ? Math.round(toNumber(param)) : 0;
            break;
        case 'u':
          subst = Math.abs(Math.round(toNumber(param)));
          break;
        case 'f':
          if (precision == -1) {
            precision = 6;
          }
          subst = parseFloat(param).toFixed(Math.min(precision, 20));
//             ? Math.round(parseFloat(param) * Math.pow(10, precision))
//             / Math.pow(10, precision)
//             : ;
            break;
        case 'o':
          subst = toNumber(param).toString(8);
          break;
        case 's':
          subst = param;
          break;
        case 'x':
          subst = ('' + toNumber(param).toString(16)).toLowerCase();
          break;
        case 'X':
          subst = ('' + toNumber(param).toString(16)).toUpperCase();
          break;
        }
        var padLeft = minLength - subst.toString().length;
        if (padLeft > 0) {
          var arrTmp = new Array(padLeft+1);
          var padding = arrTmp.join(pad?pad:" ");
        } else {
          var padding = "";
        }
      }
      result += leftpart + padding + subst;
      str = rightPart;
    }
    result += str;
    return result;
  };

  return _sprintf.apply(null, arguments);
};


//========================= Date formatting ================================
//
// Date.strftime
//    This is a third generation implementation. This is a JavaScript
//    implementation of C the library function 'strftime'. It supports all
//    format specifiers except U, W, z, Z, G, g, O, E, and V.
//    For a full description of this function, go here:
//       http://www.opengroup.org/onlinepubs/007908799/xsh/strftime.html
//    Donating implementations can be found here:
//       http://redhanded.hobix.com/inspect/showingPerfectTime.html
//    and here:
//       http://wiki.osafoundation.org/bin/view/Documentation/JavaScriptStrftime
//
// Object Method
Date.prototype.strftime = function (fmt) {
  return Date.strftime(this, fmt);
};

// Class Function
Date.strftime = function(date, fmt) {
  var t = date;
  var cnvts = Date.prototype.strftime._cnvt;
  var str = fmt;

  var rex = /([^%]*)%([%aAbBcCdDehHIjmMprRStTuwxXyYZ]{1})(.*)/;

  var result = '';
  while (m = rex.exec(str)) {
    var pre = m[1];
    var typ = m[2];
    var post = m[3];
    result += pre + cnvts[typ](t);
    str = post;
  }
  result += str;
  return result;
};

// some ISO8601 formats
Date.strftime.iso8601_date = "%Y-%m-%d";
Date.strftime.iso8601_full = "%Y-%m-%dT%H:%M:%S";
Date.strftime.iso8601      = "%Y-%m-%d %H:%M:%S";
Date.strftime.iso8601_time = "%H:%M:%S";

Date.prototype.toISO = function() {
  return this.strftime(Date.strftime.iso8601);
};


// the specifier conversion function table
Date.prototype.strftime._cnvt = {
  zeropad: function( n ){ return n>9 ? n : '0'+n; },
  spacepad: function( n ){ return n>9 ? n : ' '+n; },
  ytd: function(t) { 
    var first = new Date(t.getFullYear(), 0, 1).getTime();
    var diff = t.getTime() - first;
    return parseInt(((((diff/1000)/60)/60)/24))+1;
  },
  a: function(t) {
    return ['Sun','Mon','Tue','Wed','Thu','Fri','Sat'][t.getDay()]
  },
  A: function(t) {
    return ['Sunday','Monday','Tuesdsay','Wednesday','Thursday','Friday',
            'Saturday'][t.getDay()]
  },
  b: function(t) {
    return ['Jan','Feb','Mar','Apr','May','Jun', 'Jul','Aug','Sep','Oct',
            'Nov','Dec'][t.getMonth()] },
  B: function(t) {
    return ['January','February','March','April','May','June', 'July','August',
            'September','October','November','December'][t.getMonth()] },
  c: function(t) {
    return (this.a(t) + ' ' + this.b(t) + ' ' + this.e(t) + ' ' +
            this.H(t) + ':' + this.M(t) + ':' + this.S(t) + ' ' + this.Y(t))
  },
  C: function(t) { return this.Y(t).slice(0, 2); },
  d: function(t) { return this.zeropad(t.getDate()) },
  D: function(t) { return this.m(t) + '/' + this.d(t) + '/' + this.y(t); },
  e: function(t) { return this.spacepad(t.getDate()) },
  // E: function(t) { return '-' },
  F: function(t) { return this.Y(t) + '-' + this.m(t) + '-' + this.d(t); },
  g: function(t) { return '-' },
  G: function(t) { return '-' },
  h: function(t) { return this.b(t) },
  H: function(t) { return this.zeropad(t.getHours()) },
  I: function(t) {
    var s = this.zeropad((t.getHours() + 12) % 12);
    return (s == "00") ? "12" : s;
  },
  j: function(t) { return this.ytd(t) },
  k: function(t) { return this.spacepad(t.getHours()) },
  l: function(t) {
    var s = this.spacepad((t.getHours() + 12) % 12);
    return (s == " 0") ? "12" : s;
  },
  m: function(t) { return this.zeropad(t.getMonth()+1) }, // month-1
  M: function(t) { return this.zeropad(t.getMinutes()) },
  n: function(t) { return '\n' },
  // O: function(t) { return '-' },
  p: function(t) { return this.H(t) < 12 ? 'AM' : 'PM'; },
  r: function(t) {
    return this.I(t) + ':' + this.M(t) + ':' + this.S(t) + ' ' + this.p(t);
  },
  R: function(t) { return this.H(t) + ':' + this.M(t); },
  S: function(t) { return this.zeropad(t.getSeconds()) },
  t: function(t) { return '\t'; },
  T: function(t) {
    return this.H(t) + ':' + this.M(t) + ':' + this.S(t) + ' ' + this.p(t);
  },
  u: function(t) {return t.getDay() ? t.getDay()+1 : 7 },
  U: function(t) { return '-' },
  w: function(t) { return t.getDay() }, // 0..6 == sun..sat
  W: function(t) { return '-'; },       // not available
  x: function(t) { return this.D(t) },
  X: function(t) { return this.T(t)},
  y: function(t) { return this.zeropad(this.Y(t) % 100) },
  Y: function(t) { return t.getFullYear().toString() },
  z: function(t) { return '' },
  Z: function(t) { return '' },
  '%': function(t) { return '%' }
};

// this needs to be worked on...
function _weekNumber(date) {
  var ytd = toNumber(date.strftime("%j"));
  var week = Math.floor(ytd/7);
  if (new Date(date.getFullYear(), 0, 1).getDay() < 4) {
    week++;
  }
  return week;
};

File.prototype.toUIString = function() {
  return decodeURI(this.fsName);
};
Folder.prototype.toUIString = function() {
  return decodeURI(this.fsName);
};

File.prototype.asString = File.prototype.toUIString; // deprecated

//========================= Filename formatting ===============================
//
// File.strf
//   This is based of the file name formatting facility in exiftool. Part of
//   the description is copied directly from there. You can find exiftool at:
//      http://www.sno.phy.queensu.ca/~phil/exiftool/
//
// Description:
//   Format a file string using a printf-like format string
//
// fmt is a string where the following substitutions occur
//   %d - the directory name (no trailing /)
//   %f - the file name without the extension
//   %e - the file extension without the leading '.'
//   %% - the '%' character
//
// if fs is true the folder is in local file system format
//   (e.g. C:\images instead of /c/images)
//
// Examples:
//
// Reformat the file name:
// var f = new File("/c/work/test.jpg");
// f.strf("%d/%f_%e.txt") == "/c/work/test_jpg.txt"
//
// Change the file extension
// f.strf("%d/%f.psd") == "/c/work/test.psd"
//
// Convert to a file name in a subdirectory named after the extension
// f.strf("%d/%e/%f.%e") == "/c/work/jpg/test.jpg"
//
// Change the file extension and convert to a file name in a subdirectory named
//   after the new extension
// f.strf("%d/psd/%f.psd") == "/c/work/psd/test.psd"
//
// Advanced Substitution
//   A substring of the original file name, directory or extension may be 
//   taken by specifying a string length immediately following the % character. 
//   If the length is negative, the substring is taken from the end. The 
//   substring position (characters to ignore at the start or end of the 
//   string) may be given by a second optional value after a decimal point. 
// For example:
//
// var f = new File("Picture-123.jpg");
//
// f.strf("%7f.psd") == "Picture.psd"
// f.strf("%-.4f.psd") == "Picture.psd"
// f.strf("%7f.%-3f") == "Picture.123"
// f.strf("Meta%-3.1f.xmp") == "Meta12.xmp"
//
File.prototype.strf = function(fmt, fs) {
  var self = this;
  var name = decodeURI(self.name);
  //var name = (self.name);

  // get the portions of the full path name

  // extension
  var m = name.match(/\.([^\.\/]+)/);
  var e = m ? m[1] : '';

  // basename
  m = name.match(/(.*)\.[^\.\/]+/);
  var f = m ? m[1] : name;

  fs |= isMac();

  // full path...
  var d = decodeURI((fs ? self.parent.fsName : self.parent.absoluteURI));

  // parent directory...
  var p = decodeURI(self.parent.name);

  //var d = ((fs ? self.parent.fsName : self.parent.toString()));

  var str = fmt;
 
  // a regexp for the format specifiers

  var rex = /([^%]*)%(-)?(\d+)?(\.\d+)?(%|d|e|f|p)(.*)/;

  var result = '';

  while (m = rex.exec(str)) {
    var pre = m[1];
    var sig = m[2];
    var len = m[3];
    var ign = m[4];
    var typ = m[5];
    var post = m[6];

    var subst = '';

    if (typ == '%') {
      subst = '%';
    } else {
      var s = '';
      switch (typ) {
        case 'd': s = d; break;
        case 'e': s = e; break;
        case 'f': s = f; break;
        case 'p': s = p; break;
      }

      var strlen = s.length;

      if (strlen && (len || ign)) {
        ign = (ign ? Number(ign.slice(1)) : 0);
        if (len) {
          len = Number(len);
          if (sig) {
            var _idx = strlen - len - ign;
            subst = s.slice(_idx, _idx+len);
          } else {
            subst = s.slice(ign, ign+len);
          }
        } else {
          if (sig) {
            subst = s.slice(0, strlen-ign);
          } else {
            subst = s.slice(ign);
          }
        }

      } else {
        subst = s;
      }
    }

    result += pre + subst;
    str = post;
  }

  result += str;

  return result;
};
Folder.prototype.strf = File.prototype.strf;


/*
  From the exiftool documentation:
  Set the print format for GPS coordinates. FMT uses the same syntax as the
  printf format string. The specifiers correspond to degrees, minutes and
  seconds in that order, but minutes and seconds are optional. For example,
  the following table gives the output for the same coordinate using various
  formats: 

                FMT                  Output
        -------------------    ------------------
        "%d deg %d' %.2f"\"    54 deg 59' 22.80"   (the default)
        "%d deg %.4f min"      54 deg 59.3800 min
        "%.6f degrees"         54.989667 degrees

The common degree marker is  which is is a Unicode literal of \u00B0
*/
//
// Test cases
//
/*
Stdlib.strfGPSstr(undefined, "54.00 59.00' 22.80\"");
Stdlib.strfGPSstr(undefined, "28.00 9.97' 0.00\"");
Stdlib.strfGPSstr("%d deg %.4f min", "28.00 9.97' 0.00\"");
Stdlib.strfGPSstr("%d deg %.4f min", "28.00 9.50' 0.00\"");
Stdlib.strfGPSstr(undefined, "28.00 9.50' 0.00\"");
Stdlib.strfGPSstr("%f", "28.00 9.97' 0.00\"");
Stdlib.strfGPSstr("%f", "28.50 0.00' 0.00\"");
Stdlib.strfGPSstr(undefined, "28.50 0.00' 0.00\"");
Stdlib.strfGPSstr(undefined, "54,59,22");
Stdlib.strfGPSstr(undefined, "54,59.22");
Stdlib.strfGPSstr("%d deg %.4f min", "54,59.22");
Stdlib.strfGPSstr(undefined, "54 59 22");
Stdlib.strfGPSstr(undefined, "54.00 deg 59.00 min 22.23 secs");
*/
//

Stdlib.DEFAULT_GPS_FORMAT = "%d deg %d' %.2f\"";

Stdlib.strfGPSstr = function(fmtStr, gpsStr) {

  // This is the most likely format
  var r = gpsStr.match(/(\d+\.\d+) (\d+\.\d+)\' (\d+\.\d+)\"/);

  // This is the format from the XMP Schema spec
  if (!r) {
    var r2 = r = gpsStr.match(/(\d+)\,(\d+)(\,|\.)(\d+)/);
  }

  // This format should pick up just about anything else
  if (!r) {
    var rex = /(\d+(?:\.\d+)?)[^\d\.]+(\d+(?:\.\d+)?)[^\d\.]+(\d+(?:\.\d+)?)/;
    var r3 = r = gpsStr.match(rex);
  }

  if (!r) {
    return fmtStr;
  }

  // if we matched either the first or third patterns
  if (!r2) {
    var d = Number(r[1]);
    var m = Number(r[2]);
    var s = Number(r[3]);

    var xm = (d - Math.floor(d)) * 60;
    var xs = (m - Math.floor(m)) * 60;

    m += s/60;
    d += m/60;
    if (s == 0) {
      s = xs;
    }
    if (m == 0) {
      m = xm;
    }

    return Stdlib.strfGPS(fmtStr, d, m, s);
  }

  if (r2) {
    var d = Number(r[1]);

    var sep = r[3];

    if (sep == '.') {
      var m = Number(r[2]);
      var s = Number("0." + r[4]) * 60;

    } else {
      var m = Number(r[2]);
      var s = Number(r[4]);
    }
    return Stdlib.strfGPS(fmtStr, d, m, s);
  }

  // if we can't figure out what's going on, just return the format spec
  return fmtStr;
};

Stdlib.strfGPS = function(fmtStr, deg, min, sec) {
  if (sec == undefined) {
    sec = 0;
  }
  if (min == undefined) {
    min = 0;
  }
  if (min == Math.floor(min)) {
    min += sec/60;
  }
  if (deg == Math.floor(deg)) {
    deg += min/60;
  }
  if (fmtStr == undefined) {
    fmtStr = Stdlib.DEFAULT_GPS_FORMAT;
  }

  return String.sprintf(fmtStr, deg, min, sec);
};


// This script only works in CS4
Stdlib.loadXMPScript = function() {
  if (!ExternalObject.AdobeXMPScript) {
    ExternalObject.AdobeXMPScript = new ExternalObject('lib:AdobeXMPScript');
  }
};

// This script only works in CS4
Stdlib.unloadXMPScript = function(){
  if (ExternalObject.AdobeXMPScript) {
    ExternalObject.AdobeXMPScript.unload();
    ExternalObject.AdobeXMPScript = undefined;
  }
};

/*
d = Stdlib.toDescriptor({
  name: "test",
  num: 22,
  flag: true
});
o = Stdlib.fromDescriptor(d);
*/
Stdlib.toDescriptor = function(obj) {
  if (arguments.length != 1) {
    Error.runtimeError(1221, "obj"); // wrong number of arguments
  }
  if (obj == undefined) {
    Error.runtimeError(2, "obj");    // undefined
  }
  if (typeof(obj) != "object") {
    Error.runtimeError(21, "obj");   // is not an object
  }

  var nameID = cTID("nm  ");
  var valueID = cTID("Vl  ");
  var componentID = sTID("component");

  function addProperty(desc, nm, val) {
    var typ = typeof(val);

    var pdesc = new ActionDescriptor();
    pdesc.putString(nameID, nm);

    switch (typ) {
      case "number": {
        pdesc.putDouble(valueID, val);
        break;
      }
      case "string": {
        pdesc.putString(valueID, val);
        break;
      }
      case "boolean": {
        pdesc.putBoolean(valueID, val);
        break;
      }
      case "object": {
        pdesc.putString(valueID, val.toString());
        break;
      }
      case "undefined": pdesc = undefined; break;
      case "function":  pdesc = undefined; break;
      default:          pdesc = undefined; break;
    };
    desc.putObject(sTID(nm), componentID, pdesc);
  };

  var desc = new ActionDescriptor();

  for (var idx in obj) {
    if (idx.startsWith("_")) {
      continue;
    }
    var val = obj[idx];
    if (val || typeof(val) == "undefined" || typeof(val) == "function") {
      continue;
    }

    addProperty(desc, idx, val);
  }

  return desc;
};

Stdlib.fromDescriptor = function(desc, obj) {
  if (arguments.length < 1 || arguments.length > 2) {
    Error.runtimeError(1221);        // wrong number of arguments
  }
  if (desc == undefined) {
    Error.runtimeError(2, "desc");   // is undefined
  }
  if (typeof(desc) != "object") {
    Error.runtimeError(21, "desc");   // is not an object
  }
  if (!(desc instanceof ActionDescriptor)) {
    Error.runtimeError(1330);         // Invalid Type
  }

  var nameID = cTID("nm  ");
  var valueID = cTID("Vl  ");

  if (!obj) {
    obj = {};
  }

  function getPropertyValue(pdesc) {
    var typ = pdesc.getType(valueID);
    var val = undefined;

    switch (typ) {
      case DescValueType.DOUBLETYPE: {
        val = pdesc.getDouble(valueID);
        break;
      };
      case DescValueType.INTEGERTYPE: {
        val = pdesc.getInteger(valueID);
        break;
      };
      case DescValueType.STRINGTYPE: {
        val = pdesc.getString(valueID);
        break;
      };
      case DescValueType.BOOLEANTYPE: {
        val = pdesc.getBoolean(valueID);
        break;
      };
    };
    return val;
  };

  for (var i = 0; i < desc.count; i++) {
    var key = desc.getKey(i);
    var pdesc = desc.getObjectValue(key);
    var nm = pdesc.getString(nameID);
    var val = getPropertyValue(pdesc);
    if (val != undefined) {
      obj[nm] = val;
    }
  }

  return obj;
};

function toBoolean(s) {
  if (s == undefined) { return false; }
  if (s.constructor == Boolean) { return s.valueOf(); }
  if (s.constructor == String)  { return s.toLowerCase() == "true"; }
  return Boolean(s);
};

function isBoolean(s) {
  return (s != undefined && s.constructor == Boolean);
}

function toNumber(s) {
  if (s == undefined) { return NaN; }
  if (s.constructor == String && s.length == 0) { return NaN; }
  if (s.constructor == Number) { return s.valueOf(); }
  return Number(s.toString());
};

function isNumber(s) {
  return !isNaN(s);
}

function isString(s) {
  return (s != undefined && s.constructor == String);
}


function toFont(fs) {
  if (fs instanceof TextFont) { return fs.postScriptName; }

  var str = fs.toString();
  var f = Stdlib.determineFont(str);  // first, check by PS name

  return (f ? f.postScriptName : undefined);
};

"stdlib.js";
// EOF

//
// GenericUI
// This is a lightweight UI framework. All of the common code that you
// need to write for a ScriptUI-based application is abstracted out here.
//
// $Id: GenericUI.jsx,v 1.131 2008/10/14 22:24:19 anonymous Exp $
// Copyright: (c)2005, xbytor
// License: http://creativecommons.org/licenses/LGPL/2.1
// Contact: xbytor@gmail.com
//

isPhotoshop = function() {
  return !!app.name.match(/photoshop/i);
};
isBridge = function() {
  return !!app.name.match(/bridge/i);
};
isInDesign = function() {
  return !!app.name.match(/indesign/i);
};
isESTK = function() {
  return !!app.name.match(/estoolkit/i);
};

_initVersionFunctions = function() {
  if (isPhotoshop()) {
    isCS4 = function()  { return app.version.match(/^11\./); };
    isCS3 = function()  { return app.version.match(/^10\./); };
    isCS2 = function()  { return app.version.match(/^9\./); };
    isCS  = function()  { return app.version.match(/^8\./); };
    isPS7 = function()  { return app.version.match(/^7\./); };

  } else {
    var appName = BridgeTalk.appName;
    var version = BridgeTalk.appVersion;

    if (isBridge()) {
      isCS4 = function()  { return version.match(/^3\./); };
      isCS3 = function()  { return version.match(/^2\./); };
      isCS2 = function()  { return version.match(/^1\./); };
      isCS  = function()  { return false; }
      isPS7 = function()  { return false; };

    } else if (isInDesign()) {
      isCS4  = function() { return false; }
      isCS3 = function()  { return version.match(/^5\./); };
      isCS2 = function()  { return version.match(/^4\./); };
      isCS  = function()  { return false; }
      isPS7 = function()  { return false; };

    } else if (isESTK()) {
      isCS4 = function()  { return version.match(/^3\./); };
      isCS3 = function()  { return version.match(/^2\./); };
      isCS2 = function()  { return version.match(/^1\./); };
      isCS  = function()  { return false; }
      isPS7 = function()  { return false; };

    } else {
      isCS4 = function()  { Error.runtimeError(9001,
                                               "Unsupported application")};
      isCS3 = function()  { Error.runtimeError(9001,
                                               "Unsupported application")};
      isCS2 = function()  { Error.runtimeError(9001,
                                               "Unsupported application")};
      isCS  = function()  { Error.runtimeError(9001,
                                               "Unsupported application")};
      isPS7 = function()  { Error.runtimeError(9001,
                                               "Unsupported application")};
    }
  }
};

var isCS3;
if (!isCS3) {
  _initVersionFunctions();
}

//
// GenericUI is the core class for this framework.
//
GenericUI = function() {
  var self = this;

  self.title = "GenericUI";  // the window title
  self.notesSize = 50;       // the height of the Notes text panel
                             // set to 0 to disable
  self.winRect = {           // the rect for the window
    x: 200, 
    y: 200,
    w: 100,
    h: 200
  };
  self.documentation = "This is a Photoshop JavaScript script";

  self.iniFile = undefined; // the name of the ini file used for this script
  self.saveIni = true;      // Set to 'undefined' to disable saving  to the
                            // ini file
  self.hasBorder = true;

  self.notesTxt   = 'Notes:';
  self.processTxt = 'Process';
  self.cancelTxt  = 'Cancel';

  self.buttonOneTxt = undefined;
  self.buttonTwoTxt = undefined;

  self.settingsPanel = false;
  self.optionsClass = undefined;
  self.win = undefined;
  self.window = undefined;
  self.doc = undefined;
  self.ini = undefined;

  self.setDefault = isCS2() || isCS3() || isCS4();

  self._logDebug = false;

  self.parentWin = undefined;

  self.windowCreationProperties = undefined;

  self.buttonWidth = 90;

  self.xmlEnabled = false;
};

GenericUI.getTextOfs = function() { 
  return (isCS3() || isCS4()) ? 3 : 0; 
};

//
// Returns the xtools preferences folder
//
GenericUI._getPreferencesFolder = function() {
  var userData = Folder.userData;

  if (!userData || !userData.exists) {
    userData = Folder("~");
  }

  var folder = new Folder(userData + "/xtools");

  if (!folder.exists) {
    folder.create();
  }

  return folder;
};

isWindows = function() {
  return !!$.os.match(/windows/i);
};
isMac = function() {
  return !isWindows();
};

GenericUI.ENCODING = "LATIN1";

GenericUI.preferencesFolder = GenericUI._getPreferencesFolder();
GenericUI.PREFERENCES_FOLDER = GenericUI.preferencesFolder;

//
// createWindow constructs a window with a documentation panel and a app panel
// and 'Process' and 'Cancel' buttons. 'createPanel' (implemented by the app
// script) is invoked by this method to create the app panel.
//
GenericUI.prototype.createWindow = function(ini, doc) {
  var self = this;
  var wrect = self.winRect;

  function rectToBounds(r) {
    return[r.x, r.y, r.x+r.w, r.y+r.h];
  };
  var win = new Window('dialog', self.title, rectToBounds(wrect),
                       self.windowCreationProperties);

  win.mgr = self;  // save a ref to the UI manager
  win.ini = ini;
  if (!self.ini) {
    self.ini = win.ini;
  }
  self.window = self.win = win;
  self.doc = doc;

  var xOfs = 10;
  var yy = 10;

  var hasButtons = (self.processTxt || self.cancelTxt ||
                    self.buttonOneTxt || self.buttonTwoTxt);

  var hasNotesPanel = (self.notesSize && self.documentation);

  if (hasNotesPanel) {
    // define the notes panel (if needed) and insert the documentation text
    var docPnl = win.add('panel',
                         [xOfs, yy, wrect.w-xOfs, self.notesSize+10],
                         self.notesTxt);

    var y = (isCS() ? 20 : 10);
    var ymax = (isCS() ? self.notesSize-10 : self.notesSize-20);
    var docs = self.documentation;

    // XXX-CS4 Need to test
    if (isCS3() || isCS4()) {
      docs = docs.replace(/&/g, '&&');
    }
    docPnl.add('statictext',
               [10,y,docPnl.bounds.width-10,ymax],
               docs,
               {multiline:true});
    
    yy += self.notesSize + 10;
  }

  var appBottom = wrect.h - 10;
  if (self.settingsPanel) {
    appBottom -=  70;
  }
  if (hasButtons) {
    appBottom -=  50;
  }

  // Now, create the application panel
  var pnlType = 'panel';
  if (!isCS()) {
    pnlType = (self.hasBorder ? 'panel' : 'group');
  }
  win.appPnl = win.add(pnlType, [xOfs, yy, wrect.w-xOfs, appBottom]);

  win.appPanel = win.appPnl;

  yy = appBottom + 10;

  // and call the application callback function with the ini object
  self.createPanel(win.appPnl, ini, doc);

  // Settings Panel
  if (self.settingsPanel) {
    win.settingsPnl = win.add('panel', [xOfs,yy,wrect.w-xOfs,yy+60]);
    win.settingsPnl.text = 'Settings';
    self.createSettingsPanel(win.settingsPnl, ini);
  }

  if (hasButtons) {
    // Create the Process/Cancel buttons
    var btnY = wrect.h - 40;
    var btnW = self.buttonWidth;
    var btnOfs;

    var btns = ['processTxt', 'cancelTxt', 'buttonOneTxt', 'buttonTwoTxt'];

    var btnCnt = 0;

    for (var i = 0; i < btns.length; i++) {
      if (self[btns[i]]) {
        btnCnt++;
      }
    }

    if (!self.processTxt || !self.cancelTxt) {
      btnOfs = (wrect.w - (btnW)) / 2;
    } else {
      btnOfs = (wrect.w - (2 * btnW)) / 3;
    }

    if (self.processTxt) {
      win.process = win.add('button',
                            [btnOfs,btnY,btnOfs+btnW,btnY+20],
                            self.processTxt);
      if (self.setDefault) {
        win.defaultElement = win.process;
      }

      // And now the callback for the process button.
      win.process.onClick = function() {
        try {
          // validate the contents of the window
          var rc = this.parent.validate();
          
          if (!rc) {
            // if there was a terminal problem with the validation,
            // close up the window
            this.parent.close(2);
          }
        } catch (e) {
          var msg = Stdlib.exceptionMessage(e);
          Stdlib.log(msg);
          alert(msg);
        }
      }
    }
    
    if (self.cancelTxt) {
      win.cancel  = win.add('button',
                            [wrect.w-btnOfs-btnW,btnY,wrect.w-btnOfs,btnY+20],
                            self.cancelTxt);
      
      win.cancelElement = win.cancel;
      
      win.cancel.onClick = function() {
        this.parent.close(2);
      }
    }
  }

  // Point to the validation
  win.validate = GenericUI.validate;

  return win;
};
GenericUI.processCB = function() {
  try {
    var win = GenericUI.getWindow(this);
    // validate the contents of the window
    var rc = win.validate();
          
    if (!rc) {
      // if there was a terminal problem with the validation,
      // close up the window
      win.close(2);
    }
  } catch (e) {
    var msg = Stdlib.exceptionMessage(e);
    Stdlib.log(msg);
    alert(msg);
  }
};
GenericUI.cancelCB = function() {
  var win = GenericUI.getWindow(this);
  win.parent.close(2);
};

GenericUI.prototype.moveWindow = function(x, y) {
  var win = this.win;

  if (x != undefined && !isNaN(x)) {
    var width = win.bounds.width;
    if (isCS()) {
      x -= 2;
    }
    win.bounds.left = x;
    win.bounds.width = width; //  Not sure if this is really needed
  }
  if (y != undefined && !isNaN(y)) {
    var height = win.bounds.height; 
    if (isCS()) {
      // y -= 22;
    }
    win.bounds.top = y;
    win.bounds.height = height;  //  Not sure if this is really needed
  }
};
GenericUI.getWindow = function(pnl) {
  if (pnl.window) {
    return pnl.window;
  }
  while (pnl && !(pnl instanceof Window)) {
    pnl = pnl.parent;
  }
  return pnl;
};
GenericUI.prototype.createSettingsPanel = function(pnl, ini) {
  var win = GenericUI.getWindow(pnl);

  pnl.text = 'Settings';
  pnl.win = win;

  pnl.fileMask = "INI Files: *.ini, All Files: *.*";
  pnl.loadPrompt = "Please choose a settings file to read";
  pnl.savePrompt = "Please choose a settings file to write";
  pnl.defaultFile = undefined;
  
  var w = pnl.bounds[2] - pnl.bounds[0];
  var offsets = [w*0.2, w*0.5, w*0.8];
  var y = 15;
  var bw = 90;

  var x = offsets[0]-(bw/2);
  pnl.load = pnl.add('button', [x,y,x+bw,y+20], 'Load...');
  x = offsets[1]-(bw/2);
  pnl.save = pnl.add('button', [x,y,x+bw,y+20], 'Save...');
  x = offsets[2]-(bw/2);
  pnl.reset = pnl.add('button', [x,y,x+bw,y+20], 'Reset');

  pnl.load.onClick = function() {
    var pnl = this.parent;
    var win = pnl.win;
    var mgr = win.mgr;
    var def = pnl.defaultFile;

    if (!def) {
      if (mgr.iniFile) {
        def = GenericUI.iniFileToFile(mgr.iniFile);
      } else {
        def = GenericUI.iniFileToFile("~/settings.ini");
      }
    }

    var f;
    var prmpt = pnl.loadPrompt;
    var sel = Stdlib.createFileSelect(pnl.fileMask);
    if (isMac()) {
      sel = undefined;
    }
    f = Stdlib.selectFileOpen(prmpt, sel, def);
    if (f) {
      win.ini = mgr.readIniFile(f);
      win.close(4);

      if (pnl.onLoad) {
        pnl.onLoad(f);
      }
    }
  }
  pnl.save.onClick = function() {
    var pnl = this.parent;
    var win = pnl.win;
    var mgr = win.mgr;
    var def = pnl.defaultFile;

    if (!def) {
      if (mgr.iniFile) {
        def = GenericUI.iniFileToFile(mgr.iniFile);
      } else {
        def = GenericUI.iniFileToFile("~/settings.ini");
      }
    }

    var f;
    var prmpt = pnl.savePrompt;
    var sel = Stdlib.createFileSelect(pnl.fileMask);

    if (isMac()) {
      sel = undefined;
    }
    f = Stdlib.selectFileSave(prmpt, sel, def);

    if (f) {
      var mgr = win.mgr;
      var res = mgr.validatePanel(win.appPnl, win.ini);

      if (typeof(res) != 'boolean') {
        mgr.writeIniFile(f, res);

        if (pnl.onSave) {
          pnl.onSave(f);
        }
      }
    }
  }
  pnl.reset.onClick = function() {
    var pnl = this.parent;
    var win = pnl.win;
    var mgr = win.mgr;

    if (mgr.defaultIniFile) {
      win.ini = mgr.readIniFile(mgr.defaultIniFile);

    } else if (mgr.ini) {
      win.ini = mgr.ini;
    }

    win.close(4);
    if (pnl.onReset) {
      pnl.onReset();
    }
  }
};

GenericUI.prototype.createFontPanel = function(pnl, ini, label, lwidth) {
  var win = GenericUI.getWindow(pnl);

  pnl.win = win;

  var w = pnl.bounds[2] - pnl.bounds[0];
  var xofs = 0;
  var y = 0;

  if (pnl.type == 'panel') {
    xofs += 5;
    y += 5;
  }

  var tOfs = GenericUI.getTextOfs();

  var x = xofs;
  if (label == undefined) {
    label = "Font:";
    lwidth = 40;
  }

  if (label != '') {
    pnl.label = pnl.add('statictext', [x,y+tOfs,x+lwidth,y+22+tOfs], label);
    x += lwidth;
  }
  pnl.family = pnl.add('dropdownlist', [x,y,x+180,y+22]);
  x += 185;
  pnl.style  = pnl.add('dropdownlist', [x,y,x+110,y+22]);
  x += 115;
  pnl.fontSize  = pnl.add('edittext', [x,y,x+30,y+22], "12");
  x += 32;
  pnl.sizeLabel = pnl.add('statictext', [x,y+tOfs,x+15,y+22+tOfs], 'pt');

  pnl.fontTable = GenericUI._getFontTable();
  var names = [];
  for (var idx in pnl.fontTable) {
    names.push(idx);
  }
  names.sort();
  for (var i = 0; i < names.length; i++) {
    pnl.family.add('item', names[i]);
  }
  pnl.family.onChange = function() {
    var pnl = this.parent;
    var sel = pnl.family.selection.text;
    var family = pnl.fontTable[sel];
    
    pnl.style.removeAll();

    var styles = family.styles;

    for (var i = 0; i < styles.length; i++) {
      var it = pnl.style.add('item', styles[i].style);
      it.font = styles[i].font;
    }
    if (pnl._defaultStyle) {
      var it = pnl.style.find(pnl._defaultStyle);
      pnl._defaultStyle = undefined;
      if (it) {
        it.selected = true;
      } else {
        pnl.style.items[0].selected = true;
      }
    } else {
      pnl.style.items[0].selected = true;
    }
  }
  pnl.family.items[0].selected = true;

  pnl.fontSize.onChanging = GenericUI.numberKeystrokeFilter;

  pnl.setFont = function(str, size) {
    var pnl = this;
    if (!str) {
      return;
    }
    var font = (str.typename == "TextFont") ? str : Stdlib.determineFont(str);
    if (font) {
      var it = pnl.family.find(font.family);
      if (it) {
        it.selected = true;
        pnl._defaultStyle = font.style;
      }
    }
    pnl.fontSize.text = size;
  }
  pnl.getFont = function() {
    var pnl = this;
    var font = pnl.style.selection.font
    return { font: font.postScriptName, size: Number(pnl.fontSize.text) };

    var fsel = pnl.family.selection.text;
    var ssel = pnl.style.selection.text;
    var family = pnl.fontTable[sel];
    var styles = familyStyles;
    var font = undefined;

    for (var i = 0; i < styles.length && font == undefined; i++) {
      if (styles[i].style == ssel) {
        font = styles[i].font;
      }
    }
    return { font: font, size: Number(font.fontSize) };
  }

  return pnl;
};
GenericUI._getFontTable = function() {
  var fonts = app.fonts;
  var fontTable = {};
  for (var i = 0; i < fonts.length; i++) {
    var font = fonts[i];
    var entry = fontTable[font.family];
    if (!entry) {
      entry = { family: font.family, styles: [] };
      fontTable[font.family] = entry;
    }
    entry.styles.push({ style: font.style, font: font });
  }
  return fontTable;
};

if (!isCS()) {
//============================= FileNaming ====================================
//
// FileNaming is only available in PS at present
//
FileNamingOptions = function(obj, prefix) {
  var self = this;

  self.fileNaming = [];      // array of FileNamingType and/or String
  self.startingSerial = 1;
  self.windowsCompatible = isWindows(); 
  self.macintoshCompatible = isMac();
  self.unixCompatible = true;

  if (obj) {
    if (prefix == undefined) {
      prefix = '';
    }
    var props = FileNamingOptions.props;
    for (var i = 0; i < props.length; i++) {
      var name = props[i];
      var oname = prefix + name;
      if (oname in obj) {
        self[name] = obj[oname];
      }
    }

    if (self.fileNaming.constructor == String) {
      self.fileNaming = self.fileNaming.split(','); 
    }
  }
};
FileNamingOptions.prototype.typename = FileNamingOptions;
FileNamingOptions.props = ["fileNaming", "startingSerial", "windowsCompatible",
                           "macintoshCompatible", "unixCompatible"];

FileNamingOptions.prototype.format = function(file, cdate) {
  var self = this;
  var str  = '';

  file = Stdlib.convertFptr(file);

  if (!cdate) {
    cdate = file.created || new Date()
  }

  var fname = file.strf("%f");
  var ext = file.strf("%e");

  var parts = self.fileNaming;

  if (parts.constructor == String) {
    parts = parts.split(',');
  }

  var serial = self.startingSerial;
  var aCode = 'a'.charCodeAt(0);
  var ACode = 'A'.charCodeAt(0);

  for (var i = 0; i < parts.length; i++) {
    var p = parts[i];
    var fnel = FileNamingElements.getByName(p);

    if (!fnel) {
      if (p == '--') {
        p = '-';
      }
      str += p;
      continue;
    }

    var s = '';
    switch (fnel.type) {
    case FileNamingType.DOCUMENTNAMEMIXED: s = fname; break;
    case FileNamingType.DOCUMENTNAMELOWER: s = fname.toLowerCase(); break;
    case FileNamingType.DOCUMENTNAMEUPPER: s = fname.toUpperCase(); break;
    case FileNamingType.SERIALNUMBER1:     s = "%d".sprintf(serial++); break;
    case FileNamingType.SERIALNUMBER2:     s = "%02d".sprintf(serial++); break;
    case FileNamingType.SERIALNUMBER3:     s = "%03d".sprintf(serial++); break;
    case FileNamingType.SERIALNUMBER4:     s = "%04d".sprintf(serial++); break;
    case FileNamingElement.SERIALNUMBER5:  s = "%05d".sprintf(serial++); break;
    case FileNamingType.EXTENSIONLOWER:    s = '.' + ext.toLowerCase(); break;
    case FileNamingType.EXTENSIONUPPER:    s = '.' + ext.toUpperCase(); break;
    case FileNamingType.SERIALLETTERLOWER:
      s = String.fromCharCode(aCode + (serial++)); break;
    case FileNamingType.SERIALLETTERUPPER:
      s = String.fromCharCode(ACode + (serial++)); break;
    }

    if (s) {
      str += s;
      continue;
    }

    var fmt = '';
    switch (fnel.type) {
    case FileNamingType.MMDDYY:   fmt = "%m%d%y"; break;
    case FileNamingType.MMDD:     fmt = "%m%d"; break;
    case FileNamingType.YYYYMMDD: fmt = "%Y%m%d"; break;
    case FileNamingType.YYMMDD:   fmt = "%y%m%d"; break;
    case FileNamingType.YYDDMM:   fmt = "%y%d%m"; break;
    case FileNamingType.DDMMYY:   fmt = "%d%m%y"; break;
    case FileNamingType.DDMM:     fmt = "%d%m"; break;
    }
    
    if (fmt) {
      str += cdate.strftime(fmt);
      continue;
    }
  }

  self._serial = serial;

  return str;
};

FileNamingOptions.prototype.copyTo = function(opts, prefix) {
  var self = this;
  var props = FileNamingOptions.props;

  for (var i = 0; i < props.length; i++) {
    var name = props[i];
    var oname = prefix + name;
    opts[oname] = self[name];
    if (name == 'fileNaming' && self[name] instanceof Array) {
      opts[oname] = self[name].join(',');
    } else {
      opts[oname] = self[name];
    }
  }
};


// this array is folder into FileNamingElement
FileNamingOptions._examples =
  [ "",
    "Document",
    "document",
    "DOCUMENT",
    "1",
    "01",
    "001",
    "0001",
    "a",
    "A",
    "103107",
    "1031",
    "20071031",
    "071031",
    "073110",
    "311007",
    "3110",
    ".psd",
    ".PSD"
    ];

FileNamingOptions.prototype.getExample = function() {
  var self = this;
  var str = '';
  return str;
};

FileNamingElement = function(name, menu, type, sm, example) {
  var self = this;
  self.name = name;
  self.menu = menu;
  self.type = type;
  self.smallMenu = sm;
  self.example = (example || '');
};
FileNamingElement.prototype.typename = FileNamingElement;

FileNamingElements = [];
FileNamingElements._add = function(name, menu, type, sm, ex) {
  FileNamingElements.push(new FileNamingElement(name, menu, type, sm, ex));
}

FileNamingElement.SERIALNUMBER5 = {
  toString: function() { return "FileNamingElement.SERIALNUMBER5"; }
};

FileNamingElements._init = function() {

  FileNamingElements._add("", "", "", "", "");

  if (!isPhotoshop()) {
    return;
  }

  // the names here correspond to the sTID symbols used when making
  // a Batch request via the ActionManager interface. Except for "Name",
  // which should be "Nm  ".
  // the names should be the values used when serializing to and from
  // an INI file.
  // A FileNamingOptions object needs to be defined.
  FileNamingElements._add("Name", "Document Name",
                          FileNamingType.DOCUMENTNAMEMIXED,
                          "Name", "Document");
  FileNamingElements._add("lowerCase", "document name",
                          FileNamingType.DOCUMENTNAMELOWER,
                          "name", "document");
  FileNamingElements._add("upperCase", "DOCUMENT NAME",
                          FileNamingType.DOCUMENTNAMEUPPER,
                          "NAME", "DOCUMENT");
  FileNamingElements._add("oneDigit", "1 Digit Serial Number",
                          FileNamingType.SERIALNUMBER1,
                          "Serial #", "1");
  FileNamingElements._add("twoDigit", "2 Digit Serial Number",
                          FileNamingType.SERIALNUMBER2,
                          "Serial ##", "01");
  FileNamingElements._add("threeDigit", "3 Digit Serial Number",
                          FileNamingType.SERIALNUMBER3,
                          "Serial ###", "001");
  FileNamingElements._add("fourDigit", "4 Digit Serial Number",
                          FileNamingType.SERIALNUMBER4,
                          "Serial ####", "0001");
  FileNamingElements._add("fiveDigit", "5 Digit Serial Number",
                          FileNamingElement.SERIALNUMBER5,
                          "Serial #####", "00001");
  FileNamingElements._add("lowerCaseSerial", "Serial Letter (a, b, c...)",
                          FileNamingType.SERIALLETTERLOWER,
                          "Serial a", "a");
  FileNamingElements._add("upperCaseSerial", "Serial Letter (A, B, C...)",
                          FileNamingType.SERIALLETTERUPPER,
                          "Serial A", "A");
  FileNamingElements._add("mmddyy", "mmddyy (date)",
                          FileNamingType.MMDDYY,
                          "mmddyy", "103107");
  FileNamingElements._add("mmdd", "mmdd (date)",
                          FileNamingType.MMDD,
                          "mmdd", "1031");
  FileNamingElements._add("yyyymmdd", "yyyymmdd (date)",
                          FileNamingType.YYYYMMDD,
                          "yyyymmdd", "20071031");
  FileNamingElements._add("yymmdd", "yymmdd (date)",
                          FileNamingType.YYMMDD,
                          "yymmdd", "071031");
  FileNamingElements._add("yyddmm", "yyddmm (date)",
                          FileNamingType.YYDDMM,
                          "yyddmm", "073110");
  FileNamingElements._add("ddmmyy", "ddmmyy (date)",
                          FileNamingType.DDMMYY,
                          "ddmmyy", "311007");
  FileNamingElements._add("ddmm", "ddmm (date)",
                          FileNamingType.DDMM,
                          "ddmm", "3110");
  FileNamingElements._add("lowerCaseExtension", "extension",
                          FileNamingType.EXTENSIONLOWER,
                          "ext", ".psd");
  FileNamingElements._add("upperCaseExtension", "EXTENSION",
                          FileNamingType.EXTENSIONUPPER,
                          "EXT", ".PSD");
};
FileNamingElements._init();
FileNamingElements.getByName = function(name) {
  return Stdlib.getByName(FileNamingElements, name);
};

GenericUI.prototype.createFileNamingPanel = function(pnl, ini,
                                                     prefix,
                                                     useSerial,
                                                     useCompatibility,
                                                     columns) {
  var win = GenericUI.getWindow(pnl);
  if (useSerial == undefined) {
    useSerial = false
  }
  if (useCompatibility == undefined) {
    useCompatibility = false
  }
  if (columns == undefined) {
    columns = 3;
  } else {
    if (columns != 2 && columns != 3) {
      Error.runtimeError(9001, "Internal Error: Bad column spec for FileNaming panel");
    }
  }

  pnl.fnmenuElements = [];
  for (var i = 0; i < FileNamingElements.length; i++) {
    var fnel = FileNamingElements[i];
    pnl.fnmenuElements.push(fnel.menu);
  }
  var extrasMenuEls = [
    "-",
    "Create Custom Text",
    "Edit Custom Text",
    "Delete Custom Text",
    "-",
    ];
  for (var i = 0; i < extrasMenuEls.length; i++) {
    pnl.fnmenuElements.push(extrasMenuEls[i]);
  }

  pnl.win = win;
  if (prefix == undefined) {
    prefix = '';
  }
  pnl.prefix = prefix;

  var w = pnl.bounds[2] - pnl.bounds[0];
  var xofs = 0;
  var y = 0;

  if (pnl.type == 'panel') {
    xofs += 5;
    y += 10;
  }
  pnl.text = "File Naming";

  var tOfs = GenericUI.getTextOfs();

  if (columns == 2) {
    var menuW = (w - 50)/2;

  } else {
    var menuW = (w - 65)/3;
  }

  var opts = new FileNamingOptions(ini, pnl.prefix);

  x = xofs;

  pnl.exampleLabel = pnl.add('statictext', [x,y+tOfs,x+70,y+22+tOfs],
                             'Example:');
  x += 70;
  pnl.example = pnl.add('statictext', [x,y+tOfs,x+300,y+22+tOfs], '');
  y += 30;
  x = xofs;

  pnl.menus = [];

  pnl.menus[0]  = pnl.add('dropdownlist', [x,y,x+menuW,y+22],
                          pnl.fnmenuElements);
  x += menuW + 5;
  pnl.add('statictext', [x,y+tOfs,x+10,y+22+tOfs], '+');

  x += 15;

  pnl.menus[1]  = pnl.add('dropdownlist', [x,y,x+menuW,y+22],
                          pnl.fnmenuElements);
  x += menuW + 5;
  pnl.add('statictext', [x,y+tOfs,x+10,y+22+tOfs], '+');

  if (columns == 2) {
    y += 30;
    x = xofs;
  } else {
    x += 15;
  }
  
  pnl.menus[2]  = pnl.add('dropdownlist', [x,y,x+menuW,y+22],
                          pnl.fnmenuElements);
  x += menuW + 5;
  pnl.add('statictext', [x,y+tOfs,x+10,y+22+tOfs], '+');

  if (columns == 3) {
    y += 30;
    x = xofs;

  } else {
    x += 15;
  }

  pnl.menus[3]  = pnl.add('dropdownlist', [x,y,x+menuW,y+22],
                          pnl.fnmenuElements);
  x += menuW + 5;
  pnl.add('statictext', [x,y+tOfs,x+10,y+22+tOfs], '+');

  if (columns == 2) {
    y += 30;
    x = xofs;

  } else {
    x += 15;
  }

  pnl.menus[4]  = pnl.add('dropdownlist', [x,y,x+menuW,y+22],
                          pnl.fnmenuElements);
  x += menuW + 5;
  pnl.add('statictext', [x,y+tOfs,x+10,y+22+tOfs], '+');

  x += 15;

  pnl.menus[5]  = pnl.add('dropdownlist', [x,y,x+menuW,y+22],
                          pnl.fnmenuElements);
  y += 30;
  x = xofs;

  pnl.addMenuElement = function(text) {
    var pnl = this;
    for (var i = 0; i < 6; i++) {
      var vmenu = pnl.menus[i];
      vmenu.add('item', text);
    }
  }

  pnl.useSerial = useSerial;
  if (useSerial) {
    pnl.add('statictext', [x,y+tOfs,x+80,y+22+tOfs], 'Starting serial#:');
    x += 90;
    pnl.startingSerial = pnl.add('edittext', [x,y,x+50,y+22],
                                 opts.startingSerial);
    y += 30;
    x = xofs;
    pnl.startingSerial.onChanging = GenericUI.numberKeystrokeFilter;
  }
  
  pnl.useCompatibility = useCompatibility;
  if (useCompatibility) {
    pnl.add('statictext', [x,y+tOfs,x+80,y+22+tOfs], 'Compatibility:');
    x += 90;
    pnl.compatWindows = pnl.add('checkbox', [x,y,x+70,y+22], 'Windows');
    x += 80;
    pnl.compatMac = pnl.add('checkbox', [x,y,x+70,y+22], 'MacOS');
    x += 80;
    pnl.compatUnix = pnl.add('checkbox', [x,y,x+70,y+22], 'Unix');

    pnl.compatWindows.value = opts.windowsCompatible;
    pnl.compatMac.value = opts.macintoshCompatible;
    pnl.compatUnix.value = opts.unixCompatible;
  }

  function menuOnChange() {
    var pnl = this.parent;
    var win = GenericUI.getWindow(pnl);
    if (pnl.processing) {
      return;
    }
    pnl.processing = true;
    try {
      var menu = this;
      if (!menu.selection) {
        return;
      }

      var currentSelection = menu.selection.index;
      var lastSelection = menu.lastMenuSelection;

      menu.lastMenuSelection = menu.selection.index;

      var lastWasCustomText = (lastSelection >= pnl.fnmenuElements.length);

      var sel = menu.selection.text;
      if (sel == "Create Custom Text") {
        var text = GenericUI.createCustomTextDialog(win,
                                                    "Create Custom Text",
                                                    "new");
        if (text) {
          if (text.match(/^\-+$/)) {
            text += '-';
          }
          if (!menu.find(text)) {
            pnl.addMenuElement(text);
          }
        
          var it = menu.find(text);
          menu.selection = it;
          menu.lastMenuSelection = it.index;

        } else {
          if (lastSelection >= 0) {
            menu.selection = menu.items[lastSelection];
            menu.lastMenuSelection = lastSelection;

          } else {
            menu.selection = menu.items[0];
          }
        }

      } else if (lastWasCustomText) {
        if (sel == "Edit Custom Text") {
          var lastText = menu.items[lastSelection].text;
          var text = GenericUI.createCustomTextDialog(win,
                                                      "Edit Custom Text",
                                                      "edit",
                                                      lastText);
          if (text) {
            for (var i = 0; i < 6; i++) {
              var vmenu = pnl.menus[i];
              var it = vmenu.add('item', text);

              if (vmenu.selection &&
                  vmenu.selection.index == lastSelection) {

                // if a menu already has the previous version of this edited
                // entry, we have to remove the old one before setting the
                // new one or else the menu selection gets lost
                vmenu.remove(lastSelection);
                vmenu.selection = it;

              } else {
                var it = vmenu.selection;
                vmenu.remove(lastSelection);
                vmenu.selection = it;
              }
            }
        
            var it = menu.find(text);
            menu.selection = it;
            pnl.lastMenuSelection = it.index;

          } else {
            if (lastSelection >= 0) {
              menu.selection = menu.items[lastSelection];
              menu.lastMenuSelection = lastSelection;

            } else {
              menu.selection = menu.items[0];
            }
          }

        } else if (sel == "Delete Custom Text") {
          var lastText = menu.items[lastSelection].text;
          if (confirm("Do you really want to remove \"" + lastText + "\"?")) {
            for (var i = 0; i < 6; i++) {
              var vmenu = pnl.menus[i];
              vmenu.remove(lastSelection);
            }
            menu.selection = menu.items[0];

          } else {
            menu.selection = menu.items[lastSelection];
            menu.lastMenuSelection = lastSelection;
          }

        } else {
          //alert("Internal error, Custom Text request");
        }

      } else {
        if (lastSelection >= 0 && (sel == "Edit Custom Text" ||
                                   sel == "Delete Custom Text")) {
          menu.selection = menu.items[lastSelection];
          menu.lastMenuSelection = lastSelection;
        }
      }

      var example = '';
      var format = [];

      for (var i = 0; i < 6; i++) {
        var vmenu = pnl.menus[i];
        if (vmenu.selection) {
          var fmt = '';
          var text = vmenu.selection.text;
          var fne = Stdlib.getByProperty(FileNamingElements, "menu", text);
          if (fne) {
            text = fne.example;
            fmt = fne.name;
          } else {
            fmt = text;
          }

          if (text) {
            if (text.match(/^\-+$/)) {
              text = text.substr(1);
            }
            example += text;
          }

          if (fmt) {
            if (fmt.match(/^\-+$/)) {
              fmt = fmt.substr(1);
            }
            format.push(fmt);
          }
        }
      }
      if (pnl.example) {
        pnl.example.text = example;
      }
      format = format.join(",");
      var win = GenericUI.getWindow(pnl);
      if (win.mgr.updateNamingFormat) {
        win.mgr.updateNamingFormat(format, example);
      }

    } finally {
      pnl.processing = false;
    }

    if (pnl.onChange) {
      pnl.onChange();
    }
  }

  // default all slots to ''
  for (var i = 0; i < 6; i++) {
    var menu = pnl.menus[i];
    menu.selection = menu.items[0];
    menu.lastMenuSelection = 0;
  }

  for (var i = 0; i < 6; i++) {
    var name = opts.fileNaming[i];
    if (name) {
      var fne = FileNamingElements.getByName(name);
      var it;

      if (!fne) {
        if (name.match(/^\-+$/)) {
          name += '-';
        }
        it = pnl.menus[i].find(name);
        if (!it) {
          pnl.addMenuElement(name);
          it = pnl.menus[i].find(name);
        }
      } else {
        it = pnl.menus[i].find(fne.menu);
      }
      pnl.menus[i].selection = it;
    }
  }

//   pnl.menus[0].selection = pnl.menus[0].find("document name");
//   pnl.menus[0].lastMenuSelection = pnl.menus[0].selection.index;
//   pnl.menus[1].selection = pnl.menus[1].find("extension");
//   pnl.menus[1].lastMenuSelection = pnl.menus[1].selection.index;

  for (var i = 0; i < 6; i++) {
    var menu = pnl.menus[i];
    menu.onChange = menuOnChange;
  }

  pnl.getFileNamingOptions = function(ini) {
    var pnl = this;
    var fileNaming = [];

    for (var i = 0; i < 6; i++) {
      var menu = pnl.menus[i];

      if (menu.selection) {
        var idx = menu.selection.index;

        if (idx) {
          // [0] is the "" item so we ignore it
          var fnel = FileNamingElements[idx];
          if (fnel) {
            fileNaming.push(fnel.name);

          } else {
            // its a custom naming option
            var txt = menu.selection.text;
            if (txt.match(/^\-+$/)) {
              txt = txt.substr(1);
            }
            fileNaming.push(txt);
          }
        }
      }
    }

    var prefix = pnl.prefix;
    var opts = new FileNamingOptions(ini, prefix);
    opts.fileNaming = fileNaming;

    if (pnl.startingSerial) {
      opts.startingSerial = Number(pnl.startingSerial.text);
    }
    if (pnl.compatWindows) {
      opts.windowsCompatible = pnl.compatWindows.value;
    }
    if (pnl.compatMac) {
      opts.macintoshCompatible = pnl.compatMac.value;
    }
    if (pnl.compatUnix) {
      opts.unixCompatible = pnl.compatUnix.value;
    }
    return opts;
  }
  pnl.getFilenamingOptions = pnl.getFileNamingOptions;

  // XXX-CS4 Need to test
  if (isCS3() || isCS4()) {
    pnl.menus[0].onChange();
  }

  return pnl;
};
GenericUI.createCustomTextDialog = function(win, title, mode, init) {
  var rect = {
    x: 200, 
    y: 200,
    w: 350,
    h: 150
  };

  function rectToBounds(r) {
    return[r.x, r.y, r.x+r.w, r.y+r.h];
  };

  var cwin = new Window('dialog', title || 'Custom Text Editor',
                        rectToBounds(rect));

  cwin.text = title || 'Custom Text Editor';
  if (win) {
    cwin.center(win);
  }

  var xofs = 10;
  var y = 10;
  var x = xofs;

  var tOfs = GenericUI.getTextOfs();

  cwin.add('statictext', [x,y+tOfs,x+300,y+22+tOfs],
           "Please enter the desired Custom Text: ");
  y += 30;
  cwin.customText = cwin.add('edittext', [x,y,x+330,y+22]);

  cwin.customText.onChanging = function() {
    cwin = this.parent;
    var text = cwin.customText.text;

    if (cwin.initText) {
      cwin.saveBtn.enabled = (text.length > 0) && (text != cwin.initText);
    } else {
      cwin.saveBtn.enabled = (text.length > 0);
    }
  }

  if (init) {
    cwin.customText.text = init;
    cwin.initText = init;
  }

  y += 50;
  x += 100;
  cwin.saveBtn = cwin.add('button', [x,y,x+40,y+22], "Save");
  cwin.saveBtn.enabled = false;

  x += 100;
  cwin.cancelBtn = cwin.add('button', [x,y,x+40,y+22], "Cancel");

  cwin.defaultElement = cwin.saveBtn;

  var res = cwin.show();
  return (res == 1) ? cwin.customText.text : undefined;
};

GenericUI.prototype.validateFileNamingPanel = function(pnl, opts) {
  var self = this;
  var win = GenericUI.getWindow(pnl);
  var fopts = pnl.getFileNamingOptions(opts);

  if (fopts.fileNaming.length == 0) {
    return self.errorPrompt("You must specify a name for the files.");
  }

  fopts.copyTo(opts, pnl.prefix);

  return opts;
};
 }
//============================ File Save =====================================
//
// FileSave is only available in Photoshop
//
FileSaveOptions = function(obj) {
  var self = this;

  self.saveDocumentType = undefined; // SaveDocumentType
  self.fileType = "jpg";             // file extension

  self._saveOpts = undefined;

  self.bmpAlphaChannels = true;
  self.bmpDepth = BMPDepthType.TWENTYFOUR;
  self.bmpRLECompression = false;

  self.gifTransparency = true;
  self.gifInterlaced = false;

  self.jpgQuality = 10;
  self.jpgEmbedColorProfile = true;
  self.jpgFormat = FormatOptions.STANDARDBASELINE;
  self.jpgConvertToSRGB = false;          // requires code

  self.epsEncoding = SaveEncoding.BINARY;
  self.epsEmbedColorProfile = true;

  self.pdfEncoding = PDFEncoding.JPEG;

  self.psdAlphaChannels = true;
  self.psdEmbedColorProfile = true;
  self.psdLayers = true;
  self.psdMaximizeCompatibility = true;           // requires code for prefs

  self.pngInterlaced = false;

  self.tgaAlphaChannels = true;
  self.tgaRLECompression = true;

  self.tiffEncoding = TIFFEncoding.NONE;
  self.tiffByteOrder = (isWindows() ? ByteOrder.IBM : ByteOrder.MACOS);
  self.tiffEmbedColorProfile = true;

  if (obj) {
    for (var idx in self) {
      if (idx in obj) {       // only copy in FSO settings
        self[idx] = obj[idx];
      }
    }
    if (!obj.fileType) {
      self.fileType = obj.fileSaveType;
    }
  }
};
//FileSaveOptions.prototype.typename = "FileSaveOptions";
FileSaveOptions._enableDNG = false;

FileSaveOptions.convert = function(fsOpts) {
  var fsType = fsOpts.fileType;
  if (!fsType) {
    fsType = fsOpts.fileSaveType;
  }
  var fs = FileSaveOptionsTypes[fsType];
  if (fs == undefined) {
    return undefined;
  }
  if (!fs.optionsType) {
    return undefined;
  }
  var saveOpts = new fs.optionsType();

  switch (fsType) {
    case "bmp": {
      saveOpts.rleCompression = toBoolean(fsOpts.bmpRLECompression);

      var value = BMPDepthType.TWENTYFOUR;
      var str = fsOpts.bmpDepth.toString();
      if (str.match(/1[^6]|one/i)) {
        value = BMPDepthType.ONE;
      } else if (str.match(/24|twentyfour/i)) {
        // we have to match 24 before 4
        value = BMPDepthType.TWENTYFOUR;
      } else if (str.match(/4|four/i)) {
        value = BMPDepthType.FOUR;
      } else if (str.match(/8|eight/i)) {
        value = BMPDepthType.EIGHT;
      } else if (str.match(/16|sixteen/i)) {
        value = BMPDepthType.SIXTEEN;
      } else if (str.match(/32|thirtytwo/i)) {
        value = BMPDepthType.THIRTYTWO;
      }
      saveOpts.depth = value;
      saveOpts.alphaChannels = toBoolean(fsOpts.bmpAlphaChannels);

      saveOpts._flatten = true;
      saveOpts._8Bit = true; //XXX Should this be true?
      break;
    }
    case "gif": {
      saveOpts.transparency = toBoolean(fsOpts.gifTransparency);
      saveOpts.interlaced = toBoolean(fsOpts.gifInterlaced);
      
      saveOpts._convertToIndexed = true;
      saveOpts._flatten = true;
      saveOpts._8Bit = true;
      break;
    }
    case "jpg": {
      saveOpts.quality = toNumber(fsOpts.jpgQuality);
      saveOpts.embedColorProfile = toBoolean(fsOpts.jpgEmbedColorProfile);
      var value = FormatOptions.STANDARDBASELINE;
      var str = fsOpts.jpgFormat.toString();
      if (str.match(/standard/i)) {
        value = FormatOptions.STANDARDBASELINE;
      } else if (str.match(/progressive/i)) {
        value = FormatOptions.PROGRESSIVE;
      } else if (str.match(/optimized/i)) {
        value = FormatOptions.OPTIMIZEDBASELINE;
      }
      saveOpts.formatOptions = value;

      saveOpts._convertToSRGB = toBoolean(fsOpts.jpgConvertToSRGB);
      saveOpts._flatten = true;
      saveOpts._8Bit = true;
      break;
    }
    case "psd": {
      saveOpts.alphaChannels = toBoolean(fsOpts.psdAlphaChannels);
      saveOpts.embedColorProfile = toBoolean(fsOpts.psdEmbedColorProfile);
      saveOpts.layers = toBoolean(fsOpts.psdLayers);
      saveOpts.maximizeCompatibility =
        toBoolean(fsOpts.psdMaximizeCompatibility);
      break;
    }
    case "eps": {
      var value = SaveEncoding.BINARY;
      var str = fsOpts.epsEncoding.toString();
      if (str.match(/ascii/i)) {
        value = SaveEncoding.ASCII;
      } else if (str.match(/binary/i)) {
        value = SaveEncoding.BINARY;
      } else if (str.match(/jpg|jpeg/i)) {
        if (str.match(/high/i)) {
          value = SaveEncoding.JPEGHIGH;
        } else if (str.match(/low/i)) {
          value = SaveEncoding.JPEGLOW;
        } else if (str.match(/max/i)) {
          value = SaveEncoding.JPEGMAXIMUM;
        } else if (str.match(/med/i)) {
          value = SaveEncoding.JPEGMEDIUM;
        }
      }
      saveOpts.encoding = value;
      saveOpts.embedColorProfile = toBoolean(fsOpts.epsEmbedColorProfile);

      saveOpts._flatten = true;
      break;
    }
    case "pdf": {
      break;
    }
    case "png": {
      saveOpts.interlaced = toBoolean(fsOpts.pngInterlaced);

      saveOpts._flatten = true;
      break;
    }
    case "tga": {
      saveOpts.alphaChannels = toBoolean(fsOpts.tgaAlphaChannels);
      saveOpts.rleCompression = toBoolean(fsOpts.tgaRLECompression);

      saveOpts._flatten = true;
      break;
    }
    case "tiff": {
      var value = (isWindows() ? ByteOrder.IBM : ByteOrder.MACOS);
      var str = fsOpts.tiffByteOrder.toString();
      if (str.match(/ibm|pc/i)) {
        value = ByteOrder.IBM;
      } else if (str.match(/mac/i)) {
        value = ByteOrder.MACOS;
      }
      saveOpts.byteOrder = value;

      var value = TIFFEncoding.NONE;
      var str = fsOpts.tiffEncoding.toString();
      if (str.match(/none/i)) {
        value = TIFFEncoding.NONE;
      } else if (str.match(/lzw/i)) {
        value = TIFFEncoding.TIFFLZW;
      } else if (str.match(/zip/i)) {
        value = TIFFEncoding.TIFFZIP;
      } else if (str.match(/jpg|jpeg/i)) {
        value = TIFFEncoding.JPEG;
      }
      saveOpts.imageCompression = value;

      saveOpts.embedColorProfile = toBoolean(fsOpts.tiffEmbedColorProfile);
      break;
    }
    case "dng": {
    }
    default:
      Error.runtimeError(9001, "Internal Error: Unknown file type: " + fs.fileType);
  }

  return saveOpts;
};

FileSaveOptionsType = function(fileType, menu, saveType, optionsType) {
  var self = this;

  self.fileType = fileType;    // the file extension
  self.menu = menu;
  self.saveType = saveType;
  self.optionsType = optionsType;
};
FileSaveOptionsType.prototype.typename = "FileSaveOptionsType";

FileSaveOptionsTypes = [];
FileSaveOptionsTypes._add = function(fileType, menu, saveType, optionsType) {
  var fsot = new FileSaveOptionsType(fileType, menu, saveType, optionsType);
  FileSaveOptionsTypes.push(fsot);
  FileSaveOptionsTypes[fileType] = fsot;
};
FileSaveOptionsTypes._init = function() {
  if (!isPhotoshop()) {
    return;
  }
  FileSaveOptionsTypes._add("bmp", "Bitmap (BMP)", SaveDocumentType.BMP,
                            BMPSaveOptions);
  FileSaveOptionsTypes._add("gif", "GIF", SaveDocumentType.COMPUSERVEGIF,
                            GIFSaveOptions);
  FileSaveOptionsTypes._add("jpg", "JPEG", SaveDocumentType.JPEG,
                            JPEGSaveOptions);
  FileSaveOptionsTypes._add("psd", "Photoshop PSD", SaveDocumentType.PHOTOSHOP,
                            PhotoshopSaveOptions);
  FileSaveOptionsTypes._add("eps", "Photoshop EPS",
                            SaveDocumentType.PHOTOSHOPEPS, EPSSaveOptions);
  FileSaveOptionsTypes._add("pdf", "Photoshop PDF",
                            SaveDocumentType.PHOTOSHOPPDF, PDFSaveOptions);
  FileSaveOptionsTypes._add("png", "PNG", SaveDocumentType.PNG,
                            PNGSaveOptions);
  FileSaveOptionsTypes._add("tga", "Targa", SaveDocumentType.TARGA,
                            TargaSaveOptions);
  FileSaveOptionsTypes._add("tiff", "TIFF", SaveDocumentType.TIFF,
                            TiffSaveOptions);

  if (FileSaveOptions._enableDNG) {
    FileSaveOptionsTypes._add("dng", "DNG", undefined, undefined);
  }
};
FileSaveOptionsTypes._init();

// XXX remove file types _before_ creating a FS panel!
FileSaveOptionsTypes.remove = function(ext) {
  var ar = FileSaveOptionsTypes;
  var fsot = ar[ext];
  if (fsot) {
    for (var i = 0; i < ar.length; i++) {
      if (ar[i] == fsot) {
        ar.splice(i, 1);
        break;
      }
    }
    delete ar[ext];
  }
};

GenericUI.prototype.createFileSavePanel = function(pnl, ini) {
  var win = GenericUI.getWindow(pnl);
  pnl.mgr = this;

  var menuElements = [];

  for (var i = 0; i < FileSaveOptionsTypes.length; i++) {
    menuElements.push(FileSaveOptionsTypes[i].menu);
  }

  var w = pnl.bounds[2] - pnl.bounds[0];
  var xofs = 0;
  var y = 0;

  var opts = new FileSaveOptions(ini);

  if (pnl.type == 'panel') {
    xofs += 5;
    y += 10;
  }
  pnl.text = "Save Options";

  var tOfs = GenericUI.getTextOfs();

  var x = xofs;
  pnl.add('statictext', [x,y+tOfs,x+55,y+22+tOfs], 'File Type:');
  x += 150;
  pnl.fileType = pnl.add('dropdownlist', [x,y,x+135,y+22], menuElements);

  var ftype = opts.fileType || "jpg";

  var ft = Stdlib.getByProperty(FileSaveOptionsTypes,
                                "fileType",
                                ftype);
  pnl.fileType.selection = pnl.fileType.find(ft.menu);

  y += 30;
  var yofs = y;

  x = xofs;

  //=============================== Bitmap ===============================
  if (FileSaveOptionsTypes["bmp"]) {
    pnl.bmpAlphaChannels = pnl.add('checkbox', [x,y,x+125,y+22],
                                   "Alpha Channels");

    x += 150;
    var bmpDepthMenu = ["1", "4", "8", "16", "24", "32"];
    pnl.bmpDepthLabel = pnl.add('statictext', [x,y+tOfs,x+60,y+22+tOfs],
                                'Bit Depth:');
    x += 65;
    pnl.bmpDepth = pnl.add('dropdownlist', [x,y,x+55,y+22], bmpDepthMenu);
    pnl.bmpDepth.selection = pnl.bmpDepth.find("24");

    pnl.bmpDepth.find("1")._value = BMPDepthType.ONE;
    pnl.bmpDepth.find("4")._value = BMPDepthType.FOUR;
    pnl.bmpDepth.find("8")._value = BMPDepthType.EIGHT;
    pnl.bmpDepth.find("16")._value = BMPDepthType.SIXTEEN;
    pnl.bmpDepth.find("24")._value = BMPDepthType.TWENTYFOUR;
    pnl.bmpDepth.find("32")._value = BMPDepthType.THIRTYTWO;

    x = xofs;
    y += 30;
    pnl.bmpRLECompression = pnl.add('checkbox', [x,y,x+145,y+22],
                                    "RLE Compression");

    pnl.bmp = ["bmpAlphaChannels", "bmpDepthLabel", "bmpDepth",
               "bmpRLECompression"];

    pnl.bmpAlphaChannels.value = toBoolean(opts.bmpAlphaChannels);
    var it = pnl.bmpDepth.find(opts.bmpDepth.toString());
    if (it) {
      pnl.bmpDepth.selection = it;
    }
    pnl.bmpRLECompression.value = toBoolean(opts.bmpRLECompression);

    y = yofs;
    x = xofs;
  }


  //=============================== GIF ===============================
  if (FileSaveOptionsTypes["gif"]) {
    pnl.gifTransparency = pnl.add('checkbox', [x,y,x+125,y+22],
                                  "Transparency");
  
    x += 125;
    pnl.gifInterlaced = pnl.add('checkbox', [x,y,x+125,y+22],
                                "Interlaced");

    pnl.gif = ["gifTransparency", "gifInterlaced"];

    pnl.gifTransparency.value = toBoolean(opts.gifTransparency);
    pnl.gifInterlaced.value = toBoolean(opts.gifInterlaced);

    y = yofs;
    x = xofs;
  }


  //=============================== JPG ===============================
  if (FileSaveOptionsTypes["jpg"]) {
    pnl.jpgQualityLabel = pnl.add('statictext', [x,y+tOfs,x+55,y+22+tOfs],
                                  'Quality:');
    x += 60;
    var jpqQualityMenu = ["1","2","3","4","5","6","7","8","9","10","11","12"];
    pnl.jpgQuality = pnl.add('dropdownlist', [x,y,x+55,y+22], jpqQualityMenu);
    pnl.jpgQuality.selection = pnl.jpgQuality.find("10");

    y += 30;
    x = xofs;
    pnl.jpgEmbedColorProfile = pnl.add('checkbox', [x,y,x+145,y+22],
                                       "Embed Color Profile");

    y = yofs;
    x += 150;

    var jpgFormatMenu = ["Standard", "Progressive", "Optimized"];
    pnl.jpgFormatLabel = pnl.add('statictext', [x,y+tOfs,x+50,y+22+tOfs],
                                 'Format:');
    x += 55;
    pnl.jpgFormat = pnl.add('dropdownlist', [x,y,x+110,y+22], jpgFormatMenu);
    pnl.jpgFormat.selection = pnl.jpgFormat.find("Standard");

    pnl.jpgFormat.find("Standard")._value = FormatOptions.STANDARDBASELINE;
    pnl.jpgFormat.find("Progressive")._value = FormatOptions.PROGRESSIVE;
    pnl.jpgFormat.find("Optimized")._value = FormatOptions.OPTIMIZEDBASELINE;

    y += 30;
    x = xofs + 150;
    pnl.jpgConvertToSRGB = pnl.add('checkbox', [x,y,x+145,y+22],
                                   "Convert to sRGB");

    pnl.jpg = ["jpgQualityLabel", "jpgQuality", "jpgEmbedColorProfile",
               "jpgFormatLabel", "jpgFormat", "jpgConvertToSRGB" ];

    var it = pnl.jpgQuality.find(opts.jpgQuality.toString());
    if (it) {
      pnl.jpgQuality.selection = it;
    }
    pnl.jpgEmbedColorProfile.value = toBoolean(opts.jpgEmbedColorProfile);
    var it = pnl.jpgFormat.find(opts.jpgFormat);
    if (it) {
      pnl.jpgFormat.selection = it;
    }
    pnl.jpgConvertToSRGB.value = toBoolean(opts.jpgConvertToSRGB);

    x = xofs;
    y = yofs;
  }


  //=============================== PSD ===============================
  if (FileSaveOptionsTypes["psd"]) {
    pnl.psdAlphaChannels = pnl.add('checkbox', [x,y,x+125,y+22],
                                   "Alpha Channels");

    y += 30;
    pnl.psdEmbedColorProfile = pnl.add('checkbox', [x,y,x+145,y+22],
                                       "Embed Color Profile");

    y = yofs;
    x = xofs + 150;

    pnl.psdLayers = pnl.add('checkbox', [x,y,x+125,y+22],
                          "Layers");
    
    y += 30;
    pnl.psdMaximizeCompatibility = pnl.add('checkbox', [x,y,x+170,y+22],
                                           "Maximize Compatibility");

    pnl.psd = ["psdAlphaChannels", "psdEmbedColorProfile",
               "psdLayers", "psdMaximizeCompatibility"];

    pnl.psdAlphaChannels.value = toBoolean(opts.psdAlphaChannels);
    pnl.psdEmbedColorProfile.value = toBoolean(opts.psdEmbedColorProfile);
    pnl.psdLayers.value = toBoolean(opts.psdLayers);
    pnl.psdMaximizeCompatibility.value =
       toBoolean(opts.psdMaximizeCompatibility);

    x = xofs;
    y = yofs;
  }

  //=============================== EPS ===============================
  if (FileSaveOptionsTypes["eps"]) {
    var epsEncodingMenu = ["ASCII", "Binary", "JPEG High", "JPEG Med",
                           "JPEG Low", "JPEG Max"];
    pnl.epsEncodingLabel = pnl.add('statictext', [x,y+tOfs,x+60,y+22+tOfs],
                                 'Encoding:');
    x += 65;
    pnl.epsEncoding = pnl.add('dropdownlist',
                              [x,y,x+100,y+22],
                              epsEncodingMenu);
    pnl.epsEncoding.selection = pnl.epsEncoding.find("Binary");

    pnl.epsEncoding.find("ASCII")._value = SaveEncoding.ASCII;
    pnl.epsEncoding.find("Binary")._value = SaveEncoding.BINARY;
    pnl.epsEncoding.find("JPEG High")._value = SaveEncoding.JPEGHIGH;
    pnl.epsEncoding.find("JPEG Low")._value = SaveEncoding.JPEGLOW;
    pnl.epsEncoding.find("JPEG Max")._value = SaveEncoding.JPEGMAXIMUM;
    pnl.epsEncoding.find("JPEG Med")._value = SaveEncoding.JPEGMEDIUM;

    x = xofs;
    y += 30;
    pnl.epsEmbedColorProfile = pnl.add('checkbox', [x,y,x+145,y+22],
                                       "Embed Color Profile");

    pnl.eps = ["epsEncodingLabel", "epsEncoding", "epsEmbedColorProfile"];

    var it = pnl.epsEncoding.find(opts.epsEncoding);
    if (it) {
      pnl.epsEncoding.selection = it;
    }
    pnl.epsEmbedColorProfile.value = toBoolean(opts.epsEmbedColorProfile);

    x = xofs;
    y = yofs;
  }


  //=============================== PDF ===============================
  if (FileSaveOptionsTypes["pdf"]) {
    pnl.pdf = [];

    x = xofs;
    y = yofs;
  }


  //=============================== PNG ===============================
  if (FileSaveOptionsTypes["png"]) {
    pnl.pngInterlaced = pnl.add('checkbox', [x,y,x+125,y+22],
                                "Interlaced");

    pnl.png = ["pngInterlaced"];

    pnl.pngInterlaced.value = toBoolean(opts.pngInterlaced);

    x = xofs;
    y = yofs;
  }


  //=============================== TGA ===============================
  if (FileSaveOptionsTypes["tga"]) {
    pnl.tgaAlphaChannels = pnl.add('checkbox', [x,y,x+125,y+22],
                                   "Alpha Channels");

    y += 30;

    pnl.tgaRLECompression = pnl.add('checkbox', [x,y,x+145,y+22],
                                    "RLE Compression");

    pnl.tga = ["tgaAlphaChannels", "tgaRLECompression"];
    
    pnl.tgaAlphaChannels.value = toBoolean(opts.tgaAlphaChannels);
    pnl.tgaRLECompression.value = toBoolean(opts.tgaRLECompression);

    x = xofs;
    y = yofs;
  }


  //=============================== TIFF ===============================
  if (FileSaveOptionsTypes["tiff"]) {
    var tiffEncodingMenu = ["None", "LZW", "ZIP", "JPEG"];
    pnl.tiffEncodingLabel = pnl.add('statictext', [x,y+tOfs,x+60,y+22+tOfs],
                                    'Encoding:');
    x += 65;
    pnl.tiffEncoding = pnl.add('dropdownlist', [x,y,x+75,y+22],
                               tiffEncodingMenu);
    pnl.tiffEncoding.selection = pnl.tiffEncoding.find("None");

    pnl.tiffEncoding.find("None")._value = TIFFEncoding.NONE;
    pnl.tiffEncoding.find("LZW")._value = TIFFEncoding.TIFFLZW;
    pnl.tiffEncoding.find("ZIP")._value = TIFFEncoding.TIFFZIP;
    pnl.tiffEncoding.find("JPEG")._value = TIFFEncoding.JPEG;

    x += 90;

    var tiffByteOrderMenu = ["IBM", "MacOS"];
    pnl.tiffByteOrderLabel = pnl.add('statictext', [x,y+tOfs,x+65,y+22+tOfs],
                                     'ByteOrder:');
    x += 70;
    pnl.tiffByteOrder = pnl.add('dropdownlist', [x,y,x+85,y+22],
                                tiffByteOrderMenu);
    var bo = (isWindows() ? "IBM" : "MacOS");
    pnl.tiffByteOrder.selection = pnl.tiffByteOrder.find(bo);
    
    pnl.tiffByteOrder.find("IBM")._value = ByteOrder.IBM;
    pnl.tiffByteOrder.find("MacOS")._value = ByteOrder.MACOS;

    x = xofs;
    y += 30;
    pnl.tiffEmbedColorProfile = pnl.add('checkbox', [x,y,x+175,y+22],
                                        "Embed Color Profile");

    pnl.tiff = ["tiffEncodingLabel", "tiffEncoding", "tiffByteOrderLabel",
                "tiffByteOrder", "tiffEmbedColorProfile"];

    pnl.dng = [];

    var it = pnl.tiffEncoding.find(opts.tiffEncoding);
    if (it) {
      pnl.tiffEncoding.selection = it;
    }
    var it = pnl.tiffByteOrder.find(opts.tiffByteOrder);
    if (it) {
      pnl.tiffByteOrder.selection = it;
    }
    pnl.tiffEmbedColorProfile.value = toBoolean(opts.tiffEmbedColorProfile);
  }

  pnl.fileType.onChange = function() {
    var pnl = this.parent;
    var ftsel = pnl.fileType.selection.index;
    var ft = FileSaveOptionsTypes[ftsel];

    for (var i = 0; i < FileSaveOptionsTypes.length; i++) {
      var fsType = FileSaveOptionsTypes[i];
      var parts = pnl[fsType.fileType];

      for (var j = 0; j < parts.length; j++) {
        var part = parts[j];
        pnl[part].visible = (fsType == ft);
      }
    }
    pnl._onChange();
  };

  pnl._onChange = function() {
    var self = this;
    if (self.onChange) {
      self.onChange();
    }
  }

  if (false) {
    y = yofs;
    x = 300;
    var btn = pnl.add('button', [x,y,x+50,y+22], "Test");
    btn.onClick = function() {
      try {
        var pnl = this.parent;
        var mgr = pnl.mgr;
        
        var opts = {}
        mgr.validateFileSavePanel(pnl, opts);
        alert(listProps(opts));
        alert(listProps(FileSaveOptions.convert(opts)));

      } catch (e) {
        var msg = Stdlib.exceptionMessage(e);
        Stdlib.log(msg);
        alert(msg);
      }
    }
  }

  // XXX-CS4 Need to test
  if (isCS3() || isCS4()) {
    pnl.fileType.onChange();
  }

  pnl.getFileSaveType = function() {
    var pnl = this;
    var fstype = '';
    if (pnl.fileType.selection) {
      var fsSel = pnl.fileType.selection.index;
      var fs = FileSaveOptionsTypes[fsSel];
      fstype = fs.fileType;
    }
  }

  return pnl;
};
GenericUI.prototype.validateFileSavePanel = function(pnl, opts) {
  var win = GenericUI.getWindow(pnl);

  // XXX This function needs to remove any prior file save
  // options and only set the ones needed for the
  // selected file type

  var fsOpts = new FileSaveOptions();
  for (var idx in fsOpts) {
    if (idx in opts) {
      delete opts[idx];
    }
  }

  var fsSel = pnl.fileType.selection.index;
  var fs = FileSaveOptionsTypes[fsSel];

  opts.fileSaveType = fs.fileType;
  opts._saveDocumentType = fs.saveType;

  if (!fs.optionsType) {
    opts._saveOpts = undefined;
    return;
  }

  var saveOpts = new fs.optionsType();

  switch (fs.fileType) {
    case "bmp": {
      saveOpts.rleCompression = pnl.bmpRLECompression.value;
      saveOpts.depth = pnl.bmpDepth.selection._value;
      saveOpts.alphaChannels = pnl.bmpAlphaChannels.value;

      opts.bmpRLECompression = pnl.bmpRLECompression.value;
      opts.bmpDepth = Number(pnl.bmpDepth.selection.text);
      opts.bmpAlphaChannels = pnl.bmpAlphaChannels.value;
      break;
    }
    case "gif": {
      saveOpts.transparency = pnl.gifTransparency.value;
      saveOpts.interlaced = pnl.gifInterlaced.value;

      opts.gifTransparency = pnl.gifTransparency.value;
      opts.gifInterlaced = pnl.gifInterlaced.value;
      break;
    }
    case "jpg": {
      saveOpts.quality = Number(pnl.jpgQuality.selection.text);
      saveOpts.embedColorProfile = pnl.jpgEmbedColorProfile.value;
      saveOpts.formatOptions = pnl.jpgFormat.selection._value;
      saveOpts._convertToSRGB = pnl.jpgConvertToSRGB.value;

      opts.jpgQuality = Number(pnl.jpgQuality.selection.text);
      opts.jpgEmbedColorProfile = pnl.jpgEmbedColorProfile.value;
      opts.jpgFormat = pnl.jpgFormat.selection.text;
      opts.jpgConvertToSRGB = pnl.jpgConvertToSRGB.value;
      break;
    }
    case "psd": {
      saveOpts.alphaChannels = pnl.psdAlphaChannels.value;
      saveOpts.embedColorProfile = pnl.psdEmbedColorProfile.value;
      saveOpts.layers = pnl.psdLayers.value;
      saveOpts.maximizeCompatibility = pnl.psdMaximizeCompatibility.value;

      opts.psdAlphaChannels = pnl.psdAlphaChannels.value;
      opts.psdEmbedColorProfile = pnl.psdEmbedColorProfile.value;
      opts.psdLayers = pnl.psdLayers.value;
      opts.psdMaximizeCompatibility = pnl.psdMaximizeCompatibility.value;
      break;
    }
    case "eps": {
      saveOpts.encoding = pnl.epsEncoding.selection._value;
      saveOpts.embedColorProfile = pnl.epsEmbedColorProfile.value;

      opts.epsEncoding = pnl.epsEncoding.selection.text;
      opts.epsEmbedColorProfile = pnl.epsEmbedColorProfile.value;
      break;
    }
    case "pdf": {
      break;
    }
    case "png": {
      saveOpts.interlaced = pnl.pngInterlaced.value;

      opts.pngInterlaced = pnl.pngInterlaced.value;
      break;
    }
    case "tga": {
      saveOpts.alphaChannels = pnl.tgaAlphaChannels.value;
      saveOpts.rleCompression = pnl.tgaRLECompression.value;

      opts.tgaAlphaChannels = pnl.tgaAlphaChannels.value;
      opts.tgaRLECompression = pnl.tgaRLECompression.value;
      break;
    }
    case "tiff": {
      saveOpts.byteOrder = pnl.tiffByteOrder.selection._value;
      saveOpts.imageCompression = pnl.tiffEncoding.selection._value;
      saveOpts.embedColorProfile = pnl.tiffEmbedColorProfile.value;

      opts.tiffByteOrder = pnl.tiffByteOrder.selection.text;
      opts.tiffEncoding = pnl.tiffEncoding.selection.text;
      opts.tiffEmbedColorProfile = pnl.tiffEmbedColorProfile.value;
      break;
    }
    default:
      Error.runtimeError(9001, "Internal Error: Unknown file type: " + fs.fileType);
  }

  opts._saveOpts = saveOpts;

  return;
};


//================================== exec ==================================
//
// exec runs the ui and the application callback
//   doc is the document to operate on (optional)
//   if noUI is true, the window is not open. The runtime parameters
//      are taken from the ini file.
//
GenericUI.prototype.runUI = function(ovOpts, doc) {
  var self = this;

  // read the ini file (if present)
  var ini = {};

  if (self.iniFile) {
    ini = self.readIniFile();
  }

  // copyFromTo
  if (ovOpts) {
    for (var idx in ovOpts) {
      var v = ovOpts[idx];
      if (typeof v != 'function') {
        ini[idx] = v;
      }
    }
  }

  var opts = undefined;
  var win = undefined;

  if (toBoolean(ini.noUI)) {
    // if we don't want a UI, just use the ini object
    opts = ini;

  } else {
    // create window
    win = self.createWindow(ini, doc);

    self.win = win;

    // run the window and return the parameters mapped from the window
    opts = self.run(win);
  }

  return opts;
};


GenericUI.prototype.exec = function(arg1, arg2) {
  var self = this;

  var ovOpts = undefined;
  var doc = undefined;

  // either or both a document and options may be specified or neither
  if (arg1 || arg2) {
    if (!arg1) {  // if only arg2 is set, swap the args
      arg1 = arg2;
      arg2 = undefined;
    }

    ovOpts = arg1; // assume that arg1 is the options

    var dbgLevel = $.level;
    $.level = 0;
    try {
      if (arg1.typename == "Document") {
        doc = arg1;
        ovOpts = arg2;
      } else if (arg2 && arg2.typename == "Document") {
        doc = arg2;
      }
    } catch (e) {
    }
    $.level = dbgLevel;
  }

  var opts = self.runUI(ovOpts, doc);

  return self.runProcess(opts, doc);
};

GenericUI.prototype.runProcess = function(opts, doc) {
  var self = this;
  var result = undefined;

  // if we got options back, we can do some processing
  if (opts) {
    if (self.saveIni) {
      self.writeIniFile(opts);
    }

    result = self.process(opts, doc);

  } else if (self.win && self.win.canceled) { // if not, we just cancel out...
    self.cancel(doc);  
  }

  return result;
};


//
// the run method 'show's the window. If it ran successfully, the options
// returned are written to an ini file (if one has been specified
//
GenericUI.prototype.run = function(win) {
  var self = this;
  var done = false;

  if (win.show) {
    while (!done) {
      if (self.center == true) {
        win.center(self.parentWin);
      }
      var x = win.show();

      self.winX = win.bounds.x;
      self.winY = win.bounds.y;

      if (x == 0 || x == 2) {  // the window was closed or canceled
        win.canceled = true;   // treat it like a 'cancel'
        done = true;
      } else if (x == 1) {
        done = true;
      } else if (x == 4) {     // reset window
        win = self.createWindow(win.ini, win.doc);
      }
      self.runCode = x;
    }
  }

  return win.opts;
};
GenericUI.prototype._checkIniArgs = function(arg1, arg2, xmlMode) {
  var self = this;
  var obj = {
    file: undefined,
    opts: undefined,
    xml: (xmlMode == undefined) ? self.xmlEnabled : xmlMode
  };

  if (arg1) {
    if (!obj.file && ((arg1 instanceof File) ||
                      (arg1.constructor == String))) {
      obj.file = GenericUI.iniFileToFile(arg1);

    } else {
      obj.opts = arg1;
    }
  }

  if (arg2) {
    if (!obj.file && ((arg2 instanceof File) ||
                      (arg2.constructor == String))) {
      obj.file = GenericUI.iniFileToFile(arg2);

    } else if (!obj.opts) {
      obj.opts = arg2;
    }
  }

  return obj;
};
GenericUI.prototype.updateIniFile = function(arg1, arg2, xmlMode) {
  var self = this;
  var args = self._checkIniArgs(arg1, arg2, xmlMode);
  var file = args.file || self.iniFile;
  var opts = args.opts;
  var xml = args.xml;

  if (!file) {
    Error.runtimeError(9001, "Internal Error: No valid settings file specified for update");
  }

  GenericUI.updateIni(file, opts, xml);
};
GenericUI.prototype.writeIniFile = function(arg1, arg2, xmlMode) {
  var self = this;
  var args = self._checkIniArgs(arg1, arg2, xmlMode);
  var file = args.file || self.iniFile;
  var opts = args.opts;
  var xml = args.xml;

  if (!file) {
    Error.runtimeError(9001, "Internal Error: No valid settings file specified for write");
  }
  GenericUI.writeIni(file, opts, xml);
};
GenericUI.prototype.readIniFile = function(arg1, arg2, xmlMode) {
  var self = this;
  var args = self._checkIniArgs(arg1, arg2, xmlMode);
  var file = args.file || self.iniFile;
  var opts = args.opts;
  var xml = args.xml;

  if (!file) {
    Error.runtimeError(9001, "Internal Error: No valid settings file specified for read");
  }
  return GenericUI.readIni(file, opts, xml);
};

//
// errorPrompt is used in window/panel validation. It pops up a 'confirm'
// with the prompt 'str'. If the user selects 'Yes', the 'confirm' is closed
// and the user is returned to the window for further interaction. If the user
// selects 'No', the 'confirm' is closed, the window is closed, and the script
// terminates.
//
GenericUI.prototype.errorPrompt = function(str) {
  return GenericUI.errorPrompt(str);
};
GenericUI.errorPrompt = function(str) {
  return confirm(str + "\r\rDo you wish to continue?", false,
                 "Input Validation Error");
};

//
// 'validate' is called by the win.process.onClick method to validate the
// contents of the window. To validate the window, we call the application
// defined 'validatePanel' method. 'validate' returns 'true', 'false', or
// an options object with the values collected from the application panel.
// If 'true' is returned, this means that there was a problem with validation
// but the user wants to continue. If 'false' is returned, there was a problem
// with validation and the user wants to stop. If an object is returned, the
// window is closed and processing continues based on the options values
//
GenericUI.validate = function() {
  var win = this;
  var mgr = win.mgr;

  mgr.winX = win.bounds.x;
  mgr.winY = win.bounds.y;

  try {
    var res = mgr.validatePanel(win.appPnl, win.ini);

    if (typeof(res) == 'boolean') {
      return res;
    }
    win.opts = res;
    win.close(1);
    return true;

  } catch (e) {
    var msg = Stdlib.exceptionMessage(e);
    Stdlib.log(msg);
    alert(msg);
    return false;
  }
};

//
// Convert a fptr to a valid ini File object.
// If the arg is already a File, make sure it has a valid path
// If the arg is a string and
//    begins with / or ~ or contains a :, then it is a complete path
//       so return it as a File object
//
//
GenericUI.iniFileToFile = function(iniFile) {
  if (!iniFile) {
    return undefined;
  }

  if (iniFile instanceof File) {
    if (!iniFile.parent.exists) {
      Stdlib.createFolder(iniFile.parent);
    }
    return iniFile;
  }

  if (iniFile.constructor == String) {
    var c = iniFile.charAt(0);

    // This is not a partial/relative path
    if (c == '/' || c == '~' || iniFile.charAt(1) == ':') {
      iniFile = new File(iniFile);

    } else {
      var prefs = GenericUI.preferencesFolder;

      // if the path starts with 'xtools/' strip it off
      var sub = "xtools/";
      if (iniFile.startsWith(sub)) {
        iniFile = iniFile.substr(sub.length);
      }

      // and place the ini file in the prefs folder
      iniFile = new File(prefs + '/' + iniFile);
    }

    // make sure any intermediate paths have been created
    if (!iniFile.parent.exists) {
      Stdlib.createFolder(iniFile.parent);
    }

    return iniFile;
  }

  return undefined;
};

GenericUI.iniFromString = function(str, ini) {
  var lines = str.split(/\r|\n/);
  var rexp = new RegExp(/([^:]+):(.*)$/);

  if (!ini) {
    ini = {};
  }
    
  for (var i = 0; i < lines.length; i++) {
    var line = lines[i].trim();
    if (!line || line.charAt(0) == '#') {
      continue;
    }
    var ar = rexp.exec(line);
    if (!ar) {
      alert("Bad line in config: \"" + line + "\"");
      continue;
      //return undefined;
    }
    ini[ar[1].trim()] = ar[2].trim();
  }

  return ini;
};

//
// readIni
// writeIni
//   Methods for reading and writing ini files in this framework. This only
//   occurs if an ini file has been specified
//
//   These can be replaced with other storage mechanisms such as Rob Stucky's
//   ScriptStore class.
//
GenericUI.readIni = function(iniFile, ini) {
  //$.level = 1; debugger;

  if (!ini) {
    ini = {};
  }
  if (!iniFile) {
    return ini;
  }
  var file = GenericUI.iniFileToFile(iniFile);

  if (!file) {
    Error.runtimeError(9001, Error("Bad ini file specified: \"" + iniFile + "\"."));
  }

  if (!file.exists) {
    //
    // XXX Check for an ini path .ini file in the script's folder. 
    //
  }

  if (file.exists && file.open("r", "TEXT", "????")) {
    file.lineFeed = "unix";
    file.encoding = GenericUI.ENCODING;
    var str = file.read();
    ini = GenericUI.iniFromString(str, ini);
    file.close();
  }

  if (ini.noUI) {
    ini.noUI = toBoolean(ini.noUI);
  }

  return ini;
};
GenericUI.iniToString = function(ini) {
  var str = '';
  for (var idx in ini) {
    if (idx.charAt(0) == '_') {         // private stuff
      continue;
    }
    if (idx == 'typename') {
      continue;
    }
    if (idx == "noUI") {                // GenericUI property
      continue;
    }
    var val = ini[idx];
    
    if (val == undefined) {
      continue;
    }

    if (val.constructor == String ||
        val.constructor == Number ||
        val.constructor == Boolean ||
        typeof(val) == "object") {
      str += (idx + ": " + val.toString() + "\n");
    }
  }
  return str;
};
GenericUI.overwriteIni = function(iniFile, ini) {
  //$.level = 1; debugger;
  if (!ini || !iniFile) {
    return;
  }
  var file = GenericUI.iniFileToFile(iniFile);

  if (!file) {
    Error.runtimeError(9001, Error("Bad ini file specified: \"" + iniFile + "\"."));
  }
 
  if (file.open("w", "TEXT", "????")) {
    file.lineFeed = "unix";
    file.encoding = GenericUI.ENCODING;
    var str = GenericUI.iniToString(ini);
    file.write(str);
    file.close();
  }
  return ini;
};

GenericUI.iniToDescriptor = function(ini, desc) {
  if (!desc) {
    desc = new ActionDescriptor();
  }
  var str = GenericUI.iniToString(ini);
  desc.putString(sTID("INI Data"), str);
  return desc;
};
GenericUI.iniFromDescriptor = function(desc) {
  var ini = {};
  if (!desc || desc.count == 0) {
    return ini;
  }
  if (desc.hasString(sTID("INI Data"))) {
    var str = desc.getString(sTID("INI Data"));
    ini = GenericUI.iniFromString(str);
  }
  return ini;
};

//
// Updating the ini file retains the ini file layout including any externally
// add comments, blank lines, and the property sequence
//
GenericUI.updateIni = function(iniFile, ini) {
  if (!ini || !iniFile) {
    return;
  }
  var file = GenericUI.iniFileToFile(iniFile);

  // we can only update the file if it exists
  var update = file.exists;
  var str = '';

  if (update) {
    file.open("r", "TEXT", "????");
    file.encoding = GenericUI.ENCODING;
    file.lineFeed = "unix";
    str = file.read();
    file.close();
    
    for (var idx in ini) {
      if (idx.charAt(0) == '_') {         // private stuff
        continue;
      }
      if (idx == "noUI") {
        continue;
      }
      if (idx == "typename") {
        continue;
      }

      var val = ini[idx];

      if (typeof(val) == "undefined") {
        val = '';
      }
      
      if (typeof val == "string" ||
          typeof val == "number" ||
          typeof val == "boolean" ||
          typeof val == "object") {
        idx += ':';
        var re = RegExp('^' + idx, 'm');

        if (re.test(str)) {
          re = RegExp('^' + idx + '[^\n]*', 'm');
          str = str.replace(re, idx + ' ' + val);
        } else {
          str += '\n' + idx + ' ' + val;
        }
      }
    }
  } else {
    // write out a new ini file
    for (var idx in ini) {
      if (idx.charAt(0) == '_') {         // private stuff
        continue;
      }
      if (idx == "noUI") {
        continue;
      }
      var val = ini[idx];
      
      if (typeof val == "string" ||
          typeof val == "number" ||
          typeof val == "boolean" ||
          typeof val == "object") {
        str += (idx + ": " + val.toString() + "\n");
      }
    }
  }

  if (str) {
    file.open("w", "TEXT", "????");
    file.encoding = GenericUI.ENCODING;
    file.lineFeed = "unix";
    file.write(str);
    file.close();
  }

  return ini;
};

GenericUI.writeIni = GenericUI.updateIni;

//XXX this widget stuff is untested
GenericUI._widgetMap = {
  button: 'text',
  checkbox: 'value',
  dropdownlist: 'selection',
  edittext: 'text',
  iconbutton: 'icon',
  image: 'icon',
  listbox: 'selection',
  panel: 'text',
  progressbar: 'value',
  radiobutton: 'value',
  scrollbar: 'value',
  slider:  'value',
  statictext: 'text',
};
//
// These next two need to be tweaked for dropdownlist and listbox
// I'm not sure quite yet what the best interface should be, so I'll
// pass for now.
//
GenericUI.getWidgetValue = function(w) {
  var prop = GenericUI._widgetMap[w.type];
  var t = w.type
  var v = undefined;
  if (prop) {
    if (t == 'listbox' || t == 'dropdownlist') {
      v = w.selection.text;
    } else {
      v = w[prop];
    }
  } 
  return prop ? w[prop] : undefined;
};
GenericUI.setWidgetValue = function(w, v) {
  var prop = GenericUI._widgetMap[w.type];
  if (prop) {
    var t = w.type;
    if (t == 'checkbox' || t == 'radiobox') {
      w[prop] = v.toString().toLowerCase() == 'true';
    } else if (t == 'progressbar' || t == 'scrollbar' || t == 'slider') {
      var n = Number(v);
      if (!isNaN(n)) {
        w[prop] = n;
      }
    } else if (t == 'listbox' || t == 'dropdownlist') {
      var it = w.find(v);
      if (it) {
        w.selection = it;
        it.selected = true;
      }
    } else {
      w[prop] = v;
    }
  }
  return v;
};

//
// createPanel returns a panel specific to this app
//    win is the window into which the panel to be inserted
//    ini is an object containing default values for the panel
//
GenericUI.prototype.createPanel = function(pnl, ini, doc) {};

//
// validatePanel returns 
//    - an object representing the gather input
//    - true if there was an error, but continue gathering input
//    - false if there was an error and terminate
//
GenericUI.prototype.validatePanel = function(pnl, ini) {};

//
// Called by the framework to do whatever processing the script is
// supposed to perform.
//
GenericUI.prototype.process = function(opts, doc) {};

//
// Called by the framework if the user 'canceled' the UI
//
GenericUI.prototype.cancel = function(doc) {};

GenericUI.numberKeystrokeFilter = function() {
  if (this.text.match(/[^\-\.\d]/)) {
    this.text = this.text.replace(/[^\-\.\d]/g, '');
  }
};
GenericUI.numericKeystrokeFilter = function() {
  if (this.text.match(/[^\d]/)) {
    this.text = this.text.replace(/[^\d]/g, '');
  }
};

GenericUI.unitValueKeystrokeFilter = function() {
  if (this.text.match(/[^a-z0-9% ]/)) {
    this.text = this.text.toLowerCase().replace(/[^a-z0-9% ]/g, '');
  }
};

//
// createProgressPalette
//   title     the window title
//   min       the minimum value for the progress bar
//   max       the maximum value for the progress bar
//   parent    the parent ScriptUI window (opt)
//   useCancel flag for having a Cancel button (opt)
//   
//   onCancel  This method will be called when the Cancel button is pressed.
//             This method should return 'true' to close the progress window
//
GenericUI.createProgressPalette = function(title, min, max,
                                           parent, useCancel) {
  var win = new Window('palette', title);
  win.bar = win.add('progressbar', undefined, min, max);
  win.bar.preferredSize = [300, 20];

  win.parentWin = undefined;
  win.recenter = false;
  win.isDone = false;

  if (parent) {
    if (parent instanceof Window) {
      win.parentWin = parent;
    } else if (useCancel == undefined) {
      useCancel = !!parent;
    }
  }

  if (useCancel) {
    win.onCancel = function() {
      this.isDone = true;
      return true;  // return 'true' to close the window
    }

    win.cancel = win.add('button', undefined, 'Cancel');

    win.cancel.onClick = function() {
      var win = this.parent;
      try {
        win.isDone = true;
        if (win.onCancel) {
          var rc = win.onCancel();
          if (rc != false) {
            win.close();
          }
        } else {
          win.close();
        }
      } catch (e) {
        var msg = Stdlib.exceptionMessage(e);
        Stdlib.log(msg);
        alert(msg);
      }
    }
  }

  win.onClose = function() {
    this.isDone = true;
  }

  win.updateProgress = function(val) {
    var win = this;

    if (val != undefined) {
      win.bar.value = val;
    }

    if (win.recenter) {
      win.center(win.parentWin);
    }

    win.show();
    win.hide();
    win.show();
  }

  win.recenter = true;
  win.center(win.parent);

  return win;
};


//
//=============================== GenericOptions ==============================
//
GenericOptions = function(obj) {
  if (obj) {
    GenericOptions.copyFromTo(obj, this);
  }
};

function toBoolean(s) {
  if (s == undefined) { return false; }
  if (s.constructor == Boolean) { return s.valueOf(); }
  if (s.constructor == String)  { return s.toLowerCase() == "true"; }
  return Boolean(s);
};

function toNumber(s, def) {
  if (s == undefined) { return NaN; }
  if (s.constructor == String && s.length == 0) { return NaN; }
  if (s.constructor == Number) { return s.valueOf(); }
  return Number(s.toString());
};

function toFont(fs) {
  if (fs.typename == "TextFont") { return fs.postScriptName; }

  var str = fs.toString();
  var f = Stdlib.determineFont(str);  // first, check by PS name

  return (f ? f.postScriptName : undefined);
};

GenericOptions.copyFromTo = function(from, to) {
  if (!from || !to) {
    return;
  }
  for (var idx in from) {
    var v = from[idx];
    if (typeof v != 'function') {
        to[idx] = v;
    }
  }
};

GenericOptions.prototype.hasKey = function(k) {
  return this[key] != undefined;
};
GenericOptions.prototype.getBoolean = function(k, def) {
  var self = this;
  return self.hasKey(k) ? toBoolean(self[k]) : def;
};
GenericOptions.prototype.getInteger = function(k, def) {
  var self = this;
  return self.hasKey(k) ? toNumber(self[k]).toFixed(0) : def;
};
GenericOptions.prototype.getDouble = function(k, def) {
  var self = this;
  return self.hasKey(k) ? toNumber(self[k]) : def;
};
GenericOptions.prototype.getPath = function(k, def) {
  var self = this;
  return self.hasKey(k) ? File(self[k]) : def;
};
GenericOptions.prototype.getArray = function(k, def) {
  var self = this;
  if (!self.hasKey(k)) {
    return def;
  }
  var s = self[k];
  return s.split(',');
};

GenericOptions.prototype.getColor = function(k, def) {
  var self = this;
  if (!self.hasKey(k)) {
    return def;
  }
  var c = self[k];
  if (!(c instanceof SolidColor)) {
    if (c.constructor == String) {
      c = s.split(',');
    }
    if (c instanceof Array) {
      var rgbc = new SolidColor();
      rgbc.rgb.red = c[0];
      rgbc.rgb.green = c[1];
      rgbc.rgb.blue = c[2];
      c = rgbc;      
    } else {
      c = undefined;
    }
  }
  return c;
};

GenericOptions.prototype.getObject = function(k, def) {
  var self = this;
  if (!self.hasKey(k)) {
    return def;
  }
  var os = self[k];
  var obj = undefined;
  try { eval('obj = ' + os); } finally {}
  return obj;
};

String.prototype.contains = function(sub) {
  return this.indexOf(sub) != -1;
};

String.prototype.containsWord = function(str) {
  return this.match(new RegExp("\\b" + str + "\\b")) != null;
};

String.prototype.endsWith = function(sub) {
  return this.length >= sub.length &&
    this.substr(this.length - sub.length) == sub;
};

String.prototype.reverse = function() {
  var ar = this.split('');
  ar.reverse();
  return ar.join('');
};

String.prototype.startsWith = function(sub) {
  return this.indexOf(sub) == 0;
};

String.prototype.trim = function() {
  return this.replace(/^[\s]+|[\s]+$/g, '');
};
String.prototype.ltrim = function() {
  return this.replace(/^[\s]+/g, '');
};
String.prototype.rtrim = function() {
  return this.replace(/[\s]+$/g, '');
};


// see SampleUI for an example of how to use this framework.

"GenericUI.jsx";

// EOF

//
// ColorChooser
//
// This script has undergone a lof of change. Larry's basic idea is still
// in there, but much of it has been reworked.
//
// This script is an extension of Larry Ligon's color picker script.
// Found at: http://www.ps-scripts.com/bb/viewtopic.php?t=659
//
// I have left as much of his code intact as is possible. I did fix
// one typo, added code to make the text entry fields functional,
// and set it up so that app.foreground is reset after the chooser is closed
//
// Description:
//   This class has one public function ('run') that will open an RGB
//   color selection dialog and return the selected color or 'undefined'
//   if the user canceled the operation.
//
// Usage:
//    var color = ColorChooser.run();
//
// $Id: ColorChooser.jsx,v 1.8 2008/08/27 04:38:10 anonymous Exp $
//
// Program Name:  Set the foreground color
//
// Author:        Larry B. Ligon
//
// Purpose:       This JavaScript will allow the user to change the foreground color
//

ColorChooser = function() {
};

ColorChooser.selectedColor = undefined;

ColorChooser.numericKeystrokeFilter = function() {
  if (this.text.match(/[^\d]/)) {
    this.text = this.text.replace(/[^\d]/g, '');
  }
};

ColorChooser.createDialog = function(defColor, winX, winY) {
  if (!winX) {
    winX = 100;
  }
  if (!winY) {
    winY= 100;
  }

  var winW = 400;
  var winH = 400;

  var bounds = { x : winX, y : winY, width : winW, height : winH };

  var win = new Window('dialog', 'Color Chooser' );

  if (!defColor) {
    defColor = app.foregroundColor;
  }

  win.orientation = 'column';

  win.updateColor = function() {
    var win = this;
    var clr = new SolidColor();
    clr.rgb.red   = Math.round(win.redPnl.cslider.value);
    clr.rgb.green = Math.round(win.greenPnl.cslider.value);
    clr.rgb.blue  = Math.round(win.bluePnl.cslider.value);
    win._color = clr;
    app.foregroundColor = clr;
  };

  function createChannelPanel(win, name) {
    var pnl = win.add("panel", undefined, name);
    pnl.updateColor = function() {
      var win = this.parent;
      win.updateColor();
    }
    pnl.alignChildren = "right";
    pnl.orientation = 'row';
    pnl.cslider = pnl.add('scrollbar', undefined,
                                255, 0, 255);
    pnl.cslider.csize = [100,20];
    pnl.cvalue = pnl.add('edittext');
    pnl.cvalue.preferRedSize = [40,25];

    pnl.cvalue.onChanging = ColorChooser.numericKeystrokeFilter;

    pnl.cvalue.onChange = function () {
      var pnl = this.parent;
      var cn = Number(pnl.cvalue.text);
      if (isNaN(cn)) {
        alert(pnl.name + " value is not a valid number");
      }
      if (cn > 255) {
        cn = 255;
        pnl.cvalue.text = 255;
      }
      if (cn < 0) {
        cn = 0;
        pnl.cvalue.text = 0;
      }
      pnl.cslider.value = cn;
      pnl.cslider.onChanging();
    };

    pnl.cvalue.text = Math.round(pnl.cslider.value);
    pnl.cslider.onChanging = function () {
      var pnl = this.parent;
      pnl.cvalue.text = Math.round(pnl.cslider.value);
      pnl.updateColor();
    };

    return pnl;
  }

  win.redPnl = createChannelPanel(win, "Red");
  win.greenPnl = createChannelPanel(win, "Green");
  win.bluePnl = createChannelPanel(win, "Blue");

  win.ok = win.add("button", undefined, "OK" );
  win.ok.onClick = function() {
    this.parent.close(1);
  };

  win.layout.layout(true);

  win.redPnl.cslider.value = defColor.rgb.red;
  win.redPnl.cslider.onChanging();
  win.greenPnl.cslider.value = defColor.rgb.green;
  win.greenPnl.cslider.onChanging();
  win.bluePnl.cslider.value = defColor.rgb.blue;
  win.bluePnl.cslider.onChanging();

  return win;
};

ColorChooser.runColorPicker = function(defColor) {
  var color = undefined;
  if (!defColor) {
    defColor = app.foregroundColor;
  }

  try {
    var bytes;
    var rgb = defColor.rgb;
    bytes = (rgb.red << 16) + (rgb.green << 8) + rgb.blue;
    bytes = $.colorPicker(bytes);
    
    if (bytes != -1) {
      var c = new SolidColor();
      c.rgb.red = (bytes >> 16);
      c.rgb.green = (bytes >> 8) & 0xFF;
      c.rgb.blue = bytes & 0xFF;
      color = c;
    }
  } catch (e) {
    alert(e);
  }

  return color;
};

ColorChooser.run = function(def) {
  // if (isCS3()) {
  if (app.version.match(/^10\./) || app.version.match(/^11\./)) {
    return ColorChooser.runColorPicker(def);
  }

  var fgOrig = app.foregroundColor;
  var fgColor = app.foregroundColor;
  if (def) {
    app.foregroundColor = def;
    fgColor = def;
  }

  try {
    var win = ColorChooser.createDialog(fgColor);
    var rc = win.show();

    if (rc == 1) {
      ColorChooser.selectedColor = win._color;
    }

  } finally {
    app.foregroundColor = fgOrig;
  }

  return ColorChooser.selectedColor;
};

//
// Sample usage
//
ColorChooser.main = function() {
  var c = ColorChooser.run();
  if (c) {
    c = c.rgb;
    alert("RGB=[" + c.red + ", " + c.green + ", " + c.blue + "]");
  } else {
    alert("No color chosen");
  }
};
//ColorChooser.main();

"ColorChooser.jsx";
// EOF


//
// PresetsManager
// 
// var mgr = new PresetsManager()
// var brushes = mgr.getNames(PresetType.BRUSHES);
//
//
//
//
//
// $Id: PresetsManager.jsx,v 1.11 2008/07/30 19:11:54 anonymous Exp $
// Copyright: (c)2005, xbytor
// License: http://creativecommons.org/licenses/LGPL/2.1
// Contact: xbytor@gmail.com
//
//
//--include "xlib/Stdlib.js"

//
// PresetType
//   This is an enumeration of the preset types available
//
PresetType = function(name, toolID, classID) {
  this.sym = toolID;
  this.name = name;
  this.id = xTID(toolID);
  this.classID = xTID(classID);
  this.toString = function() { return this.name; };
};
PresetType.BRUSHES        = new PresetType("Brushes", 'Brsh', 'Brsh');
PresetType.COLORS         = new PresetType("Colors", 'Clr ', 'Clr ');
PresetType.GRADIENTS      = new PresetType("Gradients", 'Grdn', 'Grad');
PresetType.STYLES         = new PresetType("Styles", 'StyC', 'Styl');
PresetType.PATTERNS       = new PresetType("Patterns", 'PttR', 'Ptrn');
PresetType.SHAPING_CURVES = new PresetType("Shaping Curves", 'ShpC', 'Shp ');
PresetType.CUSTOM_SHAPES  = new PresetType("Custom Shapes", 'customShape',
                                           'customShape');
PresetType.TOOL_PRESETS   = new PresetType("Tool Presets", 'toolPreset',
                                           'toolPreset');


//
//
// PresetsManager
//   This class is a container for all of the information that we can gather
//   about presets in Photoshop.
//
PresetsManager = function() {
  var self = this;

//   self.brushes       = [];
//   self.colors        = [];
//   self.gradients     = [];
//   self.styles        = [];
//   self.patterns      = [];
//   self.shapingCurves = [];
//   self.customShapes  = [];
//   self.toolPresets   = [];

  self.manager = null;
};
PresetsManager.prototype.typename = "PresetsManager";

//
// PresetsManager.getPresetsManager
//   Retrieves the PresetsManager object/list from Photoshop
// 
PresetsManager.prototype.getPresetsManager = function() {
  var self = this;

  if (!self.manager) {
    var classApplication = cTID('capp');
    var typeOrdinal      = cTID('Ordn');
    var enumTarget       = cTID('Trgt');

    var ref = new ActionReference();
    ref.putEnumerated(classApplication, typeOrdinal, enumTarget);
    
    var appDesc = app.executeActionGet(ref);
    self.manager = appDesc.getList(sTID('presetManager'));
  }

  return self.manager;
};

PresetsManager.getManager = function(presetType) {
  var mgr = new PresetsManager();
  return new PTM(mgr, presetType);
};

PresetsManager.prototype.resetManager = function() {
  var self = this;
  self.manager = undefined;
};

PresetsManager.prototype.getCount = function(presetType) {
  if (presetType == undefined) {
    Error.runtimeError(2, "presetType");   // undefined
  }
  if (!(presetType instanceof PresetType)) {
    Error.runtimeError(19, "presetType");  // bad argument type
  }

  var self = this;

  var names = [];
  var key = presetType.id;
  var mgr = self.getPresetsManager();
  var max = mgr.count;

  for (var i = 0; i < max; i++) {
    var objType = mgr.getObjectType(i);
    if (objType == key) {
      break;
    }
  }

  if (i == max) {
    return -1;
  }
  var preset = mgr.getObjectValue(i);
  var list = preset.getList(cTID('Nm  '));
  return list.count;
};

//
//
PresetsManager.prototype.getNames = function(presetType) {
  if (presetType == undefined) {
    Error.runtimeError(2, "presetType");   // undefined
  }
  if (!(presetType instanceof PresetType)) {
    Error.runtimeError(19, "presetType");  // bad argument type
  }

  var self = this;

  var names = [];
  var key = presetType.id;
  var mgr = self.getPresetsManager();
  var max = mgr.count;

  for (var i = 0; i < max; i++) {
    var objType = mgr.getObjectType(i);
    if (objType == key) {
      break;
    }
  }

  if (i != max) {
    var preset = mgr.getObjectValue(i);
    var list = preset.getList(cTID('Nm  '));
    var max = list.count;
    for (var i = 0; i < max; i++) {
      var str = list.getString(i);
      names.push(str);
    }
    self[key] = names;
  }

  return names;
};

PresetsManager.prototype.resetPreset = function(presetType) {
  if (presetType == undefined) {
    Error.runtimeError(2, "presetType");   // undefined
  }
  if (!(presetType instanceof PresetType)) {
    Error.runtimeError(19, "presetType");  // bad argument type
  }

  var self = this;
  var ref = new ActionReference();
  ref.putProperty(cTID('Prpr'), presetType.classID);
  ref.putEnumerated(cTID('capp'), cTID('Ordn'), cTID('Trgt'));

  var desc = new ActionDescriptor();
  desc.putReference(cTID('null'), ref);

  executeAction(cTID('Rset'), desc, DialogModes.NO);
};

PresetsManager.prototype.saveAllPresets = function(presetType, fptr) {
  if (presetType == undefined) {
    Error.runtimeError(2, "presetType");   // undefined
  }
  if (fptr == undefined) {
    Error.runtimeError(2, "fptr");         // undefined
  }
  if (!(presetType instanceof PresetType)) {
    Error.runtimeError(19, "presetType");  // bad argument type
  }

  var self = this;

  var file = Stdlib.convertFptr(fptr);
  var desc = new ActionDescriptor();
  desc.putPath( cTID('null'), file);

  var ref = new ActionReference();
  ref.putProperty(cTID('Prpr'), presetType.id);
  ref.putEnumerated(cTID('capp'), cTID('Ordn'), cTID('Trgt'));
  desc.putReference(cTID('T   '), ref);

  executeAction(cTID('setd'), desc, DialogModes.NO);
};

PresetsManager.prototype.loadPresets = function(presetType, fptr, append) {
  if (presetType == undefined) {
    Error.runtimeError(2, "presetType");   // undefined
  }
  if (fptr == undefined) {
    Error.runtimeError(2, "fptr");         // undefined
  }
  if (!(presetType instanceof PresetType)) {
    Error.runtimeError(19, "presetType");  // bad argument type
  }

  var self = this;

  var file = Stdlib.convertFptr(fptr);

  var ref = new ActionReference();
  ref.putProperty(cTID('Prpr'), presetType.classID);
  ref.putEnumerated(cTID('capp'), cTID('Ordn'), cTID('Trgt'));

  var desc = new ActionDescriptor();
  desc.putReference(cTID('null'), ref);
  desc.putPath(cTID('T   '), file);

  if (Boolean(append)) {
    desc.putBoolean(cTID('Appe'), true);
  }

  executeAction(cTID('setd'), desc, DialogModes.NO);
  self.resetManager();
};

PresetsManager.prototype.appendPresets = function(presetType, fptr) {
  this.loadPresets(presetType, fptr, true);
};

PresetsManager.prototype.getIndexOfElement = function(presetType, name) {
  if (presetType == undefined) {
    Error.runtimeError(2, "presetType");   // undefined
  }
  if (name == undefined) {
    Error.runtimeError(2, "name");         // undefined
  }
  if (!(presetType instanceof PresetType)) {
    Error.runtimeError(19, "presetType");  // bad argument type
  }

  var self = this;

  var names = self.getNames(presetType);
  for (var i = 0; i < names.length; i++) {
    if (names[i] == name) {
      return i+1;
    }
  }
  return -1;
};
PresetsManager.prototype.deleteElementAt = function(presetType, index) {
  if (presetType == undefined) {
    Error.runtimeError(2, "presetType");   // undefined
  }
  if (index == undefined) {
    Error.runtimeError(2, "index");       // undefined
  }
  if (!(presetType instanceof PresetType)) {
    Error.runtimeError(19, "presetType");  // bad argument type
  }

  var self = this;
  self.resetManager();

  var ref = new ActionReference();
  ref.putIndex(presetType.classID, index);

  var list = new ActionList();
  list.putReference(ref);

  var desc = new ActionDescriptor();
  desc.putList(cTID('null'), list);

  executeAction(cTID('Dlt '), desc, DialogModes.NO);
  self.resetManager();
};

PresetsManager.prototype.deleteElement = function(presetType, name) {
  var self = this;

  var idx = self.getIndexOfElement(presetType, name);

  if (idx != -1) {
    self.deleteElementAt(presetType, idx);
  }
};
PresetsManager.prototype.renameByIndex = function(presetType, index, name) {
  if (presetType == undefined) {
    Error.runtimeError(2, "presetType");   // undefined
  }
  if (index == undefined) {
    Error.runtimeError(2, "index");       // undefined
  }
  if (name == undefined) {
    Error.runtimeError(2, "name");        // undefined
  }
  if (!(presetType instanceof PresetType)) {
    Error.runtimeError(19, "presetType");  // bad argument type
  }

  var self = this;
  self.resetManager();
  var ref = new ActionReference();
  ref.putIndex(presetType.classID, index);

  var desc = new ActionDescriptor();
  desc.putReference(cTID('null'), ref);
  desc.putString(cTID('T   '), name);

  executeAction(cTID('Rnm '), desc, DialogModes.NO );
  self.resetManager();
};
PresetsManager.prototype.renameElement = function(presetType, oldName, newName) {
  var self = this;

  var idx = self.getIndexOfElement(oldName);

  if (idx != -1) {
    self.renameByIndex(idx, newName);
  }
};

PresetsManager.prototype.saveElementByIndex = function(presetType, index, fptr) {
  if (presetType == undefined) {
    Error.runtimeError(2, "presetType");   // undefined
  }
  if (index == undefined) {
    Error.runtimeError(2, "index");        // undefined
  }
  if (fptr == undefined) {
    Error.runtimeError(2, "fptr");         // undefined
  }
  if (!(presetType instanceof PresetType)) {
    Error.runtimeError(19, "presetType");  // bad argument type
  }

  var self = this;

  var file = Stdlib.convertFptr(fptr);

  if (file.exists) {
    file.remove();
  }

  var desc = new ActionDescriptor();
  desc.putPath(cTID('null'), file);
  var list = new ActionList();
  var ref = new ActionReference();
  ref.putIndex(presetType.classID, index);
  list.putReference(ref);
  desc.putList(cTID('T   '), list);
  executeAction(cTID('setd'), desc, DialogModes.NO );
};

PresetsManager.prototype.saveElement = function(presetType, name, fptr) {
  var self = this;

  var idx = self.getIndexOfElement(presetType, name);
  if (idx != -1) {
    self.saveElementByIndex(presetType, idx, fptr);
  }
};

// XXX add code here.... This is broken... fix later
PresetsManager.prototype.newElement = function(presetType, name, obj,
                                               interactive) {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putClass( presetType.classID );
  desc.putReference( cTID('null'), ref );

  switch (presetType) {
    case PresetType.STYLES: {
      desc.putString(cTID('Nm  '), name);

      var lref = new ActionReference();
      lref.putEnumerated(cTID('Lyr '), cTID('Ordn'), cTID('Trgt'));
      desc.putReference(cTID('Usng'), lref);
      desc.putBoolean(sTID('blendOptions'), false);
      desc.putBoolean(cTID('Lefx'), true);
      break;
    };
    case PresetType.COLORS: {
      var color = obj;
      var swdesc = new ActionDescriptor();

      swdesc.putString(cTID('Nm  '), name);
      var cdesc = new ActionDescriptor();
      cdesc.putDouble(cTID('Rd  '), color.rgb.red);
      cdesc.putDouble(cTID('Grn '), color.rgb.green);
      cdesc.putDouble(cTID('Bl  '), color.rgb.blue);
      swdesc.putObject( cTID('Clr '), cTID('RGBC'), cdesc);
      desc.putObject(cTID('Usng'), cTID('Clrs'), swdesc);
    };
    case PresetType.PATTERNS: {
      var ref = new ActionReference();
        ref.putProperty(cTID('Prpr'), cTID('fsel'));
        ref.putEnumerated(cTID('Dcmn'), cTID('Ordn'), cTID('Trgt'));
        desc.putReference(cTID('Usng'), ref);
    };

    case PresetType.BRUSHES:
    case PresetType.CUSTOM_SHAPE:
    case PresetType.TOOL_PRESETS: {
      desc.putString(cTID('Nm  '), name);
      var ref = new ActionReference();
      ref.putProperty(cTID('Prpr'), cTID('CrnT'));
      ref.putEnumerated(cTID('capp'), cTID('Ordn'), cTID('Trgt'));
      desc.putReference(cTID('Usng'), ref);
    };

    case PresetType.SHAPING_CURVES:
    case PresetType.GRADIENTS:
    default: break;
  }
  var mode = (interactive ? DialogModes.ALL : DialogModes.NO);

  var xdesc = executeAction(cTID('Mk  '), desc, mode);
  return xdesc;
};


PresetsManager.prototype.populateDropdownList = function(presetType, ddlist,
                                                         none) {
  var self = this;
  var names = self.getNames(presetType);
  
  if (none) {
    ddlist.add("item", "None");
  }
  for (var i = 0; i < names.length; i++) {
    ddlist.add("item", names[i]);
  }
};

/*
//  //@include "xlib/PresetsManager.jsx"
//  PresetsManager.placeShape(doc, 'Cat Print', undefined, true);
//
*/
PresetsManager.placeShape = function(doc, name, bnds) {
  if (bnds) {
    if (bnds[0] instanceof UnitValue) {
      // assume we have an array of pixels...
      bnds[0].type == "px";
      var b = [];
      b.push(bnds[0].value);
      b.push(bnds[1].value);
      b.push(bnds[2].value);
      b.push(bnds[3].value);
      bnds = b;
    }
  } else {
    var ru = app.preferences.rulerUnits;
    app.preferences.rulerUnits = Units.PIXELS;
    bnds = [0,0,0,0];
    bnds[2] = doc.width.value / 4;
    bnds[3] = doc.height.value / 4;
    app.preferences.rulerUnits = ru;
  }

  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putClass(sTID('contentLayer'));
    desc.putReference(cTID('null'), ref);
    var tdesc = new ActionDescriptor();
    tdesc.putClass(cTID('Type'), sTID('solidColorLayer'));
    var sdesc = new ActionDescriptor();
    sdesc.putString(cTID('Nm  '), name);
    if (bnds) {
      sdesc.putUnitDouble(cTID('Left'), cTID('#Pxl'), bnds[0]);
      sdesc.putUnitDouble(cTID('Top '), cTID('#Pxl'), bnds[1]);
      sdesc.putUnitDouble(cTID('Rght'), cTID('#Pxl'), bnds[2]);
      sdesc.putUnitDouble(cTID('Btom'), cTID('#Pxl'), bnds[3]);
    }
    tdesc.putObject(cTID('Shp '), sTID('customShape'), sdesc);
    desc.putObject(cTID('Usng'), sTID('contentLayer'), tdesc);
    executeAction(cTID('Mk  '), desc, DialogModes.NO);
  }

  return Stdlib.wrapLC(doc, _ftn);
};


//
// PresetTypeManager
//
PTM = function(mgr, presetType) {
  var self = this;
  if (mgr) {
    self.mgr = mgr;
  } else {
    self.mgr = new PresetsManager();
  }
  self.presetType = presetType;
};

PTM.prototype.reset = function() {
  this.mgr.resetManager();
};
PTM.prototype.getCount = function() {
  return this.mgr.getCount(this.presetType);
};
PTM.prototype.getNames = function() {
  return this.mgr.getNames(this.presetType);
};
PTM.prototype.resetPreset = function() {
  return this.mgr.resetPreset(this.presetType);
};
PTM.prototype.saveAllPresets = function(fptr) {
  return this.mgr.saveAllPresets(this.presetType, fptr);
};
PTM.prototype.loadPresets = function(fptr, append) {
  return this.mgr.loadPresets(this.presetType, fptr, append);
};
PTM.prototype.appendPresets = function(fptr, append) {
  return this.mgr.appendPresets(this.presetType, fptr);
};
PTM.prototype.getIndexOfElement = function(name) {
  return this.mgr.getIndexOfElement(this.presetType, name);
};
PTM.prototype.deleteElementAt = function(index) {
  return this.mgr.deleteElementAt(this.presetType, index);
};
PTM.prototype.deleteElement = function(name) {
  return this.mgr.deleteElement(this.presetType, name);
};
PTM.prototype.renameByIndex = function(index, name) {
  return this.mgr.renameByIndex(this.presetType, index, name);
};
PTM.prototype.renameElement = function(oldName, newName) {
  return this.mgr.renameElement(this.presetType, oldName, newName);
};
PTM.prototype.saveElementByIndex = function(index, fptr) {
  return this.mgr.saveElementByIndex(this.presetType, index, fptr);
};
PTM.prototype.saveElement = function(name, fptr) {
  return this.mgr.saveElement(this.presetType, name, fptr);
};
PTM.prototype.newElement = function(name, obj, interactive) {
  return this.mgr.newElement(this.presetType, name, obj, interactive);
};
PTM.prototype.populateDropdownList = function(ddlist, none) {
  return this.mgr.populateDropdownList(this.presetType, ddlist, none);
};

// _newStyle = function(name) {
//   var desc = new ActionDescriptor();
//   var ref = new ActionReference();
//   ref.putClass( cTID('Styl') );
//   desc.putReference( cTID('null'), ref );
//   desc.putString( cTID('Nm  '), name );
//   var lref = new ActionReference();
//   lref.putEnumerated(cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
//   desc.putReference( cTID('Usng'), lref );
//   desc.putBoolean( sTID('blendOptions'), false );
//   desc.putBoolean( cTID('Lefx'), true );
//   executeAction( cTID('Mk  '), desc, DialogModes.NO );
// };

// // _styleToHex();
// _styleToHex = function() {
//   debugger;
//   var styleMgr = new PTM(new PresetsManager(), PresetType.STYLES);

//   var sname = "__TEMP_STYLE__";

//   //var file = new File(Folder.temp + "/" + sname + ".asl");
//   var file = new File("/c/work/tmp/" + sname + ".asl");
//   if (file.exists) {
//     file.remove();
//   }

//   var idx = styleMgr.getIndexOfElement(sname);
//   if (idx != -1) {
//     styleMgr.deleteElementAt(idx);
//   }

//   var bin = '';
//   try {
//     _newStyle(sname);
//     styleMgr.saveElement(sname, file);
//     //styleMgr.deleteElement(sname);

//     var bin = Stdlib.readFromFile(file, 'BINARY');
//     alert(file.length);
//     //file.remove();

//   } catch (e) {
//     throw e;
//   }

//   return  Stdlib.binToHex(bin);
// };

"PresetsManager.jsx";
// EOF

//
// xexec.js
//
// $Id: xexec.js,v 1.31 2008/11/14 17:07:34 anonymous Exp $
// Copyright: (c)2006, xbytor
// License: http://creativecommons.org/licenses/LGPL/2.1
// Contact: xbytor@gmail.com
//
//@show include
//
//

isWindows = function() {
  return $.os.match(/windows/i);
};
isMac = function() {
  return !isWindows();
};

Exec = function(app){
  this.app = app;         // A File object to the application
  if (app) {
    this.name = app.name;
  }

  // You can use a different tmp folder
  this.tmp = (isMac() ? '/private/var/tmp' : Folder.temp);
};

Exec.ERROR_CODE = 9003;

Exec.scriptsFolder = 
  new Folder(app.path + '/' +
             localize("$$$/ScriptingSupport/InstalledScripts=Presets/Scripts"));


Exec.ext = (isWindows() ? ".bat" : ".sh");

Exec.bashApp = (isWindows() ? "c:\\cygwin\\bin\\bash" : "/bin/bash");

Exec.setMacRoot = function(folder) {
  if (!folder) {
    folder = new Folder(Exec.scriptsFolder);
  }
  if (!folder.exists) {
    //
  }
  Exec.macRoot = folder;

  Exec.macApp = Exec.macRoot + "/macexec.app";
  Exec.macScript = Exec.macApp + "/Contents/macexec";
};

Exec.prototype.toCommandStr = function(args) {
  var str = '';

  if (this.app) {
    str = '\"' + decodeURI(this.app.fsName) + '\"'; // the app
  }

  if (args) {
    // if a file or folder was passed in, convert it to an array of one
    if (args instanceof File || args instanceof Folder) {
      args = ['\"' + args + '\"'];
    }

    // if its an array, append it to the command (could use Array.join)
    if (args.constructor == Array) {
      for (var i = 0; i < args.length; i++) {
        var arg = args[i];
        str += ' ' + arg;
      }
    } else {
      // if its something else (like a prebuilt command string), just append it
      str += ' ' + args.toString();
    }
  }
  return str;
};

Exec.prototype.getBatName = function() {
  if (isMac()) {
    return Exec.macScript;
  }

  var nm = '';
  var ts = new Date().getTime();

  if (this.app) {
    nm = this.tmp + '/' + this.app.name + '-' + ts + Exec.ext;
  } else {
    nm = this.tmp + "/exec-" + ts + Exec.ext;
  }
  return nm;
};

Exec.system = function(cmd, timeout, folder, redir, keepBat) {
  Exec.log("Exec.system(\"" + cmd + "\", " + timeout + ");")

  redir = (redir != false); // default is true

  if (isMac()) {
    return Exec.systemMac(cmd, timeout, folder, redir, keepBat);
  }
  var ts = new Date().getTime();
  var e = new Exec();
  e.name = "system";
  var outf = new File(e.tmp + "/exec-" + ts + ".out");

  if (redir) {
    cmd += "> \"" + outf.fsName + "\"\n";
  }

  e.executeBlock(cmd, timeout, folder, keepBat);

  var str = '';
  if (redir) {
    outf.open("r");
    str = outf.read();
    outf.close();
  }

  if (Exec.log.enabled) {
    Exec.log("==========================================================");
    Exec.log(str);
    Exec.log("==========================================================");
  }
  
  return str;
};

Exec.systemMac = function(cmd, timeout, folder, redir, keepBat) {
  Exec.log("Exec.systemMac(\"" + cmd + "\", " + timeout + ");")

  if (!Exec.macRoot) {
    Exec.setMacRoot();
  }
  if (!Exec.macRoot.exists) {
    Error.runtimeError(Exec.ERROR_CODE, "This machine has not been correctly " +
                       "configured to run Exec.");
  }

  var ts = new Date().getTime();
  var e = new Exec();
  e.name = "systemMac";

  var outf = new File(e.tmp + "/exec-" + ts + ".out");
  var outname = outf.fsName;
  var semaphore = new File(outname + ".sem");

  if (folder) {
    folder = decodeURI(folder.fsName);
  }

  var script = File(Exec.macScript);
  script.length = 0;
  script.lineFeed = "unix";
  script.open("e");
  script.writeln("#!/bin/sh");

  if (folder) {
    script.writeln("cd \"" + folder + "\"");
  }

  var envScript = File(Exec.macScript + ".env");
  if (envScript.exists) {
    script.writeln("source \"" + envScript.fsName + "\"");
  }

  if (redir) {
    cmd += " > \"" + outname + "\"";
  }
  script.writeln(cmd);
  script.writeln("\necho Done > \"" + semaphore.fsName + "\"");
  script.writeln("exit 0");
  var len = script.tell();
  script.close();
  script.length = len;

  var app = File(Exec.macApp);
  var rc = app.execute();
  var msg = (rc ? "execute ok" : "execute failed: \"" + app.error + "\"");

  Exec.log(msg);

  if (!rc) {
    Error.runtimeError(Exec.ERROR_CODE, msg);
  }

  try {
    e.block(semaphore, timeout);

  } finally {
    semaphore.remove();
  }

  outf.open("r");
  var str = outf.read();
  outf.close();
  outf.remove();

  if (Exec.log.enabled) {
    Exec.log("==========================================================");
    Exec.log(str);
    Exec.log("==========================================================");
  }
  
  return str;
};

Exec.bash = function(cmd, timeout) {
  Exec.log("Exec.bash(\"" + cmd + "\", " + timeout + ");")

  var ts = new Date().getTime();
  var e = new Exec();
  e.name = "bash";

  var outf = new File(e.tmp + "/exec-" + ts + ".out");
  var cmdLine = Exec.bashApp;
  cmdLine += " -c \"" + cmd + "\" > \"" + outf.fsName + "\" 2>&1";
  e.executeBlock(cmdLine, timeout);

  outf.open("r");
  var str = outf.read();
  outf.close();
  outf.remove();

  if (Exec.log.enabled) {
    Exec.log("==========================================================");
    Exec.log(str);
    Exec.log("==========================================================");
  }    
  return str;
};

Exec.openScript = function(script) {
  if (isWindows()) {
    script.open("w");

  } else {
    Exec.openMacScript(script);
  }
};
Exec.openMacScript = function(script) {
  script.length = 0;
  script.lineFeed = "unix";
  script.length = 0;
  script.open("e");
  script.writeln("#!/bin/bash");
};
Exec.closeScript = function(script) {
  if (isWindows()) {
    script.close();

  } else {
// osascript -e 'tell application "Terminal"' -e 'close front window' -e 'end tell'
//     script.writeln("osascript -e 'tell application \"Terminal\"' " +
//                    "-e 'close front window' -e 'end tell'");

    script.writeln("exit\n\n\n\n");

    var len = script.tell();
    script.close();
    script.length = len;
  }
};

Exec.fsFileName = function(file) {
  return decodeURI(file.fsName);
};
Exec.prototype.execute = function(argList, folder) {
  var str = this.toCommandStr(argList);
  var bat = new File(this.getBatName());
  Exec.openScript(bat);

  if (folder) {
    //$.level = 1; debugger;
    var dir = fsFileName(folder);
    bat.writeln("cd \"" + dir + '\"');
    if (isWindows()) {
      bat.writeln(dir.substring(0, 2));
    }
  }

  bat.writeln(str);

  if (isWindows()) {
    bat.writeln("del \"" + Exec.fsFileName(bat) + "\" >NUL");
  }

  Exec.closeScript(bat);

  if (Exec.log.enabled) {
//     bat.open("r");
//     var str = bat.read();
//     bat.close();
    Exec.log("==========================================================");
    Exec.log(str);
    Exec.log("==========================================================");
  }    

  bat.execute();
};

Exec.prototype.executeCmd = function(cmd, folder) {
  var bat = new File(this.getBatName());

  Exec.openScript(bat);

  if (folder) {
    //$.level = 1; debugger;
    var dir = Exec.fsFileName(folder);
    bat.writeln("cd \"" + dir + '\"');
    if (isWindows()) {
      bat.writeln(dir.substring(0, 2));
    }
  }
  bat.writeln(str);
  if (isWindows()) {
    bat.writeln("del \"" + Exec.fsFileName(bat) + "\" >NUL");
  }
  Exec.closeScript(bat);
  bat.execute();
};


Exec.blockForFile = function(file, timeout) {
  //$.level = 1; debugger;
  Exec.log("Exec.blockForFile(" + file.toUIString() + ", " + timeout + ");");
  if (timeout == undefined) {
    timeout = 2000;
    Exec.log("timeout set to " + 2000);
  }
  if (timeout) {
    var parts = 20;   // default to 1/20 of timeout intervals

    // if the timeout is more than 20 seconds, check every 2 seconds
    if (timeout > 20000) {
      parts = Math.ceil(timeout/2000);
    }

    timeout = timeout / parts;

    Exec.log("parts = " + parts + ", timeout= " + timeout);

    while (!file.exists && parts) {
      Exec.log('.');
      $.sleep(timeout);
      parts--;
    }
    Exec.log("wait complete. file.exists = " + file.exists +
             ", parts = " + parts);
  }
  return file.exists;
};

Exec.prototype.block = function(semaphore, timeout) {
  if (!Exec.blockForFile(semaphore, timeout)) {
    var msg = "Timeout exceeded for program " + this.name;
    Exec.log(msg);
    Error.runtimeError(Exec.ERROR_CODE, msg);
  }
};

Exec.prototype.executeBlock = function(argList, timeout, folder, keepBatfile) {
  Exec.log("Exec.executeBlock(\"" + argList + "\", " + timeout + ", " +
           folder + ", " + keepBatfile + ");")

  var str = this.toCommandStr(argList);

  Exec.log("str = " + str);

  var bat = new File(this.getBatName());
  var semaphore = new File(bat.toString() + ".sem");
  var rm = (isWindows() ? "del" : "/bin/rm -f");
  Exec.log("bat = " + bat.toUIString() + ", sem = " + semaphore.toUIString() +
           ", rm = " + rm);

  var semname = semaphore.toUIString();

  var bstr = '';
  if (folder) {
    var dir = Exec.fsFileName(folder);
    bstr += "cd \"" + dir + "\"\n";
    if (isWindows()) {
      bstr += dir.substring(0, 2) + '\n';
    }
  }
  bstr += str + "\n\n";
  bstr += "echo Done > \"" + Exec.fsFileName(semaphore) + "\"\n";
  if (keepBatfile != true && isWindows()) {
    bstr += rm + " \"" + Exec.fsFileName(bat) + "\"\n";
  }
  Exec.log(bstr);
  
  Exec.openScript(bat);
  bat.writeln(bstr);
  Exec.closeScript(bat);

  //   if (isWindows()) {
  if (true) {
    var rc = bat.execute();
    var msg = (rc ? "execute ok" : "execute failed: \"" +
               bat.error + "\"");
    Exec.log(msg);
    if (!rc) {
      Error.runtimeError(Exec.ERROR_CODE, msg);
    }
  } else {
    //$.level = 1; debugger;
    var wrapper = new File(Exec.macExecWrapper);
    if (!wrapper.exists) {
      var msg = "Wrapper file " + wrapper.toUIString() + " not found.";
      Exec.log(msg);
      Error.runtimeError(Exec.ERROR_CODE, msg);
    }

    Exec.log("Using wrapper: " + Exec.macExecWrapper);
    var rc = wrapper.execute();
    var msg = (rc ? "execute ok" : "execute failed: \"" +
               wrapper.error + "\"");
    Exec.log(msg);
    if (!rc) {
      Error.runtimeError(Exec.ERROR_CODE, msg);
    }
  }

  try {
    this.block(semaphore, timeout);

  } finally {
    semaphore.remove();
  }
};

Exec.log = function(msg) {
  var file;

  if (!Exec.log.enabled) {
    return;
  }

  if (!Exec.log.filename) {
    return;
  }

  if (!Exec.log.fptr) {
    file = new File(Exec.log.filename);
    if (file.exists) file.remove();
    if (!file.open("w")) {
      Error.runtimeError(9002, "Unable to open log file " +
                         file + ": " + file.error);
    }
    Exec.log.fptr = file;
    msg = "Exec Versions $Revision: 1.31 $\n\n" + msg;
  } else {
    file = Exec.log.fptr;
    if (!file.open("e"))  {
      Error.runtimeError(9002, "Unable to open log file " + file +
                         ": " + file.error);
    }
    file.seek(0, 2); // jump to the end of the file
  }
  var now = new Date();
  if (now.toISO) {
    now = now.toISO();
  } else {
    now = now.toString();
  }
  
  if (!file.writeln(now + " - " + msg)) {
    Error.runtimeError(Exec.ERROR_CODE, "Unable to write to log file " +
                       file + ": " + file.error);
  }
  
  file.close();
};
Exec.log.setFileName = function(name) {
  if (isWindows()) {
    var folder = new Folder("/c/temp");
    if (!folder.exists) {
      var path = folder.toUIString();
      folder = Folder.temp;
      Exec.log(path + " does not exist, changing to " + folder.toUIString());
    }
    var file = new File(folder + '/' + name);
    if (file.exists) {
      file.remove();
    }
    Exec.log.filename = file.absoluteURI;

  } else {
    var file = new File("/tmp/" + name);
    if (!file.parent.exists) {
      var path = file.toUIString();
      file = new File(Folder.temp + name);
      Exec.log(path + " does not exist, changing to " + file.toUIString());
    }
    if (file.exists) {
      file.remove();
    }
    Exec.log.filename = file.absoluteURI;
  }
};

Exec.log.setFileName("exec-psjs.log"); 
Exec.log.enabled = false;

if (isMac()) {
  Exec.setMacRoot();
}

"xexec.js";
// EOF

//
// metadata.js
//
// routines for manipulating IPTC, EXIF, XMP, and any other
// metadata
//
// Functions:
//
// History:
//  2005-01-20 v0.8 Name change
//  2004-09-27 v0.1 Creation date
//
// Copyright: (c)2007, xbytor
// License: http://creativecommons.org/licenses/LGPL/2.1
// Contact: xbytor@gmail.com
//
// $Id: metadata.js,v 1.46 2008/11/23 19:58:26 anonymous Exp $
//
//@show include


var gMETADATAlibVersion = 0.8;

//================================= EXIF ===============================

EXIF = function EXIF(obj) {
  if (obj.typename == "Document") {
    this.exif = obj.info.exif;
  } else {
    this.exif = obj;
  }
  this.caseSensitive = false;
};
EXIF.prototype.get = function(tag) {
  var exif = this.exif;

  for (var i = 0; i < exif.length; i++) {
    var name = exif[i][0];
    if (name == tag) {
      return exif[i][1];
    }
  }

  if (!this.caseSensitive) {
    tag = tag.toLowerCase().replace(/\s/g, '');

    for (var i = 0; i < exif.length; i++) {
      var name = exif[i][0];
      name = name.toLowerCase().replace(/\s/g, '');
      if (name == tag) {
        return exif[i][1];
      }
    }
  }

  return '';
};
EXIF.prototype.toString = function(indent) {
  var exif = this.exif;

  var s = '';
  if (indent == undefined) { indent = ''; }
  for (var i = 0; i < exif.length; i++) {
    var name = exif[i][0];
    var val  = exif[i][1] || '';
    s += indent + name + ': ' + val + '\r\n';
  }

  return s;
};
EXIF.prototype.toXMLString = function() {
  return "<EXIF>\r\n<![CDATA[\n" + this.toString() + "\r\n]]>\r\n</EXIF>\r\n";
};


//================================== IPTC ===================================

IPTC = function IPTC(obj) {
  if (obj.typename == "Document") {
    this.info = obj.info;
  } else if (obj.typename == "DocumentInfo") {
    this.info = obj;
  }
};
IPTC.prototype.get = function(tag) {
  var info = this.info;
  tag = tag.toLowerCase();

  for (var idx in info) {
    if (idx.toLowerCase() == tag) {
      return info[idx];
    }
  }
  return '';
};
IPTC.prototype.set = function(tag, value) {
  var info = this.info;

  for (var idx in info) {
    if (idx.toLowerCase() == tag) {
      info[idx] = value;
    }
  }
  return value;
};
IPTC.prototype.getCreationDate = function() {
  var info = this.info;

  var dstr = info.creationDate;
  var date;
  if (dstr && dstr.length != 0) {
    date = IPTC.DocumentInfoStringToDate(dstr);
  }
  return date;
};
IPTC.prototype.setCreationDate = function(date) {
  var info = this.info;

  var dstr = null;
  if (date) {
    if (typeof date != "object" || !(date instanceof Date)) {
      return null;
    }
    dstr = IPTC.DateToDocumentInfoString(date);
  } else {
    dstr = null;
  }
  return info.creationDate = dstr;
};
IPTC.prototype.getKeywords = function() {
  var info = this.info;

  return IPTC.get(info, "keywords");
};
IPTC.prototype.setKeywords = function(keywords) {
  var info = this.info;

  if (keywords == undefined) { keywords = []; }
  return info.keywords = keywords;
};
IPTC.prototype.addKeyword = function(keyword) {
  return this.addKeywords([keyword]);
};
IPTC.prototype.addKeywords = function(keywords) {
  var info = this.info;
  var keys = info.keywords;
  if (!keywords || keywords.length == 0) {
    return keys;
  }

  return info.keywords = Set.merge(keys, keywords);
};
IPTC.prototype.removeKeyword = function(keyword) {
  var info = this.info;

  if (!keyword) {
    return undefined;
  }
  return info.keywords = Set.remove(info.keywords, keyword);
};
IPTC.prototype.containsKeyword = function(keyword) {
  var info = this.info;

  if (!keyword) {
    return undefined;
  }
  return Set.contains(info.keywords, keyword);
};
IPTC.prototype.toString = function(exif) {
  var info = this.info;

  var str = '';
  if (exif == undefined) { exif = false; }
  for (var x in info) {
    if (x == "exif") {
      if (exif) {
        str += "exif:\r\n" + EXIF.toString(doc.info.exif, '\t');
      } else {
        str += "exif: [EXIF]\r\n";
      }
    } else if (x == "keywords" || x == "supplementalCategories") {
      str += x + ":\t\r\n";
      var list = info[x];
      for (var y in list){
        str += '\t' + list[y] + "\r\n";
      }
    } else if (x == "creationDate") {
      var dstr = IPTC.DocumentInfoStringToISODate(info[x]);
      str += x + ":\t" + dstr + "\r\n";
    } else {
      str += x + ":\t" + info[x] + "\r\n";
    }
  }
  return str;
};
IPTC.prototype.toXMLString = function(info) {
  return "<IPTC>\r\n<![CDATA[\n" + IPTC.toString(info) + "\r\n]]>\r\n</IPTC>\r\n";
};
IPTC.DateToDocumentInfoString = function(date) {
  if (!date) {
    date = new Date();
  } else if (typeof date != "object" || !(date instanceof Date)) {
    return undefined;
  }
  var str = '';
  function _zeroPad(val) { return (val < 10) ? '0' + val : val; }
  str = date.getFullYear() + '-' +
  _zeroPad(date.getMonth()+1,2) + '-' +
  _zeroPad(date.getDate(),2);

  return str;
};
// IPTC.DocumentInfoStringToDate("20060410");
IPTC.DocumentInfoStringToDate = function(str) {
  if (!str || str.length != 8) {
    return undefined;
  }
  return new Date(Number(str.substr(0, 4)),
                  Number(str.substr(4, 2))-1,
                  Number(str.substr(6,2)));
};
IPTC.DocumentInfoStringToISODate = function(str) {
  return str.substr(0, 4) + '-' + str.substr(4, 2) + '-' + str.substr(6,2);
};

//================================= XMP ==================================

XMPData = function(obj) {
  var self = this;

  if (obj.typename == "Document") {
    self.xmp = obj.xmpMetadata.rawData;

  } else if (obj.constructor == String) {
    self.xmp = obj;

  } else if (obj != undefined) {
    Error.runtimeError(9001, "XMPData constructor argument must be a " +
                       "Document or a String");
  }

  self.caseSensitive = false;
};


XMPData._xmp_extract = function(str, startTag, stopTag) {
  var re = new RegExp(startTag, 'i');
  var start = str.match(re);

  if (!start) {
    return undefined;
  }

  var re = new RegExp(stopTag, 'i');
  var stop = str.match(re);
  if (!stop) {
    return undefined;
  }

  var startIndex = start.index + start[0].length;

  var val = str.substring(startIndex, stop.index).trim();

  // This takes care of matches against </rdf:Description> and others
  // which are not valid...
  if (val.match('^</rdf:[^>]+>')) {
    return undefined;
  }

  // Order/Unordered Arrays
  // return a comma delimited list
  //
  if (val.match('^<rdf:Seq>') || val.match('^<rdf:Bag>')) {
    var res = [];
    var rex = /<rdf:li>([^<]+)<\/rdf:li>(.*)/;
    var m;
    while (m = rex.exec(val)) {
      res.push(m[1].trim());
      val = m[2];
    }
    return res.join(',');
  }

  // Alternative Arrays
  // return the 'default' or first element
  //
  if (val.match('^<rdf:Alt>')) {
    var m = val.match(/<rdf:li.+default.+>([^<]+)<\/rdf:li>/);
    if (!m) {
      m = val.match(/<rdf:li.+>([^<]+)<\/rdf:li>/);
      if (!m) {
        return val;
      }
    }
    return m[1].trim();
  }

  // Structures
  // result looks like "{key1:"value1",key2:"value2"}
  // should probably use json for this
  //
  if (val.match('<stDim:')) {
    var res = [];
    var rex = /<stDim:([\w]+)>([^<]+)<\/stDim:\w+>(.*)/;
    var m;
    while (m = rex.exec(val)) {
      res.push(m[1] + ":\"" + m[2].trim() + '\"');
      val = m[3];
    }

    return '{' + res.join(',') + '}';
  }

  return val;
};

XMPData.prototype.getFromXMPMeta = function(tag) {
  var self = this;
  var xmeta = new XMPMeta(self.xmp);

  return XMPTools.getMetatdataValue(xmeta, tag);
};

XMPData.prototype.get = function(tag) {
  var self = this;

  try {
//     XMPTools;  
//     if (XMPTools.isCompatible() && XMPTools.loadXMPScript()) {
//       return self.getFromXMPMeta(tag);
//     }

  } catch (e) {
//     // ignore any exceptions
//     return '';
  }

  var hasNmSpc = tag.contains(':');

  if (hasNmSpc) {
    var val = XMPData._xmp_extract(self.xmp,
      '<' + tag + '>', '</' + tag + '>');

    if (val != undefined) {
      return val;
    }

  } else {
    // XXX Fix later
    // the startTag should probably look more like this:
    // '<[^(:|\\/)]+:' + tag + '>'
    var val = XMPData._xmp_extract(self.xmp,
      '<[^:]+:' + tag + '>',
      '</[^:]+:' + tag + '>');
    
    if (val != undefined) {
      return val;
    }
  }


  // The rest of this code handles metadata formatted in a non-canonical
  // format.

  // tag with a namespace
  var restr3 = "\\W" + tag + "=\"([^\"]*)\"";

  // tag without a namespace
  var restr4 = "\\W[\\w]+:" + tag + "=\"([^\"]*)\"";

  var re = new RegExp(restr3);
  var m = self.xmp.match(re);

  if (!m) {
    re = new RegExp(restr4);
    m = self.xmp.match(re);
  }

  if (!self.caseSensitive) {
    // now check the rex's again but case-insensitive
    if (!m) {
      re = new RegExp(restr3, 'i');
      m = self.xmp.match(re);
    }

    if (!m) {
      re = new RegExp(restr4, 'i');
      m = self.xmp.match(re);
    }
  }

  if (m) {
    return m[1];
  }

  // In CS4, Adobe will apparently use xmp* name spaces instead of xap*
  // namespaces. This code addresses that equivalence.

  var nm = undefined;
  var nmspc = undefined;
  var m = tag.split(':');

  if (m.length == 2) {
    nmspc = m[0];
    nm = m[1];
  }

  if (!nmspc || !nmspc.startsWith('xap')) {
    return '';
  }

  nmspc = nmspc.replace(/xap/, 'xmp');

  var rtag = nmspc + ':' + nm;

  // CS3 style
  var restr5 = '<' + rtag + '>(.+)</' + rtag + '>';

  // CS4 style
  var restr6 = "\\W" + rtag + "=\"([^\"]*)\"";

  var re = new RegExp(restr5);
  var m = self.xmp.match(re);

  if (!m) {
    re = new RegExp(restr6);
    m = self.xmp.match(re);
  }

  if (!self.caseSensitive) {
    // now check the rex's again but case-insensitive
    if (!m) {
      re = new RegExp(restr5, 'i');
      m = self.xmp.match(re);
    }

    if (!m) {
      re = new RegExp(restr6, 'i');
      m = self.xmp.match(re);
    }
  }

  if (m) {
    return m[1];
  }

  return '';
};


//================================= Metadata ==================================

Metadata = function(obj) {
  var self = this;

  if (obj != undefined) {
    if (obj.typename == "Document") {
      self.doc = obj;

    } else if (obj instanceof File) {
      self.file = obj;

    } else if (obj instanceof String || typeof(obj) == "string") {
      self.str = obj;

    } else {
      var md = {};
      for (var idx in obj) {
        var v = obj[idx];
        if (typeof v != 'function') {
          md[idx] = v;
        }
      }
      self.obj = md;
      self.obj.get = function(tag) {
        return this.obj[tag] || '';
      }
    }
  }
  self.defaultDateTimeFormat = Metadata.defaultDateTimeFormat;
  self.defaultGPSFormat = Metadata.defaultGPSFormat;
};
Metadata.DEFAULT_DATE_FORMAT = "%Y-%m-%d";
Metadata.DEFAULT_GPS_FORMAT = "%d\u00B0 %d' %.2f\"";

Metadata.defaultDateTimeFormat = Metadata.DEFAULT_DATE_FORMAT;
Metadata.defaultGPSFormat = Metadata.DEFAULT_GPS_FORMAT;

Metadata.prototype.get = function(tags) {
  var self = this;

  var single = false;

  try {
    if (!tags) {
      return undefined;
    }
    if (tags.constructor == String) {
      tags = [tags];
      single = true;
    }
    if (!(tags instanceof Array)) {
      return undefined;
    }

    var res = {};
    var re = /\$\{([^:]+):(.+)\}/;

    if (self.obj) {
      for (var i = 0; i < tags.length; i++) {
        var tag = tags[i];
        var m = tag.match(re);
        if (m) {
          tag = m[2];
        }

        val = self.obj[tag];
        res[tag] = val || '';

        if (single) {
          single = val;
        }
      }

    } else if (self.str) {
      var xmp  = new XMPData(self.str);

      for (var i = 0; i < tags.length; i++) {
        var tag = tags[i];
        var m = tag.match(re);
        var val;
        if (!m) {
          Error.runtimeError(9001, "Bad tag value: " + tag);
        }
        var type = m[1];
        var name = m[2];
        
        if (type == 'EXIF') {
          val = xmp.get(name);

        } else if (type == 'IPTC') {
          val = xmp.get('Iptc4xmpCore:' + name);
          if (!val) {
            val = xmp.get(name);
          }
        } else if (type == 'XMP') {
          val = xmp.get(name);

        } else {
          Error.runtimeError(9001, "Bad tag type: " + type);
        }
        
        res[tag] = val || '';
        if (single) {
          single = val;
        }
      }

    } else if (self.doc && self.doc.typename == "Document") {
      var exif = new EXIF(self.doc);
      var iptc = new IPTC(self.doc);
      var xmp  = new XMPData(self.doc);

      for (var i = 0; i < tags.length; i++) {
        var tag = tags[i];
        var m = tag.match(re);
        var val;
        if (!m) {
          Error.runtimeError(9001, "Bad tag value: " + tag);
        }
        var type = m[1];
        var name = m[2];
        
        if (type == 'EXIF') {
          val = exif.get(name);
          if (!val) {
            val = xmp.get(name);
          }
        } else if (type == 'IPTC') {
          val = iptc.get(name.toLowerCase());
          if (!val) {
            val = iptc.get(name);
          }
          if (!val) {
            val = xmp.get('Iptc4xmpCore:' + name);
          }
          if (!val) {
            val = xmp.get(name);
          }
        } else if (type == 'XMP') {
          val = xmp.get(name);
        } else {
          throw "Bad tag type " + type;
        }
        
        res[tag] = val || '';
        if (single) {
          single = val;
        }
      }

    } else {
      Error.runtimeError(9001, "Internal Error: Unable to determine " +
                         "metadata for images");
    }

  } catch (e) {
    Stdlib.logException(e);
    return undefined;
  }  

  return (single ? single : res[0]);
};

Metadata.prototype.formatDate = function(date, fmt) {
  var self = this;
  var str = fmt || self.defaultDateTimeFormat;

  if (!str.contains('%')) {
    str = str.replace(/YYYY/g, '%Y');
    str = str.replace(/YY/g, '%y');
    str = str.replace(/MM/g, '%m');
    str = str.replace(/DD/g, '%d');
    str = str.replace(/H/g, '%H');
    str = str.replace(/I/g, '%I');
    str = str.replace(/M/g, '%M');
    str = str.replace(/S/g, '%S');
    str = str.replace(/P/g, '%p');
  }
  return date.strftime(str);
};

Metadata.prototype.strf = function(fmt) {
  var self = this;
  var ru = app.preferences.rulerUnits;
  app.preferences.rulerUnits = Units.PIXELS;

  try {
  var str = fmt;

  var doc = self.doc;
  var file;

  if (doc) {
    file = Stdlib.getDocumentName(doc);

  } else {
    file = self.file;
  }

  // just used as a boolean check
  var xmp = self.str;

  var restrBase = "%|B|F|H|M|P|R|s|S|W|n|t| "; // d|e|f|p
  var restrC = "|C(?:\\{([^\\}]+)\\})?";
  var restrT = "|T(?:\\{([^\\}]+)\\})?";
  var restrN = "|N(?:\\{([^\\}]+)\\})?";
  var restrIE = "|(?:I|E)\\{([^\\}]+)\\}";
  var restrX = "|X\\{([^:]+)\:([^\\}]+)\\}";
  var restrX2 = "|X\\{([^\\}]+)\\}";

  var restrFile = "|(-)?(\\d+)?(\\.\\d+)?(d|e|f|p)";

  var restr = ("([^%]*)%(" + restrBase + restrC + restrT + restrN +
               restrIE + restrX + restrX2 + restrFile + ")(.*)");

  var re = new RegExp(restr);

  var dateFormat = self.defaultDateTimeFormat;

  var a = [];
  var b = [];

  //$.level = 1; debugger;

  var result = '';

  while (a = re.exec(str)) {
    var leftpart     = a[1];
    var pType        = a[2].charAt(0);

    var createTime   = a[3];
    var fileTime     = a[4];
    var currentTime  = a[5];
    var ieTag        = a[6];
    var xmpSpace     = a[7];
    var xmpTag       = a[8];
    var xTag         = a[9];
    var rightPart    = a[10];

    var fsig         = a[10];
    var flen         = a[11];
    var fign         = a[12];
    var ftyp         = a[13];

    var rightPart    = a[14];

    var subst = '';
    
    if (pType == '%') {
      subst = '%';

    } else if (ftyp) {
      subst = file.strf('%' + a[2]);

    } else {
      switch (pType) {
        case 'd':
          if (file) {
            subst = file.strf("%d");
          }
          break;
        case 'e':
          if (file) {
            subst =  file.strf("%e");
          }
          break;
        case 'p':
          if (file) {
            subst = decodeURI(file.parent.name);
          }
          break;
        case 'f':
          if (file) {
            subst = file.strf("%f");
          }
          break;
        case 'F':
          if (file) {
            subst = decodeURI(file.name);
          }
          break;
        case 's':
          if (file) {
            subst =  file.length;
          }
          break;
        case 'S':
          if (file) {
            var len = file.length;
            if (len > 1000000000) {
              subst = Math.round(len/1000000000) + 'G';
            } else if (len > 1000000) {
              subst = Math.round(len/1000000) + 'M';
            } else if (len > 1000) {
              subst = Math.round(len/1000) + 'K';
            } else {
              subst = len;
            }
          }
          break;
        case 'C':
          if (file) {
            subst = self.formatDate(file.created, createTime);
          }
          break;
        case 'T':
          if (file) {
            subst = self.formatDate(file.modified, fileTime);
          }
          break;
        case 'N':
          if (file) {
            subst = self.formatDate(new Date(), currentTime);
          }
          break;
        case 'W':
          if (doc) {
            subst = doc.width.value;
          } else if (xmp) {
            self.get('${XMP:ImageWidth}');
            if (!subst && self._width) {
              subst = self._width;
            }
          }
          break;
        case 'H':
          if (doc) {
            subst = doc.height.value;
          } else if (xmp) {
            subst = self.get('${XMP:ImageHeight}');
            if (!subst && self._height) {
              subst = self._height;
            }
          }
          break;
        case 'M':
          if (doc) {
            subst = Stdlib.colorModeString(doc.mode);

          } else if (xmp) {
            var mstr = self.get('${XMP:ColorMode}');
            if (mstr) {
              var cmode = toNumber(mstr);
              if (!isNaN(cmode)) {
                subst = Stdlib.colorModeString(cmode);
              }
            }
            if (!subst && self._mode) {
              subst = self._mode;
            }
          }
          break;
        case 'P':
          if (doc) {
            var lvl = $.level;
            try {
              $.level = 0;
              subst = doc.colorProfileName;
            } catch (e) {
              subst = '';
            }
            $.level = lvl;
          } else if (xmp) {
            subst = self.get('${XMP:ICCProfile}');
            if (!subst && self._profile) {
              subst = self._profile;
            }
          }
          break;
        case 'R':
          if (doc) {
            subst = doc.resolution;
          } else if (xmp) {
            subst = self.get('${XMP:XResolution}');
            if (!subst && self._resolution) {
              subst = self._resolution;
            }
          }
          break;
        case 'B':
          if (doc) {
            var bpc = doc.bitsPerChannel;
            if (bpc == BitsPerChannelType.ONE) {
              subst = "1";
            } else if (bpc == BitsPerChannelType.EIGHT) {
              subst = "8";
            } else if (bpc == BitsPerChannelType.SIXTEEN) {
              subst = "16";
            } else if (bpc == BitsPerChannelType.THIRTYTWO) {
              subst = "32";
            } else {
              Error.runtimeError(9001, "Bad bits per channel value");
            }
          } else if (xmp) {
            // BitDepth
            if (self._bitDepth) {
              subst = self._bitDepth;
            } else {
              var bpc = self.get("${XMP:BitsPerSample}");
              if (bpc) {
                var m = bpc.match(/d+/);
                if (m) {
                  subst = m[0];
                }
              } else  {
                subst = "8";  // just as a default
              }
            }
          }
          break;
        case 'I':
          if (doc || xmp) {
            var doFormat = true;
            if (ieTag.startsWith('-')) {
              doFormat = false;
              ieTag = ieTag.substring(1);
            }
            subst = self.get("${IPTC:" + ieTag + '}') || '';
            if (subst) {
              try {
                var itag = ieTag.toLowerCase();
                if (itag == "creationdate" && doFormat) {
                  var date = IPTC.DocumentInfoStringToDate(subst);
                  if (date) {
                    subst = self.formatDate(date, dateFormat);
                  }
                } else if (itag == "urgency") {
                  if (subst.toString().startsWith("Urgency.")) {
                    subst = Stdlib.urgencyString(subst);
                  }
                } else if (itag == "copyrighted") {
                  if (subst.toString().startsWith("CopyrightedType.")) {
                    subst = Stdlib.copyrightedString(subst);
                  }
                }
              } catch (e) {
              }
            }
          }
          break;
        case 'E':
          // md = new Metadata(doc); md.strf("%E{GPSLongitude}")
          if (doc || xmp) {
            var doFormat = true;
            if (ieTag.startsWith('-')) {
              doFormat = false;
              ieTag = ieTag.substring(1);
            }
            subst = self.get("${EXIF:" + ieTag + '}') || '';
            if (subst && doFormat) {
              if (ieTag.match(/date/i)) {
                var date = Stdlib.parseISODateString(subst);
                if (date) {
                  subst = self.formatDate(date, dateFormat);
                }
              } else if (ieTag.match(/gps/i)) {
                if (ieTag.match(/(longitude|latitude)/i)) {
                  subst = Stdlib.strfGPSstr(self.defaultGPSFormat, subst);
                }
              }
            }
          }
          break;
        case 'X':
          if (doc || xmp) {
            var doFormat = true;
            if (xmpTag && xmpTag.startsWith('-')) {
              doFormat = false;
              xmpTag = xmpTag.substring(1);
            }
            if (xTag && xTag.startsWith('-')) {
              doFormat = false;
              xTag = xTag.substring(1);
            }
            if (!xTag) {
              xTag = xmpSpace + ':' + xmpTag;
            }
            subst = self.get("${XMP:" + xTag + '}') || '';
            if (subst) {
              if (xTag.match(/date/i) && doFormat) {
                var date = Stdlib.parseISODateString(subst);
                if (date) {
                  subst = self.formatDate(date, dateFormat);
                }
              }
            }
          }
          break;
        case 'n':
          subst = '\n';
          break;
        case 't':
          subst = '\t';
          break;
        case ' ':
          subst = ' ';
          break;

        default:
          break;
      }
    }

    result += leftpart + subst;
    str = rightPart;
  }

  result += str;

  } catch (e) {
    Stdlib.logException(e);

  } finally {
    app.preferences = ru;
  }
  return result;
};

Metadata.strf = function(fmt, obj) {
  return new Metadata(obj).strf(fmt);
};

Metadata.test = function() {
  listProps = function(obj) {
    var s = '';
    for (var x in obj) {
      s += x + ":\t";
      try {
        var o = obj[x];
        s += (typeof o == "function") ? "[function]" : o;
      } catch (e) {
      }
      s += "\r\n";
    }
    return s;
  };

  var doc = app.activeDocument;
//   alert(new EXIF(doc).toString());
//   return;

  var md = new Metadata(doc);
  var tags = ["${EXIF:Exposure Time}",
              "${EXIF:GPS Latitude}",
              "${EXIF:ISO Speed Ratings}",
              "${IPTC:Author}"];
  var res = md.get(tags);

  alert(listProps(res));
};

//Metadata.test();

Metadata.mdTest = function() {
  var doc = app.activeDocument;
  var md = new Metadata(doc);

  var str1 = "%d %p %f %F %e %s"; 
  alert(md.strf(str1));

  var str2 = "%T{%y-%m-%d} %N{%D} %W %H %R %B"; 
  alert(md.strf(str2));

  var str3 = "%X{xap:CreateDate} %I{Author} %X{dc:format}";
  alert(md.strf(str3));
};

//md = new Metadata(doc.xmpMetadata.rawData)
//Metadata.mdTest();


"metadata.js";
// EOF

//
// XBridgeTalk.jsx
//
// $Id: XBridgeTalk.jsx,v 1.26 2008/11/18 18:03:09 anonymous Exp $
// Copyright: (c)2008, xbytor
// License: http://creativecommons.org/licenses/LGPL/2.1
// Contact: xbytor@gmail.com
//
//@show include
//
//

XBridgeTalk = function() {};

XBridgeTalk.ERROR_CODE = 9006;
XBridgeTalk.IO_ERROR_CODE = 9002;  // same as Stdlib.IO_ERROR_CODE

//
// XBridgeTalk._getSource
//   In CS2, the function 'toSource()' is broken for functions. The return
//   value includes the text of the function plus whatever else is left
//   in the file.
//   This function gets around the problem if you follow some conventions.
//   First, the function definition _must_NOT_ end with a ';'.
//   Second, the next line must contain '// EOF'
//   The result string can then be passed on to Bridge as needed.
//   ftn is the (variable) name of the function
//
XBridgeTalk._getSource = function(ftn) {
  if (XBridgeTalk.isCS2()) {
    var str = ftn.toSource();
    var len = str.indexOf("// EOF");
     return str.substring(0, len) + ')';
  }

  return ftn.toSource();
};

XBridgeTalk.hasBridge = function() {
  try {
    BridgeTalk;
    return true;

  } catch (e) {
    return false;
  }
};

XBridgeTalk.isCS2 = function() {
  var lvl = $.level;
  $.level = 0;
  try {
    BridgeTalk;
  } catch (e) {
    $.level = lvl;
    return false;
  }
  $.level = lvl;
  var appName = BridgeTalk.appName;
  var version = BridgeTalk.appVersion;
  
  if (appName == 'photoshop') {
    return version.match(/^9\./);
  }
  if (appName == 'bridge') {
    return version.match(/^1\./);
  }
  if (appName == 'estoolkit') {
    return version.match(/^1\./);
  }
  if (appName == 'indesign') {
    return version.match(/^4\./);
  }
  if (appName == 'golive') {
    return version.match(/^8\./);
  }
  if (appName == 'acrobat') {
    return version.match(/^7\./);
  }
  if (appName == 'helpcenter') {
    return version.match(/^1\./);
  }
  
  return false;
};

XBridgeTalk.isCS3 = function() {
  var lvl = $.level;
  $.level = 0;
  try {
    BridgeTalk;
  } catch (e) {
    $.level = lvl;
    return false;
  }
  $.level = lvl;
  var appName = BridgeTalk.appName;
  var version = BridgeTalk.appVersion;
  
  if (appName == 'photoshop') {
    return version.match(/^10\./);
  }
  if (appName == 'bridge') {
    return version.match(/^2\./);
  }
  if (appName == 'estoolkit') {
    return version.match(/^2\./);
  }
  if (appName == 'indesign') {
    return version.match(/^5\./);
  }
  if (appName == 'devicecentral') {
    return version.match(/^1\./);
  }
  return false;
};

XBridgeTalk.isCS4 = function() {
  var lvl = $.level;
  $.level = 0;
  try {
    BridgeTalk;
  } catch (e) {
    $.level = lvl;
    return false;
  }
  $.level = lvl;
  var appName = BridgeTalk.appName;
  var version = BridgeTalk.appVersion;
  
  if (appName == 'photoshop') {
    return version.match(/^11\./);
  }
  if (appName == 'bridge') {
    return version.match(/^3\./);
  }
  if (appName == 'estoolkit') {
    return version.match(/^3\./);
  }
  if (appName == 'indesign') {
    return version.match(/^6\./);
  }
  if (appName == 'devicecentral') {
    return version.match(/^1\./);
  }
  return false;
};


XBridgeTalk.log = function(msg) {
  var self = this;
  var file;

  function currentTime() {
    var date = new Date();
    var str = '';
    var timeDesignator = 'T';
    function _zeroPad(val) { return (val < 10) ? '0' + val : val; }
    str = (date.getFullYear() + '-' +
           _zeroPad(date.getMonth()+1,2) + '-' +
           _zeroPad(date.getDate(),2));
    str += (timeDesignator +
            _zeroPad(date.getHours(),2) + ':' +
            _zeroPad(date.getMinutes(),2) + ':' +
            _zeroPad(date.getSeconds(),2));
    return str;
  };

  msg = currentTime() + " - " + msg;

  if (!self.log.enabled) {
    return;
  }
  if (!self.log.filename) {
    return;
  }

  if (!self.log.fptr) {
    file = new File(self.log.filename);
    if (!file.open("e"))  {
      Error.runtimeError(XBridgeTalk.IO_ERROR_CODE,
                         "Unable to open log file(1) " +
                         file + ": " + file.error);
    }

    if (self.log.append) {
      file.seek(0, 2); // jump to the end of the file

    } else {
      file.close();
      file.length = 0;
      file.open("w");
    }

    self.log.fptr = file;

  } else {

    file = self.log.fptr;
    if (!file.open("e"))  {
      Error.runtimeError(XBridgeTalk.IO_ERROR_CODE,
                         "Unable to open log file(2) " +
                         file + ": " + file.error);
    }
    file.seek(0, 2); // jump to the end of the file
  }

  if (!$.os.match(/windows/i)) {
    file.lineFeed = "unix";
  }

  if (self.log.encoding) {
    file.encoding = self.log.encoding;
  }
  
  if (!file.writeln(msg)) {
    Error.runtimeError(XBridgeTalk.IO_ERROR_CODE,
                       "Unable to write to log file(3) " +
                       file + ": " + file.error);
  }
  
  file.close();
};
XBridgeTalk.exceptionMessage = function(e) {
  var str = '';
  var fname = (!e.fileName ? '???' : decodeURI(e.fileName));
  str += "   Message: " + e.message + '\n';
  str += "   File: " + fname + '\n';
  str += "   Line: " + (e.line || '???') + '\n';
  str += "   Error Name: " + e.name + '\n';
  str += "   Error Number: " + e.number + '\n';

  if (e.source) {
    var srcArray = e.source.split("\n");
    var a = e.line - 10;
    var b = e.line + 10;
    var c = e.line - 1;
    if (a < 0) {
      a = 0;
    }
    if (b > srcArray.length) {
      b = srcArray.length;
    }
    for ( var i = a; i < b; i++ ) {
      if ( i == c ) {
        str += "   Line: (" + (i + 1) + ") >> " + srcArray[i] + '\n';
      } else {
        str += "   Line: (" + (i + 1) + ")    " + srcArray[i] + '\n';
      }
    }
  }

  if ($.stack) {
    str += '\n' + $.stack + '\n';
  }

  return str;
};
XBridgeTalk._getPreferencesFolder = function() {
  var appData = Folder.userData;

  var folder = new Folder(appData + "/xtools");

  if (!folder.exists) {
    folder.create();
  }

  return folder;
};

XBridgeTalk.log.filename = (XBridgeTalk._getPreferencesFolder() +
                            "/xbridge.log");
XBridgeTalk.log.enabled = false;
XBridgeTalk.log.append = false;
XBridgeTalk.log.setFile = function(file, encoding) {
  XBridgeTalk.log.filename = filename;
  XBridgeTalk.log.enabled = filename != undefined;
  XBridgeTalk.log.encoding = encoding;
};

XBridgeTalk.getAppSpecifier = function(appName) {
  var rev = undefined;

//   $.level = 1; debugger;

  if (XBridgeTalk.isCS2()) {
    if (appName == 'photoshop') {
        rev = '9';
    }
    if (appName == 'bridge') {
        rev = '1';
    }
    if (appName == 'estoolkit') {
        rev = '1';
    }
    if (appName == 'golive') {
        rev = '8';
    }
    if (appName == 'acrobat') {
        rev = '7';
    }
    if (appName == 'helpcenter') {
        rev = '1';
    }
    // add other apps here
  }
  
  if (XBridgeTalk.isCS3()) {
    if (appName == 'photoshop') {
        rev = '10';
    }
    if (appName == 'bridge') {
        rev = '2';
    }
    if (appName == 'estoolkit') {
        rev = '2';
    }
    // add other apps here
  }

  if (XBridgeTalk.isCS4()) {
    if (appName == 'photoshop') {
        rev = '11';
    }
    if (appName == 'bridge') {
        rev = '3';
    }
    if (appName == 'estoolkit') {
        rev = '3';
    }
    // add other apps here
  }

  return (rev ? (appName + '-' + rev) : undefined);

//   if (!prefix) {
//     return undefined;
//   }

//   var targets = BridgeTalk.getTargets(null);

//   var appSpec = undefined;
//   var rex = new RegExp('^' + prefix);

//   // find the most recent minor version
//   for (var i = 0; i < targets.length; i++) {
//     var spec = targets[i];
//     if (spec.match(rex)) {
//       appSpec = spec;
//     }
//   }
//   return appSpec;
};

XBridgeTalk.splitSpecifier = function(appSpec) {
  var rex = /([a-z]+)(_\d+)?(?:-([\d\.]+)(-[a-z]{2}_[a-z]{2})?)?/;
  var str = appSpec.toString();
  var m = str.match(rex);
  // m[1] name (required)
  // m[2] instance (opt)
  // m[3] version (opt)
  // m[4] locale (opt)
  if (!m) {
    return undefined;
  }
  var spec = {};
  spec.name = m[1];
  if (m[2]) {
    spec.instance = m[2].substr(1);
  }
  if (m[3]) {
    spec.version = m[3];
    var v = spec.version.split('.');
    spec.majorVersion = v[0];
    spec.minorVersion = (v[1] != undefined) ? v[1] : "0";
  }
  if (m[4]) {
    spec.locale = m[4].substr(1);
  }

  function specAsString() {
    var self = this;
    var str = self.name;
    if (self.instance) {
      str += '_' + self.instance;
    }
    if (self.version) {
      str += '-' + self.version;
    }
    if (self.locale) {
      str += '-' + self.locale;
    }

    return str;
  }

  spec.toString = specAsString;

  return spec;
};

XBridgeTalk.runSpecTest = function() {
  var specTest = ["photoshop",
                  "bridge-2.0",
                  "indesign_1-5.0",
                  "illustrator-13.0",
                  "illustrator-13.0-de_de",
                  ];
  var str = '';
  for (var i = 0; i < specTest.length; i++) {
    str += XBridgeTalk.splitSpecifier(specTest[i]) + '\r\n';
  }
  return str;
};


XBridgeTalk.START_DELAY = 1000;           // 2 seconds
XBridgeTalk.START_TIMEOUT = 1000 * 120;   // 2 minutes

XBridgeTalk.DEFAULT_TIMEOUT = 10;  // seconds

XBridgeTalk.ping = function(appSpec, timeout) {
  if (timeout == undefined) {
    timeout = XBridgeTalk.DEFAULT_TIMEOUT;
  }
  var bt = new BridgeTalk();
  bt.target = appSpec;	
  bt.body = "var t = \'" + appSpec + "\';";
  bt.onResult = function(btObj) {
    return true;
  }
  return bt.sendSync(timeout);
};

XBridgeTalk.isRunning = function(appSpec) {
  var ok = false;

  var spec = XBridgeTalk.splitSpecifier(appSpec);
  var name = spec.name;

  spec = XBridgeTalk.getAppSpecifier(name);

  if (BridgeTalk.isRunning(spec)) {
    try {
      if (XBridgeTalk.ping(spec)) {
        ok = true;
      }

    } catch (e) {
      XBridgeTalk.log(XBridgeTalk.exceptionMessage(e));
    }

    if (!ok) {
      Error.runtimeError(XBridgeTalk.IO_ERROR_CODE,
                         "Unable to communicate with " + appSpec);
    }
  } else {
    if (BridgeTalk.isRunning(name)) {
      Error.runtimeError(XBridgeTalk.IO_ERROR_CODE,
                         "Unable to communicate with " + spec +
                         ". Possible wrong version running.");
    }
  }

  return ok;
};

XBridgeTalk.startApplication = function(appSpec) {
  XBridgeTalk.log("XBridgeTalk.startApplication(" + appSpec + ")");

  if (!appSpec) {
    Error.runtimeError(19, "appSpec");
  }
  var spec = XBridgeTalk.splitSpecifier(appSpec);
  if (!spec) {
    Error.runtimeError(19, appSpec);
  }

  var appSpec = spec.toString();
  if (!XBridgeTalk.isApplicationInstalled(appSpec)) {
    Error.runtimeError(56, appSpec);
  }

  var appName = spec.name;

  if (BridgeTalk.isRunning(appSpec)) {
    var ok = false;
    try {
      if (XBridgeTalk.ping(appSpec)) {
        ok = true;
      }

    } catch (e) {
      XBridgeTalk.log(XBridgeTalk.exceptionMessage(e));
    }

    if (!ok) {
      Error.runtimeError(XBridgeTalk.IO_ERROR_CODE,
                         "Unable to communicate with " + appSpec +
                         ". Possible wrong version running.");
    }
  }

  if (!BridgeTalk.isRunning(appSpec)) {
    XBridgeTalk.log("Launching " + appSpec);
    BridgeTalk.launch(appSpec);

    var cnt = 0;
    while (!BridgeTalk.isRunning(appSpec)) {
      $.sleep(XBridgeTalk.START_DELAY);

      if ((++cnt) * XBridgeTalk.START_DELAY >= XBridgeTalk.START_TIMEOUT) {
        XBridgeTalk.log(appSpec + " failed to launch(1)");
        return false;
      }
    }

    var cnt = 0;
    var startProp = "start" + appName;
    XBridgeTalk[startProp] = false;
    var startupComplete = false;
    
    while (!XBridgeTalk[startProp]) {
      
      // fix this block
      var bt = new BridgeTalk();
      bt.target = appSpec;
      bt.body = "var t = \'" + appSpec + "\';";
      bt.onResult = function(btObj) {
        var str = ('XBridgeTalk.start' + appName + ' = true;');
        eval(str);
      }

      bt.send();
      $.sleep(XBridgeTalk.START_DELAY);
      BridgeTalk.pump();
      if ((++cnt) * XBridgeTalk.START_DELAY >= XBridgeTalk.START_TIMEOUT) {
        delete XBridgeTalk[startProp];
        XBridgeTalk.log(appSpec + " failed to launch(2)");
        return false;
      }
    }
    delete XBridgeTalk[startProp];
  }

  return true;
};

XBridgeTalk.isApplicationInstalled = function(appSpec) {
  var apps = BridgeTalk.getTargets(null);
  for (var i = 0; i < apps.length; i++) {
    if (apps[i].startsWith(appSpec)) {
      return true;
    }
  }
  return false;
};

XBridgeTalk.getBridgeSelection = function(timeout) {
  if (timeout == undefined) {
    timeout = XBridgeTalk.DEFAULT_TIMEOUT;
  }
  
  function getBridgeFiles() {
    var v = app.document.selections;
    var files = [];
    for (var i = 0; i < v.length; i++) {
      var t = v[i];
      if (t != undefined) { files[i] = t.spec; }
    }
    return files.toSource();
  }
  // EOF

  var src = XBridgeTalk._getSource(getBridgeFiles);

  var brCode = ("function _run(files) {\n" +
                "  var getBridgeFiles = " + src +
                ";\n\n" +
                "  return getBridgeFiles();\n" +
                "};\n" +
                "_run();\n");

  XBridgeTalk.log("XBridgeTalk.getBridgeSelection()");

//   var _dbg = "try {\n" + brCode + "} catch (e) {\nalert(e)\n}";
//   brCode = _dbg;

  var br = XBridgeTalk.getAppSpecifier("bridge");
  if (!XBridgeTalk.isRunning(br)) {
    XBridgeTalk.log("Bridge is not running.");
    return undefined;
  }
  var bt = new BridgeTalk();
  bt.target = br;
  bt.body = brCode;
  var str = bt.sendSync(timeout);
  var res = str ? eval(str) : [];
  XBridgeTalk.log(res);

  return res;
};


//
//XBridgeTalk.getMetadata(File("/c/tmp/207.jpg"))
//
XBridgeTalk.getMetadata = function(files, timeout) {
  // $.level = 1; debugger;

  if (!timeout) {
    timeout = XBridgeTalk.DEFAULT_TIMEOUT;
  }

  if (XBridgeTalk.isCS2()) {
    Error.runtimeError(XBridgeTalk.ERROR_CODE,
                       "XBridgeTalk.getMetadata does not work in CS2");
  }

  var isFile = false;
  if (!(files instanceof Array)) {
    if (!(files instanceof File)) {
      Error.runtimeError(19, files);
    }
    files = [files];
    isFile = true;
  }

  function getMetadata(files) {
    var mds = [];
    for (var i = 0; i < files.length; i++) {
      var t = new Thumbnail(files[i]);
      mds.push(t.synchronousMetadata.serialize());
    }
    return mds.toSource();
  }
  // EOF

  var src = getMetadata.toSource();

  var brCode = ("function _run(files) {\n" +
                 "  var getMetadata = " + src + ";\n\n" +
                 "  return getMetadata(files);\n" +
                "};\n" +
                "_run(" + files.toSource() + ");\n");

  XBridgeTalk.log("XBridgeTalk.getMetadata()");

  var br = XBridgeTalk.getAppSpecifier("bridge");
  if (!XBridgeTalk.isRunning(br)) {
    XBridgeTalk.log("Bridge is not running.");
    return undefined;
  }
  var bt = new BridgeTalk();
  bt.target = br;
  bt.body = brCode;
  var str = bt.sendSync(timeout);
  var res = (str ? eval(str) : '');

  XBridgeTalk.log(res);

  return ((isFile && res && res.length == 1) ? res[0] : res);
};

//
//XBridgeTalk.getBitDepth(File("/c/tmp/207.jpg"))
//XBridgeTalk.getBitDepth(doc.fullName);
//
XBridgeTalk.getBitDepth = function(files, timeout) {
  if (!timeout) {
    timeout = XBridgeTalk.DEFAULT_TIMEOUT;
  }

  if (XBridgeTalk.isCS2()) {
    Error.runtimeError(XBridgeTalk.ERROR_CODE,
                       "XBridgeTalk.getMetadata does not work in CS2");
  }

  var isFile = false;
  if (!(files instanceof Array)) {
    if (!(files instanceof File)) {
      Error.runtimeError(19, files);
    }
    files = [files];
    isFile = true;
  }

  function getBitDepth(files) {
    var bds = [];
    for (var i = 0; i < files.length; i++) {
      var t = new Thumbnail(files[i]);
      app.synchronousMode = true;
      t.core.preview.preview;
      app.synchronousMode = false;
      bds.push(t.core.quickMetadata.bitDepth);
    }

    return (bds.length == 1) ? bds[0] : bds.toSource();
  }

  var brCode = ("function _run(files) {\n" +
                 "  var getBitDepth = " + getBitDepth.toSource() + ";\n\n" +
                 "  return getBitDepth(files);\n" +
                "};\n" +
                "_run(" + files.toSource() + ");\n");

  XBridgeTalk.log("XBridgeTalk.getBitDepth()");

  var br = XBridgeTalk.getAppSpecifier("bridge");
  if (!XBridgeTalk.isRunning(br)) {
    XBridgeTalk.log("Bridge is not running.");
    return undefined;
  }
  var bt = new BridgeTalk();
  bt.target = br;
  bt.body = brCode;
  var str = bt.sendSync(timeout);
  var res = (str ? eval(str) : '');

  XBridgeTalk.log(res);

  return ((isFile && res && res.length == 1) ? res[0] : res);
};

//
//XBridgeTalk.getKeywords(File("/c/tmp/207.jpg"))
//
XBridgeTalk.getKeywords = function(files, timeout) {
  if (!timeout) {
    timeout = XBridgeTalk.DEFAULT_TIMEOUT;
  }

  var isFile = false;
  if (!(files instanceof Array)) {
    if (!(files instanceof File)) {
      Error.runtimeError(19, files);
    }
    files = [files];
    isFile = true;
  }

  function getKeywordsBR(files) {
    function _getKeywords(md) {
      var kwds = [];
      var ns = md.namespace;
      md.namespace = 'http://ns.adobe.com/photoshop/1.0/';
      try {
        for (var i = 0; i < md.Keywords.length; ++i) {
          kwds.push(md.Keywords[i]);
        }
      } finally {
        md.namespace = ns;
      }
      return kwds;
    }
    try {
      var res = [];

      for (var i = 0; i < files.length; i++) {
        var file = files[i];
        var th = new Thumbnail(file);
        var md = th.synchronousMetadata;
        var kwds = _getKeywords(md);
        var obj = {
          filename: file.absoluteURI,
          keywords: kwds
        };
        res.push(obj);
      }

      return res.toSource();

    } catch (e) {
      alert("Internal error (getKeywordsBR): " + e);
      return [];
    }
  };

  function getKeywordsBR(files) {
    function _getKeywords(md) {
      var kwds = [];
      var ns = md.namespace;
      md.namespace = 'http://ns.adobe.com/photoshop/1.0/';
      try {
        for (var i = 0; i < md.Keywords.length; ++i) {
          kwds.push(md.Keywords[i]);
        }
      } finally {
        md.namespace = ns;
      }
      return kwds;
    }
    try {
      var res = [];
      for (var i = 0; i < files.length; i++) {
        var file = files[i];
        var th = new Thumbnail(file);
        var md = th.synchronousMetadata;
        var kwds = _getKeywords(md);
        var obj = {
          filename: file.absoluteURI,
          keywords: kwds
        };
        res.push(obj);
      }

      return res.toSource();

    } catch (e) {
      alert("Internal error (getKeywordsBR): " + e);
      return [];
    }
  }
  // EOF

  var src = XBridgeTalk._getSource(getKeywordsBR);

  var brCode = ("function _run(files) {\n" +
                "  var getKeywordsBR = " + src +  ";\n\n" +
                "  return getKeywordsBR(files);\n" +
                "};\n" +
                "_run(" + files.toSource() + ");\n");

  var _dbg = ("$.writeln('parse OK'); try {\n" + brCode + "} " +
              "catch (e) {\nalert(e)\n}");

  // brCode = _dbg;

  XBridgeTalk.log("XBridgeTalk.getKeywords(" + files + ", " + timeout + ")");

  var br = XBridgeTalk.getAppSpecifier("bridge");
  if (!XBridgeTalk.isRunning(br)) {
    XBridgeTalk.log("Bridge is not running.");
    return undefined;
  }

  var bt = new BridgeTalk();
  bt.target = br;
  bt.body = brCode;
  var str = bt.sendSync(timeout);

  var res = (str ? eval(str) : []);

  XBridgeTalk.log("XBridgeTalk.getKeywords => " + res);

  return ((isFile && res && res.length == 1) ? res[0].keywords : res);
};

//
//XBridgeTalk.getMetadataValue(File("/c/tmp/207.jpg"),"photoshop:City");
//
XBridgeTalk.getMetadataValue = function(files, name, timeout) {
  if (!timeout) {
    timeout = XBridgeTalk.DEFAULT_TIMEOUT;
  }

  var isFile = false;

  if (!(files instanceof Array)) {
    if (!(files instanceof File)) {
      Error.runtimeError(19, files);
    }
    files = [files];
    isFile = true;
  }

  //
  // the bs bs in the setMetadata function has to do with the fact
  // that getting \ characters correctly to Bridge via BridgeTalk
  // is busted. RegExp literals appear to be busted, too.
  //
  function getMetadata(files, cname) {
    var res = [];
    try {
      var bs = '\\'.charCodeAt(0);
      var bsCh = String.fromCharCode(bs);
      var rexStr = "^(.*" + bsCh + "/)([^" + bsCh + "/]+)$";
      var rex = RegExp(rexStr);
      var m = cname.match(rex);
      var ns = m[1];
      var pname = m[2];
      for (var i = 0; i < files.length; i++) {
        var th = new Thumbnail(files[i]);
        var md = th.synchronousMetadata;
        md.namespace = ns;
        res.push(md[pname]);
      }
    } catch (e) {
      alert(e);
    }
    return res.toSource();
  }
  // EOF

  var src = XBridgeTalk._getSource(getMetadata);

  var cname = XMPNameSpaces.getCanonicalName(name);
  if (!cname) {
    Error.runtimeError(XBridgeTalk.ERROR_CODE,
                       "Invalid metadata name: " + name);
  }

  var brCode = ("function _run(files, name, value) {\n" +
                "  var getMetadata = " + src + ";\n\n" +
                "  return getMetadata(files, name);\n" +
                "};\n" +
                "_run(" + files.toSource() + ", " + cname.toSource() + ");\n");

  var _dbg = ("$.writeln('parse OK'); try {\n" + brCode + "} " +
              "catch (e) {\nalert(e)\n}");
//   brCode = _dbg;

  XBridgeTalk.log("XBridgeTalk.getMetadata()");

  var br = XBridgeTalk.getAppSpecifier("bridge");
  if (!XBridgeTalk.isRunning(br)) {
    XBridgeTalk.log("Bridge is not running.");
    return undefined;
  }
  var bt = new BridgeTalk();
  bt.target = br;
  bt.body = brCode;
  var str = bt.sendSync(timeout);
  var res = (str ? eval(str) : '');

  XBridgeTalk.log(res);

  return ((isFile && res && res.length == 1) ? res[0] : res);
};

//
//XBridgeTalk.setMetadataValue(File("/c/tmp/207.jpg"),"photoshop:City","NYC");
//
XBridgeTalk.setMetadataValue = function(files, name, value, timeout) {
  if (!timeout) {
    timeout = XBridgeTalk.DEFAULT_TIMEOUT;
  }

  if (!(files instanceof Array)) {
    if (!(files instanceof File)) {
      Error.runtimeError(19, files);
    }
    files = [files];
  }

  //
  // the bs bs in the setMetadata function has to do with the fact
  // that getting \ characters correctly to Bridge via BridgeTalk
  // is busted. RegExp literals appear to be busted, too.
  //
  function setMetadata(files, cname, value) {
    var rc = false;
    try {
      var bs = '\\'.charCodeAt(0);
      var bsCh = String.fromCharCode(bs);
      var rexStr = "^(.*" + bsCh + "/)([^" + bsCh + "/]+)$";
      var rex = RegExp(rexStr);
      var m = cname.match(rex);
      var ns = m[1];
      var pname = m[2];
      for (var i = 0; i < files.length; i++) {
        var th = new Thumbnail(files[i]);
        var md = th.synchronousMetadata;
        md.namespace = ns;
        md[pname] = value.toString();
      }
      rc = true;
    } catch (e) {
      alert(e);
    }
    return rc;
  }
  // EOF

  var src = XBridgeTalk._getSource(setMetadata);

  var cname = XMPNameSpaces.getCanonicalName(name);
  if (!cname) {
    Error.runtimeError(XBridgeTalk.ERROR_CODE,
                       "Invalid metadata name: " + name);
  }

  var brCode = ("function _run(files, name, value) {\n" +
                "  var setMetadata = " + src + ";\n\n" +
                "  return setMetadata(files, name, value);\n" +
                "};\n" +
                "_run(" + files.toSource() + ", " + cname.toSource() +
                ", " + value.toSource() + ");\n");

  var _dbg = ("$.writeln('parse OK'); try {\n" + brCode + "} " +
              "catch (e) {\nalert(e)\n}");
//   brCode = _dbg;

  XBridgeTalk.log("XBridgeTalk.setMetadata()");

  var br = XBridgeTalk.getAppSpecifier("bridge");
  if (!XBridgeTalk.isRunning(br)) {
    XBridgeTalk.log("Bridge is not running.");
    return undefined;
  }
  var bt = new BridgeTalk();
  bt.target = br;
  bt.body = brCode;
  var str = bt.sendSync(timeout);
  var res = (str ? eval(str) : '');

  XBridgeTalk.log(res);

  return res;
};

//
// var obj = {};
// obj["photoshop:City"] = "NYC";
// obj["iptcCore:Provider"] = "XBytor";
//
//XBridgeTalk.setMetadataValues(File("/c/tmp/207.jpg"), obj);
//
XBridgeTalk.setMetadataValues = function(files, nvPairs, timeout) {
  if (!timeout) {
    timeout = XBridgeTalk.DEFAULT_TIMEOUT;
  }

  if (!(files instanceof Array)) {
    if (!(files instanceof File)) { 
      Error.runtimeError(19, files);
    }
    files = [files];
  }

  //
  // the bs bs in the setMetadata function has to do with the fact
  // that getting \ characters correctly to Bridge via BridgeTalk
  // is busted. RegExp literals appear to be busted, too.
  //
  // nvPairs is an object that looks like
  // { 'http://ns.adobe.com/camera-raw-settings/1.0/HasSettings': 'True' }
  //
  function setMetadata(files, nvPairs) {
    var rc = false;
    try {
      var bs = '\\'.charCodeAt(0);
      var bsCh = String.fromCharCode(bs);
      var rexStr = "^(.*" + bsCh + "/)([^" + bsCh + "/]+)$";
      var rex = RegExp(rexStr);

      var thumbs = [];
      for (var i = 0; i < files.length; i++) {
        var th = new Thumbnail(files[i]);
        thumbs.push(th);
      }

      for (var i = 0; i < files.length; i++) {
        var th = thumbs[i];
        var md = th.synchronousMetadata;

        for (var cname in nvPairs) {
          var value = nvPairs[cname];

          var m = cname.match(rex);
          var ns = m[1];
          var pname = m[2];
          
          md.namespace = ns;
          md[pname] = value.toString();
        }
      }

      for (var i = 0; i < files.length; i++) {
        var th = new Thumbnail(files[i]);
        th.core.metadata.cacheData.status = "bad";
        th.refresh("metadata");
        th.core.cameraRaw.cacheData.status = "bad";
        th.refresh("cameraRaw");
      }

      rc = true;
    } catch (e) {
      alert(e);
    }
    return rc;
  }
  // EOF

  var src = XBridgeTalk._getSource(setMetadata);

  var mdObj = {};
  for (var name in nvPairs) {
    var cname = XMPNameSpaces.getCanonicalName(name);
    if (!cname) {
      Error.runtimeError(XBridgeTalk.ERROR_CODE,
                         "Invalid metadata name: " + name);
    }

    mdObj[cname] = nvPairs[name];
  }

  var brCode = ("function _run(files, name, value) {\n" +
                "  var setMetadata = " + src + ";\n\n" +
                "  return setMetadata(files, name, value);\n" +
                "};\n" +
                "_run(" + files.toSource() + ", " + mdObj.toSource() + ");\n");

  var _dbg = ("$.writeln('parse OK'); try {\n" + brCode + "} " +
              "catch (e) {\nalert(e)\n}");
//   brCode = _dbg;

  XBridgeTalk.log("XBridgeTalk.setMetadata()");

  var br = XBridgeTalk.getAppSpecifier("bridge");
  if (!XBridgeTalk.isRunning(br)) {
    XBridgeTalk.log("Bridge is not running.");
    return undefined;
  }
  var bt = new BridgeTalk();
  bt.target = br;
  bt.body = brCode;
  var str = bt.sendSync(timeout);
  var res = (str ? eval(str) : '');

  XBridgeTalk.log(res);

  return res;
};

//
//XBridgeTalk.chooseMenuItem("CRClear", File("/c/tmp/207.jpg"))
//
XBridgeTalk.chooseMenuItem = function(menuItem, files, timeout) {
  if (!timeout) {
    timeout = XBridgeTalk.DEFAULT_TIMEOUT;
  }

  if (!(files instanceof Array)) {
    if (!(files instanceof File)) {
      Error.runtimeError(19, files);
    }
    files = [files];
  }

  function applyMenuItem(menuItem, files) {
    try {
      /* we only want to select the files we want to operate on */
      app.document.deselectAll();

      for (var i = 0; i < files.length; i++) {
        var th = new Thumbnail(files[i]);

        app.document.select(th);
      }

      /* now choose the menu item for all of the selected files */
      app.document.chooseMenuItem(menuItem);

    } catch (e) {
      alert(e + '@' + e.line);
    }

    return true;
  }
  // EOF

  var src = applyMenuItem.toSource();

  var brCode = ("function _run(menuItem, files) {\n" +
                "  var applyMenuItem = " + src + ";\n\n" +
                "  return applyMenuItem(menuItem, files);\n" +
                "};\n" +
                "_run(\"" + menuItem + "\", " + files.toSource() + ");\n");

  XBridgeTalk.log("XBridgeTalk.applyMenuItem()");

  var br = XBridgeTalk.getAppSpecifier("bridge");
  if (!XBridgeTalk.isRunning(br)) {
    XBridgeTalk.log("Bridge is not running.");
    return undefined;
  }
  var bt = new BridgeTalk();
  bt.target = br;
  bt.body = brCode;
  var str = bt.sendSync(timeout);
  var res = (str ? eval(str) : '');

  XBridgeTalk.log(res);

  return res;
};

XBridgeTalk._init = function() {
  if (!XBridgeTalk.hasBridge()) {
    Error.runtimeError(XBridgeTalk.ERROR_CODE,
                       "This application does not support Bridge");
  }

  BridgeTalk.prototype.sendSync = function(timeout) {
    XBridgeTalk.log("BridgeTalk.sendSync(" + timeout + ")");

    var self = this;

    //if (isCS3() || isCS4) {
    //  return this.send(timeout);
    //}
    
    self.onResult = function(res) {
      this.result = res.body;
      this.complete = true;
    }
    self.complete = false;
    self.result = undefined;

    self.send();
    
    // ??? fix this so that its a doubling decay timeout
    if (timeout) {
      for (var i = 0; i < timeout; i++) {
        BridgeTalk.pump();       // process any outstanding messages
        if (!self.complete) {
          $.sleep(1000);
        } else {
          break;
        }
      }
    }
    
    var res = self.result;
    self.result = self.complete = self.onResult = undefined;

    XBridgeTalk.log("BridgeTalk.sendSync => " + res);
    
    return res;
  };
  
  BridgeTalk.prototype.sendSynch = BridgeTalk.prototype.sendSync;
};
XBridgeTalk._init();

XBridgeTalk.test = function() {
  var br = XBridgeTalk.getAppSpecifier("bridge");
  if (!br) {
    alert("Bridge not installed");
    return;
  }
  if (!XBridgeTalk.isRunning(br)) {
    alert("Bridge is not running. Starting now...");
    if (!XBridgeTalk.startApplication(br)) {
      alert("Failed to launch " + br);
      return;
    }
    alert("Bridge started");
  }

  var bt = new BridgeTalk();
  bt.target = br;
  bt.body = "new Date().toString()";
  var res = bt.sendSync(10);
  alert(res);

  alert(XBridgeTalk.getBridgeSelection());

  //XBridgeTalk.getMetadata(File("/c/tmp/207.jpg"))
  //XBridgeTalk.getBitDepth(File("/c/tmp/207.jpg"))
  //XBridgeTalk.getBitDepth(doc.fullName);
  //XBridgeTalk.getKeywords(File("/c/tmp/207.jpg"))
  //XBridgeTalk.setMetadataValue(File("/c/tmp/207.jpg"),"photoshop:City","NYC");

  // obj = {};
  // obj["photoshop:City"] = "Antwerp";
  // obj["iptcCore:Provider"] = "XBytor";
  // XBridgeTalk.setMetadataValues(File("/c/tmp/207.jpg"), obj);
};

//XBridgeTalk.test();

"xbridge.jsx";
// EOF


//
// XProperty.jsx
//
//
// $Id: XProperty.jsx,v 1.13 2008/08/20 15:30:13 anonymous Exp $
// Copyright: (c)2006, xbytor
// License: http://creativecommons.org/licenses/LGPL/2.1
// Contact: xbytor@gmail.com
//
//@show include
//
//
//

//================================ XProperty =================================

XProperty = function(prop, defValue, typeInfo, helpTip) {
  var self = this;

  self.setInfo(prop, defValue, typeInfo, helpTip);
};
XProperty.prototype.typename = "XProperty";

XProperty.ALERT_ON_ERRORS = false;

XProperty.prototype.psConstants = false;

XProperty._init = function() {
  var lvl = $.level;
  $.level = 0;
  try {
    PSConstants;
    XProperty.prototype.psConstants = true;
  } catch (e) {
  } finally {
    $.level = lvl;
  }
};
XProperty._init();

XProperty.prototype.setInfo = function(propInfo, defValue, typeInfo, helpTip) {
  var self = this;

  // $.level = 1; debugger;

  self.name = propInfo.name;
  self.sym = propInfo.sym;
  self.id = xTID(propInfo.sym);

  self.type = typeInfo;

  self.helpTip = helpTip;

  if (self.psConstants) {
    PSString._add(self.name, self.sym);
  }
};
XProperty.prototype.toString = function() {
  return "[XProperty " + this.name + "]";
};

//============================== XPropertyTable ===============================

XPropertyTable = function(props) {
  this.table = {};

  if (props) {
    this.loadTableResource(props);
  }
};
XPropertyTable.prototype.typename = "XPropertyTable";

//
// Add a property definition to this table
//
XPropertyTable.prototype.add = function(prop) {
  var self = this;

  self.table[prop.name] = prop;
  self.table[prop.id] = prop;
  prop.parent = self;
};

//
// Insert the key/val pair into the descriptor as
// an untyped (String) property

XPropertyTable.insertProperty = function(desc, id, val) {
  var pdesc = new ActionDescriptor();
  pdesc.putString(cTID('Nm  '), id);
  pdesc.putString(cTID('Vl  '), (val ? val.toString() : ''));
  desc.putObject(xTID(id), cTID('Prpr'), pdesc);
};

XPropertyTable.prototype.toDescriptor = function(obj, desc) {
  var self = this;
  var table = self.table;

  //  $.level = 1; debugger;

  if (!desc) {
    desc = new ActionDescriptor();
  }
   
  for (var idx in obj) {
    if (idx.charAt(0) == '_') {
      continue;
    }

    var val = obj[idx]
    if (typeof(val) == "function") {
      continue;
    }

    var typ = table[idx];

    if (typ) {
      if (val == undefined) {
        var msg = ("XPropertyTable.toDescriptor()->" +
                   "undefined value for attribute: " + id2char(typ.id));
        Stdlib.log(msg);
        if (XProperty.ALERT_ON_ERRORS) {
          alert(msg);
        }
        continue;
      }

      typ.type.write(desc, typ.id, val);

    } else {

      if (val == undefined) {
        var msg = ("XPropertyTable.toDescriptor()->" +
                   "undefined value for property: " + idx);
        Stdlib.log(msg);
        if (XProperty.ALERT_ON_ERRORS) {
          alert(msg);
        }
        continue;
      }

      XPropertyTable.insertProperty(desc, idx, val);
    }
  }
  return desc;
};


XPropertyTable.prototype.fromDescriptor = function(desc, obj) {
  var self = this;
  var table = self.table;

  //$.level = 1; debugger;

  if (!obj) {
    obj = {};
  }
  var cnt = desc.count;
    
  for (var i = 0; i < cnt; i++) {
    var key = desc.getKey(i);
    var typ = table[key];
    if (typ) {
      var v = typ.type.read(desc, typ.id);
      obj[typ.name] = v;
    } else {
      if (desc.getType(key) == DescValueType.OBJECTTYPE && 
          desc.getObjectType(key) == cTID('Prpr')) {
        var odesc = desc.getObjectValue(key);
        var okey = odesc.getString(cTID('Nm  '));
        var oval = odesc.getString(cTID('Vl  '));
        obj[okey] = oval;

      } else {
        alert("Unknown property: " + id2char(key));
      }
    }
  }
  return obj;
};

XPropertyTable.prototype.asString = function(obj) {
  var self = this;
  var table = self.table;

  //  $.level = 1; debugger;

  var str = '';
  for (var idx in obj) {
    if (idx.charAt(0) == '_') {
      continue;
    }
    if (idx == "typename") {
      continue;
    }
    var val = obj[idx];
    if (typeof(val) == "function") {
      continue;
    }
    str += (idx + ": ");

    var typ = table[idx];
    if (typ) {
      str += typ.type.asString(val);
    } else {
      str += val;
    }
    str += '\n';
  }
  return str;
};
XPropertyTable.prototype.fromString = function(str, obj) {
  var self = this;

  // $.level = 1; debugger;

  // split it up like a normal INI string
  var xobj = XPropertyTable.fromIniString(str);

  return self.rationalize(xobj, obj);
};

XPropertyTable.prototype.rationalize = function(xobj, obj) {
  var self = this;
  var table = self.table;

  if (obj == undefined) {
    obj = {};
  }

  for (var idx in xobj) {
    if (idx.charAt(0) == '_') {
      continue;
    }
    if (idx == "typename") {
      continue;
    }
    var val = xobj[idx];
    if (typeof(val) == "function") {
      continue;
    }

    var typ = table[idx];
    if (typ) {
      try {
        val = typ.type.fromString(val);

      } catch (e) {
        alert(e + '@' + e.line + "\n" + idx + ": " + val);
      }
    }

    obj[idx] = val;
  }

  return obj;
};

XPropertyTable.prototype.loadTableResource = function(props) {
  var self = this;

  for (var i = 0; i < props.length; i++) {
    var propDef = props[i];
    var prop = new XProperty(propDef.prop,
                             propDef.defValue,
                             propDef.typeInfo,
                             propDef.helpTip);
    self.add(prop);
  }
};

//========================== XPropertyTableResource ==========================


//=================================== XOpt ===================================

XOpt = function() {};

//================================ XOpt.Type =================================

XOpt.Type = function(descType, typename) {
  var self = this;
  self.type = descType;
  self.typename = typename;
};
XOpt.Type.prototype.typename = "XOpt.Type";
XOpt.Type.prototype.read = function(desc, sym) {
  var self = this;
  var id;

  if (sym.constructor == Number) {
    id = sym;
  } else {
    id = xTID(sym);
  }

  if (desc.hasKey(id)) {
    return self._read(desc, id);
  } else {
    return undefined;
  }
};
XOpt.Type.prototype.write = function(desc, sym, val) {
  var self = this;
  var id;

  if (sym.constructor == Number) {
    id = sym;
  } else {
    id = xTID(sym);
  }

  self._write(desc, id, val);
};
XOpt.Type.prototype.asString = function(val)   { return val.toString(); };
XOpt.Type.prototype.fromString = function(str) { return str; };


//================================ XOpt.Null =================================

XOpt.Null = new XOpt.Type(undefined, "XOpt.Null");
XOpt.Null.read = function(desc, sym) {};
XOpt.Null.write = function(desc, sym, val) {};
XOpt.Null.asString = function(val)   { };
XOpt.Null.fromString = function(str) { };


//================================= XOpts.Bool ===============================

XOpt.Bool = new XOpt.Type(DescValueType.BOOLEANTYPE, "XOpt.Bool");
XOpt.Bool._read = function(desc, id) {
  return desc.getBoolean(id);
};
XOpt.Bool._write = function(desc, id, val) {
  val = toBoolean(val);
  desc.putBoolean(id, val);
};
XOpt.Bool.asString = function(val) {
  return toBoolean(val).toString();
};
XOpt.Bool.fromString = function(str) {
  return toBoolean(str);
};


//================================= XOpts.Integer ============================

XOpt.Integer = new XOpt.Type(DescValueType.INTEGERTYPE, "XOpt.Integer");
XOpt.Integer._read = function(desc, id) {
  return desc.getInteger(id);
};
XOpt.Integer._write = function(desc, id, val) {
  val = Number(val);
  desc.putInteger(id, val);
};
XOpt.Integer.asString = function(val) {
  var n = toNumber(val); 
  return (isNaN(n) ? n : Math.round(n).toString());
};
XOpt.Integer.fromString = function(str) {
  return Math.round(Number(str));
};


//================================= XOpts.String ============================

XOpt.String  = new XOpt.Type(DescValueType.STRINGTYPE, "XOpt.String");
XOpt.String._read = function(desc, id) {
  return desc.getString(id);
};
XOpt.String._write = function(desc, id, val) {
  desc.putString(id, val.toString());
};


//================================= XOpts.Double ============================

XOpt.Double  = new XOpt.Type(DescValueType.DOUBLETYPE, "XOpt.Double");
XOpt.Double._read = function(desc, id) {
  return desc.getDouble(id);
};
XOpt.Double._write = function(desc, id, val) {
  val = Number(val);
  desc.putDouble(id, val);
};
XOpt.Double.asString = function(val) {
  return toNumber(val); 
};
XOpt.Double.fromString = function(str) {
  return Number(str);
};


//================================ XOpt.Path =================================

XOpt.Path    = new XOpt.Type(DescValueType.ALIASTYPE, "XOpt.Path");
XOpt.Path._read = function(desc, id) {
  return desc.getPath(id);
};
XOpt.Path._write = function(desc, id, val) {
  if (!val) {
    val = '';
  }
  val = File(val);
  desc.putPath(id, val);
};
XOpt.Path.asString = function(val) {
  return val.toUIString();
};
XOpt.Path.fromString = function(str) {
  return File(str);
};


//================================ XOpt.Enum =================================

XOpt.Enum = function(type, values, strs) {
  var self = this;

  if (typeof(self) == "function") {
    return new XOpt.Enum(type, values, strs);
  }

  self.type   = type;
  self.typeID = xTID(type);
  self.values = values;
  self.strings = strs;
};
XOpt.Enum.prototype = new XOpt.Type(DescValueType.ENUMERATEDTYPE, "XOpt.Enum");

XOpt.Enum.prototype._read = function(desc, id) {
  var self = this;
  var vid = desc.getEnumerationValue(id);
  var vals = self.values;
  var res = id2char(vid);
  var strs = self.strings;

  // if there is not a strs array, use the values as the str
  if (!strs) {
    strs = self.values;
  }

  for (var i = 0; i < vals.length; i++) {
    if (xTID(vals[i]) == vid) {
      res = strs[i];
      break;
    }
  }

  return res;
};
XOpt.Enum.prototype._write = function(desc, id, val) {
  var self = this;
  var strs = self.strings;
  var valID = xTID(val);

  //$.level = 1; debugger;

  // if there is not a strs array, use the values as the str
  if (!strs) {
    strs = self.values;
  }

  for (var i = 0; i < strs.length; i++) {
    if (strs[i] == val) {
      valID = xTID(self.values[i]);
      break;
    }
  }

  if (i == strs.length) {
    var msg = ("XOpt.Enum._write->" +
               "Bad Enum Value: " + val + " for Enum:" + self.type);
    Stdlib.log(msg);
    if (XProperty.ALERT_ON_ERRORS) {
      alert(msg);
    }
  }

  desc.putEnumerated(id, self.typeID, valID);
};


//=========================== XOpt.UnitDouble =================================

XOpt.UnitDouble = function(type) {
  var self = this;

  if (typeof(self) == "function") {
    return new XOpt.UnitDouble(type);
  }

  self.type   = type;
  self.typeID = xTID(type);
};
XOpt.UnitDouble.prototype = new XOpt.Type(DescValueType.UNITDOUBLE,
                                          "XOpt.UnitDouble");

XOpt.UnitDouble.prototype._read = function(desc, id) {
  var self = this;
  return desc.getUnitDoubleValue(id);
};
XOpt.UnitDouble.prototype._write = function(desc, id, val) {
  var self = this;
  desc.putUnitDouble(id, self.typeID, toNumber(val));
};
XOpt.UnitDouble.fromString = function(str) {
  return Number(str);
};

//================================ XOpt.Obj ================================

XOpt.Obj = function(type) {
  var self = this;

  if (typeof(self) == "function") {
    return new XOpt.Obj(type);
  }

  var self = this;
  self.type   = type;
  self.typeID = xTID(type);
};
XOpt.Obj.prototype = new XOpt.Type(DescValueType.OBJECTTYPE, "XOpt.Obj");


//================================= XOpt.Fptr ============================

XOpt.Fptr = new XOpt.Obj("Fptr");
XOpt.Fptr.typename = "XOpt.Fptr";

XOpt.Fptr._read = function(desc, id) {
  var self = this;
  var fdesc = desc.getObjectValue(id);
  var fptr = fdesc.getString(cTID('Path'));
  return fptr;
};
XOpt.Fptr._write = function(desc, id, val) {
  var self = this;
  var fdesc = new ActionDescriptor();
  fdesc.putString(cTID('Path'), val.toString());
  desc.putObject(id, cTID('Fptr'), fdesc);
};
XOpt.Fptr.asString = function(val) {
  return val.toString();
};
XOpt.Fptr.fromString = function(str) {
  return str;
};


//================================= XOpt.Color ============================

XOpt.Color = new XOpt.Obj("Clr ");
XOpt.Color.typename = "XOpt.Color";

XOpt.Color._read = function(desc, id) {
  var res = '';
  try {
    var cdesc = desc.getObjectValue(id);

    var color = cdesc.getString(cTID('Clr '));

    if (color == "RGB") {
      var rgb = new RGBColor();
    
      rgb.red   = cdesc.getDouble(cTID('Rd  '));
      rgb.green = cdesc.getDouble(cTID('Grn '));
      rgb.blue  = cdesc.getDouble(cTID('Bl  '));

      var sc = new SolidColor();
      sc.rgb = rgb;
      res = sc;

    } else {
      var strs = XOpt.Color.strings;
      var val = color;
      for (var i = 0; i < strs.length; i++) {
        if (val == strs[i]) {
          break;
        }
      }
      if (i == strs.length) {
        alert("Bad Color Value: " + val + " for " + self.type);
      }
      res = color;
    }
  } catch (e) {
    alert(e);
  }

  return res;
};
XOpt.Color.strings = ["White",
                      "Black",
                      "Foreground",
                      "Background"];

XOpt.Color._write = function(desc, id, val) {
  var self = this;
  var cdesc = new ActionDescriptor();

  if (val.constructor == String) {
    var strs = XOpt.Color.strings;
    var valStr = val;

    // check for symbolic name
    for (var i = 0; i < strs.length; i++) {
      if (val == strs[i]) {
        break;
      }
    }

    // if it's not a symbolic name, parse it up as an RGB
    if (i == strs.length) {
      var color = XOpt.Color.rgbFromString(val);
      if (color) {
        val = "RGB";
        var rgb = color.rgb;
        cdesc.putDouble(cTID('Rd  '), rgb.red);
        cdesc.putDouble(cTID('Grn '), rgb.green);
        cdesc.putDouble(cTID('Bl  '), rgb.blue);

      } else {
        alert("Bad Color Value: " + val + " for " + self.type);
        val = "";
      }
    } else {
      // the symbolic names do not have RGB values in cdesc
    }
    

    if (val) {
      cdesc.putString(cTID('Clr '), val);
      desc.putObject(id, self.typeID, cdesc);
    }

  } else if (val instanceof SolidColor) {
    var rgbColor = val.rgb;

    cdesc.putString(cTID('Clr '), "RGB");
    cdesc.putDouble(cTID('Rd  '), rgbColor.red);
    cdesc.putDouble(cTID('Grn '), rgbColor.green);
    cdesc.putDouble(cTID('Bl  '), rgbColor.blue);
    desc.putObject(id, self.typeID, cdesc);

  } else {
    alert("Bad Color Value for " + self.type);
  }
};
XOpt.Color.asString = function(val) {
  var str;
  if (val.constructor == String) {
    for (var i = 0; i < strs.length; i++) {
      if (val == strs[i]) {
        str = strs[i];
        break;
      }
    }
  } else {
    str = XOpt.Color.rgbToString(val).replace(/[\[\]]/g, '');
  }
  return str;
};
XOpt.Color.fromString = function(str) {
  if (str instanceof SolidColor) {
    return str;
  }

  var clr = XOpt.Color.rgbFromString(str);

  if (!clr) {
    var strs = XOpt.Color.strings;
    for (var i = 0; i < strs.length; i++) {
      if (str == strs[i]) {
        clr = strs[i];
        break;
      }
    }
  }

  return clr;
};

XOpt.Color.rgbToString = function(c) {
  return "[" + c.rgb.red + "," + c.rgb.green + "," + c.rgb.blue + "]";
};
XOpt.Color.rgbFromString = function(str) {
  var rex = /([\d\.]+),([\d\.]+),([\d\.]+)/;
  var m = str.match(rex);
  if (m) {
    return XOpt.Color.createRGBColor(Number(m[1]),
                                     Number(m[2]),
                                     Number(m[3]));
  }
  return undefined;
};
XOpt.Color.createRGBColor = function(r, g, b) {
  var c = new RGBColor();
  if (r instanceof Array) {
    b = r[2]; g = r[1]; r = r[0];
  }
  c.red = parseInt(r); c.green = parseInt(g); c.blue = parseInt(b);
  var sc = new SolidColor();
  sc.rgb = c;
  return sc;
};

XOpt.Color.getSymbolicColor = function(obj) {
  var color = undefined;

  if (obj.typename == "SolidColor") {
    color = obj;
  } else if (obj == 'White') {
    color = Stdlib.createRGBColor(255, 255, 255);
  } else if (obj == 'Black') {
    color = Stdlib.createRGBColor(0, 0, 0);
  } else if (obj == 'Foreground') {
    color = app.foregroundColor;
  } else if (obj == 'Background') {
    color = app.BackgroundColor;
  }

  return color;
};

//================================= XOpt.HexColor ============================

XOpt.HexColor = new XOpt.Type(DescValueType.STRINGTYPE, "XOpt.HexColor");
XOpt.HexColor.typename = "XOpt.HexColor";

XOpt.HexColor.REX = /^#?[A-Fa-f0-9]{6}$/;
XOpt.HexColor._read = function(desc, id) {
  var res = '';
  try {
    var cstr = desc.getString(id);
    var sc = new SolidColor();
    sc.rgb.hexValue = cstr.slice(1);
    res = sc;

  } catch (e) {
    alert(e);
  }

  return res;
};
XOpt.HexColor.strings = ["White",
                         "Black",
                         "Foreground",
                         "Background"];

XOpt.HexColor._write = function(desc, id, val) {
  var self = this;

  if (val.constructor == String) {
    if (val.match(XOpt.HexColor.REX)) {
      // we're good but could check the format better...
      if (!val[0] == '#') {
        val = '#' + val;
      }
    } else {
      alert("Bad Color Value: " + val + " for " + self.type);
      val = "#FFFFFF";
    }

    desc.putString(id, val);

  } else if (val instanceof SolidColor) {
    var cstr = '#' + val.rgb.hexValue;
    desc.putString(id, cstr);

  } else if (val instanceof RGBColor) {
    var cstr = '#' + val.hexValue;
    desc.putString(id, cstr);

  } else {
    alert("Bad Color Value for " + self.type);
  }
};
XOpt.HexColor.asString = function(val) {
  var str;

  if (val.constructor == String) {
    str = val;

  } else if (val instanceof SolidColor) {
    str = '#' + val.rgb.hexValue;

  } else if (val instanceof RGBColor) {
    str = '#' + val.hexValue;

  } else {
    alert("Unexpected color value: " + val);
  }

  return str;
};
XOpt.HexColor.fromString = function(str) {
  var clr = undefined;

  if (str.constructor == String) {
    if (str.match(XOpt.HexColor.REX)) {
      clr = new SolidColor();
      if (str[0] == '#') {
        str = str.slice(1);
      }

      clr.rgb.hexValue = str;
    }
  } else if (str instanceof SolidColor) {
    clr = str;
  }

  return clr;
};


//================================ init code ==================================

XProperty._need_cTID = false;
XProperty.__init = function() {
  var __lvl = $.level;
  $.level = 0;

  try {
    cTID;

  } catch (e) {
    XProperty._need_cTID = true;

  } finally {
    $.level = __lvl;
    delete __lvl;
  }
};

if (XProperty._need_cTID) {
  cTID = function(s) { return app.charIDToTypeID(s); };
  sTID = function(s) { return app.stringIDToTypeID(s); };
  xTID = function(s) {
    if (s.constructor == Number) {
      return s;
    }
    if (s.constructor == String) {
      if (s.length != 4) return sTID(s);
      try { return cTID(s); } catch (e) { return sTID(s); }
    }
    Error.runtimeError(19, "s");  // Bad Argument
  };
  id2char = function(s) {
    if (isNaN(Number(s))){
      return '';
    }
    var v;

    // Use every mechanism available to map the typeID
    try {
      if (!v) {
        try { v = PSConstants.reverseNameLookup(s); } catch (e) {}
      }
      if (!v) {
        try { v = PSConstants.reverseSymLookup(s); } catch (e) {}
      }
      if (!v) {
        try { v = app.typeIDToCharID(s); } catch (e) {}
      }
      if (!v) {
        try { v = app.typeIDToStringID(s); } catch (e) {}
      }
    } catch (e) {
    }
    if (!v) {
      v = _numberToAscii(s); 
    }
    return v ? v : s;
  };

  _numberToAscii = function(n) {
    if (isNaN(n)) {
      return n;
    }
    var str = '';
    str += String.fromCharCode(n >> 24);
    str += String.fromCharCode((n >> 16) & 0xFF);
    str += String.fromCharCode((n >> 8) & 0xFF);
    str += String.fromCharCode(n & 0xFF);
    
    return str.match(/^\w{4}$/) ? str : n;
  };

}

XPropertyTable.fromIniString = function(str, obj) {
  if (!obj) {
    obj = {};
  }
  var lines = str.split(/[\r\n]+/);

  var rexp = new RegExp(/([^:]+):(.*)$/);

  for (var i = 0; i < lines.length; i++) {
    var line = lines[i].trim();
    if (!line || line.charAt(0) == '#') {
      continue;
    }
    var ar = rexp.exec(line);
    if (!ar) {
      alert("Bad line in config file: \"" + line + "\"");
      return;
    }
    obj[ar[1].trim()] = ar[2].trim();
  }
  return obj;
};

//=====================================================================
//
// Everything below this point is test data
//
//=====================================================================


"XProperty.jsx";
// EOF

//

// CSX is a namespace for constants and enumerations used in this script
CSX = function() {};

CSX.UUID_v1_4_2 = "0be2b720-cd2e-11dd-ad8b-0800200c9a66";

CSX.UUID = CSX.UUID_v1_4_2;

CSX.CONTACT_SHEET = "Contact Sheet";
CSX.IMAGES_LAYER = CSX.CONTACT_SHEET + " Images";
CSX.CAPTIONS_LAYER = CSX.CONTACT_SHEET + " Captions";

CSX.RELEASE = "1.4.2";

CSX.FILE = "CSX-" + CSX.RELEASE.replace(/\./g, '_') + ".jsx";

CSX.VERSION  = "v" + CSX.RELEASE;
CSX.REVISION = "$Revision: 1.95 $";
CSX.TITLE = "Contact Sheet X " + CSX.VERSION + ' ' + CSX.REVISION;

CSX.FOLDER        = 'Folder';
CSX.TEMPLATE      = 'Template';
CSX.OPENDOCUMENTS = 'Open Documents';
CSX.SHEETS        = 'Sheets';
CSX.BRIDGE        = 'Bridge';

CSX.PIXEL = 'Pixl';
CSX.INCH  = 'Inch';
CSX.CM    = 'Cmtr';

CSX.PX = 'px';
CSX.IN = 'in';
CSX.CM = 'cm';

CSX.PIXELS_PER_INCH = 'PpIn';
CSX.PIXELS_PER_CM   = 'PpCm';

CSX.CW  = 'CW';
CSX.CCW = 'CCW';

CSX.TOP    = 'Top';
CSX.CENTER = 'Center';
CSX.BOTTOM = 'Bottom';
CSX.LEFT   = 'Left';
CSX.MIDDLE = 'Middle';
CSX.RIGHT  = 'Right';

CSX.NONE = 'None';

CSX.JPG = 'jpg';
CSX.PSD = 'psd';
CSX.TIF = 'tif';
CSX.PNG = 'png';

CSX.PROGRESSIVE = 'Progessive';
CSX.STANDARD    = 'Standard';
CSX.OPTIMIZED   = 'Optimized';

CSX.PC    = 'PC';
CSX.MACOS = 'MacOS';

CSX.THUMBNAIL = 'thumbnail';
CSX.SAMPLE    = 'sample';
CSX.SCALE     = 'scale';
CSX.RESIZE    = 'resize';

CSX.EXIFTOOL_MAC = "~/pkg/Image-ExifTool-6.61/exiftool";
CSX.EXIFTOOL_PC  = "exiftool";
CSX.EXIFTOOL     = (isMac() ? CSX.EXIFTOOL_MAC : CSX.EXIFTOOL_PC);

CSX.EXIF_PREVIEWIMAGE   = 'PreviewImage';
CSX.EXIF_JPGFROMRAW     = 'JpgFromRaw';
CSX.EXIF_THUMBNAILIMAGE = 'ThumbnailImage';

CSX.COLOR_PROFILE_FOLDER = (isWindows() ?
                            Folder(Folder.system + "/spool/drivers/color") :
                            Folder(Folder.appDate + "/ColorSync/Profiles"));

CSX.DEFAULT_PROFILE = 'Default';
CSX.FIRST_IMAGE_PROFILE = 'Match First Image';

//
//
// CSXTypes.jsx
//
// $Id: CSXTypes.jsx,v 1.26 2008/10/21 16:59:09 xbytor Exp $
// Copyright: (c)2008, xbytor
// License: http://creativecommons.org/licenses/LGPL/2.1
// Contact: xbytor@gmail.com
//

//@show include
//
//
//-include "xlib/stdlib.js"
//-include "xlib/XProperty.jsx"

//=================================== CSX ===============================
var __lvl = $.level;
$.level = 0;
try {
  CSX;
} catch (e) {
  CSX = {};
} finally {
  $.level = __lvl;
  delete __lvl;
}

//================================= CSX.Mode ============================

CSX.Mode = XOpt.Enum('Md  ',
                    ['Grys',
                     'RGBM',
                     'CMYM',
                     'LbCM'],
                    ["Grayscale",
                     "RGB",
                     "CMYK",
                     "Lab"]);

CSX.Mode.typename = "CSX.Mode";
CSX.Mode.super_write = CSX.Mode._write;
CSX.Mode._write = function(desc, id, val) {
  var self = this;

  var strs = self.strings;
  var vals = val.toString();

  if (vals.startsWith("NewDocumentMode")) {
    vals = vals.substr(vals.indexOf('.')+1);
  }

  self.super_write(desc, id, vals);
};
CSX.Mode.super_read = CSX.Mode._read;
CSX.Mode._read = function(desc, id) {
  var self = this;
  var res = self.super_read(desc, id);
  var mode;

  switch (res.toUpperCase()) {
    case "RGB":       mode = NewDocumentMode.RGB; break;
    case "CMYK":      mode = NewDocumentMode.CMYK; break;
    case "LAB":       mode = NewDocumentMode.LAB; break;
    case "GRAYSCALE": mode = NewDocumentMode.GRAYSCALE; break;
    default: mode = undefined; break;
  }

  return mode;
};
CSX.Mode.fromString = function(str) {
  if (str.constructor != String) {
    // we probably already have a well-typed Mode
    return str;
  }

  var val = str;
  if (str.startsWith("NewDocumentMode.")) {
    try { eval("val = " + str); } catch (e) {}
  } else {
    switch (str) {
      case "RGB":
      case "CMYK":
      case "Lab":
      case "Grayscale":
      eval("val = NewDocumentMode." + str.toUpperCase());
        break;
      default:
        Error.runtimeError(9001, "Invalid value for Mode Setting:" + str);
        break;
    }
  }
  return val;
};


//============================== CSX.TIFFEncoding =============================
CSX.TIFFEncoding = XOpt.Enum('Encd',
                            ['None',
                             'LZWC'],
                            ["None",
                             "LZW"]);
CSX.TIFFEncoding.typename = "CSX.TIFFEncoding";
CSX.TIFFEncoding.super_write = CSX.TIFFEncoding._write;
CSX.TIFFEncoding._write = function(desc, id, val) {
  var self = this;

  var strs = self.strings;
  var vals = val.toString();

  if (vals.startsWith("TIFFEncoding")) {
    if (vals == "TIFFEncoding.NONE") {
      vals = "None";
    } else if (vals == "TIFFEncoding.TIFFLZW") {
      vals = "LZW";
    }
  }

  if (vals != 'None' && vals != 'LZW') {
    Error.runtimeError(9001, "Invalid value for tiffEncoding: " + val);
  }

  self.super_write(desc, id, vals);
};
CSX.TIFFEncoding.super_read = CSX.TIFFEncoding._read;
CSX.TIFFEncoding._read = function(desc, id) {
  var self = this;
  var res = self.super_read(desc, id);
  var enc;
  
  switch (res) {
    case "None":  enc = TIFFEncoding.NONE; break;
    case "LZW":   enc = TIFFEncoding.TIFFLZW; break;
    default: break;
  }
  return enc;
};
CSX.TIFFEncoding.fromString = function(str) {
  if (str.constructor != String) {
    return str;
  }
  var val;
  if (str.startsWith("TIFFEncoding.")) {
    try { eval("val = " + str); } catch (e) {}
  } else if (str == "None" || str.match(/none/i)) {
    return TIFFEncoding.NONE;
  } else if (str == "LZWC" || str == "LZW" || str.match(/lzw/i)) {
    return TIFFEncoding.TIFFLZW;
  }
  return val;
};


//============================== CSX.FormatOptions ============================
CSX.FormatOptions = XOpt.Enum("JPEG",
                              ["progressive", "standard", "optimized"],
                              ["Progressive", "Standard", "Optimized"])
CSX.FormatOptions.typename = "CSX.FormatOptions";
CSX.FormatOptions.super_write = CSX.FormatOptions._write;
CSX.FormatOptions._write = function(desc, id, val) {
  var self = this;

  var strs = self.strings;
  var vals = val.toString();

  if (vals.startsWith("FormatOptions")) {
    if (vals == "FormatOptions.OPTIMIZEDBASELINE") {
      vals = "Optimized";
    } else if (vals == "FormatOptions.PROGRESSIVE") {
      vals = "Progressive";
    } else if (vals == "FormatOptions.STANDARDBASELINE") {
      vals = "Standard";
    }
  } else {
    switch (vals.toLowerCase()) {
      case "optimized":
      case "progressive":
      case "standard":
    default: 
      Error.runtimeError(9001, "Invalid value for jpgFormat: " + str);
      break;
    }    
  }

  self.super_write(desc, id, vals);
};

CSX.FormatOptions.super_read = CSX.FormatOptions._read;
CSX.FormatOptions._read = function(desc, id) {
  var self = this;
  var res = self.super_read(desc, id);
  var fmt;
  
  switch (res) {
    case "Optimized":    fmt = FormatOptions.OPTIMIZEDBASELINE; break;
    case "Progressive":  fmt = FormatOptions.PROGRESSIVE; break;
    case "Standard":     fmt = FormatOptions.STANDARDBASELINE; break;
    default: break;
  }
  return fmt;
};
CSX.FormatOptions.fromString = function(str) {
  if (str.constructor != String) {
    return str;
  }
  var val;
  if (str.startsWith("FormatOptions.")) {
    try { eval("val = " + str); } catch (e) {}
  } else {
    switch (str.toLowerCase()) {
      case "optimized":    val = FormatOptions.OPTIMIZEDBASELINE; break;
      case "progressive":  val = FormatOptions.PROGRESSIVE; break;
      case "standard":     val = FormatOptions.STANDARDBASELINE; break;
    default: 
      Error.runtimeError(9001, "Invalid value for jpgFormat: " + str);
      break;
    }
  }
  return val;
};


//============================== CSX.ByteOrder ============================
CSX.ByteOrder = XOpt.Enum('BytO',
                          ['IBMP',
                           'McnS'],
                          ["PC",
                           "MacOS"]);
CSX.ByteOrder.typename = "CSX.ByteOrder";
CSX.ByteOrder.super_write = CSX.ByteOrder._write;
CSX.ByteOrder._write = function(desc, id, val) {
  var self = this;

  var strs = self.strings;
  var vals = val.toString();

  if (vals.startsWith("ByteOrder")) {
    if (vals == "ByteOrder.MACOS") {
      vals = "MacOS";
    } else if (vals == "ByteOrder.IBM") {
      vals = "PC";
    }
  }

  self.super_write(desc, id, vals);
};
CSX.ByteOrder.super_read = CSX.ByteOrder._read;
CSX.ByteOrder._read = function(desc, id) {
  var self = this;
  var res = self.super_read(desc, id);
  var bo;
  
  switch (res) {
    case "MacOS":  bo = ByteOrder.MACOS; break;
    case "PC":     bo = ByteOrder.IBM; break;
    default: break;
  }
  return bo;
};
CSX.ByteOrder.fromString = function(str) {
  if (str.constructor != String) {
    return str;
  }
  var val;
  if (str.startsWith("ByteOrder.")) {
    try { eval("val = " + str); } catch (e) {}
  } else if (str == "MacOS" || str.match(/mac/i)) {
    val = ByteOrder.MACOS;
  } else if (str == "PC" || str.match(/ibm|pc/i)) {
    val = ByteOrder.IBM;
  }
  return val;
};


//====================================================================
CSX.PropertyTableResource = [

  //=================== Source ===================
  { prop:     { name: "imageSource", sym: 'isrc' },
    defValue: "sourceFolder",
    typeInfo: XOpt.Enum("sourceType",
                       ["sourceFolder",
                        "sourceOpenFiles",
                        "SrcB"],
                       ["Folder",
                        "Open Documents",
                        "Bridge"])
  }, 
  { prop:     { name: "folder", sym: 'Fldr' },
    defValue: "~",
    typeInfo: XOpt.Fptr
  },
  { prop:     { name: "recurse", sym: 'Recr' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "spanFolders", sym: 'Span' },
    defValue: false,
    typeInfo: XOpt.Bool
  },

  //=================== Document ===================
  { prop:     { name: "background", sym: 'BckL' },
    defValue: 'Wht ',
    typeInfo: XOpt.Enum("backgroundType",
                       ['Wht ','Blck','FrgC','BckC',"template",'None'],
           ["White", "Black","Foreground", "Background","Template","None"])},
  { prop:     { name: "templateFile", sym: 'Tmpl' },
    defValue: "",
    typeInfo: XOpt.Fptr
  },
  { prop:     { name: "docUnits", sym: 'RlrU' },
    defValue: 'RrPx',
    typeInfo: XOpt.Enum('RlrU',  // ruler units
                       ['RrPx', 'RrIn', 'RrCm'],
                       ["Pixl", "Inch", "Cmtr"])
  },
  { prop:     { name: "docWidth", sym: 'Wdth' },
    defValue: 2400,
    typeInfo: XOpt.Double
  },
  { prop:     { name: "docHeight", sym: 'Hght' },
    defValue: 3000,
    typeInfo: XOpt.Double
  },
  { prop:     { name: "resolution", sym: 'Rslt' },
    devValue: 300,
    typeInfo: XOpt.Double
  },
  { prop:     { name: "resUnits", sym: 'RslU' },
    defValue: 'PpIn',
    typeInfo: XOpt.Enum("resUnits",
                        ["PpIn","PpCm"])
  },
  { prop:     { name: "mode", sym: 'Md  '},
    defValue: 'RGBM',
    typeInfo: CSX.Mode,
//     typeInfo: XOpt.Enum('Md  ',
//                        ['Grys','RGBM','CMYM','LbCM'],
//                        ["Grayscale","RGB","CMYK","Lab"])
  },
  { prop:     { name: "colorProfile", sym: 'Prof' },
    devValue: 'Default',
    typeInfo: XOpt.String
  },
  { prop:     { name: "marginsEnabled", sym: 'Marg' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "leftMargin", sym: 'LMar' },
    defValue: 0,
    typeInfo: XOpt.Double
  },
  { prop:     { name: "rightMargin", sym: 'RMar' },
    defValue: 0,
    typeInfo: XOpt.Double
  },
  { prop:     { name: "topMargin", sym: 'TMar' },
    defValue: 0,
    typeInfo: XOpt.Double
  },
  { prop:     { name: "bottomMargin", sym: 'BMar' },
    defValue: 0,
    typeInfo: XOpt.Double
  },
  { prop:     { name: "alternateMargins", sym: 'AMar' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  
  //=================== Layout ===================
  { prop:     { name: "acrossFirst", sym: "Acrs" },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "bestFit", sym: 'Bst ' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "rotate", sym: 'Rtt '},
    defValue: 'CCW ',
    typeInfo: XOpt.Enum('Rtt ',
                       ["CW", "CCW"]) },
  { prop:     { name: "autoFill", sym: 'Fl  '},
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "valign", sym: 'VAlg'},
    defValue: 'Mddl',
    typeInfo: XOpt.Enum('VAlg',
                       ['Top ', 'Mddl', 'Bttm'],
                       ["Top", "Middle", "Bottom"]) },
  { prop:     { name: "halign", sym: 'HAlg'},
    defValue: 'Cntr',
    typeInfo: XOpt.Enum('HAlg',
                       ['Left', 'Cntr', 'Rght'],
                       ["Left", "Center", "Right"]) },
  { prop:     { name: "rowCount", sym: 'RowC' },
    defValue: 3,
    typeInfo: XOpt.Integer
  },
  { prop:     { name: "columnCount", sym: 'ColC' },
    defValue: 2,
    typeInfo: XOpt.Integer
  },
  { prop:     { name: "useAutoSpacing", sym: 'AtSp' },
    defValue: true, 
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "spacingUnits", sym: 'SpcU' },
    defValue: 'RrPx',
    typeInfo: XOpt.Enum('UntR',
                       ['RrPx', 'RrIn', 'RrCm'],
                       ["px", "in", "cm"])
  },
  { prop:     { name: "vertical", sym: 'Vrtc' },
    defValue: 1,
    typeInfo: XOpt.Double
  },
  { prop:     { name: "horizontal", sym: 'Hrzn' },
    defValue: 1,
    typeInfo: XOpt.Double
  },
  { prop:     { name: "thumbStyle", sym: 'Styl' },
    defValue: 'None',
    typeInfo: XOpt.String
  },
  { prop:     { name: "squareCell", sym: 'SqrC' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  
  //=================== Caption ===================
  { prop:     { name: "caption", sym: 'Capt' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "captionFilename", sym: 'CapF' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "noExtensions", sym: 'NoEx' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "overlayCaption", sym: 'CapO' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "captionStyle", sym: 'TxtS'},
    defValue: 'None',
    typeInfo: XOpt.String
  },
  { prop:     { name: "font", sym: "Scrp" },
    defValue: "ArialMT",
    typeInfo: XOpt.String
  },
  { prop:     { name: "fontSize", sym: 'FntZ' },
    defValue: 12,
    typeInfo: XOpt.Double
  },
  { prop:     { name: "fontColor", sym: 'FntC' },
    defValue: "Black",
    typeInfo: XOpt.Color
  },
  { prop:     { name: "captionFormat", sym: 'CFmt' },
    defValue: "%f.%e",
    typeInfo: XOpt.String
  },
  { prop:     { name: "capAlignment", sym: 'CAlg'},
    defValue: 'Cntr',
    typeInfo: XOpt.Enum('CAlg',
                       ['Left', 'Cntr', 'Rght'],
                       ["Left", "Center", "Right"])
  },
  { prop:     { name: "capVAlignment", sym: 'CVAl'},
    defValue: 'Bttm',
    typeInfo: XOpt.Enum('CVAl',
                        ['Top ', 'Mddl', 'Bttm'],
                        ["Top", "Middle", "Bottom"])
  },

  
  //====================== Output ===================
  { prop:     { name: "keepOpen", sym: 'KOpn' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "saveSheet", sym: 'SvSh' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "outputFolder", sym: 'OutF' },
    defValue: "~",
    typeInfo: XOpt.Fptr
  },
  { prop:     { name: "nextPage", sym: 'nxtP' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "nextFile", sym: 'nxtF' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "outputPrefix", sym: 'OutP' },
    defValue: "sheet_",
    typeInfo: XOpt.String
  },
  { prop:     { name: "outputFormat", sym: 'Fmt '},
    defValue: 'JPEG',
    typeInfo: XOpt.Enum('Fmt ',
                        ['JPEG', 'PSDF', 'TIFF', 'PNGF'],
                        ["jpg", "psd", "tif", "png"])
  },
  { prop:     { name: "jpgQuality", sym: 'JPEQ' },
    defValue: 10,
    typeInfo: XOpt.Integer
  },
  { prop:     { name: "jpgFormat", sym: 'JPEG' },
    defValue: "standard",
    typeInfo: CSX.FormatOptions
//     typeInfo: XOpt.Enum("JPEG",
//                        ["progressive", "standard", "optimized"],
//                        ["Progressive", "Standard", "Optimized"])
  },
  { prop:     { name: "tiffEncoding", sym: 'Encd' },
    defValue: 'None',
    typeInfo: CSX.TIFFEncoding
//   XOpt.Enum('Encd',
//                        ['None', 'LZWC'],
//                        ["None", "LZW"])
  },
  { prop:     { name: "tiffByteOrder", sym: 'BytO' },
    defValue: ($.os.match(/windows/i) ? 'IBMP' : 'McnS'),
    typeInfo: CSX.ByteOrder
//   XOpt.Enum('BytO',
//                        ['IBMP', 'McnS'],
//                        ["PC", "MacOS"])
  },
  { prop:     { name: "flatten", sym: 'Fltt' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "flattenCells", sym: 'FltC' },
    defValue: true,
    typeInfo: XOpt.Bool
  },


  //=================== Advanced Settings ===================
  { prop:     { name: "accumulateKeywords", sym: 'AccK' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "enableTextSubstitution", sym: 'EnTx' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "autospaceFactor", sym: 'aspf' },
    defValue: 1.0,
    typeInfo: XOpt.Double
  },
  { prop:     { name: "tabbed", sym: 'Tab ' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "hiperfMode", sym: 'HPMd' },
    defValue: 1,
    typeInfo: XOpt.Integer
  },
  { prop:     { name: "hp2submode", sym: 'HP2S' },
    defValue: 'Thmb',
    typeInfo: XOpt.Enum('HP2S',
                       ['Thmb','Samp','Scl ','Resz'],
                       ['thumbnail','sample','scale','resize'])
  },
  { prop:     { name: "hp3submode", sym: 'HP3S' },
    defValue: 'PrvI',
    typeInfo: XOpt.Enum('HP3S',
                       ['PrvI','JPEG','Thmb'],
                       ['PreviewImage','JpgFromRaw','ThumbnailImage'])
  },
  { prop:     { name: "exiftool", sym: 'exif' },
    defValue: "exiftool",
    typeInfo: XOpt.String
  },
  { prop:     { name: "dateFormat", sym: 'DFmt' },
    defValue: "%Y-%m-%d",
    typeInfo: XOpt.String
  },
  { prop:     { name: "gpsFormat", sym: 'GFmt' },
    defValue: "%d\u00B0 %d' %.2f\"",
    typeInfo: XOpt.String
  },
  { prop:     { name: "logEnabled", sym: 'LgEn' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "logFile", sym: 'LgFl' },
    defValue: "ContactSheetX.log",
    typeInfo: XOpt.Fptr
  },
  { prop:     { name: "headerEnabled", sym: 'HdEn' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "@Header", sym: '@Hdr' },
    defValue: "Contact Sheet",
    typeInfo: XOpt.String
  },
  { prop:     { name: "@Header.enabled", sym: '@HEn' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "bridgeEnabled", sym: 'BrEn' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "alphaLayerPinRegister", sym: 'ALPR' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "metadataSubstitution", sym: 'MdSb' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "forceProfileMatch", sym: 'PrfM' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "splitCSXLayerOnFlatten", sym: 'SpCL' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "postProcessAction", sym: 'PPrA' },
    defValue: "",
    typeInfo: XOpt.String
  },
  { prop:     { name: "convertToProfile", sym: 'CvPr' },
    defValue: "",
    typeInfo: XOpt.String
  },
  { prop:     { name: "convertToProfileEnabled", sym: 'CPEn' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "xpSort", sym: 'ISrt' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "embedSmartObjects", sym: 'EmSO' },
    defValue: false,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "fixMaskPhantomPixels", sym: 'fMPP' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "watermarkMode", sym: 'WtMd' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "uiX", sym: 'uiX ' },
    defValue: 100,
    typeInfo: XOpt.Integer
  },
  { prop:     { name: "uiY", sym: 'uiY ' },
    defValue: 100,
    typeInfo: XOpt.Integer
  },
  { prop:     { name: "Message", sym: 'Msge' },
    defValue: "Settings for CSX",
    typeInfo: XOpt.String
  },
  { prop:     { name: "noUI", sym: 'noUI' },
    defValue: false,
    typeInfo: XOpt.Null
  },
  { prop:     { name: "forceRecording", sym: 'forceRecording' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "autoscaleCaptions", sym: 'autoscaleCaptions' },
    defValue: true,
    typeInfo: XOpt.Bool
  },
  { prop:     { name: "uiConfirmBridgeForMetadata",
                sym: 'uiConfirmBridgeForMetadata' },
    defValue: 'uiModeOnly',
    typeInfo: XOpt.Enum('uiConfirmBasicModeForMetadata',
                        ['uiModeOnly', 'true', 'false'])
  },
  { prop:     { name: "filesList", sym: 'filesList' },
    defValue: false,
    typeInfo: XOpt.Null
  },
  { prop:     { name: "typename", sym: 'tynm' },
    defValue: false,
    typeInfo: XOpt.Null
  },
];

//=============================== Testing =====================================
CSX.Test_CSXTypes = function() {

  // XXX This test rigging needs to be updated to reflect 
  // post-1.2 changes

/******************************************************

  // misc
accumulateKeywords     = true;
enableTextSubstitution = true;
enablePageLayers       = true;
enableDateLayers       = true;
autospaceFactor        = 1.0;   // percent of width
tabbed                 = false;

hiperfMode      = 0;               // 1,2...
hp2submode      = CSX.THUMBNAIL;
hp3submode      = CSX.EXIF_PREVIEWIMAGE;
exiftool        = CSX.EXIFTOOL;
dateFormat      = "%Y-%m-%d";

logEnabled      = ContactSheetConfig.LOG_ENABLED;
logFile         = ContactSheetConfig.LOG_FILE;

headerEnabled   = false;
  self['@Credits']     = "CSX by xbytor";
  self['@Header']      = "Contact Sheet";

bridgeEnabled   = true;
******************************************************/

//XXX This needs to be updated...
var testObject = {
  imageSource: "Folder",
  folder: new File("~/images"),
  recurse: true,
  spanFolders: false,

  background: "White",
  templateFile: "~/work/csx/templates/CSXTemplate-Default.psd",
  docUnits: "Inch",
  docWidth: 8,
  docHeight: 10,
  marginsEnabled: true,
  leftMargin: 0,
  rightMargin: 0,
  topMargin: 0,
  bottomMargin: 0,
  alternateMargins: false,
  resolution: 72,
  resUnits: "PpIn",
  mode: NewDocumentMode.RGB,
  headerEnabled: true,

  acrossFirst: true,
  valign: "Bottom",
  bestFit: false,
  rotate: "CW",
  columnCount: 2,
  rowCount: 3,
  useAutoSpacing: true,
  spacingUnits: "px",
  vertical: 5,
  horizontal: 5,
  thumbStyle: "None",
  autoFill: false,
  squareCell: false,

  caption: true,
  noExtensions: false,
  overlayCaption: false,
  captionStyle: "None",
  font: "ArialMT",
  fontSize: 12,
  fontColor: "[255,0,0]",
  captionFormat: "%f.%e",
  captionFormatEnabled: false,
  capAlignment: "Center",

  saveSheet: true,
  keepOpen: false,
  outputFolder: "~",
  outputPrefix: "sheet_",
  outputFormat: "jpg",
  flatten: false,
  jpgQuality: 10,
  jpgFormat: "Standard",
  tiffEncoding: "TIFFEncoding.NONE",
  tiffByteOrder: "ByteOrder.IBM",

  watermarkMode: true,
  accumulateKeywords: false,
  enableTextSubstitution: true,
  autospaceFactor: 1,
  dateFormat: "%Y-%m-%d",
  hiperfMode: 1,
  hp2submode: "thumbnail",
  hp3submode: "PreviewImage",
  exiftool: "exiftool",
  logEnabled: true,
  logFile: "ContactSheetX.log",
  enablePageLayers: true,
  enableDateLayers: true,
  tabbed: true,
  bridgeEnabled: true,
};

function main() {
  var tbl = new XPropertyTable();

  var props = CSX.PropertyTableResource;

  tbl.loadTableResource(props);

  var obj = testObject;

  var outf = XOpt.test(tbl, obj);
  var outstr = tbl.asString(outf);
  //alert(outstr.substr(0,500) + '...');

  var nobj = tbl.fromString(outstr);
  var noutf = XOpt.test(tbl, nobj);
  var noutstr = tbl.asString(noutf);

  alert(noutstr == outstr);
  alert(outstr.substr(0,500) + '...');
};

function xlistProps(obj) {
  var s = '';

  for (var x in obj) {
    s += x + ":\t";
    try {
      var o = obj[x];
      var str = (o.asString ? o.asString() : o.toString());
      s += (typeof o == "function") ? "[function]" : str;
    } catch (e) {
    }
    s += "\r\n";
  }
  return s;
};
XOpt.test = function(tbl, obj) {
  var desc = tbl.toDescriptor(obj);
  var binFile = new File("/c/work/tmp/csxtypes.bin");
  Stdlib.writeToFile(binFile,
                     desc.toStream(),
                     'BINARY');
  cnvtAD2XML(binFile);

  var out = tbl.fromDescriptor(desc);
  var r1 = listProps(obj);
  var r2 = listProps(out);
  var rc = r1 == r2;
//   if (!rc) {
//     alert("Failed:\n" + obj.toSource() + '\n\n' + out.toSource());
//   }
  return out;
};

// //@include "xlib/Stream.js"
// //@include "xlib/PSConstants.js"
// //@include "xlib/Action.js"
// //@include "xlib/xml/atn2xml.jsx"

function cnvtAD2XML(file) {
  try {
    var str = Stdlib.readFromFile(file, 'BINARY');
    var desc = new ActionDescriptor();

    desc.fromStream(str);

    var xml = desc.toXML();
    var xmlf = new File(file.strf("%d/%f.xml"));
    Stdlib.writeToFile(xmlf, xml);

  } catch (e) {
    alert("cnvtAD2XML::" + e + '@' + e.line);
  }
};


main();
};

// //@include "xlib/stdlib.js"
// //@include "xlib/XProperty.jsx"
// CSX.Test_CSXTypes();

"CSXTypes.jsx";

// EOF

//

//
// ContactSheetConfig
//
ContactSheetConfig = function ContactSheetConfig(obj) {
  var self = this;

  self._version    = CSX.VERSION;
  self._revision   = CSX.REVISION;
  self._appName    = app.name;
  self._appVersion = app.version;
  self._os         = $.os;

  // Source Images
  self.imageSource  = CSX.FOLDER;   // Folder,Open Documents,Bridge,Sheets
  self.folder       = "~";
  self.recurse      = false;        // recurse into subfolders
  self.spanFolders  = false;        // span folders or restart for each folder

  // Document
  self.background   = 'White';      // White,Black,Template,None
  self.templateFile = '';
  self.docUnits     = 'Pixl';       // Pixl,Inch,Cmtr
  self.docWidth     = 2400;         // 100..20000
  self.docHeight    = 3000;         // 100..20000
  self.resolution   = 72.0;         // 25..1200
  self.resUnits     = 'PpIn';       // PpIn,PpCm
  self.mode         = NewDocumentMode.RGB;
  self.colorProfile = CSX.DEFAULT_PROFILE;
  self.marginsEnabled = false;
  self.leftMargin   = 0;
  self.rightMargin  = 0;
  self.topMargin    = 0;
  self.bottomMargin = 0;
  self.alternateMargins = false;

  // Layout
  self.acrossFirst     = true;
  self.bestFit         = false;
  self.rotate          = 'CCW';      // CW,CCW
  self.autoFill        = false;
  self.valign          = 'Middle';   // Top,Middle,Bottom
  self.halign          = 'Center';   // Left,Center,Right
  self.rowCount        = 6;          // 1..30
  self.columnCount     = 5;          // 1..30
  self.useAutoSpacing  = true;
  self.spacingUnits    = 'px';       // px,in,cm
  self.vertical        = 1;          // 0..1000
  self.horizontal      = 1;          // 0..1000
  self.thumbStyle      = 'None';
  self.squareCell      = false;

  // Caption
  self.caption         = true;
  self.captionFilename = true;
  self.captionFormat   = "%f.%e";
  self.noExtensions    = true;
  self.font            = "Arial";
  self.fontSize        = 12;
  self.fontColor       = "Black";     //  White,Black,Foreground Color,
                                      //  Background Color,RGB
  self.captionStyle    = "None";
  self.overlayCaption  = false;
  self.capAlignment    = "Center";
  self.capVAlignment   = "Bottom";

  // Output
  self.keepOpen        = false;
  self.saveSheet       = true;
  self.outputFolder    = "~";
  self.flatten         = true;
  self.flattenCells    = true;

  self.nextPage        = true;
  self.nextFile        = true;
  self._pageStart      = 1;
  self._pagePad        = 2;
  self._outputStart    = 1;
  self._outputPad      = 4;
  self.outputPrefix    = "sheet_";
  self.fileNameFormat  = "sheet_#";

  self.outputFormat    = CSX.JPG;        // jpg,psd,tif,png
  self.jpgQuality      = 10;             // 2..12
  self.jpgFormat       = CSX.STANDARD;   // Progressive,Standard,Optimized
  self.tiffEncoding    = 'None';         // LZW, None
  self.tiffByteOrder   = ($.os.match(/windows/i) ? 'PC' : 'MacOS');

  self.fileSaveType    = "jpg";        // bmp,gif,jpg,psd,eps,pdf,png,tga,tiff

  // Advanced
  self.accumulateKeywords     = true;
  self.enableTextSubstitution = true;
  self.autospaceFactor        = 1.0;   // percent of width

  self.hiperfMode             = 1;               // 1,2...
  self.hp2submode             = CSX.THUMBNAIL;
  self.hp3submode             = CSX.EXIF_PREVIEWIMAGE;
  self.exiftool               = CSX.EXIFTOOL;
  self.dateFormat             = "%Y-%m-%d";
  self.gpsFormat              = "%d\u00B0 %d' %.2f\"";

  self.metadataSubstitution   = false;
  self.forceRecording         = true;
  self.alphaLayerPinRegister  = false;
  self.splitCSXLayerOnFlatten = false;
  self.xpSort                 = false;
  self.embedSmartObjects      = false;
  self.postProcessAction      = '';

  self.fixMaskPhantomPixels   = true;

  // misc/internal
  self.tabbed                 = false;
  self.watermarkMode          = false;


//   self['@Credits']     = "CSX by xbytor";
//   self['@Header']      = "Contact Sheet";

  self.bridgeEnabled   = true;
  self.uiX             = 100;
  self.uiY             = 100;


  self.uiConfirmBridgeForMetadata = 'uiModeOnly';

  self._formatPanel = true;
  self._fileNamingFormat = true;

  self.autoscaleCaptions = true;

  Stdlib.copyFromTo(obj, self);
};


ContactSheetConfig.prototype.toString = function() { return this.typename; };
ContactSheetConfig.prototype.typename = "ContactSheetConfig";

ContactSheetConfig.Table = new XPropertyTable(CSX.PropertyTableResource);

ContactSheetConfig.INI_FILE = (GenericUI.preferencesFolder +
                               "/ContactSheetX.ini");
ContactSheetConfig.LOG_FILE = (GenericUI.preferencesFolder +
                               "/ContactSheetX.log");
ContactSheetConfig.UI_LOG_FILE = (GenericUI.preferencesFolder +
                                  "/ContactSheetX-UI.log");

ContactSheetConfig.LOG_ENABLED = true;
ContactSheetConfig.STATUS_FILE = (GenericUI.preferencesFolder +
                                  "csx-status.ini");
ContactSheetConfig.PAGE_PAD = 2;
ContactSheetConfig.FILE_PAD = 4;

ContactSheetConfig.toMode = function(str) {
  str = str.toString();
  if (str.match(/rgb/i)) {
    return NewDocumentMode.RGB;
  }
  if (str.match(/cmyk/i)) {
    return NewDocumentMode.CMYK;
  }
  if (str.match(/lab/i)) {
    return NewDocumentMode.LAB;
  }
  if (str.match(/grayscale/i)) {
    return NewDocumentMode.GRAYSCALE;
  }
  return undefined;
};
ContactSheetConfig.toModeStr = function(str) {
  str = str.toString();
  if (str.match(/rgb/i)) {
    return "RGB";
  }
  if (str.match(/cmyk/i)) {
    return "CMYK";
  }
  if (str.match(/lab/i)) {
    return "Lab";
  }
  if (str.match(/grayscale/i)) {
    return "Grayscale";
  }
  return undefined;
};

ContactSheetConfig.toFont = function(str) {
  str = str.toString();

  var f = Stdlib.determineFont(str);  // first, check by PS name

  return (f ? f.postScriptName : undefined);
};

ContactSheetConfig.prototype.rationalize = function() {
  var self = this;

  Stdlib.log("Rationalizing options");

  ContactSheetConfig.Table.rationalize(self, self);

  if (/* self.imageSource == CSX.FOLDER && */ self.folder) {
    self.folder = Stdlib.convertFptr(self.folder);
  }

  if (/* self.background == CSX.TEMPLATE && */ self.templateFile) {
    var fptr = Stdlib.convertFptr(self.templateFile);
    if (!fptr.exists) {
      var fld = ContactSheetUI.getTemplatesFolder();
      fptr = Stdlib.convertFptr(fld + '/' + fptr.name);
    }
    self.templateFile = fptr;
  }

  if (self.font && self.font.constructor == String) {
    self.font = ContactSheetConfig.toFont(self.font);
  }

  if (/* self.saveSheet && */ self.outputFolder) {
    self.outputFolder = Stdlib.convertFptr(self.outputFolder);
  }
  
  if (!self.uiX && !self.uiY) {
    self.uiX = self.uiY = 100;
  }

  return self;
};

ContactSheetConfig.prototype.toDescriptor = function() {
  //$.level = 1; debugger;
  var self = this;
  var desc = ContactSheetConfig.Table.toDescriptor(self);
  return desc;
};
ContactSheetConfig.prototype.fromDescriptor = function(desc) {
  //$.level = 1; debugger;
  var self = this;
  return ContactSheetConfig.Table.fromDescriptor(desc, self);
};

//
// ContactSheetUI
//
ContactSheetUI = function ContactSheetUI(obj) {
  var self = this;

  self.title = CSX.TITLE;
  self.notesSize = 0;
  self.winRect = {   // the rect for the Standard window
    x: 100, 
    y: 100,
    w: 900, // 1024 Max
    h: 731
  };
  self.documentation = undefined;

  self.iniFile = ContactSheetConfig.INI_FILE;
  self.saveIni = true;
  self.hasBorder = false;

  self.windowCreationProperties = { resizeable : true };

  self.setTabbed = function(on) {
    self.tabbed = on;

    if (self.tabbed) {
      self.winRect.w = 660;
      self.winRect.h = 500;

    } else {
      self.winRect.w = 900;
      self.winRect.h = 731;

      if (self.compressStandard) {
        self.winRect.h = 700;
      }
    }
  }

  self.center = false;
  self.setDefault = false;
  self.textOfs = (isCS2() ? 0 : 3);

  var defName = ContactSheetUI.getCSXFolder() + "/ContactSheetX.ini";
  var file = new File(defName);
  if (file.exists) {
    self.defaultIniFile = file;
  }

  self.compressStandard = (isWindows() && $.screens[0].bottom == 768);

  self.iniFileCheck();
};
ContactSheetUI.prototype = new GenericUI();

ContactSheetUI.notes = 
  ("This enhanced Contact Sheet script has been brought to you by xbytor, " +
   "The Icon, and The Warner Bros. PhotoLab. " +
   "For support, please visit http://ps-scripts.sourceforge.net.");

ContactSheetUI.prototype.insertModeButton = function(win, def) {
  if (win.mode) {
    win.remove(win.mode);
  }

  var wbnds = win.bounds;
  var top = wbnds.bottom - wbnds.top - 40;
  var x = wbnds.right-wbnds.left-80-20;
  var bnds = [x, top, x + 80, top+20];

  var btn = win.add('button', bnds, def);
  win.mode = btn;

  btn.onClick = function() {
    try {
      var pnl = this.parent;
      var win = GenericUI.getWindow(pnl);
      var mgr = win.mgr;

      win.ini.tabbed = !toBoolean(win.ini.tabbed);
      win.mgr.setTabbed(win.ini.tabbed);
      win.ini.uiX = win.bounds.x;
      win.ini.uiY = win.bounds.y;
      win.close(4);

      btn.text = (win.ini.tabbed ? 'Advanced' : 'Standard');

    } catch (e) {
      Stdlib.logException(e, "******* Error in CSX UI *******\r", true);
    }
  } 
};
ContactSheetUI.prototype.iniFileCheck = function() {
  var self = this;
  var f = new File(self.iniFile);
  if (!f.exists) {
    var defName = ContactSheetUI.getCSXFolder() + "/ContactSheetX.ini";
    var file = new File(defName);
    if (file.exists) {
      file.copy(f);
    }
  }
};

ContactSheetUI.prototype.createPanel = function(pnl, ini) {
  var self = this;

  if (self.tabbed) {
    self.winRect.w = 660;
    self.winRect.h = 500;
    return self.createTabbedPanel(pnl, ini);

  } else {
    self.winRect.w = 900;
    self.winRect.h = 731;

    if (self.compressStandard) {
      self.winRect.h = 700;
    }

    return self.createStandardPanel(pnl, ini);
  }
};

ContactSheetUI.prototype.createStandardPanel = function(pnl, ini) {
  var self = this;
  var opts = new ContactSheetConfig(ini);

  Stdlib.log("Creating standard panel");

//   Stdlib.log("winRect:\n" + listProps(self.winRect));
//   Stdlib.log("Window Bounds:\n" + listProps(pnl.parent.bounds));
//   Stdlib.log("Panel Bounds:\n" + listProps(pnl.bounds));

  self.insertModeButton(GenericUI.getWindow(pnl), 'Advanced');

  opts.rationalize();

  self.moveWindow(toNumber(opts.uiX), toNumber(opts.uiY));

  var panelWidth = 430;

  var height = pnl.bounds[3] - pnl.bounds[1];

  var xofs = 5;
  var yofs = 10;
  self.gutter = 105;
  self.xofs = 20;

  var yy = yofs;
  var xx = xofs;

  // Source Panel
  pnl.source = pnl.add('panel', [xx,yy,xx+panelWidth,yy+110], 'Source Images');
  self.createSourcePanel(pnl.source, opts);

  yy += 120;
  xx = xofs;

  // Document Panel
  var dph = 275;
  if (self.compressStandard) {
    dph = 245;
  }
  pnl.document = pnl.add('panel', [xx,yy,xx+panelWidth,yy+dph], 'Document');
  self.createDocumentPanel(pnl.document, opts);
  
  yy += dph+10;
  xx = xofs;

  // Layout Panel
  pnl.layoutPanel = pnl.add('panel', [xx,yy,xx+panelWidth,yy+245],
                            'Thumbnail Layout');
  self.createLayoutPanel(pnl.layoutPanel, opts);

  yy += 255;
  xx = xofs;

  // Notes Panel was here

  yy = yofs;
  xx += panelWidth + 10;

  // Caption Panel
  pnl.caption = pnl.add('panel', [xx,yy,xx+panelWidth,yy+160], 'Captions');
  self.createCaptionPanel(pnl.caption, opts);

  yy += 170;

  // Output
  pnl.output = pnl.add('panel', [xx,yy,xx+panelWidth,yy+300], 'Output');
  self.createOutputPanel(pnl.output, opts);

  yy += 305;

  // Settings
  pnl.settings = pnl.add('panel', [xx,yy,xx+panelWidth,yy+60], 'Settings');
  self.createSettingsPanel(pnl.settings, opts);

  yy += 70;

  // Notes Panel
  pnl.notes = pnl.add('panel', [xx,yy,xx+panelWidth,height]);
  self.createNotesPanel(pnl.notes, opts);

  return pnl;
};


ContactSheetUI.prototype.createTabbedPanel = function(pnl, ini) {
  var self = this;
  var opts = new ContactSheetConfig(ini);

  pnl.mgr = this;
  self.insertModeButton(GenericUI.getWindow(pnl), 'Standard');

  opts.rationalize();

  self.moveWindow(toNumber(opts.uiX), toNumber(opts.uiY));

  var panelWidth  = 630;
  var panelHeight = 315;

  var height = pnl.bounds[3] - pnl.bounds[1];

  var xofs = 5;
  var yofs = 10;
  self.gutter = 120;
  self.xofs = 20;

  var yy = yofs;
  var xx = xofs;

  pnl.selectors = pnl.add('group', [xx,yy,xx+panelWidth,yy+30]);

  var sel = pnl.selectors;
  sel.mgr = self;

  var y = 0;
  var x = 10;
  var btnW = 90;
  pnl.sourceBtn   = sel.add('radiobutton', [x,y,x+btnW,y+20], 'Source');
  x += btnW;
  pnl.documentBtn = sel.add('radiobutton', [x,y,x+btnW,y+20], 'Document');
  x += btnW;
  pnl.layoutBtn    = sel.add('radiobutton', [x,y,x+btnW,y+20], 'Layout');
  x += btnW;
  pnl.captionBtn  = sel.add('radiobutton', [x,y,x+btnW,y+20], 'Captions');
  x += btnW;
  pnl.outputBtn   = sel.add('radiobutton', [x,y,x+btnW,y+20], 'Output');
  x += btnW;
  pnl.advancedBtn = sel.add('radiobutton', [x,y,x+btnW,y+20], 'Advanced');
  x += btnW;
  pnl.settingsBtn = sel.add('radiobutton', [x,y,x+btnW,y+20], 'Settings');

  pnl.sourceBtn.onClick = function() {
    var sel = this.parent;
    var pnl = sel.parent;
    pnl.source.visible    = pnl.sourceBtn.value;
    pnl.document.visible  = pnl.documentBtn.value;
    pnl.layoutPanel.visible = pnl.layoutBtn.value;
    pnl.caption.visible   = pnl.captionBtn.value;
    pnl.output.visible    = pnl.outputBtn.value;
    pnl.advanced.visible  = pnl.advancedBtn.value;
    pnl.settings.visible  = pnl.settingsBtn.value;

    pnl.currentPanel = this.text;
  }
  pnl.documentBtn.onClick = pnl.layoutBtn.onClick = pnl.captionBtn.onClick =
  pnl.outputBtn.onClick = pnl.settingsBtn.onClick = pnl.advancedBtn.onClick =
  pnl.sourceBtn.onClick;
  

  yy += 30;

  // Source Panel
  pnl.source = pnl.add('panel', [xx,yy,xx+panelWidth,yy+panelHeight],
                       'Source Images');
  self.createSourcePanel(pnl.source, opts);

  // Document Panel
  pnl.document = pnl.add('panel', [xx,yy,xx+panelWidth,yy+panelHeight],
                         'Document');
  self.createDocumentPanel(pnl.document, opts);
  
  // Layout Panel
  pnl.layoutPanel = pnl.add('panel', [xx,yy,xx+panelWidth,yy+panelHeight],
                            'Thumbnail Layout');
  self.createLayoutPanel(pnl.layoutPanel, opts);

  // Caption Panel
  pnl.caption = pnl.add('panel', [xx,yy,xx+panelWidth,yy+panelHeight],
                        'Captions');
  self.createCaptionPanel(pnl.caption, opts);

  // Output
  pnl.output = pnl.add('panel', [xx,yy,xx+panelWidth,yy+panelHeight],
                       'Output');
  self.createOutputPanel(pnl.output, opts);

  // Advanced
  pnl.advanced = pnl.add('panel', [xx,yy,xx+panelWidth,yy+panelHeight],
                         'Advanced');
  self.createAdvancedPanel(pnl.advanced, opts);

  // Settings
  pnl.settings = pnl.add('panel', [xx,yy,xx+panelWidth,yy+panelHeight],
                         'Settings');
  self.createSettingsPanel(pnl.settings, opts);

  // Notes Panel
  pnl.notes = pnl.add('panel', [xx,height-62,xx+panelWidth,height]);
  self.createNotesPanel(pnl.notes, opts);

  if (opts.lastPanel) {
    var btn = pnl.sourceBtn;
    var parts = pnl.selectors.children;
    for (var i = 0; i < parts.length; i++) {
      var part = parts[i];
      if (part.text == opts.lastPanel) {
        btn = part;
        break;
      }
    }
    btn.notify();

  } else {
    pnl.sourceBtn.notify();
  }

  return pnl;
};

//
// We need to look at the options before the window opens to determine
// if we should create a tabbed or standard window.
// After that, we need to reset the createWindow prototype reference
//
ContactSheetUI.prototype.createWindow = function(ini, doc) {
  var self = this;

  Stdlib.log("Pre-UI Options:\n-------------------------\n");
  Stdlib.log(listProps(ini));
  Stdlib.log("-------------------------\n");

  self.setTabbed(ini && toBoolean(ini.tabbed));

  ContactSheetUI.prototype.createWindow = GenericUI.prototype.createWindow;

  return self.createWindow(ini, doc);
};

ContactSheetUI.prototype.validatePanel = function(pnl, ini) {
  var self = this;
  var opts = new ContactSheetConfig(ini);

  Stdlib.log("Validating settings");

  // Source
  var res = self.validateSourcePanel(pnl.source, opts);
  if (typeof(res) == 'boolean') {
    return res;
  }

  // Document
  var res = self.validateDocumentPanel(pnl.document, opts);
  if (typeof(res) == 'boolean') {
    return res;
  }

  // Layout
  var res = self.validateLayoutPanel(pnl.layoutPanel, opts);
  if (typeof(res) == 'boolean') {
    return res;
  }

  // Captions
  var res = self.validateCaptionPanel(pnl.caption, opts);
  if (typeof(res) == 'boolean') {
    return res;
  }

  // Output
  var res = self.validateOutputPanel(pnl.output, opts);
  if (typeof(res) == 'boolean') {
    return res;
  }

  // Advanced
  if (pnl.advanced) {
    var res = self.validateAdvancedPanel(pnl.advanced, opts);
    if (typeof(res) == 'boolean') {
      return res;
    }
  }

  opts.uiX = self.winX;
  opts.uiY = self.winY;

  if (self.tabbed && pnl.currentPanel) {
    opts.lastPanel = pnl.currentPanel;
  }

  Stdlib.log("Settings Validated");

  return opts;
};

//========================= Source Panel ==============================

ContactSheetUI._bridgeSelection = undefined;

//
// Returns true if Bridge is running there are files selected
//
ContactSheetUI._haveBridgeFiles = function(opts) {
  //$.level = 1; debugger;

  if (!opts.bridgeEnabled) {
    return false;
  }

  // if we haven't checked for files from Bridge yet
  if (ContactSheetUI._bridgeSelection == undefined) {
    if (!ContactSheetUI.isBridgeRunning()) {
      ContactSheetUI._bridgeSelection = [];
    }
  }

  if (ContactSheetUI._bridgeSelection == undefined) {
    if (ContactSheetUI.calledFromBridge()) {

      // and if files were passed over
      if (CSXBridge.files) {
        ContactSheetUI._bridgeSelection = CSXBridge.files;
        
        // Force the UI to default to Bridge
        opts.imageSource = CSX.BRIDGE;
      }
    }
  }

  // if we still don't have any files
  if (ContactSheetUI._bridgeSelection == undefined) {
    // Ask Bridge
    ContactSheetUI._bridgeSelection = XBridgeTalk.getBridgeSelection() || [];
  }

  return ContactSheetUI._bridgeSelection.length != 0;
};

ContactSheetUI._isBridgeRunning = undefined;
ContactSheetUI.isBridgeRunning = function() {
  if (ContactSheetUI._isBridgeRunning == undefined) {
    ContactSheetUI._isBridgeRunning = BridgeTalk.isRunning("bridge");
  }
  return ContactSheetUI._isBridgeRunning;
}

ContactSheetUI.prototype.createSourcePanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Creating Source Panel");

  var useBridge = ContactSheetUI._haveBridgeFiles(opts);

  var xofs = self.xofs;
  var yofs = 10;
  var gutter = self.gutter;

  var x = xofs;
  var y = yofs;

  var w = pnl.bounds[2] - pnl.bounds[0];

  pnl.mgr = this;

  // Image Source
  pnl.add('statictext', [x,y+self.textOfs,x+gutter,y+22+self.textOfs], 'Use:');
  x += gutter;

  var srcsel = ['Folder'];

  if (app.documents.length > 0) {
    srcsel.push('Open Documents');
  }

  if (useBridge) {
    srcsel.push('Selection From Bridge');
  }

  pnl.imageSource = pnl.add('dropdownlist', [x,y,x+200,y+22], srcsel);

  y += 28;
  x = xofs;

  // Images
  pnl.browse = pnl.add('button', [x,y,x+gutter-10,y+22], 'Images...');
  x += gutter;

  var textType = (isMac() ? 'statictext' : 'edittext');
  var xtofs = (isMac() ? 3 : 0);

  pnl.folder = pnl.add(textType, [x,y+xtofs,w-10,y+23+xtofs], '',
                       { readonly : true});
  y += 30;
  x = xofs;

  // Subfolders
  pnl.recurse = pnl.add('checkbox', [x,y,x+gutter+80,y+25],
                        'Include Subfolders');
  x += gutter + 90;

  // Group
  pnl.group = pnl.add('checkbox', [x,y,x+180,y+25], 'Group Images by Folder');

  var idx = 0;
  var src = ((opts.imageSource == CSX.BRIDGE) ?
             "Selection From Bridge" : opts.imageSource);
  var it = pnl.imageSource.find(src);
  if (it) {
    idx = it.index;
  }

  pnl.imageSource.selection = pnl.imageSource.items[idx];
  pnl.imageSource.items[idx].selected = true;

  pnl.folder.text = new Folder(opts.folder).toUIString();

  pnl.recurse.value = opts.recurse;
  pnl.group.value = !opts.spanFolders;
  
  pnl.browse.onClick = function() {
    try {
      var pnl = this.parent;
      var def = (pnl.folder.text ?
                 new Folder(pnl.folder.text) : Folder.current);
      var f = Stdlib.selectFolder('Browse for Folder', def);
      if (f) {
        pnl.folder.text = decodeURI(f.fsName);
      }
    } catch (e) {
      alert(Stdlib.exceptionMessage(e));
    }
  }
  pnl.imageSource.onChange = function() {
    try {
      var pnl = this.parent;
      var master = pnl.parent;
      var idx = pnl.imageSource.selection.index;
      var txt = pnl.imageSource.selection.text;

      var folder  = (txt == CSX.FOLDER);
      var openDocs = (txt == CSX.OPENDOCUMENTS);
      var bridge  = (txt == "Selection From Bridge");
      var sheets  = (txt == CSX.SHEETS);

      if (openDocs && app.documents.length == 0) {
        //alert("This setting is not available. No documents are open.");
        pnl.imageSource.items[0].selected = true;
        alert("Internal Error: Image Source not available");
        return;
      }

      pnl.browse.enabled  = !openDocs && !bridge;
      pnl.folder.enabled  = !openDocs && !bridge;
      pnl.recurse.enabled = folder;
      pnl.group.enabled   = folder && pnl.recurse.value;

      //self.getPageAndImageCounts();

    } catch (e) {
      alert(Stdlib.exceptionMessage(e));
    }
  }

  pnl.recurse.onClick = function() {
    var pnl = this.parent;
    pnl.group.enabled = pnl.recurse.value;
  }

  if (isCS3() || isCS4()) {
    pnl.imageSource.onChange();
  }
  return pnl;
};
ContactSheetUI.prototype.validateSourcePanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Validating Source panel");

  var seltxt = pnl.imageSource.selection.text;

  if (seltxt == CSX.OPENDOCUMENTS) {
    var docs = app.documents;
    var odocs = [];
    for (var i = 0; i < docs.length; i++) {
      odocs.push(docs[i]);
    }
    opts._openDocs = odocs;

  } else if (seltxt == CSX.FOLDER) {
    var f = undefined;

    s = pnl.folder.text;
    if (s) {
      f = new Folder(s);
    }
    if (!f || !f.exists) {
      return self.errorPrompt("Please specify a valid source folder.");
    }

    opts.folder = decodeURI(f.fsName);
    opts.recurse = pnl.recurse.value;
    opts.spanFolders = !pnl.group.value;

  } else if (seltxt.match(/bridge/i)) {
    // opts._fileList = ContactSheetUI._bridgeSelection;
  }

  var tag = seltxt;
  if (seltxt.match(/bridge/i)) {
    tag = CSX.BRIDGE;
  }

  opts.imageSource = tag;

  Stdlib.log("Source panel validated");

  return opts;
};

function numberKeystrokeFilter() {
  if (this.text.match(/[^\.\d]/)) {
    this.text = this.text.replace(/[^\.\d]/g, '');
  }
};

ContactSheetUI.getScriptFolder = function() { 
  return ContactSheetUI.getScriptFile().parent;
};
ContactSheetUI.getScriptFileName = function() {
  var f = ContactSheetUI.getScriptFile();
  return (f ? f.absoluteURI : '');
};
ContactSheetUI.getScriptFile = function() {
  var dbLevel = $.level;
  $.level = 0;
  var path = undefined;

  try {
    some_undefined_variable;
  } catch (e) {
    path = e.fileName;
  }

  if (path.startsWith('#')) {
    // we are probably being called from CSXBridge
    path = Stdlib.SCRIPTS_FOLDER + '/' + CSX.FILE;
  }

  $.level = dbLevel;
  return new File(path);
};

//
// Get the csx folder which should be a sub from where the script is located
//
ContactSheetUI.getCSXFolder = function() {

  if (!ContactSheetUI._csxFolder) {
    var root = ContactSheetUI.getScriptFolder();
    var f = new Folder(root + "/csx");

    if (!f.exists) {
      // XXX check for the CS3 script name bug
      if (root.toString() == app.path.toString()) {
        f = new Folder(Stdlib.SCRIPTS_FOLDER + "/csx");
        if (!f.exists) {
          f = f.parent;
        }
      } else {
        f = root;
      }
    }
    ContactSheetUI._csxFolder = f;

    if (!ContactSheetUI._csxFolder.exists) {
      alert("No CSX Folder was found");
    }
  }

  return ContactSheetUI._csxFolder;
};
ContactSheetUI.getTemplatesFolder = function() {
  if (!ContactSheetUI._templatesFolder) {
    var csx = ContactSheetUI.getCSXFolder();
    ContactSheetUI._templatesFolder = new Folder(csx + "/templates");
  }

  return ContactSheetUI._templatesFolder;
};

//========================= Document Panel ==============================

ContactSheetUI.prototype.setPreviewImage = function(pnl, opts) {
  var self = this;

  if (!self.tabbed) {
    return;
  }

  try {
    var file = pnl.templateFile.text;

    if (!file) {
      pnl.previewImage.visible = false;
      return;
    }

    file = new File(file);
    if (!file.exists) {
      pnl.previewImage.visible = false;
      return;
    }

    var pngFileName = file.strf("%d/%f.png");
    var pngFile = new File(pngFileName);

    if (!pngFile.exists) {
      pnl.previewImage.visible = false;
      return;
    }

    pnl.previewImage.icon = pngFile;
    pnl.previewImage.visible = true;

  } catch (e) {
    // ignore any exceptions....
    pnl.previewImage.visible = false;
  }
};

ContactSheetUI.prototype.createDocumentPanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Creating Document Panel");

  var xofs = self.xofs;
  var yofs = 10;
  var gutter = self.gutter;

  var x = xofs;
  var y = yofs;

  var w = pnl.bounds[2] - pnl.bounds[0];

  var tOfs = self.textOfs;

  pnl.mgr = this;

  // Background
  pnl.add('statictext', [x,y+tOfs,x+80,y+22+tOfs], 'Background:');
  x += gutter;
  pnl.background = pnl.add('dropdownlist', [x,y,x+gutter,y+22],
                          ['Template',
                           'Black',
                           'White',
                           'Foreground',
                           'Background',
                           'None']);

  var items = pnl.background.items;
  var idx = 0;
  for (var i = 0; i < items.length; i++) {
    var it = items[i];
    if (it.text == opts.background) {
      idx = i;
      break;
    }
  }
  pnl.background.items[idx].selected = true;

  pnl.background.onChange = function() {
    try {
      var pnl = this.parent;
      var selection = pnl.background.selection;
      var templ = (selection && selection.text == 'Template');

      var ws = ["unitsLabel", "units", "width", "widthLabel",
                "height", "heightLabel", "resolution", "resolutionLabel",
                "resUnits", "mode", "modeLabel", "marginPanel",
                "colorProfileLabel", "colorProfile"];

      for (var i = 0; i < ws.length; i++) {
        if (pnl[ws[i]]) {
          pnl[ws[i]].enabled = !templ;
          if (pnl.templateVars) {
            pnl[ws[i]].visible = !templ;
          }
        }
      }

      pnl.templateBrowse.enabled = templ;
      pnl.templateFile.enabled = templ;

      if (pnl.preview) {
        pnl.preview.visible = templ;

        if (templ) {
          pnl.mgr.setPreviewImage(pnl);
        }
      }

      if (pnl.templateVars) {
        pnl.templateVars.visible = templ;
      }

    } catch (e) {
      alert(Stdlib.exceptionMessage(e));
    }
  }

  // Template
  y += 28;
  x = xofs;
  pnl.templateBrowse = pnl.add('button', [x,y,x+gutter-10,y+22],
                               'Template...');
  x += gutter;
  var textType = (isMac() ? 'statictext' : 'edittext');
  var xtofs = (isMac() ? 3 : 0);

  pnl.templateFile = pnl.add(textType, [x,y+xtofs,w-10,y+23+xtofs], '',
                             { readonly : true});

  if (opts.templateFile) {
    if (opts.templateFile.fsName) {
      pnl.templateFile.text = decodeURI(opts.templateFile.fsName);
    } else {
      pnl.templateFile.text = opts.templateFile;
    }
    idx = 0;
  }

  pnl.templateBrowse.onClick = function() {
    try {
      var pnl = this.parent;
      var def;
      if (pnl.templateFile.text) {
        def = new File(pnl.templateFile.text);
      } else {
        var def = ContactSheetUI.getTemplatesFolder();
        if (!def.exists) {
          def = def.parent;
        }
      }

      var fsel = Stdlib.createFileSelect("Template Files: *.psd");

      var f = Stdlib.selectFileOpen("Select a CSX Template file",
                                    fsel, def);

      if (f) {
        pnl.templateFile.text = decodeURI(f.fsName);

        if (pnl.preview) {
          pnl.mgr.setPreviewImage(pnl);
        }
      }
    } catch (e) {
      alert(Stdlib.exceptionMessage(e));
    }
  }

  y += 28;
  x = xofs;

  // Units
  pnl.unitsLabel = pnl.add('statictext',
                           [x,y+tOfs,x+gutter,y+22+tOfs],
                           'Units:');
  x += gutter;
  pnl.units = pnl.add('dropdownlist', [x,y,x+70,y+20], ['px','in','cm']);

  var idx = 0;
  if (opts.docUnits == 'Pixl') idx = 0;
  if (opts.docUnits == 'Inch') idx = 1;
  if (opts.docUnits == 'Cmtr') idx = 2;
  pnl.units.items[idx].selected = true;
  pnl.units.orig = pnl.units.items[idx].text;

  pnl.units.onChange = function() {
    try {
      var pnl = this.parent;
      var newUnits = pnl.units.selection.text;
      var oldUnits = pnl.units.orig;
      var res = toNumber(pnl.resolution.text);
      if (isNaN(res)) {
        return;
      }
      if (!pnl.resUnits.selection) {
        return;
      }
      if (pnl.resUnits.selection.text == 'PpCm') {
        res *= 2.54;
      }
      var fact = 1;

      if (oldUnits == 'in') {
        if (newUnits == 'px') {
          fact = res;
        } else {
          fact = 2.54;
        }
      } else if (oldUnits == 'cm') {
        if (newUnits == 'px') {
          fact = res/2.54;
        } else {
          fact = 1/2.54;
        }
      } else if (oldUnits == 'px') {
        if (newUnits == 'in') {
          fact = 1/res;
        } else {
          fact = 2.54/res;
        }
      }
      pnl.units.orig = newUnits;

      function toField(n) {
        var s = Number(n).toFixed(2);
        return s.replace(/\.00$/, '');
      }

      if (fact != 1) {
        var w = toNumber(pnl.width.text);
        if (!isNaN(w)) pnl.width.text = toField(w * fact);

        var h = toNumber(pnl.height.text);
        if (!isNaN(h)) pnl.height.text = toField(h * fact);
      }

    } catch (e) {
      alert(Stdlib.exceptionMessage(e));
    }
  }

  // Width
  y += 25;
  x = xofs;

  pnl.widthLabel = pnl.add('statictext',
                           [x,y+tOfs,x+gutter,y+22+tOfs],
                           'Width:');
  x += gutter;
  pnl.width = pnl.add('edittext', [x,y,x+50,y+20], opts.docWidth);

  pnl.width.onChanging = numberKeystrokeFilter;

  if (opts.tabbed) {
    y += 25;
    x = xofs;

  } else {
    x += 90;
  }

  // Height
  pnl.heightLabel = pnl.add('statictext',
                            [x,y+tOfs,x+gutter,y+22+tOfs],
                            'Height:');
  x += gutter;
  pnl.height = pnl.add('edittext', [x,y,x+50,y+20], opts.docHeight);
  pnl.height.onChanging = numberKeystrokeFilter;

  // Margin Panel
  y += 25;
  x = xofs;
  pnl.marginPanel = pnl.add('group', [x,y,x+375,y+60], 'Margins')

  y += 60;
  x = xofs;

  // Resolution
  pnl.resolutionLabel = pnl.add('statictext',
                                [x,y+tOfs,x+gutter,y+22+tOfs],
                                'Resolution:');
  x += gutter;
  pnl.resolution = pnl.add('edittext', [x,y,x+50,y+22], opts.resolution);
  x += 55;

  // Res Units
  pnl.resUnits = pnl.add('dropdownlist', [x,y,x+90,y+22],
                         ['pixels/in', 'pixels/cm']);
  var idx = 0;
  if (opts.resUnits == 'PpIn') idx = 0;
  if (opts.resUnits == 'PpCm') idx = 1;
  pnl.resUnits.items[idx].selected = true;
  pnl.resUnits.orig = pnl.resUnits.items[idx].text;

  pnl.resUnits.onChange = function() {
    try {
      var pnl = this.parent;
      var res = toNumber(pnl.resolution.text);
    
      if (isNaN(res)) {
        return;
      }
      if (!pnl.resUnits.selection) {
        return;
      }
      var newUnits = pnl.resUnits.selection.text;
      var origUnits = pnl.resUnits.orig;

      function toField(n) {
        var s = Number(n).toFixed(2);
        return s.replace(/\.0\d$/, '');
      }

      if (origUnits == 'pixels/in') {
        if (newUnits == 'pixels/cm') {
          pnl.resolution.text = toField(res / 2.54);
        }
      } else if (origUnits == 'pixels/cm') {
        if (newUnits == 'pixels/in') {
          pnl.resolution.text = toField(res * 2.54);
        }
      }
      pnl.resUnits.orig = newUnits;

    } catch (e) {
      alert(Stdlib.exceptionMessage(e));
    }
  };

  pnl.resolution.onChanging = numberKeystrokeFilter;

  y += 32;
  x = xofs;
  
  //
  // Color Mode
  //
  pnl.modeLabel = pnl.add('statictext',
                          [x,y+tOfs,x+gutter,y+22+tOfs],
                          'Mode:');
  x += gutter;
  pnl.mode = pnl.add('dropdownlist', [x,y,x+110,y+22],
                     ['Grayscale',
                      'RGB Color',
                      'CMYK Color',
                      'Lab Color']);
  var idx = 1;
  var m = ContactSheetConfig.toMode(opts.mode.toString());
  if (m == NewDocumentMode.GRAYSCALE) idx = 0;
  if (m == NewDocumentMode.RGB)       idx = 1;
  if (m == NewDocumentMode.CMYK)      idx = 2;
  if (m == NewDocumentMode.LAB)       idx = 3;
  pnl.mode.items[idx].selected = true;


  //
  // Color Profile
  //
  if (self.tabbed) {
    var colorProfileList = self.colorProfileList = [CSX.DEFAULT_PROFILE];
    for (var idx in ColorProfileNames) {
      colorProfileList.push(ColorProfileNames[idx]);
    }

    var cpMenu = colorProfileList.slice(0);
    cpMenu.push('-');
    cpMenu.push(CSX.FIRST_IMAGE_PROFILE);
    cpMenu.push('-');
    cpMenu.push('Other...');
    cpMenu.push('-');

    if (opts.colorProfile && !cpMenu.contains(opts.colorProfile)) {
      cpMenu.push(opts.colorProfile);
    }

    x = xofs;
    y += 32;
    pnl.colorProfileLabel = pnl.add('statictext',
                                    [x,y+tOfs,x+gutter,y+22+tOfs],
                                    'Color Profile:');
    x += gutter;
    pnl.colorProfile = pnl.add('dropdownlist', [x,y,x+200,y+22], cpMenu);

    var idx = 0;
    var profile = opts.colorProfile || CSX.DEFAULT_PROFILE;

    for (var i = 0; i < cpMenu.length; i++) {
      if (profile == cpMenu[i]) {
        idx = i;
        break;
      }
    }
 
    pnl.colorProfile.items[idx].selected = true;
    pnl.colorProfile._lastSelected = pnl.colorProfile.items[idx];

    pnl.colorProfile.onChange = function() {
      var pnl = this.parent;
      var sel = pnl.colorProfile.selection;
      if (!sel) {
        return;
      }
      var profile = sel.text;
      var items = pnl.colorProfile.items;

      if (profile == 'Other...') {
        var fpat = "Profiles: *.icc; *.icm";
        var profileFolder = CSX.COLOR_PROFILE_FOLDER;

        var files = profileFolder.getFiles(/\.ic(c|m)$/i);
        var def = files[0];

        var f = Stdlib.selectFileOpen("Select a Color Profile", fpat, def);

        if (f) {
          var name = decodeURI(f.name).replace(/\.(icc|icm)$/i, '');
          var nameLC = name.toLowerCase();

          for (var i = 0; i < items.length; i++) {
            var text = items[i].text.toLowerCase();
            var nspc = text.replace(/\W/g, '');
            if (text == nameLC || nspc == nameLC) {
              break;
            }
          }

          if (i == items.length) {
            var item = pnl.colorProfile.add('item', name);
            pnl.colorProfile.selection = item;
            pnl.colorProfile._lastSelected = item;

          } else {
            items[i].selected = true;
            pnl.colorProfile._lastSelected = item;
          }

        } else {
          pnl.colorProfile._lastSelected.selected = true;
        }
      }

      pnl.colorProfile._lastSelected = pnl.colorProfile.selection;
    }

    pnl.colorProfile.onChange();
  }


  x = xofs;
  y += 37;
  
  function createMarginPanel(pnl, opts) {
    var x = 0;
    var y = 0;
    var tOfs = pnl.textOfs;
    // Margins
    pnl.marginsEnabled = pnl.add('checkbox', [x,y,x+80,y+22], 'Margins:');
    pnl.marginsEnabled.value = opts.marginsEnabled;

    x += gutter;
    pnl.leftLabel = pnl.add('statictext', [x,y+tOfs,x+12,y+22+tOfs], 'L:');
    x += 15;
    pnl.leftMargin = pnl.add('edittext', [x,y,x+40,y+20]);
    pnl.leftMargin.text = opts.leftMargin;
    pnl.leftMargin.onChanging = numberKeystrokeFilter;
    x += 45;
    pnl.rightLabel = pnl.add('statictext', [x,y+tOfs,x+12,y+22+tOfs], 'R:');
    x += 15;
    pnl.rightMargin = pnl.add('edittext', [x,y,x+40,y+20]);
    pnl.rightMargin.text = opts.rightMargin;
    pnl.rightMargin.onChanging = numberKeystrokeFilter;
    x += 45;
    pnl.topLabel = pnl.add('statictext', [x,y+tOfs,x+12,y+22+tOfs], 'T:');
    x += 15;
    pnl.topMargin = pnl.add('edittext', [x,y,x+40,y+20]);
    pnl.topMargin.text = opts.topMargin;
    pnl.topMargin.onChanging = numberKeystrokeFilter;
    x += 45;
    pnl.bottomLabel = pnl.add('statictext', [x,y+tOfs,x+12,y+22+tOfs], 'B:');
    x += 15;
    pnl.bottomMargin = pnl.add('edittext', [x,y,x+40,y+20]);
    pnl.bottomMargin.text = opts.bottomMargin;
    pnl.bottomMargin.onChanging = numberKeystrokeFilter;

    x = gutter;
    var ty = y + 30
    pnl.alternateMargins = pnl.add('checkbox', [x,ty,x+180,ty+22],
                                   'Alternate L/R Margins');
    pnl.alternateMargins.value = opts.alternateMargins;

    pnl.marginsEnabled.onClick = function() {
      var pnl = this.parent;
      var on = pnl.marginsEnabled.value;
      var els = ["leftLabel", "leftMargin", "rightLabel", "rightMargin",
                 "topLabel", "topMargin", "bottomLabel", "bottomMargin",
                 "alternateMargins"];
      for (var i = 0; i < els.length; i++) {
        pnl[els[i]].enabled = on;
      }
    }
    pnl.marginsEnabled.onClick();
  }

  pnl.marginPanel.textOfs = self.textOfs;
  createMarginPanel(pnl.marginPanel, opts);

  x = xofs;
  y += 35;

  if (self.tabbed) {
    y = 70;
    x = xofs;

    // Template Variables
    pnl.templateVars = pnl.add('panel', [x,y,x+380,y+230],
                               'Template Variables');

    self.createTemplateVariablesPanel(pnl.templateVars, opts);

    // Preview
    x = 410;
    pnl.preview = pnl.add('panel', [x,y,x+200,y+230], 'Preview');
    pnl.previewImage = pnl.preview.add('image', [10,10,180,210]);
  }

  if (isCS3() || isCS4()) {
    pnl.background.onChange();
  }
  return pnl;
};

ContactSheetUI.prototype.createTemplateVariablesPanel = function(pnl, opts) {
  var self = this;

  var xofs = 10;
  var yofs = 15;
  var gutter = self.gutter;

  var x = xofs;
  var y = yofs;

  var w = pnl.bounds[2] - pnl.bounds[0];

  var vars = [];
  for (var idx in opts) {
    if (idx.charAt(0) == '@') {
      var v = {
        name: idx.substr(1),
        value: opts[idx]
      }
      vars.push(v);
    }
  }
  function checkClick() {
    var check = this;
    var pnl = check.parent;
    check.name.enabled = check.value;
    check.val.enabled = check.value;
  }
  for (var i = 0; i < 7; i++) {
    var name = "var" + i + "-Check";

    var check = pnl.add('checkbox', [x,y,x+20,y+20]);
    check._name = name;    
    check.onClick = checkClick;
    pnl[name] = check;
    x += 25;
    check.name = pnl.add('edittext', [x,y,x+gutter-5,y+20], '');
    x += gutter;
    check.val = pnl.add('edittext', [x,y,x+gutter+90,y+20], '');
    y += 30;
    x = xofs;

    if (vars.length) {
      var v = vars.shift();
      check.name.text = v.name;
      check.val.text = v.value;
      check.value = true;
    }
    check.onClick();
  }


  return pnl;
};

ContactSheetUI.prototype.validateDocumentPanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Validating Document panel");

  var f = undefined;
  opts.background = pnl.background.selection.text;

  if (opts.background == 'Template') {
    f = new File(pnl.templateFile.text);
    if (!f.exists) {
      return self.errorPrompt("Unable to find template file image");
    }
    opts.templateFile = decodeURI(f.fsName);
  }

  if (opts.background != 'Template') {
    // Units
    var s = pnl.units.selection.text;
    var min = 200;
    if (s == 'px') {
      opts.docUnits = 'Pixl';
      min = 200;
    } else if (s == 'in') {
      opts.docUnits = 'Inch'
      min = 2;
    } else if (s == 'cm') {
      opts.docUnits = 'Cmtr'
      min = 5;
    }

    // Width
    //var n = self.getNumber(pnl.width.text, "width", 100, 2900, 576);
    var n = self.getNumber(pnl.width.text, "width", min, 20000, 2400);
    if (typeof n != "number") {
      return n;
    }
    opts.docWidth = n;
    
    // Height
    n = self.getNumber(pnl.height.text, "height", min, 20000, 3000);
    if (typeof n != "number") {
      return n;
    }
    opts.docHeight = n;

    // Margins
    var mpnl = pnl.marginPanel;
    opts.marginsEnabled = mpnl.marginsEnabled.value;

    if (opts.marginsEnabled) {
      n = self.getNumber(mpnl.leftMargin.text, "margin - left",
                         0, 1000, 0);
      if (typeof n != "number") {
        return n;
      }
      opts.leftMargin = n;
      
      n = self.getNumber(mpnl.rightMargin.text, "margin - right",
                         0, 1000, 0);
      if (typeof n != "number") {
        return n;
      }
      opts.rightMargin = n;
      
      n = self.getNumber(mpnl.topMargin.text, "margin - top",
                         0, 1000, 0);
      if (typeof n != "number") {
        return n;
      }
      opts.topMargin = n;
      
      n = self.getNumber(mpnl.bottomMargin.text, "margin - bottom",
                         0, 1000, 0);
      if (typeof n != "number") {
        return n;
      }
      opts.bottomMargin = n;

      opts.alternateMargins = mpnl.alternateMargins.value;
    }
    
    
    // Resolution
    n = self.getNumber(pnl.resolution.text, "resolution", 25, 1200, 72.0);
    if (typeof n != "number") {
      return n;
    }
    opts.resolution = n;
    
    // Resolution Units
    s = pnl.resUnits.selection.text;
    if (s == 'pixels/in') {
      opts.resUnits = 'PpIn';
    } else if (s == 'pixels/cm') {
      opts.resUnits = 'PpCm';
    }

    // Mode
    opts.mode = ContactSheetConfig.toModeStr(pnl.mode.selection.text);

    // Color Profile
    if (self.tabbed) {
      opts.colorProfile = pnl.colorProfile.selection.text;
    }
  }

  if (opts.background == 'Template') {

    // Template Variables
    if (pnl.templateVars) {
      for (var i = 0; i < 20; i++) {
        var name = "var" + i + "-Check";
        var check = pnl.templateVars[name];
        if (!check) {
          break;
        }
        if (check.value) {
          var nm = check.name.text;
          var val = check.val.text;
          if (nm) {
            opts['@' + nm] = val;
          }
        }
      }
    }
  }

  Stdlib.log("Document panel validated");

  return opts;
};

//========================= Layout Panel ==============================

ContactSheetUI.prototype.createLayoutPanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Creating Layout Panel");

  var xofs = self.xofs;
  var yofs = 10;
  var gutter = self.gutter;

  var x = xofs;
  var y = yofs;

  var tOfs = self.textOfs

  var w = pnl.bounds[2] - pnl.bounds[0];

  // Place
  pnl.add('statictext', [x,y+tOfs,x+gutter,y+22+tOfs], 'Place:');
  x += gutter;
  pnl.place = pnl.add('dropdownlist', [x,y,x+140,y+20],
                      ['across first','down first']);

  if (opts.acrossFirst) {
    pnl.place.items[0].selected = true;
  } else {
    pnl.place.items[1].selected = true;
  }

  y += 25;
  x = xofs;

  // Alignment
  pnl.add('statictext', [x,y+tOfs,x+gutter,y+22+tOfs], 'Alignment:');
  x += gutter;
  pnl.valign = pnl.add('dropdownlist', [x,y,x+140,y+20],
                       ['Top','Middle', 'Bottom']);

  var idx = 1;
  if (opts.valign == 'Top')    idx = 0;
  if (opts.valign == 'Middle') idx = 1;
  if (opts.valign == 'Bottom') idx = 2;
  pnl.valign.items[idx].selected = true;

  x += 145;
  pnl.halign = pnl.add('dropdownlist', [x,y,x+138,y+20],
                       ['Left','Center', 'Right']);

  var idx = 1;
  if (opts.halign == 'Left')   idx = 0;
  if (opts.halign == 'Center') idx = 1;
  if (opts.halign == 'Right')  idx = 2;
  pnl.halign.items[idx].selected = true;

  y += 25;
  x = xofs;

  // Columns
  pnl.add('statictext', [x,y+tOfs,x+gutter,y+22+tOfs], 'Columns:');
  x += gutter;
  pnl.cols = pnl.add('edittext', [x,y,x+50,y+20], opts.columnCount);
  pnl.cols.onChanging = numberKeystrokeFilter;

  x += 90;

  // Rows
  pnl.add('statictext', [x,y+tOfs,x+gutter,y+22+tOfs], 'Rows:');
  x += gutter;
  pnl.rows = pnl.add('edittext', [x,y,x+50,y+20], opts.rowCount);
  pnl.rows.onChanging = numberKeystrokeFilter;

  y += 30;
  x = xofs;

  // Autospacing
  pnl.autoSpacing = pnl.add('checkbox', [x,y,x+150,y+22], 'Use Auto-Spacing');
  pnl.autoSpacing.value = opts.useAutoSpacing;
  pnl.autoSpacing.onClick = function() {
    var pnl = this.parent;
    var st = !pnl.autoSpacing.value;

    pnl.vert.enabled         = st;
    pnl.vertLabel.enabled    = st;
    pnl.horz.enabled         = st;
    pnl.horzLabel.enabled    = st;
    pnl.spacingUnitsLabel.enabled = st;
    pnl.spacingUnits.enabled = st;
  }

  x += gutter + 90;

  // Autospacing Units
  pnl.spacingUnitsLabel = pnl.add('statictext',
                                  [x,y+tOfs,x+gutter,y+22+tOfs],
                                  'Spacing Units:');
  x += gutter;
  pnl.spacingUnits = pnl.add('dropdownlist', [x,y,x+70,y+20],
                             ['px','in','cm']);

  pnl.spacingUnitsLabel.enabled = false;
  pnl.spacingUnits.enabled = false;

  var idx = 0;
  if (opts.spacingUnits == 'px') idx = 0;
  if (opts.spacingUnits == 'in') idx = 1;
  if (opts.spacingUnits == 'cm') idx = 2;
  pnl.spacingUnits.items[idx].selected = true;

  pnl.spacingUnits.onChange = function() {
    return;
  }

  y += 30;
  x = xofs;

  // Vertical
  pnl.vertLabel = pnl.add('statictext',
                          [x,y+tOfs,x+gutter,y+22+tOfs],
                          'Vertical:');
  x += gutter;
  pnl.vert = pnl.add('edittext', [x,y,x+50,y+20], opts.vertical);

  x += 90;
  
  // Horizontal
  pnl.horzLabel = pnl.add('statictext',
                          [x,y+tOfs,x+gutter,y+22+tOfs],
                          'Horizontal:');
  x += gutter;
  pnl.horz = pnl.add('edittext', [x,y,x+50,y+20], opts.horizontal);

  y += 25;
  x = xofs;

  // Autofill
  pnl.autoFill = pnl.add('checkbox', [x,y,x+gutter,y+22], 'Auto-fill');
  pnl.autoFill.value = opts.autoFill;

  if (opts.tabbed) {
    y += 30;
  } else {
    x += gutter + 90;
  }

  // Square Cell
  pnl.squareCell = pnl.add('checkbox',
                           [x,y,x+175,y+22],
                           'Constrain to Square');
  pnl.squareCell.value = opts.squareCell;

  y += 30;
  x = xofs;
  // Best fit
  pnl.bestFit = pnl.add('checkbox',
                        [x,y,x+175,y+22],
                        'Rotate For Best Fit');
  pnl.bestFit.value = opts.bestFit;

  pnl.bestFit.onClick = function() {
    var pnl = this.parent;
    pnl.rotate.enabled = pnl.bestFit.value;
  }

  x += gutter + 90;

  // CW/CCW
  pnl.rotate = pnl.add('dropdownlist', [x,y,x+70,y+22], ['CW', 'CCW']);
  var idx = 0;
  if (opts.rotate == 'CW')  idx = 0;
  if (opts.rotate == 'CCW') idx = 1;
  pnl.rotate.items[idx].selected = true;

  pnl.rotate.enabled = pnl.bestFit.value;

  y += 30;
  x = xofs;

  // Layer Style
  pnl.styleLabel = pnl.add("statictext",
                           [x,y+tOfs,x+gutter,y+22+tOfs],
                           "Layer Style:");
  x += gutter;

  pnl.style = pnl.add("dropdownlist", [x,y,x+160,y+22]);
  var pm = new PresetsManager();
  pm.populateDropdownList(PresetType.STYLES, pnl.style, true);
  var it = pnl.style.find(opts.thumbStyle);
  if (it) {
    it.selected = true;
  } else {
    pnl.style.items[0].selected = true;
  }

  x = xofs;

  pnl.autoSpacing.onClick();

  return pnl;
};

ContactSheetUI.prototype.validateLayoutPanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Validating Layout panel");

  // Across First
  opts.acrossFirst = (pnl.place.selection.text == 'across first');

  // Columns
  n = self.getNumber(pnl.cols.text, "columns", 1, 30, 5);
  if (typeof n != "number") {
    return n;
  }
  opts.columnCount = n;

  // Rows
  n = self.getNumber(pnl.rows.text, "rows", 1, 30, 6);
  if (typeof n != "number") {
    return n;
  }
  opts.rowCount = n;

  // AutoSpacing
  opts.useAutoSpacing = pnl.autoSpacing.value;

  opts.spacingUnits = pnl.spacingUnits.selection.text;

  if (!opts.useAutoSpacing) {
    // Vertical
    n = self.getNumber(pnl.vert.text, "vertical spacing", 0, 1000, 1);
    if (typeof n != "number") {
      return n;
    }
    opts.vertical = n;

    // Horizontal
    n = self.getNumber(pnl.horz.text, "horizontal spacing", 0, 1000, 1);
    if (typeof n != "number") {
      return n;
    }
    opts.horizontal = n;
  }

  // Best Fit
  opts.bestFit = pnl.bestFit.value;

  // Rotate
  opts.rotate = pnl.rotate.selection.text;

  // Auto-fill
  opts.autoFill = pnl.autoFill.value;

  // Square Thumb
  opts.squareCell = pnl.squareCell.value;

  // Vertical Alignment
  opts.valign = pnl.valign.selection.text;

  // Horizontal Alignment
  opts.halign = pnl.halign.selection.text;

  // Layer Style
  opts.thumbStyle = pnl.style.selection.text; 

  Stdlib.log("Layout panel validated");

 return opts;
};


//========================= Caption Panel ==============================

ContactSheetUI.prototype.createCaptionPanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Creating Caption Panel");

  var xofs = self.xofs;
  var yofs = 10;
  var gutter = self.gutter;

  var x = xofs;
  var y = yofs;

  var tOfs = self.textOfs;

  var w = pnl.bounds[2] - pnl.bounds[0];

  pnl.mgr = this;
  pnl.initialized = false;

  pnl.caption = pnl.add('checkbox', [x,y,x+100,y+22], 'Enabled');
  pnl.caption.value = opts.caption;

  pnl.caption.onClick = function() {
    var pnl = this.parent;
    var st = pnl.caption.value;
    pnl.useFile.enabled = st;
    pnl.noExtensions.enabled = st && pnl.useFile.value;
    pnl.font.enabled = st;
    pnl.colorListLabel.enabled = st;
    pnl.colorList.enabled = st;
    pnl.fontColorIcon.enabled = st;
    pnl.style.enabled = st;
    pnl.styleLabel.enabled = st;
    pnl.overlayCaption.enabled = st;
    pnl.capAlignLabel.enabled = st;
    pnl.capAlignment.enabled = st;
    pnl.capVAlignment.enabled = st;

    pnl.setCaptionFormatState(st);
  }

  pnl.setCaptionFormatState = function(st) {
    var pnl = this;
    if (!pnl.mgr.tabbed) {
      return;
    }
    if (!pnl.captionFormatLabel) {
      return;
    }

    st = st && !pnl.useFile.value;
    pnl.captionFormatLabel.visible = st;
    pnl.captionFormat.visible = st;
    pnl.captionFormatNote.visible = st;
//     pnl.captionFormatAdd.visible = st;
    pnl.captionFormatDesc1.visible = st;
    pnl.captionFormatDesc2.visible = st;
    pnl.captionFormatHelp.visible = st;
  }

  x += 100;

  pnl.overlayCaption = pnl.add('checkbox', [x,y,x+80,y+22], 'Overlay');
  pnl.overlayCaption.value = opts.overlayCaption;

  x += 100;

  pnl.useFile = pnl.add('checkbox', [x,y,x+100,y+22], 'Filename');
  pnl.useFile.value = opts.captionFilename;
  pnl.useFile.onClick = function() {
    var pnl = this.parent;
    var st = pnl.caption.value;
    pnl.noExtensions.enabled = st && pnl.useFile.value;
    pnl.setCaptionFormatState(st);
  }

  x += 100;
  pnl.noExtensions = pnl.add('checkbox', [x,y,x+120,y+22], 'No Extension');
  pnl.noExtensions.value = opts.noExtensions;

  x += 120;
  y += 35;
  x = xofs;


  // Font
  pnl.font = pnl.add('group', [x,y,x+440,y+30]);
  self.createFontPanel(pnl.font, opts);
  pnl.font.setFont(opts.font, opts.fontSize);

  x = xofs;
  y += 35; 

  // Font Color
  pnl.colorListLabel = pnl.add("statictext",
                               [x,y+tOfs,x+40,y+22+tOfs],
                               "Color:");
  x += 40;
  pnl.colorList = pnl.add('dropdownlist',
                          [x,y,x+130,y+22],
                          ['Black',
                           'White',
                           'Foreground',
                           'Background',
                           'RGB...']);

  pnl.colorList.isRGB = function() {
    return this.selection && this.selection.text == "RGB...";
  }

  x += 150;
  pnl.fontColorIcon = pnl.add('iconbutton', [x,y,x+44,y+24],
                              undefined, {style: 'button'});
  ContactSheetUI.configColorButton(pnl.fontColorIcon, "#000000");

  pnl.colorList.onChange = function() {
    var pnl = this.parent
    if (!pnl.initialized) {
      return;
    }
    var txt = pnl.colorList.selection.text;
    if (txt == 'Foreground') {
      pnl.fontColorIcon.setColor(app.foregroundColor);
    } else if (txt == 'Background') {
      pnl.fontColorIcon.setColor(app.backgroundColor);
    } else if (txt == 'Black') {
      pnl.fontColorIcon.setColor("0,0,0");
    } else if (txt == 'White') {
      pnl.fontColorIcon.setColor("255,255,255");
    } else {
      pnl.fontColorIcon.onClick();
    }
  }

  if (opts.fontColor) {
    var txt = opts.fontColor;
    if (opts.fontColor.typename == "SolidColor") {
      pnl.fontColorIcon.setColor(opts.fontColor);
      txt = 'RGB...';
    }
    var it = pnl.colorList.find(txt);
    if (it) {
      pnl.colorList.selection = it;
    } else {
      pnl.colorList.selection = pnl.colorList.items[0];
    }
    if (txt == 'Foreground') {
      pnl.fontColorIcon.setColor(app.foregroundColor);
    } else if (txt == 'Background') {
      pnl.fontColorIcon.setColor(app.backgroundColor);
    } else if (txt == 'Black') {
      pnl.fontColorIcon.setColor("0,0,0");
    } else if (txt == 'White') {
      pnl.fontColorIcon.setColor("255,255,255");
    }
  }

  pnl.fontColorIcon.onColorChange = function() {
    var pnl = this.parent;
    var clr = pnl.fontColorIcon._color;
    var menuItem = "RGB...";

    if (clr.rgb.hexValue == '000000') {
      menuItem = 'Black';
    } else if (clr.rgb.hexValue == 'FFFFFF') {
      menuItem = 'White';
    } else if (clr.isEqual(app.foregroundColor)) {
      menuItem = "Foreground";
    } else if (clr.isEqual(app.backgroundColor)) {
      menuItem = "Background";
    }

    var it = pnl.colorList.find(menuItem);
    it.selected = true;
    pnl.colorList.selection = it;
  };


  x = xofs;
  y += 35;

  // Style
  pnl.styleLabel = pnl.add("statictext",
                           [x,y+tOfs,x+40,y+22+tOfs],
                           "Style:");
  x += 40;

  pnl.style = pnl.add("dropdownlist", [x,y,x+180,y+22]);
  var pm = new PresetsManager();
  pm.populateDropdownList(PresetType.STYLES, pnl.style, true);

  var it = pnl.style.find(opts.captionStyle);
  if (it) {
    it.selected = true;
  } else {
    pnl.style.items[0].selected = true;
  }

  x += 190;

  // Alignment
  pnl.capAlignLabel = pnl.add('statictext',
                              [x,y+tOfs,x+70,y+22+tOfs],
                              'Alignment:');
  x += 70;
  pnl.capAlignment = pnl.add('dropdownlist',
                             [x,y-12,x+85,y+22-12],
                             ['Left', 'Center', 'Right']);

  var idx = 1;
  var it = pnl.capAlignment.find(opts.capAlignment);

  if (it) {
    it.selected = true;
  } else {
    // default to Center
    pnl.capAlignment.items[1].selected = true;
  }

  pnl.capVAlignment = pnl.add('dropdownlist',
                              [x,y+12,x+85,y+22+12],
                              ['Top', 'Middle', 'Bottom']);

  var idx = 1;
  var it = pnl.capVAlignment.find(opts.capVAlignment);

  if (it) {
    it.selected = true;
  } else {
    // default to Bottom
    pnl.capVAlignment.items[1].selected = true;
  }

  x = xofs;
  y += 30;


  // CaptionFormat
  if (self.tabbed) {
    pnl.captionFormatLabel = pnl.add('statictext',
                                     [x,y+tOfs,x+150,y+22+tOfs],
                                     'Caption Format:');
    y += 25;

    var ybase = y;
    var format = opts.captionFormat.replace(/\\n/g, '\r');
    pnl.captionFormat = pnl.add('edittext',
                                [x,y,x+300,y+60],
                                format,
                                {multiline: true});

    y += 60;
    pnl.captionFormatNote = pnl.add('statictext',
                                    [x,y+tOfs,x+300,y+22+tOfs],
                                    '[Ctrl-Enter(XP)/Ctrl-m(OSX) to add a line]');
    if (isCS2()) {
      pnl.captionFormatNote.text = '';
    }

    y += 40;
//     pnl.captionFormatAdd = pnl.add('button',
//                                     [x,y,x+80,y+22],
//                                     'Add...');
//     pnl.captionFormatAdd.onClick = function() {
//       var pnl = this.parent;
//       var ui = pnl.mgr;
//       ui.popup('Caption Format Help',
//                "Metadata-Add dialog goes here....",
//                GenericUI.getWindow(pnl));
//     }


    y = ybase;
    x += 310;
    pnl.captionFormatDesc1 = pnl.add('statictext',
                                    [x,y,x+150,y+95],
                                    '',
                                    {multiline: true});
    pnl.captionFormatDesc1.text = 
      "Format substitutions:\n" +
      "%f -> file name\n"+
      "%e -> file extension\n" +
      "%p -> directory name\n" +
      "%S -> Image Size\n   (K/M/G)\n" + 
      "%X{ns:name} -> XMP\n";

    pnl.captionFormatDesc2 = pnl.add('statictext',
                                    [x+170,y,x+300,y+95],
                                    '',
                                    {multiline: true});
    pnl.captionFormatDesc2.text = 
      "\n" +
      "%W -> Width\n"+
      "%H  -> Height\n" +
      "%R  -> Resolution\n" +
      "%E{name} -> EXIF\n" + 
      "%I{name} -> IPTC\n";

    y += 100;
    pnl.captionFormatHelp = pnl.add('button',
                                    [x,y,x+80,y+22],
                                    'Help');
    pnl.captionFormatHelp.onClick = function() {
      var pnl = this.parent;
      var ui = pnl.mgr;
      ui.popup('Caption Format Help',
               CaptionFormatSpecification,
               GenericUI.getWindow(pnl));
    }
  }

  pnl.caption.onClick();
  pnl.useFile.onClick();

  pnl.initialized = true;

  return pnl;
};
ContactSheetUI.prototype.validateCaptionPanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Validating Caption panel");

  opts.caption = pnl.caption.value;

  if (opts.caption) {
    opts.captionFilename = pnl.useFile.value;
    opts.noExtensions = pnl.noExtensions.value;
    opts.overlayCaption = pnl.overlayCaption.value;

    var ctxt = pnl.colorList.selection.text;
    if (ctxt == 'RGB...') {
      opts.fontColor = Stdlib.rgbToString(pnl.fontColorIcon._color);

    } else {
      opts.fontColor = ctxt;
    }
    opts.captionStyle = pnl.style.selection.text;

    var f = pnl.font.getFont();
    if (!f.font || isNaN(f.size)) {
      Error.runtimeError(9001, "Very bad font: " + listProps(f));
    }

    opts.font         = f.font;
    opts.fontSize     = f.size;

    // Horizontal Alignment
    opts.capAlignment = pnl.capAlignment.selection.text;

    // Vertical Alignment
    opts.capVAlignment = pnl.capVAlignment.selection.text;

    if (self.tabbed) {
      if (pnl.captionFormat.enabled) {
        var str = pnl.captionFormat.text.trim();
        opts.captionFormat = str.replace(/[\r\n]/g, "\\n");
      }
    }
  }

  Stdlib.log("Caption panel validated");

  return opts;
};


//========================= Output Panel ==============================

ContactSheetUI.nextPageNumber = function(folder, prefix) {
  var st = ContactSheetUI.zeroPad(1, ContactSheetConfig.PAGE_PAD);
  var p = ContactSheetUI.getNextIndex(folder, prefix, st);
  return ContactSheetUI.zeroPad(Number(p), ContactSheetConfig.PAGE_PAD);
};
ContactSheetUI.nextFileNumber = function(folder, prefix, len) {
  if (!len) {
    len = ContactSheetConfig.FILE_PAD;
  }
  var st = ContactSheetUI.zeroPad(1, len);
  return ContactSheetUI.getNextIndex(folder, prefix, st);
};

ContactSheetUI.updateOutputFolder = function(pnl) {
  var folder = new Folder(pnl.folder.text);
  var prefix = undefined;
  if (pnl.prefix) {
    prefix = pnl.prefix.text;
  } else {
    prefix = pnl.fileNameFormat.text;
  }
  var len = pnl.fileStart.text.length;

  if (prefix) {
    pnl.pageStart.text = ContactSheetUI.nextPageNumber(folder, prefix);
    pnl.fileStart.text = ContactSheetUI.nextFileNumber(folder, prefix, len);
  }
}; 

ContactSheetUI.prototype.createOutputPanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Creating Ouput Panel");

  var xofs = self.xofs;
  var yofs = 10;
  var gutter = self.gutter;

  var x = xofs;
  var y = yofs;

  var tOfs = self.textOfs;

  var win = GenericUI.getWindow(pnl);
  var w = pnl.bounds[2] - pnl.bounds[0];

  // Save Sheet

  pnl.saveSheet = pnl.add('checkbox', [x,y,x+gutter-10,y+23], 'Save Sheet');
  pnl.saveSheet.value = opts.saveSheet;
  pnl.saveSheet.onClick = function() {
    try {
      var pnl = this.parent;
      var save = pnl.saveSheet.value;
      pnl.folderBrowse.enabled = save;
      pnl.folder.enabled = save;

      var common = save || pnl.keepOpen.value;
      pnl.flatten.enabled = common;

      // naming
      pnl.nextPage.enabled = common;
      pnl.pageLabel.enabled = common;
      pnl.pageStart.enabled = common;
      pnl.nextFile.enabled = common;
      pnl.fileIndexLabel.enabled = common;
      pnl.fileStart.enabled = common;

      if (pnl.fileNameFormat) {
        pnl.fileNameFormat.enabled = common;
        pnl.fileNameFormatLabel.enabled = common;

      } else {
        pnl.prefixLabel.enabled = save;
        pnl.prefix.enabled = save;
      }

      if (pnl.formatPanel) {
        pnl.formatPanel.enabled = save;

      } else {
        pnl.typeLabel.enabled = save;
        pnl.jpg.enabled = save;
        pnl.psd.enabled = save;
        pnl.tif.enabled = save;
        pnl.png.enabled = save;
        pnl.jpgQualityLabel.enabled = save;
        pnl.jpgQuality.enabled = save;
        pnl.jpgFormatLabel.enabled = save;
        pnl.jpgFormat.enabled = save;
        pnl.tiffEncodingLabel.enabled = save;
        pnl.tiffEncoding.enabled = save;
        pnl.tiffByteOrderLabel.enabled = save;
        pnl.tiffByteOrder.enabled = save;
      }

      // this will take care of flattenCells
      pnl.flatten.onClick();

      if (save) {
        if (pnl.jpg) {
          pnl.jpg.onClick();
        }
      }

      if (pnl.nextPage) {
        pnl.nextPage.onClick();
        pnl.nextFile.onClick();
      }
    } catch (e) {
      alert(Stdlib.exceptionMessage(e));
    }
  }

  x += gutter;

  //
  // Keep Open
  pnl.keepOpen = pnl.add('checkbox', [x,y,x+150,y+23], 'Keep Sheet Open');
  pnl.keepOpen.value = opts.keepOpen;
  pnl.keepOpen.onClick = pnl.saveSheet.onClick;

  y += 28;
  x = xofs;

  // Output Folder
  pnl.folderBrowse = pnl.add('button', [x,y,x+gutter-10,y+22], 'Folder...');
  x += gutter;
  var textType = (isMac() ? 'statictext' : 'edittext');
  var xtofs = (isMac() ? 3 : 0);

  pnl.folder = pnl.add(textType, [x,y+xtofs,w-10,y+23+xtofs], '',
                       { readonly : true});
  x += 225;

  pnl.folderBrowse.onClick = function() {
    try {
      var pnl = this.parent;
      var def = (pnl.folder.text ? new Folder(pnl.folder.text) :
                 Folder.current);
      var f = Stdlib.selectFolder("Select an output folder", def);

      if (f) {
        pnl.folder.text = f.toUIString();
        ContactSheetUI.updateOutputFolder(pnl);
      }
    } catch (e) {
      alert(Stdlib.exceptionMessage(e));
    }
  }
  
  y += 28;
  x = xofs;

  // Flatten All Layers
  pnl.flatten = pnl.add('checkbox', [x,y,x+150,y+22], 'Flatten All Layers');
  pnl.flatten.value = toBoolean(opts.flatten);

  x += gutter+90;

  // Flatten Cell Layers
  pnl.flattenCells = pnl.add('checkbox', [x,y,x+150,y+22],
                             'Flatten Cell Layers');
  pnl.flattenCells.value = toBoolean(opts.flattenCells);

  pnl.flatten.onClick = function() {
    var pnl = this.parent;

    pnl.flattenCells.enabled = pnl.flatten.enabled && !pnl.flatten.value;
  }

  y += 25;
  x = xofs;

  // Page Index
  pnl.nextPage = pnl.add('checkbox', [x,y,x+gutter,y+22], 'Next Page');
  pnl.nextPage.value = opts.nextPage;
  x += gutter;
  pnl.pageLabel = pnl.add('statictext',
                          [x,y+tOfs,x+gutter,y+22+tOfs],
                          'Page Index:');
  var start = opts._pageStart ? opts._pageStart : 1;
  var pad = opts._pagePad ? opts._pagePad : ContactSheetConfig.PAGE_PAD;

  x += gutter;
  pnl.pageStart = pnl.add('edittext', [x,y,x+60,y+20],
                          ContactSheetUI.zeroPad(start, pad));
  pnl.pageStart.onChanging = numberKeystrokeFilter;

  pnl.nextPage.onClick = function() {
    var pnl = this.parent;
    pnl.pageLabel.enabled = pnl.pageStart.enabled = !pnl.nextPage.value;
  }
  pnl.nextPage.onClick();
  y += 25;
  x = xofs;

  // File Index
  pnl.nextFile = pnl.add('checkbox', [x,y,x+gutter,y+22], 'Next File');
  pnl.nextFile.value = opts.nextFile;
  x += gutter;
  pnl.fileIndexLabel = pnl.add('statictext',
                               [x,y+tOfs,x+gutter,y+22+tOfs],
                               'File Index:');
  x += gutter;

  var start = opts._outputStart ? opts._outputStart : 1;
  var pad = (opts._outputPad ? opts._outputPad : ContactSheetConfig.FILE_PAD);

  pnl.fileStart = pnl.add('edittext', [x,y,x+60,y+20],
                          ContactSheetUI.zeroPad(start, pad));
  pnl.fileStart.onChanging = numberKeystrokeFilter;

  pnl.nextFile.onClick = function() {
    var pnl = this.parent;
    pnl.fileIndexLabel.enabled = pnl.fileStart.enabled = !pnl.nextFile.value;
  }
  pnl.nextFile.onClick();

  x = xofs;
  y += 25;

  if (opts._fileNamingFormat) {
    var fmt = opts.fileNameFormat || opts.outputPrefix || '';
    pnl.fileNameFormatLabel = pnl.add('statictext',
                                      [x,y+tOfs,x+gutter,y+22+tOfs],
                                      'Filename Format:');
    x += gutter;
    if (!fmt.contains('#')) {
      fmt += '#';
    }
    pnl.fileNameFormat = pnl.add('edittext', [x,y,x+140,y+20], fmt);
    pnl.fileNameFormatLabel.helpTip =
      pnl.fileNameFormat.helpTip = "'#' is replaced with the file index";

    y += 30;
    x = xofs;

    pnl.fileNameFormat.onChange = function() {
      try { 
        var pnl = this.parent;
        ContactSheetUI.updateOutputFolder(pnl);

      } catch (e) {
        alert(Stdlib.exceptionMessage(e));
      }
    }

  } else {
    // Prefix
    var prefix = opts.outputPrefix || '';
    pnl.prefixLabel = pnl.add('statictext',
                              [x,y+tOfs,x+gutter,y+22+tOfs],
                              'File Prefix:');
    x += gutter;
    pnl.prefix = pnl.add('edittext', [x,y,x+140,y+20], prefix);

    y += 30;
    x = xofs;

    pnl.prefix.onChange = function() {
      try { 
        var pnl = this.parent;
        ContactSheetUI.updateOutputFolder(pnl);

      } catch (e) {
        alert(Stdlib.exceptionMessage(e));
      }
    }
  }

  if (opts.outputFolder) {
    // have to do this _after_ the prefix is set
    pnl.folder.text = opts.outputFolder.toUIString();
    ContactSheetUI.updateOutputFolder(pnl);
  }

  if (opts._formatPanel) {
    var ybase = 175;
    pnl.formatPanel = pnl.add('group',
                              [xofs,ybase,xofs+350,ybase+95]);

    self.createFileSavePanel(pnl.formatPanel, opts);

    pnl.formatPanel.text = 'Format Options';

  } else {
    // Format
    pnl.typeLabel = pnl.add('statictext',
                            [x,y+tOfs,x+gutter,y+22+tOfs],
                            'File Type:');
    x += gutter;
    pnl.jpg = pnl.add('radiobutton', [x,y,x+50,y+20], 'JPEG');
    x += 55;
    pnl.psd = pnl.add('radiobutton', [x,y,x+50,y+20], 'PSD');
    x += 55;
    pnl.tif = pnl.add('radiobutton', [x,y,x+50,y+20], 'TIFF');
    x += 55;
    pnl.png = pnl.add('radiobutton', [x,y,x+50,y+20], 'PNG');

    var fmt = opts.outputFormat.toLowerCase();
    if (fmt == 'jpg' || fmt == 'psd' || fmt == 'tif' || fmt == 'png') {
      pnl[fmt].value = true;
    }
    pnl.jpg.onClick = function() {
      var pnl = this.parent;
      var jpg = pnl.jpg.value;
      pnl.jpgQuality.enabled = jpg;
      pnl.jpgQualityLabel.enabled = jpg;
      pnl.jpgFormat.enabled = jpg;
      pnl.jpgFormatLabel.enabled = jpg;
      pnl.flatten.enabled = !jpg || pnl.keepOpen.value;

      pnl.flatten.onClick();

      var tif = pnl.tif.value;
      pnl.tiffEncoding.enabled = tif;
      pnl.tiffEncodingLabel.enabled = tif;
      pnl.tiffByteOrder.enabled = tif;
      pnl.tiffByteOrderLabel.enabled = tif;
    }
    pnl.psd.onClick = pnl.jpg.onClick;
    pnl.tif.onClick = pnl.jpg.onClick;
    pnl.png.onClick = pnl.jpg.onClick;

    pnl.keepOpen.onClick = pnl.jpg.onClick;

    y += 30;
    x = xofs;

    // JPEG Quality
    pnl.jpgQualityLabel = pnl.add('statictext',
                                  [x,y+tOfs,x+gutter,y+22+tOfs],
                                  'JPEG Quality:');
    x += gutter;
    pnl.jpgQuality = pnl.add('edittext', [x,y,x+30,y+20], opts.jpgQuality);
    pnl.jpgQuality.onChanging = numberKeystrokeFilter;

    // JPEG Format
    x += 90;
    pnl.jpgFormatLabel = pnl.add('statictext',
                                 [x,y+tOfs,x+50,y+22+tOfs],
                                 'Format:');
    x += 70;
    pnl.jpgFormat = pnl.add('dropdownlist', [x,y,x+115,y+22],
                            ['Standard',
                             'Progressive',
                             'Optimized']);
    var idx = 0;
    var fmt = opts.jpgFormat;
    if (fmt == FormatOptions.STANDARDBASELINE)  idx = 0;
    if (fmt == FormatOptions.PROGRESSIVE)       idx = 1;
    if (fmt == FormatOptions.OPTIMIZEDBASELINE) idx = 2;

    pnl.jpgFormat.items[idx].selected = true;
  
    // Tiff Encoding
    y += 30;
    x = xofs;
    pnl.tiffEncodingLabel = pnl.add('statictext',
                                    [x,y+tOfs,x+gutter,y+22+tOfs],
                                    'Tiff Encoding:');
    x += gutter;
    pnl.tiffEncoding = pnl.add('dropdownlist',
                               [x,y,x+70,y+22],
                               ['None', 'LZW']);

    var idx = 0;
    var en = opts.tiffEncoding;
    if (en == TIFFEncoding.NONE) idx = 0;
    if (en == TIFFEncoding.TIFFLZW)  idx = 1;
    pnl.tiffEncoding.items[idx].selected = true;

    // Tiff Byte Order
    x += 90;
    pnl.tiffByteOrderLabel = pnl.add('statictext',
                                     [x,y+tOfs,x+100,y+22+tOfs],
                                     'Tiff Byte Order:');
    x += 105;
    pnl.tiffByteOrder = pnl.add('dropdownlist',
                                [x,y,x+80,y+22],
                                ['MacOS', 'PC']);
    var idx = 0;
    var bo = opts.tiffByteOrder;
    if (bo == ByteOrder.MACOS) idx = 0;
    if (bo == ByteOrder.IBM)   idx = 1;
    pnl.tiffByteOrder.items[idx].selected = true;

    pnl.jpg.onClick();
  }

  pnl.saveSheet.onClick();

  return pnl;
};

ContactSheetUI.prototype.validateOutputPanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Validating Ouput panel");

  // Keep Open
  opts.keepOpen = pnl.keepOpen.value;

  // Flatten All Layers
  opts.flatten = pnl.flatten.value;

  // Flatten Cell Layers
  opts.flattenCells = pnl.flattenCells.value;

  // Save Sheet
  opts.saveSheet = pnl.saveSheet.value;

  var prefix = undefined;
  // FileName Format
  if (pnl.fileNameFormat) {
    prefix = opts.fileNameFormat = pnl.fileNameFormat.text;
  }

  // Prefix
  if (pnl.prefix) {
    prefix = opts.outputPrefix = pnl.prefix.text;
  }

  // Next File
  opts.nextFile = pnl.nextFile.value;

  // Next Page
  opts.nextPage = pnl.nextPage.value;

  // if we are not saving the sheet, we need to swizzle some settings
  // some of this code is duplicated b
  if (!opts.saveSheet) {

    // Page Start
    if (opts.nextPage) {
      opts._pageStart = 1;
      opts._pagePad = 2;

    } else {
      var start = pnl.pageStart.text || "01";
      var n = self.getNumber(start, "page start", 0, 100000, 1);
      if (typeof n != "number") {
        return n;
      }
      opts._pageStart = n;
      opts._pagePad = start.trim().length;
    }

    // File Start
    if (opts.nextFile) {
      opts._outputStart = 1;
      opts._outputPad = 4;

    } else {
      var start = pnl.fileStart.text || "0001";
      var n = self.getNumber(start, "file start", 0, 100000, 1);
      if (typeof n != "number") {
        return n;
      }
      opts._outputStart = n;
      opts._outputPad = start.trim().length;
    }

    // XXXXX -------------------- PREMATURE RETURN -----------------------XXX

    Stdlib.log("Ouput panel validated");

    return opts;
  }

  // Output Folder
  // An output directory must be specified and either must already
  // exist or we need to be able to create it now
  var f = undefined;
  if (pnl.folder.text) {
    f = new Folder(pnl.folder.text);
    if (!f.exists) {
      if (!f.create()) {
        return self.errorPrompt("Unable to create output folder");
      }
    }
  }
  if (!f || !f.exists) {
    return self.errorPrompt("Output folder not found");
  }
  opts.outputFolder = decodeURI(f.fsName);

  var folder = new Folder(opts.outputFolder);

//   debugger;

  // Page Start
  if (opts.nextPage) {
    var start = ContactSheetUI.nextPageNumber(folder, prefix);
    opts._pageStart = toNumber(start);
    opts._pagePad = start.length;

  } else {
    var start = pnl.pageStart.text || "01";
    var n = self.getNumber(start, "page start", 0, 100000, 1);
    if (typeof n != "number") {
      return n;
    }
    opts._pageStart = n;
    opts._pagePad = start.trim().length;
  }

  // File Start
  if (opts.nextFile) {
    var start = ContactSheetUI.nextFileNumber(folder, prefix);
    opts._outputStart = toNumber(start);
    opts._outputPad = start.length;

  } else {
    var start = pnl.fileStart.text || "0001";
    var n = self.getNumber(start, "file start", 0, 100000, 1);
    if (typeof n != "number") {
      return n;
    }
    opts._outputStart = n;
    opts._outputPad = start.trim().length;
  }

  if (pnl.formatPanel) {
    self.validateFileSavePanel(pnl.formatPanel, opts);

  } else {
    // Format
    if (pnl.jpg.value) {
      //  Quality
      opts.outputFormat = 'jpg';
      var n = self.getNumber(pnl.jpgQuality.text, "jpeg quality", 1, 12, 10);
      if (typeof n != "number") {
        return n;
      }
      opts.jpgQuality = n;
      opts.jpgFormat  = pnl.jpgFormat.selection.text;

    } else if (pnl.tif.value) {
      // Encoding
      opts.outputFormat  = 'tif';
      opts.tiffEncoding  = pnl.tiffEncoding.selection.text;
      opts.tiffByteOrder = pnl.tiffByteOrder.selection.text;

    } else if (pnl.psd.value) {
      opts.outputFormat = 'psd';

    } else if (pnl.png.value) {
      opts.outputFormat = 'png';
    }
  }

  Stdlib.log("Ouput panel validated");
  return opts;
};


//========================= Settings Panel ==============================

ContactSheetUI.prototype.createSettingsPanel = function(pnl, ini) {
  var self = this;

  Stdlib.log("Creating Settings Panel");

  var win = GenericUI.getWindow(pnl);

  pnl.text = 'Settings';
  pnl.win = win;

  var w = pnl.bounds[2] - pnl.bounds[0];
  var offsets = [w*0.15, w*0.38, w*0.62,w*0.85];
  var y = 15;
  var bw = 90;

  var x = offsets[0]-(bw/2);
  pnl.load = pnl.add('button', [x,y,x+bw,y+20], 'Load...');
  x = offsets[1]-(bw/2);
  pnl.save = pnl.add('button', [x,y,x+bw,y+20], 'Save...');
  x = offsets[2]-(bw/2);
  pnl.view = pnl.add('button', [x,y,x+bw,y+20], 'View...');
  x = offsets[3]-(bw/2);
  pnl.reset = pnl.add('button', [x,y,x+bw,y+20], 'Reset');

  pnl.load.onClick = function() {
    var pnl = this.parent;
    var win = pnl.win;
    var mgr = win.mgr;
    var def = mgr.iniFile;
    var f;
    var prmpt = "Please choose a settings file to read";
    if (def.openDlg) {
      // var fsel = Stdlib.createFileSelect(...);
      f = def.openDlg(prmpt, "INI Files: *.ini, All Files: *.*");
    } else {
      Folder.current = def.parent;
      f = File.openDialog(prmpt);
    }
    if (f) {
      win.ini = GenericUI.readIni(f);
      win.close(4);
    }
  }
  pnl.save.onClick = function() {
    var pnl = this.parent;
    var win = pnl.win;
    var mgr = win.mgr;
    var def = mgr.iniFile;
    var f;
    var prmpt = "Please choose a settings file to write";
    if (def.saveDlg) {
      // var fsel = Stdlib.createFileSelect(...);
      f = def.saveDlg(prmpt,
                      "INI Files: *.ini, Preset Files: *.pre, All Files: *.*");
    } else {
      Folder.current = def.parent;
      f = File.saveDialog(prmpt);
    }
    if (f) {
      var mgr = win.mgr;
      var res = mgr.validatePanel(win.appPnl, win.ini);
      if (typeof(res) != 'boolean') {
        GenericUI.overwriteIni(f, res);
      }
    }
  }
  pnl.view.onClick = function() {
    try {
      var pnl = this.parent;
      var win = pnl.win;
      var mgr = win.mgr;
      var res = mgr.validatePanel(win.appPnl, win.ini);
      if (typeof(res) != 'boolean') {
        var w = new Window('dialog', 'Settings', [200,200,700,700]);
        var t = w.add('edittext', [10,10,490,490], '',
                      {multiline:true, readonly:true});
        t.text = listProps(res); //.replace(/\n/g, '\r');
        w.center(win);
        w.show();
      }
    } catch (e) {
      alert(Stdlib.exceptionMessage(e));
    }
  }
  pnl.reset.onClick = function() {
    var pnl = this.parent;
    var win = pnl.win;
    var mgr = win.mgr;
    if (mgr.ini) {
      win.ini = mgr.ini;
    }
    win.close(4);
  }

  if (self.tabbed) {
    var gutter = self.gutter + 40;
    var xofs = self.xofs;
    var x = xofs;
    y += 30;

    pnl.add('statictext', [x,y,x+gutter,y+35], "Presets:");
    y += 40;

    var ybase = y;
  
    var temps = ContactSheetUI.getTemplatesFolder();
    var preFolder = (temps.exists ? temps : temps.parent);
  
    function loadPreset() {
      var btn = this;
      var pnl = this.parent;
      var win = pnl.win;
      var mgr = win.mgr;
      var fname = preFolder + '/' + btn.text + ".ini";
      var f = new File(fname);

      if (f.exists) {
        var ini = GenericUI.readIni(f);

        if (ini.folder && !Folder(ini.folder).exists) {
          delete ini.folder;
        }

        if (ini.templateFile) {
          var tf = new File(ini.templateFile);
          if (!tf.exists) {
            var f = new File(preFolder + '/' + tf.name);
            if (!f.exists) {
              delete ini.templateFile;
            } else {
              ini.templateName = f.toUIString();
            }
          }
        }

        if (ini.outputFolder && !Folder(ini.outputFolder)) {
          delete ini.outputFolder;
        }

        for (var idx in ini) {
          if (typeof(ini[idx]) != "undefined") {
            win.ini[idx] = ini[idx];
          }
        }

        win.close(4);

      } else {
        alert("Unable to load preset " + f.toUIString());
      }
    }

    function addButton(pnl, nm) {
      pnl[nm] = pnl.add('button', [x,y,x+160,y+22], nm);
      pnl[nm].onClick = loadPreset;
      y += 30;
      return pnl[nm];
    }

    var files = preFolder.getFiles("*.ini");
    for (var i = 0; i < files.length; i++) {
      var file = files[i];
      var nm = file.strf("%f");

      addButton(pnl, nm);

      if ((i+1) % 7 == 0) {
        x += (gutter + 10);
        y = ybase;
      }
    }
  }
};


//========================= Advanced Panel ==============================

ContactSheetUI.prototype.createAdvancedPanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Creating Advanced Panel");

  var xofs = self.xofs;
  var yofs = 10;
  var gutter = Math.floor(self.gutter * 1.25);

  var x = xofs;
  var y = yofs;

  pnl.tOfs = self.textOfs;

  var w = pnl.bounds[2] - pnl.bounds[0];
  
  var notes = ("This panel is for modifying INI properties that are not " +
               "editable elsewhere in the UI. ");

  pnl.notes = pnl.add('statictext', [x,y,x+w-20,y+20], notes,
                      {multiline: true});

  y += 25;

  function addBool(pnl, nm, v) {
    pnl[nm + 'Label'] = pnl.add('statictext',
                                [x,y+pnl.tOfs,x+gutter,y+22+pnl.tOfs],
                                nm + ':');
    x += gutter;
    pnl[nm] = pnl.add('checkbox', [x,y,x+30,y+22]);
    pnl[nm].value = v;
    x = xofs;
    y += 25;
    return pnl[nm];
  }

  function addBtn(pnl, nm) {
    pnl[nm + 'Button'] = pnl.add('button',
                                 [x,y+pnl.tOfs,x+gutter-20,y+22+pnl.tOfs],
                                 nm);
    x = xofs;
    y += 25;
    return pnl[nm + 'Button'];
  }

  function addStr(pnl, nm, v, w) {
    if (!w) {
      w = gutter;
    }
    pnl[nm + 'Label'] = pnl.add('statictext',
                                [x,y+pnl.tOfs,x+gutter,y+22+pnl.tOfs],
                                nm + ':');
    x += gutter;
    pnl[nm] = pnl.add('edittext', [x,y,x+w,y+22]);
    pnl[nm].text = v;
    x = xofs;
    y += 25;
    return pnl[nm];
  }

  function addNum(pnl, nm, v, w) {
    var f = addStr(pnl, nm, v, w);
    f.onChanging = numberKeystrokeFilter;
    return f;
  }

  function addDrop(pnl, nm, items, v) {
    pnl[nm + 'Label'] = pnl.add('statictext',
                                [x,y+pnl.tOfs,x+gutter,y+22+pnl.tOfs],
                                nm + ':');
    x += gutter;
    pnl[nm] = pnl.add('dropdownlist', [x,y,x+gutter,y+22]);
    for (var i = 0; i < items.length; i++) {
      pnl[nm].add('item', items[i]);
    }
  
    pnl[nm].items[v].selected = true;
    x = xofs;
    y += 25;
    return pnl[nm];
  }

  function addColorProfileSelect(pnl, nm, enabled, value, w) {
    if (!w) {
      w = gutter;
    }
    var chkNm = nm + 'Check';
    var brNm = nm + 'Browse';

    pnl[chkNm] = pnl.add('checkbox',
                         [x,y,x+gutter,y+22],
                         nm + ':');

    pnl[chkNm].value = toBoolean(enabled);
    pnl[chkNm]._name = chkNm;
    pnl[chkNm]._brname = brNm;
    
    pnl[chkNm].onClick = function() {
      var pnl = this.parent;
      pnl[this._brname].enabled = pnl[this._name].value;
    }
    x += gutter;
    pnl[nm] = pnl.add('edittext', [x,y,x+w,y+22], '', { readonly: true });
    pnl[nm].text = (value || '');
    x += w + 5;

    pnl[brNm] = pnl.add('button', [x,y,x+30,y+20], '...');
    pnl[brNm]._name = brNm;
    pnl[brNm]._txtName = nm;
    pnl[brNm].onClick = function() {
      try {
        var pnl = this.parent;
        var nm = this._name;
        var profileFolder = CSX.COLOR_PROFILE_FOLDER
        var fpat = "Profiles: *.icc; *.icm";

        var txt = pnl[this._txtName].text;
        if (txt) {
          def = File(profileFolder + '/' + txt);
        } else {
          def = profileFolder;
        }

        var f = Stdlib.selectFileOpen("Select a Color Profile", fpat, def);
        if (f) {
          var p = decodeURI(f.name).replace(/\.(icc|icm)$/i, '');
          pnl[this._txtName].text = p;
        }
      } catch (e) {
        alert(Stdlib.exceptionMessage(e));
      }
    }
    pnl[chkNm].onClick();

    x = xofs;
    y += 25;
    return pnl[nm];
  }

  // High Performance Mode
  addDrop(pnl, "hiperfMode",
          ['Basic', 'HP Mode 1', 'HP Mode 2', 'HP Mode 3'],
          opts.hiperfMode);

  var modes = ['thumbnail','sample','scale','resize'];
  addDrop(pnl, "hp2submode", modes, 0);

  var it = pnl.hp2submode.find(opts.hp2submode);
  if (it) {
    it.selected = true;
  } else {
    pnl.hp2submode.items[0].selected = true;
  }

  pnl.hiperfMode.onChange = function() {
    var pnl = this.parent;
    pnl.hp2submode.enabled = (pnl.hiperfMode.selection.index == 2);
  }

  addBool(pnl, "accumulateKeywords", opts.accumulateKeywords);
  addBool(pnl, "enableTextSubstitution", opts.enableTextSubstitution);

  addNum(pnl,  "autospaceFactor", opts.autospaceFactor, 40);

  addStr(pnl,  "dateFormat", opts.dateFormat);
  addStr(pnl,  "gpsFormat", opts.gpsFormat);

  var w = addStr(pnl,  "postProcessAction", opts.postProcessAction,
                 gutter*3-10);
  w.helpTip = "ActionSet@Action";

  var btn = addBtn(pnl, "Show Last Log");
  btn.onClick = function() {
    var pnl = this.parent;
    var ui = pnl.parent.mgr;
    ui.popup('Log File Contents',
             ui.getLogFileContents(),
             GenericUI.getWindow(pnl),
             [200,200,900,750]);
  }

  y = 35;
  xofs = 2 * gutter + 30;
  x = xofs;
  addBool(pnl, "metadataSubstitution", opts.metadataSubstitution);
  addBool(pnl, "alphaLayerPinRegister", opts.alphaLayerPinRegister);
  addBool(pnl, "forceRecording", opts.forceRecording);
  addBool(pnl, "splitCSXLayerOnFlatten", opts.splitCSXLayerOnFlatten);
  addBool(pnl, "xpSort", opts.xpSort);
  addBool(pnl, "embedSmartObjects", opts.embedSmartObjects);
  addBool(pnl, "autoscaleCaptions", opts.autoscaleCaptions);

  if (isCS3() || isCS4()) {
    pnl.hiperfMode.onChange();
  }

  return pnl;
};

ContactSheetUI.prototype.validateAdvancedPanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Validating Advanced panel");

  // High Performance Mode
  opts.hiperfMode = pnl.hiperfMode.selection.index;

  opts.hp2submode = pnl.hp2submode.selection.text;

  opts.accumulateKeywords = pnl.accumulateKeywords.value;
  opts.enableTextSubstitution = pnl.enableTextSubstitution.value;

  var n = self.getNumber(pnl.autospaceFactor.text, "autospaceFactor",
                         0, 10, 1);
  if (typeof n != "number") {
    return n;
  }
  opts.autospaceFactor = n;

  opts.dateFormat = pnl.dateFormat.text;
  opts.gpsFormat = pnl.gpsFormat.text;

  opts.forceRecording = pnl.forceRecording.value;
  opts.metadataSubstitution = pnl.metadataSubstitution.value;
  opts.alphaLayerPinRegister = pnl.alphaLayerPinRegister.value;
  opts.splitCSXLayerOnFlatten = pnl.splitCSXLayerOnFlatten.value;
  opts.xpSort = pnl.xpSort.value;
  opts.embedSmartObjects = pnl.embedSmartObjects.value;

  var actf = pnl.postProcessAction.text;

  if (actf) {
    var ok = false;

    var parts = actf.split('@');

    if (parts.length == 2 && parts[0] != '') {
      var actions = Stdlib.getActions(parts[0]);
      if (actions != undefined) {
        if (!actions.contains(parts[1])) {
          return self.errorPrompt("Bad value for postProcessAction: " +
                                  "Action " + parts[1] + " not found.");
        } else {
          ok = true;
        }
      }
    } else if (!actf.contains('@')) {
      var scr = actf;
      var f;
      if (scr.startsWith("/")) {
        f = new File(scr);
      } else {
        f = new File(ContactSheetUI.getScriptFolder() + '/' + scr);
      }
      if (!f.exists) {
        return self.errorPrompt("Unable to find script: " + scr);
      }
      ok = true;
    }

    if (!ok) {
      return self.errorPrompt("Bad value for postProcessAction: " +
                              "Should be 'ActionSet@Action'.");
    }

    opts.postProcessAction = actf;

  } else {
    opts.postProcessAction = '';
  }

  Stdlib.log("Advanced panel validated");

  return opts;
};

//========================= Notes Panel ==============================

ContactSheetUI.prototype.createNotesPanel = function(pnl, opts) {
  var self = this;

  Stdlib.log("Creating Notes Panel");

  var x = 10;
  var y = 10;

  var w = pnl.bounds[2] - pnl.bounds[0] - (2*x);
  var h = pnl.bounds[3] - pnl.bounds[1] - y;

  pnl.notes = pnl.add('statictext', [x,y,x+w-20,h-y], ContactSheetUI.notes,
                      {multiline: true});
};

ContactSheetUI.getNextIndex = function(folder, prefix, def) {
  var idx = 0;
  var pad = ContactSheetUI.PAD;

  if (!(folder instanceof Folder)) {
    return def;
  }

  if (folder.alias) {
    folder = folder.resolve();
  }

  prefix = decodeURI(prefix);

  if (prefix.contains('#')) {
    var rex = RegExp(prefix.replace(/#+/g, "(\\d+)"));
    var flist = folder.getFiles(rex);

    if (flist && flist.length) {
      for (var i = 0; i < flist.length; i++) {
        var file = flist[i];
        var m = file.name.match(rex);
        if (m) {
          var v = Number(m[1]);
          if (v > idx) {
            idx = v;
            pad = m[1].length;
          }
        }
      }

      idx++;
      return ContactSheetUI.zeroPad(idx, pad);

    } else {
      return def;
    }
    
  } else {
    function _folderChk(f) {
      return (f instanceof File) && f.name.match(RegExp(prefix + "(\\d+)\\."));
    }

    var flist = folder.getFiles(_folderChk);
    if (flist && flist.length) {
      for (var i = 0; i < flist.length; i++) {
        var file = flist[i];
        var m = file.name.match(/(\d+)\.[^\.]+$/);
        if (m) {
          var v = Number(m[1]);
          if (v > idx) {
            idx = v;
            pad = m[1].length;
          }
        }
      }

      idx++;
      return ContactSheetUI.zeroPad(idx, pad);

    } else {
      return def;
    }
  }
};
ContactSheetUI.prototype.getNextIndex = ContactSheetUI.getNextIndex;

ContactSheetUI.prototype.getNumber = function(s, nm, min, max, def) {
  if (s.length == 0) {
    return def;
  }
  var n = Number(s);
  if (isNaN(n)) {
    return GenericUI.errorPrompt("Please specify a valid number for the "
                                 + nm + ".");
  }
  if (n < min || n > max) {
    return GenericUI.errorPrompt(nm + " is out of range.\nPlease specify a " +
                                 "number between " + min + " and " +
                                 max + ".");
  }
  return n;
};

ContactSheetUI.prototype.popup = function(title, str, win, bnds) {
  if (!bnds) {
    bnds = [200,200,700,750];
  }
  var w = new Window('dialog', title, bnds);
  var t = w.add('edittext', [10, 10,
                             bnds[2]-bnds[0]-10,
                             bnds[3]-bnds[1]-10],
                '', {multiline:true, readonly:true});
  t.text = str;
  if (win) {
    w.center(win);
  }
  w.show();
};

ContactSheetUI.prototype.getLogFileContents = function() {
  var file = new File(ContactSheetConfig.LOG_FILE);

  var str = "Log File: " + file.toUIString() + '\n';
  if (file.exists) {
    str += Stdlib.readFromFile(file);
  } else {
    str += "Log file not found.";
  }

  if (isCS2()) {
    str = str.replace(/\n/g, '\r\n');
  }

  return str;
};

ContactSheetUI.zeroPad = function(num, w) {
  var str = num.toString();

  while (str.length < w) {
    str = "0" + str;
  }
  return str;
};

//
// ContactSheetUI.configColorButton
//   This function adds a callback to iconBtn to launch a ColorChooser
//   to allow a user to select a new color. The color of the button changes
//   to reflect the chosen color.
//   The clrStr is the default color. It can be a color object, array, or
//   string. See ContactSheetUI.getColorIcon for format details for the
//   parameter.
//   When a color has been chosen, the iconBtn._color property will be
//   set to the corresponding color object. The button will also call
//   a new onColorChange callback when the color is changed.
//
ContactSheetUI.configColorButton = function(iconBtn, clrStr) {
  iconBtn.setColor = function(clr) {
    if (!clr) {
      return;
    }
    var self = this;
    var icon = ContactSheetUI.getColorIcon(clr);
    if (icon) {
      self.icon = icon.file;
      self._color = icon.color;
      if (self.onColorChange) {
        self.onColorChange();
      }
    }
    return icon.color;
  };

  iconBtn.setColor(clrStr);

  iconBtn.onClick = function() {
    var pnl = this.parent;
    var self = this;
    if (self._settingColor == true) {
      return;
    }
    var color = ColorChooser.run(self._color);

    if (color) {
      self._settingColor = true;
      try {
        self.setColor(color);
      } catch (e) {
      }
      self._settingColor = false;
    }
    return;
  };
};

//
// ContactSheetUI.getColorIcon (color)
//   Returns an plain object with two fields  or undefined if it couldn't
//               figure out what 'color' was.
//       file:   is a 40x20 png of the specified color
//       color:  is the actual underlying SolidColor. If you passed a
//               SolidColor object, that's what you get back, if not, this
//               is what happened when your 'color' got converted
//
//   'color' can be a SolidColor, RGBColor, Array, or a String.
//   If it's an Array, it must be 3 RGB numbers.
//   If it's a String, it must be in one of these formats:
//     "255,255,255"
//     "#FFFFFF"
//     "FEFEFE"
//
//   The png file that is returned has a name format like this: 'FFFF00.png'
//   and it created in the Folder.temp directory. This folder can be overridden
//   by setting the property ContactSheetUI.getColorIcon.temp to
//  another folder.
//
//   The property ContactSheetUI.getColorIcon.cacheFiles controls whether or
//   not a new png icon file is generated with each request or the cache is
//   used.
//   Files are cached by default.
//
ContactSheetUI.getColorIcon = function(color) {
  var clr = undefined;

  if (!color) {
    return undefined;
  }

  // Try to make sense of the 'color' we've been given
  if (color.constructor == String) {
    clr = XOpt.HexColor.fromString(color);
    if (!clr) {
      clr = Stdlib.rgbFromString(color);
    }

  } else if (color.constructor == Array && color.length == 3) {
    clr = Stdlib.createRGBColor(color);

  } else if (color instanceof RGBColor) {
    clr = new SolidColor();
    clr.rgb = color;

  } else if (color instanceof SolidColor) {
    clr = color;
  }
  
  if (!clr) {
    return undefined;
  }

  // Now lets make sure that we have a good 'temp' Folder
  if (ContactSheetUI.getColorIcon.temp.constructor == String) {
    var f = new Folder(ContactSheetUI.getColorIcon.temp);

    if (!f.exists) {
      if (!f.create()) {
        f = Folder.temp;
      }
    }
    ContactSheetUI.getColorIcon.temp = f;

  } else if (!(ContactSheetUI.getColorIcon.temp instanceof Folder)) {
    ContactSheetUI.getColorIcon.temp = Folder.temp;
  }

  var cname = clr.rgb.hexValue;
  var file = new File(Folder.temp + '/' + cname + '.png');

  // this checks to see if we've already built the preview before
  if (ContactSheetUI.getColorIcon.cachesFiles) {
    if (file.exists) {
      return { file: file, color: clr };
    }
  }

  var ru = app.preferences.rulerUnits;
  app.preferences.rulerUnits = Units.PIXELS;

  try {
    var doc = Stdlib.newDocument(cname, "RGBM", 40, 20, 72, 8);

  } finally {
    app.preferences.rulerUnits = ru;
  }

  doc.selection.selectAll();
  doc.selection.fill(clr, ColorBlendMode.NORMAL, 100);
  var saveOpts = new PNGSaveOptions();
  doc.saveAs(file, saveOpts, true);
  doc.close(SaveOptions.DONOTSAVECHANGES);

  return { file: file, color: clr };
};

ContactSheetUI.getColorIcon.temp = Folder.temp;
ContactSheetUI.getColorIcon.cachesFiles = true;

ContactSheetUI.prototype.getPageAndImageCounts = function() {
  var self = this;
  var opts = new ContactSheetConfig();
  var win = self.win;
  var appPnl = win.appPnl;

  self.validateSourcePanel(appPnl.source, opts);

  if (!appPnl.layoutPanel) {
    return;
  }
  opts.rowCount = Number(appPnl.layoutPanel.rows.text);
  opts.columnCount = Number(appPnl.layoutPanel.cols.text);
  if (opts.folder) {
    opts.folder = new Folder(opts.folder);
  }

  var fileSets = ContactSheetX.getSourceImages(opts);
  var pages = fileSets.length;
  var images = 0;
  for (var i = 0; i < fileSets.length; i++) {
    var set = fileSets[i];
    images += set.length;
  }

  return { pages: pages, images: images };
};

ContactSheetUI.prototype.createContactSheetX = function() {
  return new ContactSheetX()
};

ContactSheetUI.prototype.process = function(opts) {
  var csx = this.createContactSheetX();
  return csx.process(opts);
};

//============================== END OF UI ================================

ContactSheetX = function() {
  var self = this;

  self.now = new Date();
  self.dateStr = '';
  self.imageCount = 0;
  self.errorCount = 0;
  self.skipImageErrors = false;
};
ContactSheetX.typename = "ContactSheetX";


ContactSheetUI.prototype.test_openImage = function(file, bnds) {
  var self = this;
  var w = bnds[2]-bnds[0];
  var h = bnds[3]-bnds[1];
  var thfile = ContactSheetX.makeThumbnail(w, h, 'sample', file);

  return self.openDocument(thfile, "Thumbnail");
};

ContactSheetX.prototype.openImage = function(file, bnds) {
  return this.openDocument(file, "Image");
};

function openDoc(file) {
  var desc = new ActionDescriptor();
  desc.putPath(cTID('null'), file);
  executeAction(cTID('Opn '), desc, DialogModes.NO);

  return app.activeDocument;
};

ContactSheetX.prototype.openDocument = function(file, type) {
  var self = this;
  var doc = undefined;

  try {
    doc = app.open(file);

    //doc = openDoc(file);

  } catch (e) {
    if (!type) type = '';
    var str = ("Open Document Error: " + e.message + "\nFailed to open " +
               type + " file " + file.toUIString());
    Stdlib.logException(e, str, true);
    self.errorCount++;
    //alert(str);
  }

  return doc;
};

ContactSheetX.prototype.process = function(opts) {
  var self = this;

  function handleError(e, pre) {
    Stdlib.logException(e);

    var str = (pre || "Error in processing: ") + e.toString();

    str += ("\n\nLook in the CSX log file for more details:\n    " +
            ContactSheetConfig.LOG_FILE);

    str += ("\n\nReport failures (with the log file) here:\n    " +
            "http://sourceforge.net/tracker/?" +
            "func=add&group_id=173281&atid=864854");

    return str;
  }

  var timer = new Timer();
  timer.start();

  self.imageProcessingTimer = new Timer();

  if (ContactSheetConfig.LOG_ENABLED) {
    Stdlib.log.setFile(ContactSheetConfig.LOG_FILE, "UTF8");
  }

  Stdlib.log("Begin Processing");
  Stdlib.log(listProps(opts));

  try {
    // XXX noUI gets wiped in rationalize()
    var noUI = opts.noUI;
    if (!(opts instanceof ContactSheetConfig)) {
      opts = new ContactSheetConfig(opts);
    }
    opts.rationalize();
    opts.noUI = noUI;

  } catch (e) {
    var str = handleError(e, "Error in converting settings: ");
    alert(str);
    return undefined;
  }

  try {
    // if this fails, it will only cause a problem for recording in an action
    // this is a non-fatal error
    self.descriptor = opts.toDescriptor();

  } catch (e) {
    var str = handleError(e, "Error translation settings to ActionDesriptor. " +
                          "Unable to record as an Action step: ");
    self.descriptor = undefined;

    if (opts.forceRecording) {
      self.errorCount++;
    }
//     alert(str);
//     return undefined;
  }

  var ru = app.preferences.rulerUnits
  app.preferences.rulerUnits = Units.PIXELS;
  var tu = app.preferences.typeUnits
  app.preferences.typeUnits = TypeUnits.PIXELS;

  try {
    self._processX(opts);

    // post processing
    Stdlib.log("End Processing");

    timer.stop();

    var s = String.sprintf("%.3f seconds overall per image",
                           1.0 * timer.elapsed/self.imageCount);
    Stdlib.log(s);
    
    var tmr = self.imageProcessingTimer;
    if (!isNaN(tmr.per)) {
      s = String.sprintf("%.3f seconds processing time per image", tmr.per);
      Stdlib.log(s);
    }
    
  } catch (e) {
    var str = handleError(e, "Error in processing: ");

    alert(str);
    self.descriptor = undefined;

  } finally {
    app.preferences.rulerUnits = ru;
    app.preferences.typeUnits = tu;
  }

  if (self.errorCount) {
    var str = String.sprintf("%d errors were detected.\n" +
                             "Please look in your log file:\r%s",
                             self.errorCount,
                             ContactSheetConfig.LOG_FILE);
    alert(str);
  }
  return self.descriptor;
};

ContactSheetX.prototype._processX = function(opts) {
  var self = this;

  self.openDocMode = (opts.imageSource == CSX.OPENDOCUMENTS);

  opts.noUI = toBoolean(opts.noUI);

  var fileSets = ContactSheetX.getSourceImages(opts);

  if (fileSets.length == 0) {
    var msg = "No image files were found.";
    Stdlib.log(msg);
    alert(msg);
    return;
  }
  self.fileSets = fileSets;

  app.purge(PurgeTarget.ALLCACHES);

  if (opts.resUnits == 'PpCm') {
    opts._resolution = opts.resolution;
    opts.resolution = opts.resolution * 2.54;
  }

  var templ;
  if (opts.background == 'Template') {
    self.templateOriginal = self.openDocument(opts.templateFile, "Template");
    if (!self.templateOriginal) {
      var msg = "Unable to open template file: " + opts.templateFile;
      Stdlib.log(msg);
      alert(msg);
      return;
    }
    templ = self.templateOriginal;
  }

  // make sure that this is clear...
  opts._colorProfileName = undefined;

  // if there is more than one row or one column, disable watermark mode
  opts.watermarkMode &= (opts.rowCount == 1 && opts.columnCount == 1);

  opts.loadMetadataFromBridge = (opts.metadataSubstitution ||
                                 opts.watermarkMode) && !isCS2();

  if (!opts.loadMetadataFromBridge && !self.openDocMode &&
      opts.caption && !opts.captionFilename &&
      opts.hiperfMode != 0 && opts.noUI) {

    var uic = opts.uiConfirmBridgeForMetadata;

    if (uic == 'true' || (uic == 'uiModeOnly' && !opts.noUI) &&
        opts.imageSource != CSX.BRIDGE && !ContactSheetUI.isBridgeRunning()) {

      // these are specs you dont need a doc metadata for
      var fileSpecs = " depfFsSCTN\-\.\d";
      var fmt = opts.captionFormat;
      fmt = fmt.replace(/%[ depfFsSCTN\-\.\d%]/g, '');

      var nonFileRex = /%[\{BHMPRWCIEX]/;

      if (fmt.match(nonFileRex)) {
        var confirmBridgeStart = ("The Caption format requires Bridge " +
                                  "to be running to retrieve metada.\r\r" +
                                  "Start Bridge now?");
        if (confirm(confirmBridgeStart)) {
          opts.loadMetadataFromBridge = true;

          var br = XBridgeTalk.getAppSpecifier("bridge");

          if (!XBridgeTalk.startApplication(br)) {
            var msg = "Failed to launch " + br;
            Stdlib.log(msg);
            alert(msg);
            return;
          }

        } else {
          opts.hiperfMode = 0;
        }
      }
    }
  }

  //$.level = 1; debugger;

  var sheet;
  if (templ) {
    var layers  = Stdlib.getLayersList(templ);
    var cslayer = Stdlib.getByName(layers, CSX.CONTACT_SHEET);
    
    var bnds;
    if (cslayer && Stdlib.hasLayerMask(templ, cslayer)) {
      bnds = Stdlib.getMaskBounds(templ, cslayer);
    } else {
      bnds = [0,0,templ.width.value,templ.height.value];
    }

    opts.docUnits = 'Pixl'; 
    opts.docWidth  = Math.round(bnds[2] - bnds[0]);
    opts.docHeight = Math.round(bnds[3] - bnds[1]);

    opts.resolution = templ.resolution;

    switch (templ.mode) {
      case DocumentMode.GRAYSCALE:opts.mode = NewDocumentMode.GRAYSCALE; break;
      case DocumentMode.RGB:      opts.mode = NewDocumentMode.RGB; break;
      case DocumentMode.CMYK:     opts.mode = NewDocumentMode.CMYK; break;
      case DocumentMode.LAB:      opts.mode = NewDocumentMode.LAB; break;
    }
  } else {
    opts.mode = ContactSheetConfig.toMode(opts.mode);
  }

  if (!opts.marginsEnabled || templ) {
    opts.leftMargin   = 0;
    opts.rightMargin  = 0;
    opts.topMargin    = 0;
    opts.bottomMargin = 0;
  }

  opts._width  = opts.docWidth;
  opts._height = opts.docHeight;

  if (opts.docUnits != 'Pixl') {
    var res;

    if (opts.docUnits == 'Inch') {
      res = opts.resolution;

    } else if (opts.docUnits == 'Cmtr') {
      res = opts.resolution/2.54;
    }

    opts.docWidth  = Math.round(opts.docWidth * res);
    opts.docHeight = Math.round(opts.docHeight * res);

    opts.leftMargin   = Math.round(opts.leftMargin * res);
    opts.rightMargin  = Math.round(opts.rightMargin * res);
    opts.topMargin    = Math.round(opts.topMargin * res);
    opts.bottomMargin = Math.round(opts.bottomMargin * res);
  }

  var w = opts.docWidth;
  var h = opts.docHeight;
  var res = opts.resolution;

  // configure autospacing
  if (opts.useAutoSpacing) {
    var v = (w/opts.columnCount) * opts.autospaceFactor / 100;
    opts.horizontal = Math.floor(v);
//     v = (h /opts.rowCount) * opts.autospaceFactor / 100;
//     opts.vertical = Math.floor(v);

    opts.vertical = opts.horizontal;

  } else {

    if (opts.spacingUnits == "in") {
      opts.horizontal = Math.floor(opts.resolution * opts.horizontal);
      opts.vertical = Math.floor(opts.resolution * opts.vertical);

    } else if (opts.spacingUnits == "cm") {
      opts.horizontal = Math.floor(opts.resolution * opts.horizontal / 2.54);
      opts.vertical = Math.floor(opts.resolution * opts.vertical / 2.54);
    }
  }

  // these 'frame' dimensions describe the size of the thumbnail/caption
  // area in a non-template-based sheet
  opts.frameWidth  = opts.docWidth - (opts.leftMargin + opts.rightMargin);
  opts.frameHeight = opts.docHeight - (opts.topMargin + opts.bottomMargin);
  
  // convert to pixels
  opts.fontSizePX = Math.floor(opts.fontSize * opts.resolution / 72);

  if (opts.caption) {
    if (opts.captionFilename) {
      opts.captionFormat = (opts.noExtensions ? "%f" : "%f.%e");
    }
  }

  if (opts.nextPage) {
    var start = ContactSheetUI.nextPageNumber(opts.outputFolder,
                                              opts.fileNameFormat);
    opts._pageStart = Number(start);
    opts._pagePad = start.length;
  }

  if (opts.nextFile) {
    var start = ContactSheetUI.nextFileNumber(opts.outputFolder,
                                              opts.fileNameFormat);
    opts._outputStart = Number(start);
    opts._outputPad = start.length;
  }

  self.currentPageNumber = opts._pageStart;
  self.currentFileIndex = opts._outputStart;

  Stdlib.log("Options:\n" + listProps(opts));

  if (opts.colorProfile == CSX.FIRST_IMAGE_PROFILE) {
    var fset = fileSets[0];
    opts.colorProfile = self.getColorProfileName(fset[0]);
  }

  if (self.templateOriginal && (opts.colorProfile != CSX.DEFAULT_PROFILE)) {
    try {
      self.convertProfile(self.templateOriginal, opts.colorProfile);

    } catch (e) {
      var msg = ("Failed to convert Template to color profile " +
                 opts.colorProfile);
      Stdlib.logException(e, msg, true);
//    alert(msg);
    }
  }

  var progressPalette = undefined;

  if (!opts.noUI) {
    progressPalette = GenericUI.createProgressPalette("CSX Progress...",
                                                      1, fileSets.length,
                                                      undefined, true);
    self.progressPalette = progressPalette;
  }

  try {
    for (var i = 0; i < fileSets.length; i++) {
      if (progressPalette) {
        if (progressPalette.isDone) {
          var msg = ('Stopped prematurely. ' + i + ' out of ' +
                     fileSets.length + ' sheets processed.');
          Stdlib.log(msg);
          break;
        }
        progressPalette.text = ("CSX - Processing " + (i+1) + " of " +
                                fileSets.length + " sheets...");
        progressPalette.updateProgress(i+1);
      }

      var set = fileSets[i];
      var templateDoc = undefined;

      if (set.length > 0) {
        opts.files = set;

        if (opts.background == 'Template') {
          if (opts.loadMetadataFromBridge) {
            self.metadata = self.getMetadataFromFile(opts, opts.files[0]);
          }

          var title = "CSX-Page " + (i+1);
          Stdlib.log("Creating Page " + title);
          templateDoc = Stdlib.duplicateDocument(self.templateOriginal,
                                                 title, false);
          if (!templateDoc) {
            Error.runtimeError(1268);  // "NotCreated"
            return;
          }
        }

        if (opts.watermarkMode) {
          var width = self.getMetadata("%W");
          var height = self.getMetadata("%H");
          templateDoc.resizeImage(width, height, undefined,
                                  ResampleMethod.NONE);
        }

        var rc = self.processFiles(opts, templateDoc);

        if (!rc) {
          break;
        }
      }
    }

  } finally {
    if (progressPalette) {
      progressPalette.close();
    }

    if (self.templateOriginal) {
      try { self.templateOriginal.close(SaveOptions.DONOTSAVECHANGES); }
      catch (e) {};
    }
  }
};


function selectToLayer(doc, layer) {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  var idx = Stdlib.getLayerIndex(doc, layer);
  ref.putIndex(cTID('Lyr '), idx);
  desc.putReference(cTID('null'), ref );
  desc.putEnumerated(sTID('selectionModifier'),
                     sTID('selectionModifierType'),
                     sTID('addToSelectionContinuous'));
  desc.putBoolean(cTID('MkVs'), false);
  executeAction(cTID('slct'), desc, DialogModes.NO);
};
function moveSelectedLayersToIndex(doc, idx) {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated(cTID('Lyr '), cTID('Ordn'), cTID('Trgt'));
  desc.putReference(cTID('null'), ref);
  var lref = new ActionReference();
  
  lref.putIndex(cTID('Lyr '), (Stdlib.hasBackground(doc) ? idx+1 : idx));
  desc.putReference(cTID('T   '), lref);
  desc.putBoolean(cTID('Adjs'), false);
  executeAction(cTID('move'), desc, DialogModes.NO);
};

ContactSheetX.prototype.processFiles = function(opts, templateDoc) {
  var self = this;

  // XXX this bit is somewhat clutzy. it needs to be fixed...
  var csLayer;        // the Contact Sheet layer, if there is one
  var csdoc;
  var fileCount = opts.files.length;

  if (templateDoc) {
    var topLayer = templateDoc.layers[0];
    var layers = Stdlib.getLayersList(templateDoc);
    csLayer = Stdlib.getByName(layers, CSX.CONTACT_SHEET);

    // populate the template
    csdoc = self.contactSheetX(opts, templateDoc);

  } else {

    // create and populate a sheet
    csdoc = self.contactSheetX(opts);
  }

  if (!csdoc) {
    return false;
  }

  Stdlib.makeActive(csdoc); // just to be sure...

  if (csdoc == templateDoc) {
    // if it's a template-based document

    // apply the collected keywords from the images
    // in the sheet to the sheet itself
    if (opts.accumulateKeywords) {
      var keys = csdoc.info.keywords;
      var iptc = new IPTC(csdoc);
      iptc.addKeywords(keys);
    }

    // do variable substitution on layer text in the template
    self.updateLayers(csdoc, opts);

    // if the csLayer is already the top layer,
    // we don't need to move the cell layers
    if (csLayer && csLayer != topLayer) {
      // if there's a CS layer, get the index of it
      csdoc.activeLayer = csLayer;
//    Stdlib.nextLayer(csdoc);
      var csIndex = Stdlib.getActiveLayerIndex(csdoc);
    }

    // select the sheet/cell layers
    csdoc.activeLayer = topLayer;
    Stdlib.nextLayer(csdoc);

    selectToLayer(csdoc, csdoc.layers[0]);

    // if there is a csLayer, move the cells to just above it
    // in the layer stack unless they are already there
    if (csLayer && csLayer != topLayer) {
      moveSelectedLayersToIndex(csdoc, csIndex);
    }

//     $.level = 1; debugger;

    if (opts.flattenCells || opts.flatten) {
      // by default, the cells in the sheet are flattened
      // to a single layer that is then merged with the
      // (optional) Contact Sheet layer. The merge preserves
      // the layer style settings on the CS layer

      if (opts.flattenCells && opts.splitCSXLayerOnFlatten &&
          !opts.flattenCells) {
        self.splitCSXLayers(csdoc, opts);

        // in the case with a split csx layer, copy/paste layer styles
        // instead of doing the merge

        if (csLayer) {
          if (Stdlib.hasEffects(csdoc, csLayer)) {
            Stdlib.copyEffects(csdoc, csLayer);
            var imagesLayer = Stdlib.getByName(doc.artLayers,
                                               CSX.IMAGES_LAYER);
            Stdlib.pasteEffects(csdoc, imagesLayer);

            if (opts.caption) {
              var capsLayer = Stdlib.getByName(doc.artLayers,
                                               CSX.CAPTIONS_LAYER);
              Stdlib.pasteEffects(csdoc, capsLayer);
            }
          }
          csLayer.remove();
          csLayer = undefined;
        }

      } else {

        // merge all of the thumb/caption layers, if needed
        if (fileCount > 0) {
          try {
            Stdlib.mergeLayers(csdoc);
          } catch (e) {
          }
        }

        if (csLayer) {
          // fold thumnbs/caption into the Contact Sheet layer acquiring
          // layer styles, settings, etc...
          csdoc.activeLayer.merge();
        }

        // set to the 'standard' sheet layer name
        csdoc.activeLayer.name = CSX.CONTACT_SHEET;
      }

    } else {
      csdoc.activeLayer = csdoc.layers[0];
    }

    if (opts.flatten) {
      csdoc.flatten();
 
      // set to the 'standard' sheet layer name if flattened
      csdoc.activeLayer.name = CSX.CONTACT_SHEET;
    }

  } else {
    // it's not a template-based document

    if (opts.background == 'None') {
      if (Stdlib.hasBackground(csdoc)) {
        csdoc.backgroundLayer.remove();
      }

      if (opts.flatten || opts.flattenCells) {
        if (opts.flattenCells && opts.splitCSXLayerOnFlatten) {
          self.splitCSXLayers(csdoc, opts);

        } else {
          Stdlib.mergeVisible(csdoc);
          // set to the 'standard' sheet layer name if flattened
          csdoc.activeLayer.name = CSX.CONTACT_SHEET;
        }
      }

    } else {
      if (opts.flatten) {
        csdoc.flatten();

        // set to the 'standard' sheet layer name if flattened
        csdoc.activeLayer.name = CSX.CONTACT_SHEET;

      } else if (opts.flattenCells) {
        
        if (opts.splitCSXLayerOnFlatten) {
          self.splitCSXLayers(csdoc, opts);

        } else {

          if (Stdlib.hasBackground(csdoc)) {
            var vis = csdoc.backgroundLayer.visible;
            csdoc.backgroundLayer.visible = false;
            Stdlib.mergeVisible(csdoc);
            csdoc.backgroundLayer.visible = vis;
            
          } else {
            csdoc.flatten();
          }

          // set to the 'standard' sheet layer name if flattened/merged
          csdoc.activeLayer.name = CSX.CONTACT_SHEET;
        }
      }
    }
  }

  if (opts.postProcessAction) {
    self.runPostProcessAction(csdoc, opts);
  }

  if (opts.saveSheet) {
    self.saveDocument(csdoc, opts);
  }
  if (!opts.keepOpen) {
    csdoc.close(SaveOptions.DONOTSAVECHANGES);
  }

  self.currentPageNumber++;
  self.currentFileIndex++;

  opts._base = undefined;

  return true;
};
ContactSheetX.prototype.splitCSXLayers = function(doc, opts) {
  var self = this;
  var layers = Stdlib.getLayersList(doc);
  var imageLayers = [];
  var captionLayers = [];

  // This needs to take into account the situation where ops.splitCSXLayer
  // is set to true but opts.caption is set to false.

  for (var i = 0; i < layers.length; i++) {
    var layer = layers[i];
    var lname = layer.name;

    if (lname.contains('.') &&
        layer.kind == LayerKind.TEXT &&
        (i + 1) < layers.length) {
      var nextLayer = layers[i+1];

      if (nextLayer.kind == LayerKind.NORMAL) {
        if (lname.startsWith(nextLayer.name + '.')) {
          imageLayers.push(nextLayer);
          captionLayers.push(layer);
        }
      }
    }
  }

  if (captionLayers) {
    Stdlib.selectLayer(doc, captionLayers[0]);
    Stdlib.mergeLayers(doc, imageLayers);
    doc.activeLayer.name = CSX.IMAGES_LAYER;
    Stdlib.mergeLayers(doc, captionLayers);
    doc.activeLayer.name = CSX.CAPTIONS_LAYER;

  } else {
    Stdlib.mergeLayers(doc, imageLayers);
    doc.activeLayer.name = CSX.IMAGES_LAYER;
  }
};

ContactSheetX.prototype.runPostProcessAction = function(doc, opts) {
  var self = this;

  if (!opts._postProcessAction) {
    var actf = opts.postProcessAction;
    var parts = actf.split('@');

    if (parts.length == 2 && parts[0] != '') {
      if (!Stdlib.hasAction(parts[1], parts[0])) {
        Error.runtimeError(9001, "Action " + act + " is missing.");
      }

      opts._postProcessAction = {
        actionSet: parts[0],
        action: parts[1]
      };

    } else {
      var scr = actf;
      var f;
      if (scr.startsWith("/")) {
        f = new File(scr);
      } else {
        f = new File(ContactSheetUI.getScriptFolder() + '/' + scr);
      }
      if (!f.exists) {
        Error.runtimeError(9001, "Unable to find PostProcess Action " +
                           "script: " + scr);
      }
      
      var scr = Stdlib.readFromFile(f);
      opts._postProcessAction = {
        script: scr
      };
    }
  }

  if (opts._postProcessAction.action) {
    if (!Stdlib.runAction(opts._postProcessAction.action,
                          opts._postProcessAction.actionSet)) {
      Error.runtimeError(9001, "Error running postProcessAction.");
    }

  } else if (opts._postProcessAction.script) {
    ContactSheetX._opts = opts;

    eval(opts._postProcessAction.script);

  } else {
    Error.runtimeError(9001, "Unknown internal error attempting to " +
                       "run PostProcess action.");
  }
};

ContactSheetX.prototype.getSymbolicColor = function(obj) {
  return XOpt.Color.getSymbolicColor(obj);
};

ContactSheetX.prototype.createSheet = function(opts) {
  var self = this;
  var doc;
  var name = self.getSheetName(opts);

  try {
    doc = app.documents.add(opts.docWidth, opts.docHeight, opts.resolution,
                            name,
//                             "CSX-Sheet " + self.currentPageNumber,
                            opts.mode);
  } catch (e) {
    var msg;
    if (e.number == 8007) {
      msg = "User cancelled the operation.";

    } else {
      msg = ("Unable create new contact sheet document.\n" +
             "Please check your document dimensions and units.\n\n\"" +
             e.toString() + "\"");
    }

    Error.runtimeError(9001, msg);
  }

  if (opts.colorProfile != CSX.DEFAULT_PROFILE) {
    try {
      self.convertProfile(doc, opts.colorProfile);

    } catch (e) {
      var msg = ("Failed to convert sheet to color profile " +
                 opts.colorProfile);
      Stdlib.log(msg);
      Stdlib.logException(e);
//    alert(msg);
    }
  }

  //doc.activeLayer.isBackground = false;
  doc.selection.selectAll();

  var color = self.getSymbolicColor(opts.background);

  if (color) {
    doc.selection.fill(color);
  } else if (opts.background == 'None') {
    doc.selection.clear();
  }

  doc.selection.deselect();

  return doc;
};

ContactSheetX.prototype.convertProfile = function(doc, profile) {
  var convert = true;

  if (doc.colorProfileType != ColorProfile.NONE) {
    convert = doc.colorProfileName != profile;
  } 

  if (convert) {
    Stdlib.log("Convert color profile for " + decodeURI(doc.name) +
               " to " + profile);
    Stdlib.convertProfile(doc, profile);
  }
};

//
// Returns the color profile of the File or the default PS
// profile if no file is specified.
//
ContactSheetX.prototype.getColorProfileName = function(opts, file) {
  var self = this;
  var profileName = CSX.DEFAULT_PROFILE;

  var doc = app.documents.add(UnitValue(1, "px"), UnitValue(1, "px"));
  var psDefaultProfile = doc.colorProfileName;
  doc.close(SaveOptions.DONOTSAVECHANGES);

  if (!file) {
    profileName = psDefaultProfile;

  } else {
    // a side effect from this is opts._colorProfileName
    self.getMetadataFromFile(opts, file);

    profileName = opts._colorProfileName;

    // We should only have to open the file in CS2
    // or in CS3 if Bridge is not running. XMPScript code
    // for CS4 will be added later

    if (!profileName) {
      try {
        var fdoc = app.open(file);
      } catch (e) {
        return undefined;
      }

      if (fdoc.colorProfileType != ColorProfile.NONE) {
        profileName = fdoc.colorProfileName;

      } else {
      }

      try {
        fdoc.close(SaveOptions.DONOTSAVECHANGES);
      } catch (e) {
      }

      if (!profileName || profileName == "None") {
        profileName = psDefaultProfile;
      }

      opts._colorProfileName = profileName;
    }
  }

  return profileName;
};

ContactSheetX.prototype.getMetadataFromFile = function(opts, file) {
  var self = this;
  var metadata = undefined;

  if (!file) {
    return undefined;
  }

  if (ContactSheetUI.isBridgeRunning()) {
    if (!isCS2()) {
      var xmp = XBridgeTalk.getMetadata(file);
      metadata = new Metadata(xmp);
      metadata.file = file;
      metadata.defaultDateTimeFormat = opts.dateFormat;
      metadata.defaultGPSFormat = opts.gpsFormat;

      if (!opts._colorProfileName) {
        opts._colorProfileName = (metadata.get('${XMP:ICCProfile}') || 'None');
      }
      metadata._profile = opts._colorProfileName;

      metadata._bitDepth = '';

      // metadata._bitDepth = XBridgeTalk.getBitDepth(file);
    }
  }

  if (!metadata) {
    // We should only have to open the file in CS2
    // or in CS3 if Bridge is not running. XMPScript code
    // for CS4 will be added later

    try {
      var fdoc = app.open(file);
    } catch (e) {
      return;
    }

    metadata = new Metadata(fdoc.xmpMetadata.rawData);
    metadata.defaultDateTimeFormat = opts.dateFormat;
    metadata.defaultGPSFormat = opts.gpsFormat;
    metadata.file = file;
    metadata._resolution = fdoc.resolution;
    metadata._width = fdoc.width.value;
    metadata._height = fdoc.height.value;
    metadata._mode = Stdlib.colorModeString(fdoc.mode);

    if (!opts._colorProfileName) {
      var colorProfile = "None";

      if (fdoc.colorProfileType != ColorProfile.NONE) {
        colorProfile = fdoc.colorProfileName;
      }

      metadata._profile = colorProfile;
      opts._colorProfileName = colorProfile;
    }

    var bpc = fdoc.bitsPerChannel;
    var str = '';
    if (bpc == BitsPerChannelType.ONE) {
      str = "1";
    } else if (bpc == BitsPerChannelType.EIGHT) {
      str = "8";
    } else if (bpc == BitsPerChannelType.SIXTEEN) {
      str = "16";
    } else if (bpc == BitsPerChannelType.THIRTYTWO) {
      str = "32";
    }
    metadata._bitDepth = str;

    try {
      fdoc.close(SaveOptions.DONOTSAVECHANGES);

    } catch (e) {
    }
  }

  return metadata;
};


ContactSheetX.prototype.formatDate = function(str) {
  var self = this;

  if (!str) {
    return self.dateTimeStr;
  }
  if (!str.contains('%')) {
    str = str.replace(/YYYY/g, '%Y');
    str = str.replace(/YY/g, '%y');
    str = str.replace(/MM/g, '%m');
    str = str.replace(/DD/g, '%d');
    str = str.replace(/H/g, '%H');
    str = str.replace(/I/g, '%I');
    str = str.replace(/M/g, '%M');
    str = str.replace(/S/g, '%S');
    str = str.replace(/P/g, '%p');
  }
  return self.now.strftime(str);
};

ContactSheetX.prototype.formatPageNumber = function(str, current, total) {
  var self = this;

  if (!str) {
    return current;
  }

  if (str.contains('%')) {
    str = str.replace(/%0p/g, current);
    str = str.replace(/%p/g,  Number(current));
    str = str.replace(/%P/g, total);
  }

  return str;
};

ContactSheetX.prototype.updateLayers = function(doc, opts) {
  var self = this;
  var layers = Stdlib.getLayersList(doc);

  var pageNumber = self.zeroPad(self.currentPageNumber, opts._pagePad);
  var totalPages = self.fileSets.length;

  if (!self.dateStr) {
    self.dateStr = self.formatDate(opts.dateFormat);
  }

  var dialogMode = app.displayDialogs;

  try {
    // we need to do this for the text-layer-needs-updating dialog
    app.displayDialogs = DialogModes.NO;

    for (var i = 0; i < layers.length; i++) {
      var layer = layers[i];
      if (!layer.visible || layer.kind != LayerKind.TEXT) {
        continue;
      }
      var name = layer.name;

      if (name.charAt(0) != '@') {
        continue;
      }
      var str = layer.textItem.contents;
      var val = undefined;

      var dateTag = '@Date';
      var pageTag = '@Page Number';
      var mdPrefix = '@Metadata';

      if (name == dateTag) {
        if (str) {
          val = self.formatDate(str);
        } else {
          val = self.dateStr;
        }
      }
      if (name == pageTag) {
        val = self.formatPageNumber(str, pageNumber,
                                    totalPages + opts._pageStart - 1);
      }

      if (name.startsWith(mdPrefix)) {
        var nm;
        // check for a metadata format spec in the layername
        // or in the layer content
        if (name.startsWith(mdPrefix + '=')) {
          nm = name.slice(mdPrefix.length + 1);
        } else {
          nm = str;
        }
        val = self.getMetadata(nm);
      }

      if (opts.enableTextSubstitution) {
        // This picks up the Template Variables specied in the UI.
        // As a side-effect can override @Date and @Page Number layers

        if (opts[name] != undefined) {
          val = opts[name];
          if (val.contains('%')) {
            val = self.getMetadata(val);
          }
        }
      }

      if (val != undefined) {
        layer.textItem.contents = val;
        
      } else {
        layer.visible = false;
      }
    }

  } finally {
    app.displayDialogs = dialogMode;
  }
};
ContactSheetX.prototype.getMetadata = function(fmtTag) {
  var self = this;
  return (self.metadata ? self.metadata.strf(fmtTag) : '');
};

ContactSheetX.prototype.setBackground = function(doc, opts) {
  var bg = opts.background;
  var layer = doc.backgroundLayer;
  if (bg == 'White') {
    return;
  }
  if (bg == 'None') {
    layer.remove();
    return;
  }
  if (bg == 'Black') {
    doc.activeLayer = layer;
    doc.selection.selectAll();
    doc.selection.fill(Stdlib.createRGBColor(0, 0, 0));
    doc.selection.deselect();
    return;
  }
  if (bg == 'Template') {
    //layer.clear();
    return;
  }
};
ContactSheetX.prototype.getSheetName = function(opts) {
  var self = this;
  var name;
  var base = '';

  // XXX this little hook can be set by a postProcessAction script.
  if (opts._base) {
    base = opts._base;

  } else { 
    var index = self.zeroPad(self.currentFileIndex, opts._outputPad);

    if (opts.fileNameFormat.contains('#')) {
      base = opts.fileNameFormat.replace(/#+/g, index);
    } else {
      base = opts.fileNameFormat + index;
    }
  }

  if (opts.saveSheet) {
    name = base + '.' + opts.fileSaveType;

  } else {
    name = base;
  }

  // base = (opts.outputPrefix + 
  //         self.zeroPad(self.currentFileIndex, opts._outputPad));

  return name;
};

ContactSheetX.prototype.saveDocument = function(doc, opts) {
  var self = this;

  if (!opts.saveSheet) {
    Stdlib.log("Contact Sheet not saved #" + self.currentPageNumber);
    return;
  }

  var profileConverted = false;

  var saveOpts = self.getSaveOpts(opts);

  var name = self.getSheetName(opts);
  
  if (opts._formatPanel) {
    var fname = (opts.outputFolder + '/' + name);

    var file = new File(fname);

    if (opts.fileSaveType == 'jpg') {
      var bpc = doc.bitsPerChannel;
      if (bpc != BitsPerChannelType.ONE && bpc != BitsPerChannelType.EIGHT) {
        doc.bitsPerChannel = BitsPerChannelType.EIGHT;
      }
    }

    if (saveOpts._flatten) {
      doc.flatten();
    }

    if (saveOpts._convertToIndexed) {
      if (doc.mode != DocumentMode.INDEXEDCOLOR) {
        if (doc.mode != DocumentMode.RGB) {
          doc.changeMode(ChangeMode.RGB);
        }
        var cnvtOpts = new IndexedConversionOptions();
        doc.changeMode(ChangeMode.INDEXEDCOLOR, cnvtOpts);
      }
    }

    if (saveOpts._convertToSRGB) {
      try {
        Stdlib.log("Converting to sRGB");

        self.convertProfile(doc, ColorProfileNames.SRGB);
        profileConverted = true;

      } catch (e) {
      }
    }
   
  } else {
    var fname = opts.outputFolder + '/' + base + '.' + opts.outputFormat;

    var file = new File(fname);

    if (opts.outputFormat == 'jpg') {
      var bpc = doc.bitsPerChannel;
      if (bpc != BitsPerChannelType.ONE && bpc != BitsPerChannelType.EIGHT) {
        doc.bitsPerChannel = BitsPerChannelType.EIGHT;
      }
    }
  }

  Stdlib.log("Saving sheet: " + file.toUIString());
  doc.saveAs(file, saveOpts, false);

  Stdlib.log("Contact Sheet saved " + file.toUIString());
};

ContactSheetX.prototype.getSaveOpts = function(opts) {

  if (opts._formatPanel) {
    var fsOpts = FileSaveOptions.convert(opts);
    return fsOpts;
  }

  var saveOpts = undefined;
  var fmt = opts.outputFormat;

  if (fmt == 'jpg') {
    saveOpts = new JPEGSaveOptions();
    if (opts.jpgQuality) {
      saveOpts.quality = opts.jpgQuality;
    }
    if (opts.jpgFormat) {
      saveOpts.formatOptions = opts.jpgFormat;
    }

  } else if (fmt == 'tif') {
    saveOpts = new TiffSaveOptions();
    if (opts.tiffEncoding) {
      saveOpts.imageCompression = opts.tiffEncoding;
    }
    if (opts.tiffByteOrder) {
      saveOpts.byteOrder = opts.tiffByteOrder;
    }

  } else if (fmt == 'psd') {
    saveOpts = new PhotoshopSaveOptions();

  } else if (fmt == 'png') {
    saveOpts = new PNGSaveOptions();
  }

  return saveOpts;
};

ContactSheetX.prototype.zeroPad = function(num, w) {
  var str = num.toString();

  while (str.length < w) {
    str = "0" + str;
  }
  return str;
};

ContactSheetX.getSourceImages = function(opts) {
  var fileSets;

  if (opts.files && opts.files.length > 0) {
    fileSets = ContactSheetX.getFileSetsFromFiles(opts, opts.files);

  } else if (opts.imageSource == CSX.OPENDOCUMENTS) {
    fileSets = ContactSheetX.getImageSets(opts);

  } else {
    fileSets = ContactSheetX.getFileSets(opts);
  }
  return fileSets;
};

ContactSheetX.getImageSets = function(opts) {
  var sets = [];
  var setSize = opts.rowCount * opts.columnCount;

  var docs = app.documents;

  var currentSet = [];

  for (var i = 0; i < docs.length; i++) {
    currentSet.push(docs[i]);
    if (currentSet.length == setSize) {
      sets.push(currentSet);
      currentSet = [];
    }
  }

  if (currentSet.length != 0) {
    sets.push(currentSet);
  }

  return sets;
};
  
ContactSheetX.getFileSetsFromFiles = function(opts, files) {
  //files.sort();

  var sets = [];
  var setSize = opts.rowCount * opts.columnCount;
  var span = opts.spanFolders;

  var currentSet = [];
  //
  // XXX insert code to map an array of files into a array of fileSets/sheets
  //
  // XXX This is untested....
  //

  var folderStr = files[0].parent.absoluteURI;
  
  while (files.length > 0) {
    var file = files.shift();
    if (file.parent.absoluteURI != folderStr && !span) {
      folder = file.parent;
      sets.push(currentSet);
      currentSet = [];
    }
    currentSet.push(file);
    if (currentSet.length == setSize) {
      sets.push(currentSet);
      currentSet = [];
    }
  }
  if (currentSet.length != 0) {
    sets.push(currentSet);
  }

  return sets;
};
ContactSheetX.xpFileSort = function(list) {
  var rex = /(\d+)\./;

  function xpCmp(a, b) {
    var ap = a.name.match(rex);
    var bp = b.name.match(rex);
    if (ap != null && bp != null) {
      return toNumber(ap[1]) - toNumber(bp[1]);
    }
    if (a.name.toLowerCase() < b.name.toLowerCase()) {
      return -1;
    } else if (a.name > b.name) {
      return 1;
    }
    return 0;
  }
  return list.sort(xpCmp);
};

ContactSheetX.getFileSets = function(opts) {
  var sets = [];
  var setSize = opts.rowCount * opts.columnCount;
  var span = opts.spanFolders;

  var currentSet = [];

  function collectSets(f) {
    var images = f.images;
    var ss = sets;
    var cs = currentSet;

    //$.level = 1; debugger;

    while (images.length) {
      currentSet.push(images.shift());
      if (currentSet.length == setSize) {
        sets.push(currentSet);
        currentSet = [];
      }
    }
    if (currentSet.length != 0 && !span) {
      sets.push(currentSet);
      currentSet = [];
    }
    var folders = f.subfolders;
    while (folders.length) {
      collectSets(folders.shift());
    }
  };

  if (opts.imageSource == 'Folder') {
    var tree = ContactSheetX.getDirectoryTree(opts);
    collectSets(tree);
    if (currentSet.length != 0) {
      sets.push(currentSet);
    }

  } else {
    var flist = ContactSheetUI._bridgeSelection;

    if (opts.xpSort) {
      // deviant XP Intuitive sort
      ContactSheetX.xpFileSort(flist);
    }

    // Note that this does not take into account folder-spanning
    for (var i = 0; i < flist.length; i++) {
      var fl = flist[i];
      if (fl.name.match(Stdlib.ImageFileExtsCompleteRE) && !fl.hidden) {
        currentSet.push(fl);
        if (currentSet.length == setSize) {
          sets.push(currentSet);
          currentSet = [];
        }
      }
    }
    if (currentSet.length != 0) {
      sets.push(currentSet);
    }
  }
  return sets;
};
ContactSheetX.getDirectoryTree = function(opts) {

  function getTree(f, recurse) {
    var tree = {
      folder: f,
      images: [],
      subfolders: [],
    };

    var flist = f.getFiles();

    if (opts.xpSort) {
      // deviant XP Intuitive sort
      ContactSheetX.xpFileSort(flist);

    } else {
      flist.sort();
    }

    for (var i = 0; i < flist.length; i++) {
      var fl = flist[i];

      if (fl instanceof Folder && recurse) {
        var sub = getTree(fl, true);
        tree.subfolders.push(sub);

      } else if (fl.name.match(Stdlib.ImageFileExtsCompleteRE) && !fl.hidden) {
        tree.images.push(fl);
      }
    }

    return tree;
  }

  if (opts.imageSource == 'Folder' && opts.folder &&
      opts.folder instanceof Folder) {
    var tree = getTree(opts.folder, opts.recurse);
    return tree;
  }
  return undefined;
};

// NOTE: this apparently is not used
ContactSheetX.prototype.getFolderList = function(opts) {
  var folders = [];

  function getFolders(f) {
    if (!getFolders.list) {
      getFolders.list = [];
    }
    getFolders.list.push(f);
    var ar = Stdlib.getFolders(f);
    for (var i = 0; i < ar.length; i++) {
      getFolders(ar[i]);
    }
    return getFolders.list;
  }

  if (opts.imageSource == 'Folder' && opts.folder &&
      opts.folder instanceof Folder) {
    if (opts.recurse) {
      return getFolders(opts.folder);
    } else {
      return [opts.folder];
    }
  }

  return undefined;
};

ContactSheetX.fitImage = function(doc, width, height) {
  var ru = app.preferences.rulerUnits;
  try {
    app.preferences.rulerUnits = Units.PIXELS;
    var desc = new ActionDescriptor();
    desc.putUnitDouble(cTID("Wdth"),  cTID("#Pxl"), parseFloat(width));
    desc.putUnitDouble(cTID("Hght"),  cTID("#Pxl"), parseFloat(height));
    executeAction(sTID("3caa3434-cb67-11d1-bc43-0060b0a13dc4"),
                  desc, DialogModes.NO);
  } finally {
    app.preferences.rulerUnits = ru;
  }
};

//
// compute the fundamental bounds arrays at 0,0. All others will
// be computed as offsets from 0,0
//
ContactSheetX.prototype.computeBounds = function(csOpts, cellW, cellH) {
  var self = this;

  // compute the cell bounds
  csOpts.cellBnds = [0, 0, cellW, cellH];

  csOpts.landscape = (cellW > cellH);

  // compute the basic image bounds with spacing
  var imageW = cellW - (2 * csOpts.horizontal);
  var imageH = cellH - (2 * csOpts.vertical);

  csOpts.imageBnds = [csOpts.horizontal, csOpts.vertical,
                      imageW+csOpts.horizontal, imageH+csOpts.vertical];

  var capHeight = 0;
  var overlay = false;

  var caption = csOpts.caption;

  if (caption) {
    // handle multi-line options
    var lineCnt = csOpts.captionFormat.split('\\n').length;
    capHeight = Math.floor(csOpts.fontSizePX * lineCnt);
    overlay = csOpts.overlayCaption && csOpts.capVAlignment == 'Middle';

    if (!overlay) {
      imageH -= (capHeight + csOpts.vertical/2);
    }
  }

  // adjust if constrained to a square
  if (csOpts.squareCell) {
    if (imageW > imageH) {
      imageW = imageH;
    } else {
      imageH = imageW;
    }
  }

  csOpts.imageBnds[2] = csOpts.imageBnds[0] + imageW;

  if (!caption) {
    csOpts.imageBnds[3] = csOpts.imageBnds[1] + imageH;
  }

  if (caption) {
    if (csOpts.capVAlignment == 'Bottom') {
      csOpts.imageBnds[3] = csOpts.imageBnds[1] + imageH;

    } else if (csOpts.capVAlignment == 'Top') {
      csOpts.imageBnds[1] = csOpts.imageBnds[3] - imageH;
    }

    // compute the bounds for the caption
    var yy;
    if (csOpts.capVAlignment == 'Middle') {
      yy = (csOpts.imageBnds[3] + csOpts.vertical/2 + csOpts.imageBnds[1] -
            capHeight) / 2;
    } else {
      if (csOpts.overlayCaption) {
        if (csOpts.capVAlignment == 'Bottom') {
          yy = csOpts.imageBnds[3] - capHeight; // csOpts.fontSizePX;

        } else if (csOpts.capVAlignment == 'Top') {
          yy = csOpts.imageBnds[1] + csOpts.vertical/2;
        }
      } else {
        if (csOpts.capVAlignment == 'Bottom') {
          yy = csOpts.imageBnds[3] + csOpts.vertical/2;

        } else if (csOpts.capVAlignment == 'Top') {
          yy = csOpts.imageBnds[1] - capHeight; // csOpts.fontSizePX;
        }
      }
    }

    csOpts.captionBnds = [0, yy, cellW, yy + capHeight];

  } else {
    csOpts.captionBnds = [0, 0, 0, 0];
  }
};

ContactSheetX.prototype.offsetBounds = function(bnds, x, y) {
  return [bnds[0]+x, bnds[1]+y, bnds[2]+x, bnds[3]+y];
};

ContactSheetX.prototype.contactSheetX = function(csOpts, templateDoc) {
  var self = this;

  Stdlib.log("Creating sheet " + self.currentPageNumber + " with files:\n" +
             csOpts.files.toString().replace(/,/g, '\n'));

  var xbase = 0;
  var ybase = 0;
  var doc;

  if (templateDoc) {
    // if there's a template doc, we place the images directly into
    // the template.
    // xbase and ybase are the offsets from 0,0 and point to the region
    // marked by the optional mask

    doc = templateDoc;
    var layers = Stdlib.getLayersList(doc);
    var csLayer = Stdlib.getByName(layers, CSX.CONTACT_SHEET);

    if (csLayer) {
      Stdlib.makeActive(csLayer);

      if (Stdlib.hasLayerMask(doc, csLayer)) {
        var bnds = Stdlib.getMaskBounds(doc, csLayer);
        xbase = bnds[0];
        ybase = bnds[1];
        Stdlib.selectMaskChannel(doc, csLayer);

        if (csOpts.fixMaskPhantomPixels) {
          Stdlib.removeLayerMask(doc, csLayer, false);
          Stdlib.selectBounds(doc, bnds);
          Stdlib.createLayerMask(doc, csLayer, true);
          Stdlib.selectRGBChannel(doc, csLayer);
          Stdlib.selectBounds(doc, bnds);
        }
        
      } else {
        doc.selection.selectAll();
      }

      // clear the contents of the CS layer.
      // the layer style is left in place
      doc.selection.clear();
    }

  } else {
    // if we don't have a template to work with,
    // we create a completely new document
    doc = self.createSheet(csOpts);
  }

  var res = doc.resolution;

  // things don't work right if you're not in 72dpi mode
  if (res != 72) {
    doc.resizeImage(undefined, undefined, 72, ResampleMethod.NONE);
  }
  var cellW = Math.floor(csOpts.frameWidth / csOpts.columnCount);
  var cellH = Math.floor(csOpts.frameHeight / csOpts.rowCount);

  self.computeBounds(csOpts, cellW, cellH);

  var row = 0;
  var col = 0;

  var okay = true;
  var isDone = false;

  if (csOpts.acrossFirst) {
    var useGuides = false; // XXX

    for (var i = 0; i < csOpts.rowCount && okay && !isDone; i++) {
      var yofs = i * cellH + csOpts.topMargin + ybase;

      if (useGuides) {
        Stdlib.createHorizontalGuide(doc, yofs);
        Stdlib.createHorizontalGuide(doc, yofs+cellH);
      }

      for (var j = 0; j < csOpts.columnCount && okay && !isDone; j++) {
        var xofs = j * cellW + csOpts.leftMargin + xbase;

        if (useGuides) {
          Stdlib.createVerticalGuide(doc, xofs);
          Stdlib.createVerticalGuide(doc, xofs+cellW);
        }

        if (self.progressPalette && self.progressPalette.isDone) {
          var msg = ('User cancelled processing.');
          Stdlib.log(msg);
          okay = false;
          break;
        }

        isDone = !self.createCell(doc, csOpts, xofs, yofs);
      }
    }
  } else {
    for (var j = 0; j < csOpts.columnCount && okay && !isDone; j++) {
      var xofs = j * cellW + csOpts.leftMargin + xbase;

      for (var i = 0; i < csOpts.rowCount && okay && !isDone; i++) {
        var yofs = i * cellH + csOpts.topMargin + ybase;

        if (self.progressPalette && self.progressPalette.isDone) {
          var msg = ('User cancelled processing.');
          Stdlib.log(msg);
          okay = false;
          break;
        }

        isDone = !self.createCell(doc, csOpts, xofs, yofs);
      }
    }
  }

  if (okay) {
    // re-res if needed
    if (res != 72) {
      doc.resizeImage(undefined, undefined, res, ResampleMethod.NONE);
    }

    Stdlib.log("Sheet creation complete");

    if (csOpts.alternateMargins) {
      var m = csOpts.leftMargin;
      csOpts.leftMargin = csOpts.rightMargin;
      csOpts.rightMargin = m;
    }

  } else {
    doc = undefined;
  }

  return doc;
};

ContactSheetX.prototype.createCellHP = function(doc, csOpts, x, y) {
  var self = this;

  var bnds = self.offsetBounds(csOpts.imageBnds, x, y);

  var rc = false;
  while (!rc) {
    var file = csOpts.files.shift();

    if (!file) {
      return false;  // we're done
    }

    Stdlib.log("Processing: " + file.toUIString());

    self.imageProcessingTimer.start();
    rc = self.insertImageHP(doc, csOpts, bnds, file);
  }

  self.imageProcessingTimer.stop();
  
  if (csOpts.caption) {
    var bnds = self.offsetBounds(csOpts.captionBnds, x, y);

    self.insertCaption(doc, csOpts, bnds, file);
  }
  
  return true;
};

ContactSheetX.prototype.createCell = function(doc, csOpts, x, y) {
  var self = this;

  if (csOpts.hiperfMode > 0 && !self.openDocMode) {
    return self.createCellHP(doc, csOpts, x, y);
  }

  var image = undefined;
  var bnds = self.offsetBounds(csOpts.imageBnds, x, y);

  var histState;

  while (image == undefined) {
    var file = csOpts.files.shift();

    if (!file) {
      return false;  // we're done
    }

    if (self.openDocMode) {
      Stdlib.log("Processing: " + file.name);

      image = file;
      file = Stdlib.getDocumentName(image);
      Stdlib.makeActive(image); 
      histState = undefined;

      if (image.historyStates.length > 1) {
        try {
          histState = image.activeHistoryState;

        } catch (e) {
          // This exception is getting thrown CS3/OSX
          // When stepping through this code with a debugger, it magically
          // works.
        }
      }

    } else {
      Stdlib.log("Processing: " + file.toUIString());
      image = self.openImage(file);
    }

    self.imageProcessingTimer.start();

    if (csOpts.colorProfile != CSX.DEFAULT_PROFILE) {
      self.convertProfile(image, csOpts.colorProfile);
    }
  }

  self.insertImage(doc, csOpts, bnds, image);

  self.imageProcessingTimer.stop();
  
  if (csOpts.caption) {
    var bnds = self.offsetBounds(csOpts.captionBnds, x, y);

    self.insertCaption(doc, csOpts, bnds, file, image);
  }

  if (self.openDocMode) {
    var d = Stdlib.makeActive(image);
    if (histState) {
      image.activeHistoryState = histState;
    } else {
      Stdlib.revertDocument(image);
    }
    Stdlib.makeActive(d);

  } else {
    image.close(SaveOptions.DONOTSAVECHANGES);
  }

  return true;
};

ContactSheetX.prototype.insertImage = function(doc, csOpts, bnds, image) {
  var self = this;

  self.imageCount++;

  Stdlib.log("Inserting image " + image.name + " at " + bnds);

  Stdlib.makeActive(doc);
  var layer = doc.artLayers.add();

  // XXX app.activeDocument = image;
  var lname = File(image.name).strf("%f");

  app.activeDocument = doc;
  layer.name = lname;

  Stdlib.selectBounds(doc, bnds, SelectionType.REPLACE, 0.0, false);

  var fit = !csOpts.autoFill;

  layer = self.insertImageIntoSelection(doc, csOpts, layer, image, fit);

  Stdlib.makeActive(doc);
  doc.selection.deselect();

  self.alignThumbnail(doc, csOpts, bnds, layer);

  var style = csOpts.thumbStyle;
  if (style && style != 'None') {
    layer.applyStyle(style);
  }

  if (csOpts.accumulateKeywords) {
    var iptc = new IPTC(doc);
    iptc.addKeywords(image.info.keywords);
  }

  return layer;
};

ContactSheetX.prototype.insertCaption = function(doc, csOpts, bnds, file,
                                                 image) {
  var self = this;
  var caption = decodeURI(file.name);

  if (csOpts.captionFilename) {
    if (csOpts.noExtensions) {
      caption = file.strf("%f");
    }

  } else if (csOpts.captionFormat) {
    if (image) {
      // format based on the image
      Stdlib.revertDocument(image);
      if (csOpts.dateFormat) {
        Metadata.defaultDateTimeFormat = csOpts.dateFormat;
      }
      if (csOpts.gpsFormat) {
        Metadata.defaultGPSFormat = csOpts.gpsFormat;
      }
      caption = Metadata.strf(csOpts.captionFormat, image);

    } else {
      if (csOpts.dateFormat) {
        Metadata.defaultDateTimeFormat = csOpts.dateFormat;
      }
      if (ContactSheetUI.isBridgeRunning()) {
        var md = self.getMetadataFromFile(csOpts, file);
        caption = md.strf(csOpts.captionFormat, file);

      } else {
        // format based on the file
        caption = Metadata.strf(csOpts.captionFormat, file);
      }
    }

    if (caption == undefined) {
      caption = '';
    }

  } else {
    caption = '';
  }

  caption = caption.replace(/(\\n)|(\n)|(&#xA;)/g, '\r').trim();
  
  Stdlib.log("Inserting caption " + caption + " at " + bnds);

  Stdlib.makeActive(doc);
  var layer = doc.artLayers.add();
  layer.kind = LayerKind.TEXT;
  layer.name = decodeURI(file.name);

  var titem = layer.textItem;
  if (csOpts.autoscaleCaptions) {
    titem.minimumGlyphScaling = 50;
    titem.desiredGlyphScaling = 100;
  }
  titem.contents = caption;
  titem.color = self.getSymbolicColor(csOpts.fontColor);
  titem.size = csOpts.fontSizePX;
  titem.font = csOpts.font;
  titem.kind = TextType.PARAGRAPHTEXT;  // XXX ???

  if (csOpts.autoscaleCaptions) {
    var twidth = Math.round(titem.width);
    if (twidth > (bnds[2]-bnds[0])) { // Make text fit in box
      if (((bnds[2]-bnds[0]) / twidth) > 0.5) {
        titem.desiredGlyphScaling = (100 * (bnds[2]-bnds[0])) / twidth;
      } else {
        titem.desiredGlyphScaling = 50;
      }
    }
  }

  if (csOpts.capAlignment == CSX.LEFT) {
    titem.justification = Justification.LEFTJUSTIFIED;
  } else if (csOpts.capAlignment == CSX.CENTER) {
    titem.justification = Justification.CENTERJUSTIFIED;
  } else if (csOpts.capAlignment == CSX.RIGHT) {
    titem.justification = Justification.RIGHTJUSTIFIED;
  }

  titem.width = bnds[2]-bnds[0];
  titem.position = [bnds[0], bnds[1]];

  var style = csOpts.captionStyle;
  if (style && style != 'None') {
    layer.applyStyle(style);
  }

  return layer;
};

//
// set the color of the corners described by bnds to the
// values in prclr. if prclr is not set, use the hardwired color
//
ContactSheetX.pinRegisterSet = function(doc, bnds, prclr) {
  var sel = doc.selection;
  var x  = bnds[0];
  var y  = bnds[1];
  var x1 = bnds[2]-1;
  var y1 = bnds[3]-1;

  function prSet(doc, x, y) {
    var clr = undefined;
    Stdlib.selectBounds(doc, [x, y, x+1, y+1]);
    var lvl = $.level;
    $.level = 0; 
    try {
      var multiLayer = doc.layers.length > 1;
      doc.selection.copy(multiLayer);
      clr = Stdlib.getColorAt(doc, x, y, false);
    } catch (e) {
      //$.level = 1; debugger;
    }
    $.level = lvl;
    return clr;
  }

  function prUnset(doc, x, y, clr) {
    var cbmode = ColorBlendMode.NORMAL;
    var opacity = 100;

    if (clr) {
      Stdlib.setColorAt(doc, x, y, clr, cbmode, opacity);
    } else {
      Stdlib.selectBounds(doc, [x, y, x+1, y+1]);
      doc.selection.clear();
    }
  }
  
  var oprclr = [];
  if (!prclr) {
    // use green as the pin marker
    var clr = Stdlib.createRGBColor(0,255,0);
    prclr = [];
    prclr.push(clr);
    prclr.push(clr);
    prclr.push(clr);
    prclr.push(clr);

    // return the current values
    oprclr.push(prSet(doc, x, y));
    oprclr.push(prSet(doc, x, y1-1));
    oprclr.push(prSet(doc, x1-1, y1-1));
    oprclr.push(prSet(doc, x1-1, y));
  }

  prUnset(doc, x, y, prclr[0]);
  prUnset(doc, x, y1, prclr[1]);
  prUnset(doc, x1, y1, prclr[2]);
  prUnset(doc, x1, y, prclr[3]);

  return oprclr;
};

ContactSheetX.prototype.insertImageIntoSelection = function(doc, csOpts,
                                                            layer, im, fit) {
  var self = this;

  var imageDoc;
  var imageFile;
  if (im instanceof Document) {
    imageDoc = im;
  } else {
    imageFile = Stdlib.convertFptr(im);
  }

  if (fit == undefined) fit = true;

  if (!Stdlib.hasSelection(doc)) {
    Error.runtimeError(8152); // NoSelection
  }

  var bnds = Stdlib.getSelectionBounds(doc);

  // resize the image doc based on the selection bounds
  var width = bnds[2] - bnds[0];
  var height = bnds[3] - bnds[1];

  if (!imageDoc) {
    if (!imageFile.exists) {
      alert('Image ' + imageFile + ' does not exist.');
      return;
    }
    imageDoc = app.open(imageFile);
  }

  Stdlib.makeActive(imageDoc);
  if (csOpts.bestFit) {
    var deg = (csOpts.rotate == 'CW' ? 90 : -90);
    if (csOpts.landscape && !Stdlib.isLandscapeMode(imageDoc)) {
      imageDoc.rotateCanvas(deg);
    }
    if (!csOpts.landscape && Stdlib.isLandscapeMode(imageDoc)) {
      imageDoc.rotateCanvas(deg);
    }
  }

  var ru = app.preferences.rulerUnits;
  try {
    app.preferences.rulerUnits = Units.PIXELS;

    var lname = layer.name;

    if (fit) {
      // change the res
      app.activeDocument = imageDoc;
      imageDoc.resizeImage(undefined, undefined, doc.resolution,
                           ResampleMethod.NONE);
      app.activeDocument = imageDoc;
      Stdlib.fitImage(imageDoc, width, height);

    } else {
      // fit to the shortest side (image will crop)
      var dwidth = imageDoc.width.value;
      var dheight = imageDoc.height.value;
    
      var ratio = height/width;
      var dratio = dheight/dwidth;
      
      var xw = width;
      var xh = height;
      if (dratio > ratio) {
        height = undefined;
      } else {
        width = undefined;
      }
      app.activeDocument = imageDoc;
      imageDoc.resizeImage(width, height, doc.resolution,
                           ResampleMethod.BICUBIC);
      width = xw;
      height = xh;
    }

    app.activeDocument = imageDoc;

    var prset;

    if (csOpts.alphaLayerPinRegister)  {
      var ibnds = [0, 0, imageDoc.width.value, imageDoc.height.value];
      prset = ContactSheetX.pinRegisterSet(imageDoc, ibnds);
    }

    imageDoc.selection.selectAll();
    app.activeDocument = imageDoc;
    var multiLayer = imageDoc.layers.length > 1;
    imageDoc.selection.copy(multiLayer);
    //imageDoc.close(SaveOptions.DONOTSAVECHANGES);

    var hasStyles = Stdlib.hasLayerStyles(doc, layer);
    if (hasStyles) {
      Stdlib.copyStyles(doc, true);
    }

    app.activeDocument = doc;

    //if (!Stdlib.hasSelection(doc)) {
    Stdlib.selectBounds(doc, bnds);
    //}

    app.activeDocument = doc;
    Stdlib.pasteInto(doc);
    
    layer.remove();
    layer = doc.activeLayer;

    Stdlib.linkLayerMask(doc, layer);

    if (prset) {
      var ibnds = layer.bounds;
      for (var i = 0; i < 4; i++) {
        ibnds[i] = ibnds[i].value;
      }

      prset = ContactSheetX.pinRegisterSet(doc, ibnds, prset);
    }

    layer.name = lname;

    if (hasStyles) {
      Stdlib.pasteStyles(doc, true);
    }

  } catch (e) {
    Stdlib.logException(e);
    var str = "Internal error: " + e.toString() + ", line " + e.line;
    alert(str);

  } finally {
    app.preferences.rulerUnits = ru;

    if (im != imageDoc) {
      try { imageDoc.close(SaveOptions.DONOTSAVECHANGES); } catch (e) {}
    }
  }

  return layer;
};


// HiPerf Code
// XXX new hiperf XXXX

function replaceLayer(file){
  var desc = new ActionDescriptor();
  desc.putPath(cTID("null"), new File(file));
  executeAction(sTID("placedLayerReplaceContents"), desc, DialogModes.NO);
};

function placeImage(file) {
  var desc7 = new ActionDescriptor();
  desc7.putPath( cTID('null'), file);
  desc7.putEnumerated( cTID('FTcs'), cTID('QCSt'), cTID('Qcsa') );
  var desc8 = new ActionDescriptor();
  desc8.putUnitDouble( cTID('Hrzn'), cTID('#Pxl'), 0.000000 );
  desc8.putUnitDouble( cTID('Vrtc'), cTID('#Pxl'), 0.000000 );
  desc7.putObject( cTID('Ofst'), cTID('Ofst'), desc8 );
  return executeAction( cTID('Plc '), desc7, DialogModes.NO );
};


ContactSheetX.prototype.alignThumbnail = function(doc, csOpts, bnds, layer) {
  var vert = 0;
  var horz = 0;

  // XXX The code for vertical alignment and horizontal alignement
  // should probably be a bit more similar

  if (csOpts.valign == 'Top') {
    vert = -(layer.bounds[1].value-bnds[1]);

  } else if (csOpts.valign == 'Bottom') {
    vert = layer.bounds[1].value-bnds[1];
  }

  var imageCenter = (bnds[0]+bnds[2])/2; // the horizontal center of the image
  var cellCenter = (csOpts.cellBnds[0]+csOpts.cellBnds[2])/2;

  // assert(imageCenter == cellCenter);

  if (csOpts.halign == 'Left') {
    horz = bnds[0] + csOpts.cellBnds[0] - layer.bounds[0].value;

  } else if (csOpts.halign == 'Right') {
    horz = -(bnds[0] + csOpts.cellBnds[0] - layer.bounds[0].value);
  }

  if (vert || horz) {
    layer.translate(UnitValue(horz, "px"), UnitValue(vert, "px"));
  }
};

ContactSheetX.prototype.insertImageHP = function(doc, csOpts, bnds, file) {
  var self = this;

  self.imageCount++;

  Stdlib.log("Inserting image " + decodeURI(file.name) + " at " + bnds);

  Stdlib.makeActive(doc);

  // Add the thumbnail layer and give it the files name
  var layer = doc.artLayers.add();
  var lname = file.strf("%f");

  layer.name = lname;

  var fit = !csOpts.autoFill;

  layer = self.insertImageIntoBounds(doc, layer, csOpts, bnds, file, fit);

  if (!layer) {
    return undefined;
  }

  Stdlib.makeActive(doc);

  self.alignThumbnail(doc, csOpts, bnds, layer);

  var style = csOpts.thumbStyle;
  if (style && style != 'None') {
    layer.applyStyle(style);
  }

//   if (csOpts.accumulateKeywords) {
//     var iptc = new IPTC(doc);
//     iptc.addKeywords(image.info.keywords);
//   }

  if (csOpts.accumulateKeywords && ContactSheetUI.isBridgeRunning()) {
    var iptc = new IPTC(doc);
    var keywords = XBridgeTalk.getKeywords(file);
    iptc.addKeywords(keywords);
  }

  return layer;
};

//
// mode = thumbnail,sample,scale,resize
//
ContactSheetX.makeThumbnail  = function(opts, wsize, hsize, mode, file) {
  var temp = (isMac() ? "/private/var/tmp" : Folder.temp);
  var fname  = decodeURI(file.fsName);
  var outfname = file.strf(temp + "/th/%f.psd");
  var outfile = new File(outfname);

  Stdlib.createFolder(outfile.parent);
  var outf  = decodeURI(outfile.fsName);
  var fmt   = 'convert -%s %dx%d "%s" "%s"';
  var cmd = String.sprintf(fmt, mode, wsize, hsize, fname, outf);

  var res = Exec.system(cmd, 5000);

  return outfile;
};
//
//
ContactSheetX.extractThumbnail  = function(opts, file) {
  var temp = (isMac() ? "/private/var/tmp" : Folder.temp);
  var fname  = decodeURI(file.fsName);
  var outfname = file.strf(temp + "/th/%f.jpg");
  var outfile = new File(outfname);

  Stdlib.createFolder(outfile.parent);
  var outf  = decodeURI(outfile.fsName);
  var exiftool = opts.exiftool;
  var fmt   = exiftool + ' -b -%s "%s" > "%s"';

  var cmd = String.sprintf(fmt, opts.hp3submode, fname, outf);
  
  Exec.system(cmd, 5000, undefined, false);

  return outfile;
};

ContactSheetX.getMetadata = function(file) {
  var str = '\"' + decodeURI(file.fsName) + '\"';

  var exiftool = CSX.EXIFTOOL;
  var cmd = exiftool + " -n -s " + str;
  var inistr = Exec.system(cmd, 2000);

  return Stdlib.fromIniString(inistr);
};

ContactSheetX.prototype.insertImageIntoBounds = function(doc, layer, csOpts,
                                                         bnds, file, fit) {
  var self = this;

  if (fit == undefined) fit = true;

  var width = bnds[2] - bnds[0];
  var height = bnds[3] - bnds[1];

  if (!file.exists) {
    var msg = 'Image ' + file + ' does not exist.';
    Stdlib.log(msg);
    return undefined;
  }

  var f = file;
  if (csOpts.hiperfMode == 2) {
    var m = Math.max(width, height);
    f = ContactSheetX.makeThumbnail(csOpts, m, m, csOpts.hp2submode, file);
    if (!f || !f.exists) {
      Error.runtimeError(9001, "Failed to make thumbnail.");
    }
    
  } else if (csOpts.hiperfMode == 3) {
    var m = Math.max(width, height);
    f = ContactSheetX.extractThumbnail(csOpts, file);
    if (!f || !f.exists) {
      Error.runtimeError(9001, "Failed to extract thumbnail.");
    }
  }

  if (file != f && f.length == 0) {
    var m = "Zero length thumbnail for " + file.toUIString();
    Stdlib.log(m);
    if (!self.skipImageErrors) {
      var msg = ("A zero length thumbnail has been detected for file " +
                 file.toUIString() + ".\nThe file is corrupt or CSX-HP " +
                 "is not properly configured. Do you wish to stop now?");
      if (confirm(msg)) {
        Error.runtimeError(9001, m);
      }
    }
  }

  try {
    var desc = placeImage(f);

    layer = doc.activeLayer;

    if (f != file) {
      f.remove();
    }

  } catch (e) {
    var msg = ('Image file not placed: ' + file + ' - ' + e.message +
               '@' + e.line);
    Stdlib.log(msg);
    Stdlib.logException(e);
    self.errorCount++;

    if (e.number == 8007) { // User cancelled the operation
      Error.runtimeError(8007);
    }

    return undefined;
  }

  function _rasterize() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref );
    executeAction( sTID('rasterizeLayer'), desc, DialogModes.NO );
  };

  try {
    layer.resize(100, 100);

  } catch (e) {
    if (e.number == 8007) {      // User cancelled
      try {
        layer.resize(100, 100);
      } catch (e) {
        if (e.number != 8007) {      // User cancelled
          Error.runtimeError(9001, e.toString());
        }
      }
    } else {
      Error.runtimeError(9001, e.toString());
    }
  }

  if (!csOpts.embedSmartObjects) {
    _rasterize(doc, layer);
  }

  var lname = layer.name;

  var lbnds = Stdlib.getLayerBounds(doc, layer);
  var lw = lbnds[2]-lbnds[0];
  var lh = lbnds[3]-lbnds[1];

  if (csOpts.bestFit) {
    var deg = (csOpts.rotate == 'CW' ? 90 : -90);
      
    if (csOpts.landscape && lh > lw) {
      Stdlib.rotateLayer(doc, layer, deg);
    }
    if (!csOpts.landscape && lw > lh) {
      Stdlib.rotateLayer(doc, layer, deg);
    }

    lbnds = Stdlib.getLayerBounds(doc, layer);
    lw = lbnds[2]-lbnds[0];
    lh = lbnds[3]-lbnds[1];
  }

  var orient;

  var lrat = lh/lw;
  var rat  = height/width;
  if (fit) {
    if (lrat > rat) {
      orient = 'vert';
    } else {
      orient = 'horz';
    }
  } else { // fill
    if (lrat > rat) {
      orient = 'horz';
    } else {
      orient = 'vert';
    }
  }

  ContactSheetX.transformLayer(doc, layer, bnds, orient);
  Stdlib.selectBounds(doc, bnds);
  Stdlib.createLayerMask(doc, layer, true);
  doc.selection.deselect();

  return layer;
};

ContactSheetX.transformLayer = function(doc, layer, bnds, orient) {
  var lbnds = Stdlib.getLayerBounds(doc, layer);

  var newW = bnds[2]-bnds[0];
  var newH = bnds[3]-bnds[1];
  var oldW = lbnds[2]-lbnds[0];
  var oldH = lbnds[3]-lbnds[1];

  var hrzn = bnds[0] - (lbnds[0] - (newW-oldW)/2);
  var vrtc = bnds[1] - (lbnds[1] - (newH-oldH)/2);

  var prc;
  if (orient == 'horz') {
    prc = (newW/oldW) * 100;
  } else {
    prc = (newH/oldH) * 100;
  }

  function _ftn() {
    var desc = new ActionDescriptor();
    var ref = new ActionReference();
    ref.putEnumerated( cTID('Lyr '), cTID('Ordn'), cTID('Trgt') );
    desc.putReference( cTID('null'), ref );
    desc.putEnumerated( cTID('FTcs'), cTID('QCSt'), cTID('Qcsa') );
    var ldesc = new ActionDescriptor();
    ldesc.putUnitDouble( cTID('Hrzn'), cTID('#Pxl'), hrzn );
    ldesc.putUnitDouble( cTID('Vrtc'), cTID('#Pxl'), vrtc );
    desc.putObject( cTID('Ofst'), cTID('Ofst'), ldesc );
    desc.putUnitDouble( cTID('Wdth'), cTID('#Prc'), prc );
    desc.putUnitDouble( cTID('Hght'), cTID('#Prc'), prc );
    executeAction( cTID('Trnf'), desc, DialogModes.NO );
  };

  Stdlib.wrapLCLayer(doc, layer, _ftn);
};

// Check to see if we were called from Bridge
ContactSheetUI.calledFromBridge = function() {
  var inBridge = false;

  try {
    var lvl = $.level;
    $.level = 0;
    if (CSXBridge.callFromBridge) {
      inBridge = true;
    }

  } catch (e) {
  } finally {
    $.level = lvl;
    delete lvl;
  }

  return inBridge;
};

CaptionFormatSpecification = 
  ("Captions are defined using pattern substitutions. The patterns are specifed by " +
   "a '%' character followed by one or more characters. For instance, the pattern " +
   "'%e' will be replaced with the file extension of the image.\r\n" +
   "\r\n" +
   "You can have more than one pattern in a captions. The pattern '%Wx%H %Rppi' " +
   "would result in a caption that looked something like '640x480 72ppi'.\r\n" +
   "\r\n" +
   "There are limits to the length of the caption which depend on the space " +
   "available in the contact sheet and the size of caption font. A future release " +
   "will support multi-line captions which will make it easier to have long " +
   "captions.\r\n" +
   "\r\n" +
   "Pattern\t\tSubstitution\r\n" +
   "%%\t\t%\r\n" +
   "%d\t\tDirectory (full path)\r\n" +
   "%e\t\tExtension\r\n" +
   "%f\t\tFilename without Extension\r\n" +
   "%p\t\tDirectory (name only)\r\n" +
   "%s\t\tSize of File\r\n" +
   "%S\t\tSize of File using K/M/G shorthand\r\n" +
   "%B\t\tBits Per Channel\r\n" +
   "%C\t\tFile Creation Date\r\n" +
   "%C{dateFormat}\tFile Creation Date using specified format\r\n" +
   "%E{tag}\t\tEXIF field\r\n" +
   "%F\t\tFilename (same as %f.%e)\r\n" +
   "%H\t\tImage Height (pixels)\r\n" +
   "%I{tag}\t\tIPTC file (case insensitive)\r\n" +
   "%N\t\tCurrent Date\r\n" +
   "%N{dateFormat}\tCurrent Date using specified format\r\n" +
   "%P\t\tColor Profile\r\n" +
   "%R\t\tResolution (ppi)\r\n" +
   "%T\t\tFile Modification Date\r\n" +
   "%T{dateFormat}\tFile Modification Date using specified format\r\n" +
   "%W\t\tImage Width (pixels)\r\n" +
   "%X{tag}\t\tXMP Field (from first space with tag)\r\n" +
   "%X{space:tag}\tXMP Field from specified space\r\n" +
   "\r\n" +
   "Note that the 'dateFormat' settings use a specification format specific to\r\n" +
   "handling date and time. That format is detailed below. If a date format is not\r\n" +
   "specified, the default date format (from the Advanced Panel) is used. For\r\n" +
   "those IPTC, EXIF, and XMP fields that represent dates, the default date\r\n" +
   "format is always used.\r\n" +
   "\r\n" +
   "\r\n" +
   "Examples:     Assume an image file at c:\\test\\frodo.psd\r\n" +
   "\r\n" +
   "Pattern\t\tResult\r\n" +
   "%d\t\tc:\\test\\frodo\r\n" +
   "%e\t\tpsd\r\n" +
   "%f\t\tfrodo\r\n" +
   "%p\t\ttest\r\n" +
   "%s\t\t13400000\r\n" +
   "%S\t\t13M\r\n" +
   "%B\t\t16\r\n" +
   "%C\t\t2004-06-30\r\n" +
   "%C{%m/%d/%Y}\t06/30/2004\r\n" +
   "%E{PixelXDimension} 1900\r\n" +
   "%F\t\tfrodo.psd\r\n" +
   "%H\t\t1700\r\n" +
   "%I{Author}\tBuckaroo Banzai\r\n" +
   "%N\t\t2007-04-22\r\n" +
   "%N{%m/%d/%Y}\t04/22/2007\r\n" +
   "%R\t\t72\r\n" +
   "%T\t\t2007-04-01\r\n" +
   "%T{%m/%d/%Y}\t04/01/2007\r\n" +
   "%X{CreatorTool}\tAdobe Photoshop CS2 Windows\r\n" +
   "\r\n" +
   "\r\n" +
   "IPTC Fields\r\n" +
   "\r\n" +
   "This list of fields is the set that Photoshop makes available in the " +
   "File->Info dialog. Some fields may otheres that are not listed here. " +
   "IPTC fields are not case sensitive.\r\n" +
   "\r\n" +
   "Example:   %I{Title}\r\n" +
   "\r\n" +
   "Author\r\n" +
   "AuthorPosition\r\n" +
   "Caption\r\n" +
   "CaptionWriter\r\n" +
   "Category\r\n" +
   "City\r\n" +
   "Copyrighted\r\n" +
   "CopyrightNotice\r\n" +
   "Country\r\n" +
   "CreationDate\r\n" +
   "Credit\r\n" +
   "Headline\r\n" +
   "Instructions\r\n" +
   "JobName\r\n" +
   "Keywords\r\n" +
   "OwnerURL\r\n" +
   "ProvinceState\r\n" +
   "Source\r\n" +
   "SupplementalCategories\r\n" +
   "Title\r\n" +
   "TransmissionReference\r\n" +
   "Urgency\r\n" +
   "\r\n" +
   "\r\n" +
   "EXIF Fields\r\n" +
   "\r\n" +
   "There are a very large number of possible EXIF fields, more than is " +
   "practical to list here. Some are readily avaialable via Photoshop, " +
   "while others have to be computed from binary EXIF field data. It is " +
   "beyond the scope of this script to deal with binary or otherwise " +
   "derived EXIF fields. The fields that are handled are the ones that " +
   "are listed in the File->Info->Advanced panel.\r\n" +
   "\r\n" +
   "Example:   %E{F-Stop}\r\n" +
   "\r\n" +
   "Aperture Value\r\n" +
   "Artist\r\n" +
   "Color Space\r\n" +
   "Date Time\r\n" +
   "Date Time Original\r\n" +
   "Exposure Bias Value\r\n" +
   "Exposure Mode\r\n" +
   "Exposure Program\r\n" +
   "Exposure Time\r\n" +
   "F-Stop\r\n" +
   "Flash\r\n" +
   "Focal Length\r\n" +
   "ISO Speed Ratings\r\n" +
   "Make\r\n" +
   "Max Aperture Value\r\n" +
   "Metering Mode\r\n" +
   "Model\r\n" +
   "Orientation\r\n" +
   "Software\r\n" +
   "Shutter Speed\r\n" +
   "White Balance\r\n" +
   "\r\n" +
   "\r\n" +
   "XMP Fields\r\n" +
   "\r\n" +
   "XMP Metadata Fields are normally specified in two parts: the namespace " +
   "and the field name. The namespace is typically some abbreviation like " +
   "'xap' or 'dc'. Namespaces are a grouping mechanism. Within each namespace " +
   "are a set of fields. For instance, xap has 'CreateDate' and 'Author' as " +
   "fields; dc has 'format' and 'title'.\r\n" +
   "\r\n" +
   "You normally specify XMP fields like this:\r\n\r\n" +
   "    '%X{xap:CreateDate} %X{dc:format}'\r\n\r\n" +
   "However, you can leave the namespace off. In that case, the namespaces are " +
   "searched until one with a matching field name is found.\r\n\r\n" +
   "'%X{CreateDate} %X{format}' would typically result in an caption identical " +
   "to the previous example. As with the EXIF and IPTC, if a field is not found " +
   "that matches the requested one identically, a case-insensitive search is " +
   "run. However, the namespaces are always case sensitive.\r\n" +
   "\r\n" +
   "\r\n" +
   "Date Format Specification\r\n" +
   "\r\n" +
   "Date fields can be formatted using the following specifications:\r\n\r\n" +
   "Pattern\t\tSubsitution\r\n" +
   "%a\t\tA three-letter abbreviation for the day of the week, one of\r\n" +
   "\t\t  'Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', or 'Sat'.\r\n" +
   "\r\n" +
   "%A\t\tThe full name for the day of the week, one of 'Sunday', \r\n" +
   "\t\t  'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', or\r\n" +
   "\t\t  'Saturday'.\r\n" +
   "\r\n" +
   "%b\t\tA three-letter abbreviation for the name of the month, one of\r\n" +
   "\t\t  'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep',\r\n" +
   "\t\t  'Oct, 'Nov', or 'Dec'.\r\n" +
   "\r\n" +
   "%B\t\tThe full name of the month. One of 'January', 'February',\r\n" +
   "\t\t  'March', 'April', 'May', 'June', 'July', 'August',\r\n" +
   "\t\t  'September', 'October', 'November', or 'December'.\r\n" +
   "\r\n" +
   "%c\t\tThe complete date and time in this format:\r\n" +
   "\t\t  'Tue Oct 31 20:43:02 2006'.\r\n" +
   "\r\n" +
   "%C\t\tThe century portion of the year, zero padded. 20\r\n" +
   "\r\n" +
   "%d\t\tThe day of the month, zero padded. 31\r\n" +
   "\r\n" +
   "%D\t\tThe date in the format '%m/%d/%y'. 10/31/06\r\n" +
   "\r\n" +
   "%e\t\tThe day of the month, space padded.\r\n" +
   "\r\n" +
   "%F\t\tThe date in the format '%Y-%m-%d'. 2006-10-31\r\n" +
   "\r\n" +
   "%h\t\tA three-letter abbreviation for the name of the month,\r\n" +
   "\t\t  same as %b.\r\n" +
   "\r\n" +
   "%H\t\tThe hour on a 24 hour clock, zero padded. 20\r\n" +
   "\r\n" +
   "%I\t\tThe hour on a 12 hour clock, zero padded. 08\r\n" +
   "\r\n" +
   "%j\t\tThe Julian date.  304\r\n" +
   "\r\n" +
   "%k\t\tThe hour on a 24 hour clock, space padded. 20\r\n" +
   "\r\n" +
   "%l\t\tThe hour on a 12 hour clock, space padded.  8\r\n" +
   "\r\n" +
   "%m\t\tThe month number, zero padded. 10\r\n" +
   "\r\n" +
   "%M\t\tThe minutes, zero padded. 43\r\n" +
   "\r\n" +
   "%n\t\tA newline character.\r\n" +
   "\r\n" +
   "%p\t\tEither AM or PM as appropriate. PM\r\n" +
   "\r\n" +
   "%r\t\t12 hour time to the second with this format: \r\n" +
   "\t\t  '%I:%M:%S %p'.  08:43:02 PM\r\n" +
   "\r\n" +
   "%S\t\tThe seconds, zero padded. 02\r\n" +
   "\r\n" +
   "%t\t\tA tab character.\r\n" +
   "\r\n" +
   "%T\t\t24 hour time to the seconds with this format:\r\n" +
   "\t\t  '%H:%M:%S'. 20:43:02\r\n" +
   "\r\n" +
   "%u\t\tThe weekday as a number where Monday is 1 and Sunday is 7. 2\r\n" +
   "\r\n" +
   "%w\t\tThe weekday as a number where Sunday is 0 and Saturday is 6. 2\r\n" +
   "\r\n" +
   "%x\t\tThe date in the format '%m/%d/%y'. Same as %D.\r\n" +
   "\r\n" +
   "%X\t\t24 hour time to the seconds with this format:\r\n" +
   "\t\t  '%H:%M:%S'. Same as %T.\r\n" +
   "\r\n" +
   "%y\t\tThe last two digits of the year. 06\r\n" +
   "\r\n" +
   "%Y\t\tThe full four digits of the year. 2006\r\n" +
   "\r\n" +
   "%%\t\tThe '%' character.\r\n");


"ContactSheet.jsx";
// EOF

//

ContactSheetX.main = function() {
  CSX.REVISION = "$Revision: 1.123 $";

  if (ContactSheetConfig.LOG_ENABLED) {
    // set the log file for the UI portion of the script

    Stdlib.log.setFile(ContactSheetConfig.UI_LOG_FILE, "UTF8");
    Stdlib.log("Version: " + CSX.VERSION);
    Stdlib.log("Revision: $Revision: 1.123 $");
    Stdlib.log("App: " + app.name);
    Stdlib.log("App Version: " + app.version);
    Stdlib.log("OS: " + $.os);
  }

  Stdlib.log("CSX Starting up.");
  try {
    ContactSheetX._main();

  } catch (e) {
    Stdlib.logException(e);

  } finally {
    Stdlib.log("CSX Shutting down.");
  }
};

ContactSheetX._main = function() {
  // File.execute support for OSX
  if (isMac()) {
    Exec.setMacRoot(Stdlib.SCRIPTS_FOLDER);
  }

  // This start up logic may not cover everything, but it's good enough
  // for now...
  //
  // For app.displayDialogs
  // ALL - direct exec (menu/browse) or from action with dialogs
  // ERROR - from action no dialogs
  // NO - from debugger
  //
  var mode = app.playbackDisplayDialogs;

  // if we are launched from the debugger OR we have no parameters
  // we need a UI
  if (mode == DialogModes.NO || app.playbackParameters.count == 0) {
    mode = DialogModes.ALL;
  }

  // only turn off the ui if we have parameters and are called from an action
  var opts = {
    noUI: (app.playbackDisplayDialogs == DialogModes.ERROR),
  };

  // If we're called from Bridge, there is always a UI
  if (ContactSheetUI.calledFromBridge()) {
    // this is only true in before 1.2 or in CS2
    opts.noUI = false;

  } else {

    if (isCS3() || isCS4()) {
      // This code handles the CSX being called via the
      // Automation Framework in CS3
      var lvl = $.level;
      $.level = 0;

      try {
        if (app.playbackParameters.hasKey(sTID('filesList'))) {
          CSXBridge.callFromBridge = true;
          CSXBridge.files = [];
          opts.noUI = false;
          var flist = app.playbackParameters.getList(sTID('filesList'));
          for (var i = 0; i < flist.count; i++) {
            CSXBridge.files.push(flist.getPath(i));
          }

          // since we are only interested in the filesList
          // we can clear the playbackParameters and read in
          // settings from the default ini file
          app.playbackParameters = new ActionDescriptor();
          app.displayDialogs = DialogModes.ERROR;
        }
      } catch (e) {
      }
      $.level = lvl;
    }
  }

  var desc;
  // now set up our options based on the parameters
  // for use with Adobe Automation framework
  if (app.playbackParameters.count > 0) {
    //$.level = 1; debugger;

//     alert("XXXX-Internal Check: " + app.playbackParameters.count);

    opts = new ContactSheetConfig(opts);
    var desc = app.playbackParameters;
    opts.fromDescriptor(desc);

//     var dstr = app.playbackParameters.toStream();
//     Stdlib.writeToFile("/c/work/csx/in-desc.bin", dstr, 'BINARY');

    // in case Bridge is the source. this needs to be handled differently
    ContactSheetUI._haveBridgeFiles(opts);

  } else {
    opts.noUI = false;
  }

  if (!opts.noUI) {
    app.bringToFront();
  }
  
  var ui = new ContactSheetUI(opts);

  // Run the actual script here
  try {
    var uiOpts = ui.runUI(opts);

  } catch (e) {
    Stdlib.logException(e);
    alert("******* Error in CSX UI *******\r\r" + Stdlib.exceptionMessage(e));
    return;
  }

  if (!uiOpts) {
    return;
  }

  var xdesc = ui.runProcess(uiOpts);

  if (ui.saveIni) {
    ui.updateIniFile({ uiX: ui.winX, uiY: ui.winY });
  }

  // for use with Adobe Automation framework
  if (xdesc) {
    try {
      // see if 'forceRecording' is set to 'true'
      if (xdesc.hasKey(sTID('forceRecording')) &&
          xdesc.getBoolean(sTID('forceRecording'))) {
        var dstr = xdesc.toStream();

//     Stdlib.writeToFile("/c/work/csx/out-desc.bin", dstr, 'BINARY');

        var desc;

        if (isCS3() || isCS4()) {
//           desc = new ActionDescriptor();
//           desc.fromStream(dstr);
//           desc.putString(cTID('Msge'), "Settings for CSX");
//           app.putCustomOptions(CSX.UUID, desc);
        }

        desc = new ActionDescriptor();
        desc.fromStream(dstr);
        desc.putString(cTID('Msge'), "Settings for CSX");
        app.playbackParameters = desc;
      }

    } catch (e) {
      Stdlib.log("Error in saving settings: " + e + '@' + e.line);
    }
  }
};

// Exec.log.setFileName("exec-psjs.log"); 
// Exec.log.enabled = false;

ContactSheetX.main();

"ContactSheet.jsx";
// EOF
